#include <stdio.h>
#include <string.h>
#include <math.h>
/* #include <malloc.h> */
#define NDIST 17
#define ACU  0.0000000001
#define TINY  0.0000000001
#define ACUB 0.0000001
#define DEL  4
#define DEL1  6
#define DELA  20
#define DELA1  22
#define MISS 5
#define MISSA 21
#define ERR   stdout
#define FLUSH  fflush(stdout)
typedef struct branch *Branchptr;
typedef struct tnode *Tnodeptr;
typedef struct tnode {
   int nkey;
   Tnodeptr tnodex,tnodey,tnodez;
   Branchptr bx,by,bz;
   double height,heightb,havdif,havdifb,havdifbsq;
   int dcount;

} Tnode;
typedef struct branch {
  int nkey,nbtbp;
  double blength0,blength,blengthb;
  float bprob;
  Tnodeptr tnodex,tnodey;
  char *partptr;
} Branch;
struct com{
      int nseq,*ma,*mb,*mc,*md;
      int ndwnseq,nmseq,*mseq;
      double dav,davb;
    };
extern float *fvector();
extern int *ivector(),**imatrix();
extern char *cvector(),**cmatrix();
extern double *dvector(),**dmatrix();
extern Tnode **tnvector();
extern Branch **brvector();


int dflg;
int tr1[4][4]={0,2,3,3,
               2,0,3,3,
               3,3,0,1,
               3,3,1,0};

int tr[4][4]={-1, 0, 1, 1,
               0,-1, 1, 1,
               1, 1,-1, 0,
               1, 1, 0,-1};
int trp[5][5]={-1,0 ,0,0,0,
                0,-1,0,0,0,
                0,0,-1,0,0,
                0,0,0,-1,0,
                0,0,0,0,-1};
char base[7]={'T','C','A','G','-','?','*'};
char amn[23]={'A','C','D','E','F','G','H','I','K','L','M','N','P','Q',
                     'R','S','T','V','W','Y','-','?','*'};

char *dname[NDIST]={"JC distance","K2P distance","Tajima Nei distance","Tamura distance","Gamma distance","amino Poisson","amino p-distance","amino Gamma","Tamura Nei","Tamura Nei Gamma","p-distance","p-distance with gap","V(proportion)","V K2P","V K2P gamma","V Hasegawa","V Hasegawa gamma"};
struct com comm;

int *ivector(n)
int n;
{
int *vp;

   vp = (int *)malloc((unsigned) n*sizeof(int));
   if( !vp ) {
       fprintf(ERR,"memory allocation error\n");
       fprintf(ERR,"integer vector[%d]\n",n);
       exit(1);
     }
    return(vp);
}
char *cvector(n)
int n;
{
char *vp;

   vp = (char *)malloc((unsigned) n*sizeof(char));
   if( !vp ) {
       fprintf(ERR,"memory allocation error\n");
       fprintf(ERR,"char vector[%d]\n",n);
       exit(1);
     }
    return(vp);
}


float *fvector(n)
int n;
{
float *vp;

   vp = (float *)malloc((unsigned) n*sizeof(float));
   if( !vp ) {
       fprintf(ERR,"memory allocation error\n");
       fprintf(ERR,"char vector[%d]\n",n);
       exit(1);
     }
    return(vp);
}

double *dvector(n)
int n;
{
double *vp;

   vp = (double *)malloc((unsigned) n*sizeof(double));
   if( !vp ) {
       fprintf(ERR,"memory allocation error\n");
       fprintf(ERR,"double vector[%d]\n",n);
       exit(1);
     }
    return(vp);
}

int **imatrix(n1,n2)
int n1,n2;
{
int i,**ip;

 ip = (int **) malloc((unsigned ) n1*sizeof(int*) );
 if( !ip ) {
    fprintf(ERR,"memory allocation error\n");
    fprintf(ERR,"step1 integer matrix %d %d\n",n1,n2);
    exit(1);
  }
 for(i=0; i<n1 ; i++){
   ip[i] = (int *) malloc((unsigned) n2*sizeof(int));
   if( !ip[i] ) {
    fprintf(ERR,"memory allocation error\n");
    fprintf(ERR,"step2(i=%d) integer matrix %d %d\n",i,n1,n2);
    exit(1);

  }
 }
 
  return(ip);
				 
}




char **cmatrix(n1,n2)
int n1,n2;
{
int i;
char **ip;

 ip = (char **) malloc((unsigned ) n1*sizeof(char*) );
 if( !ip ) {
    fprintf(ERR,"memory allocation error\n");
    fprintf(ERR,"step1 char matrix %d %d\n",n1,n2);
    exit(1);
  }
 for(i=0; i<n1 ; i++){
   ip[i] = (char *) malloc((unsigned) n2*sizeof(char));
   if( !ip[i] ) {
    fprintf(ERR,"memory allocation error\n");
    fprintf(ERR,"step2(i=%d) integer matrix %d %d\n",i,n1,n2);
    exit(1);

  }
 }
 
  return(ip);
				 
}


double **dmatrix(n1,n2)
int n1,n2;
{
int i;
double **ip;

 ip = (double **) malloc((unsigned ) n1*sizeof(double*) );
 if( !ip ) {
    fprintf(ERR,"memory allocation error\n");
    fprintf(ERR,"step1 char matrix %d %d\n",n1,n2);
    exit(1);
  }
 for(i=0; i<n1 ; i++){
   ip[i] = (double *) malloc((unsigned) n2*sizeof(double));
   if( !ip[i] ) {
    fprintf(ERR,"memory allocation error\n");
    fprintf(ERR,"step2(i=%d) double matrix %d %d\n",i,n1,n2);
    exit(1);

  }
 }
 
  return(ip);
				 
}


Tnode **tnvector(n)
int n;
{
int i;
Tnode **ip;

 ip = (Tnode **) malloc((unsigned ) n*sizeof(Tnode*) );
 if( !ip ) {
    fprintf(ERR,"memory allocation error\n");
    fprintf(ERR,"Tnode step1 %d\n",n);
    exit(1);
  }
 for(i=0; i<n ; i++){
   ip[i] = (Tnode *) malloc(sizeof(Tnode));
   if( !ip[i] ) {
    fprintf(ERR,"memory allocation error\n");
    fprintf(ERR,"step2(i=%d) Tnode %d\n",i,n);
    exit(1);

  }
 }
 
  return(ip);
				 
}


Branch **brvector(n)
int n;
{
int i;
Branch **ip;

/*  printf("n=%d\n",n); */
 ip = (Branch **) malloc((unsigned ) n*sizeof(Branch*) );
 if( !ip ) {
    fprintf(ERR,"memory allocation error\n");
    fprintf(ERR,"Branch step1 %d\n",n);
    exit(1);
  }
 for(i=0; i<n ; i++){
   ip[i] = (Branch *) malloc(sizeof(Branch));
   if( !ip[i] ) {
    fprintf(ERR,"memory allocation error\n");
    fprintf(ERR,"step2(i=%d) Tnode %d\n",i,n);
    exit(1);
   }
/*
   ip[i]->partptr = (char *) malloc( (unsigned ) ((n1-1)/8+1)*sizeof(char));
   if( !(ip[i]->partptr) ) {
     fprintf(ERR,"memory allocation error\n");
     fprintf(ERR,"Branch step3 %d\n",i);
     exit(1);
   }
*/
 }
 
  return(ip);
				 
}

void free_ivector(v,n)
int *v,n;
{
   free((char*) v );
   return ;
 }

void free_dvector(v,n)
double *v;
int n;
{
   free((char*) v );
   return ;
 }


void free_cvector(v,n)
char *v;
int n;
{
   free((char*) v );
   return ;
 }


void free_cmatrix(m,n1,n2)
char **m;
int n1,n2;
{
int i;

    for(i=n1-1 ; i >= 0 ; i-- ){
       free((char *) (m[i]));
     }
    free((char *) m);
}

void free_imatrix(m,n1,n2)
int  **m;
int n1,n2;
{
int i;

    for(i=n1-1 ; i >= 0 ; i-- ){
       free((char *) (m[i]));
     }
    free((char *) m);
}


void free_dmatrix(m,n1,n2)
double  **m;
int n1,n2;
{
int i;

    for(i=n1-1 ; i >= 0 ; i-- ){
       free((char *) (m[i]));
     }
    free((char *) m);
}


void free_tnvector(ip,n)
Tnode **ip;
int n;
{
int i;


 for(i=n-1; i=0 ; i--){
   free((char*) ip[i]);
 }
 free((char *)ip); 
  return ;
				 
}

void free_brvector(ip,n)
Branch **ip;
int n;
{
int i;


 for(i=n-1; i=0 ; i--){
   free((char*) ip[i]->partptr);
   free((char*) ip[i]);
 }
 free((char *)ip); 
 return;
}

checkfl(fpi,nseq,nsite,maxnm)
FILE *fpi;
int *nseq,*nsite,*maxnm;
{
int cw,flg,fc,sc,flg1,cw1;
/* flg  0   initial
        1   file name
        2   file name end
        3   sequence
   flg1 1   comment
 */

   *nseq=0;
   *nsite =0;
   *maxnm=0;
   fc=0;
   sc=0;
   flg1=0;
   flg = 0;
   cw =0;
   cw1=0;
   for( ; ; ){
      cw1=cw;
      if( cw1 != EOF ) cw = getc(fpi);
      if( cw1 == EOF ) break;
      if( cw1 == '/' && cw == '*' ){
          flg1 = 1;
          continue;
	}
      if( flg1 == 1 ) {
           if( cw1 == '*' && cw == '/' ){
               flg1=0;
	     }
            continue;
	 }
      switch(flg){
        case 0: if( cw1 == ' ' || cw1 == '\t' ) break;
                if( cw1 == '\n' ) break;
                flg=1;
                fc++;
                break;
        case 1: if( cw1 == ' ' || cw1 == '\t' ) {
                  if( fc > *maxnm ) *maxnm=fc;
                  fc=0;
                  flg = 2;
                  break;
		}
                if( cw1 == '\n' ){
                   fprintf(ERR,"format error (1) in data file\n");
                   exit(1);
		 }
                fc++;
                break;
        case 2: if( cw1 == ' ' || cw1 == '\t' ) break;
                if( cw1 == '\n' ){
                   fprintf(ERR,"format error (2) in data file\n");
                   exit(1);
		 }
                 flg=3;
                 sc++;
                 break;
         case 3: if( cw1 == '\n'){
                   if( *nseq == 0 ) {
                     *nsite = sc;
                   }else{
                     if( sc != *nsite ){
                        fprintf(ERR,"nsite is not the same %d (in seq %d)\n",sc,(*nseq)+1);
                        exit(1);                                                                    }
                   }
                   (*nseq)++;
                   flg=0;
                   sc=0;
                   fc=0;
                   break;
		 }
                 if( cw1 == ' ' || cw1 == '\t' ) break;
                 sc++;
	}
     
    }
    if( sc != 0 ){
      if( sc != *nsite ){
            fprintf(ERR,"nsite is not the same %d (in seq %d)\n",sc,(*nseq)+1);
            exit(1);                                                                    }
      (*nseq)++;
    }
    return(0);
}



getseq(fpi,nseq,nsite,seq,seqnm)
FILE *fpi;
int nseq,nsite;
char **seq,**seqnm;
{
int cw,flg,fc,sc,flg1,cw1,seqc,sitec,cn;
/* flg  0   initial
        1   file name
        2   file name end
        3   sequence
   flg1 1   comment
 */
   cn=0;
   seqc=0;
   sitec=0;
   fc=0;
   sc=0;
   flg1=0;
   flg = 0;
   cw =0;
   cw1=0;
   for( ; ; ){
      cw1=cw;
      if( cw1 != EOF ) cw = getc(fpi);
      if( cw1 == EOF ) break;
      if( cn == 0 ) continue;
      cn++;
      if( cw1 == '/' && cw == '*' ){
          flg1 = 1;
          continue;
	}
      if( flg1 == 1 ) {
           if( cw1 == '*' && cw == '/' ){
               flg1=0;
	     }
            continue;
	 }
      switch(flg){
        case 0: if( cw1 == ' ' || cw1 == '\t' ) break;
                if( cw1 == '\n' ) break;
                flg=1;
                seqnm[seqc][fc]=cw1;
                fc++;
                break;
        case 1: if( cw1 == ' ' || cw1 == '\t' ) {
                  fc=0;
                  flg = 2;
                  break;
		}
                if( cw1 == '\n' ){
                   fprintf(stderr,"format error (1) in data file\n");
                   exit(1);
		 }
                seqnm[seqc][fc]=cw1;
                fc++;
                break;
        case 2: if( cw1 == ' ' || cw1 == '\t' ) break;
                if( cw1 == '\n' ){
                   fprintf(stderr,"format error (2) in data file\n");
                   exit(1);
		 }
                 flg=3;
                 seq[seqc][sc]=cw1;
                 sc++;
                 break;
         case 3: if( cw1 == '\n'){
                     if( sc != nsite ){
                        fprintf(stderr,"nsite is not the same %d (in seq %d)\n",sc,(seqc)+1);
                        exit(1);                                                                    }
                   seqc++;
                   flg=0;
                   sc=0;
                   fc=0;
                   break;
		 }
                 if( cw1 == ' ' || cw1 == '\t' ) break;
                 seq[seqc][sc]=cw1;
                 sc++;
	}
     
    }
    if( sc != 0 ){
      if( sc != nsite ){
            fprintf(stderr,"nsite is not the same %d (in seq %d)\n",sc,seqc+1);
            exit(1);                                                                    }
      seqc++;
    }
   if( seqc != nseq ){
      printf("sequence number inconsistency seqc=%d nseq=%d\n",seqc,nseq);
      exit(1);
    }
    return(0);
}

rdtv(fp,nseq,fl,nda,blen,maxnm,parttbl) 
Tnode **nda;
FILE *fp;
int nseq,maxnm;
Branch **blen;
char **fl,**parttbl;
{
int i,j, rn,n,nw,n1,n2,n3,bstn,nl,bc,nseqw;
char b[1000],bw[200],bw1[200];
float fw,fw1,fw2;

/*
    printf("rdtv nseq=%d\n",nseq);
    for(i=0; i<nseq ; i++){
       printf("%d %s\n",i+1,fl[i]);
     }
*/
    nl=0;
    bc = 0;
    zeroc(b,1000);
    zeroc(bw,200);
    zeroc(bw1,200);
   for(i=0; i< 2*nseq -2 ; i++){
       nda[i]->nkey = i;
       nda[i]->tnodex = NULL;
       nda[i]->tnodey = NULL;
       nda[i]->tnodez = NULL;
       nda[i]->bx = NULL;
       nda[i]->by = NULL;
       nda[i]->bz = NULL;
       nda[i]->height = 0.0;
     }
   for(i=0; i< 2*nseq -3 ; i++){
        blen[i]->nkey = i;
        blen[i]->nbtbp = 0;
        blen[i]->blength0=-999999.9;
        blen[i]->blength =-999999.9;
        blen[i]->tnodex=NULL;
        blen[i]->tnodey=NULL;
        blen[i]->partptr=parttbl[i];
      }
   for(i=0; i<200; i++){
       bw[i]=bw1[i]=0;
     }
   for( ; ; ){
     zeroc(b,1000);
     rn=rdline(fp,b,&n);
     nl++;
/*     printf("nl=%d\n",nl); */


     if( rn == 2 ) continue;
     if( rn == 1 ){
        printf("first line read error\n");
        exit(1);
    }
     break;
   }
   zeroc(bw,200);
   zeroc(bw1,200);
   sscanf(b,"%d %s %d %s\n",&nseqw,bw,&bstn,bw1);
   if( strcmp(bw,"sequences") != 0 && strcmp(bw,"otus") !=  0){
      printf("first line invalid format nseq=%d %s %d %s\n",nseqw,bw,bstn,bw1);
      exit(1);
    }
   if( nseqw != nseq ){
       printf("number of sequences inconsistent %d (data) %d (treefile)\n",nseq,nseqw);
       exit(1);
     }
   for(i=0; i< nseqw ; i++){
     zeroc(b,1000);
     if( (rn=rdline(fp,b,&n)) != 0 ){
        printf("sequence names read error\n");
      }
     nl++;
/*     printf("nl=%d\n",nl); */
       zeroc(bw,200);
       getname(&nw,bw,b,n,maxnm);
/*     sscanf(b,"%d %s",&nw,bw); */     
      if( nw != i+1 ){
        printf("sequence number read error %d %d\n",nw,i+1);
        exit(1);
      }
      nw = strlen(bw);
      if( nw > maxnm){
        printf("sequence name too long %s\n",bw);
        exit(1);
      }

      if( strcmp(fl[i],bw) != 0 ) {
         printf("sequence name inconsistency %d fl:%s bw:%s:\n",i+1,fl[i],bw);
         exit(1);
       }
/*       strcpy(fl[i],bw); */
/*       printf("bw %s fl %s\n",bw,fl[i]); */
   }
/*  printf("bootstap =%d\n",comm.bstflg); */
  for(i=0; i< 2*(nseqw)-3 ; i++){
     for( ; ; ){
        zeroc(b,1000);
        rn = rdline(fp,b,&n);
        nl++;
/*        printf("nl=%d\n",nl); */
        if( rn == 2 ) continue;
        if( rn == 1 ){
             printf("format error\n");
              exit(1);
	   }
         break;
     }
            sscanf(b,"%d and %d %f",&n1,&n2,&fw);
            if( n1 < 1 || n1 > 2*nseq-2 ){
                 fprintf(ERR,"invalid node number %d\n",n1);
                 exit(1);
	       }

            if( n2 < 1 || n2 > 2*nseq-2 ){
                 fprintf(ERR,"invalid node number %d\n",n2);
                 exit(1);
	       }
            blen[bc]->blength0 = fw;
            blen[bc]->tnodex = nda[n1-1];
            blen[bc]->tnodey = nda[n2-1];
            if( n1 <= nseq ){
                nda[n1-1]->tnodex = nda[n2-1];
                nda[n1-1]->bx = blen[bc];
	      }else{
                if( nda[n1-1]->tnodex == NULL ){
                      nda[n1-1]->tnodex = nda[n2-1];
                      nda[n1-1]->bx = blen[bc];
		    }else if( nda[n1-1]->tnodey == NULL ){
                      nda[n1-1]->tnodey = nda[n2-1];
                      nda[n1-1]->by = blen[bc];
		    }else if( nda[n1-1]->tnodez == NULL ){
                      nda[n1-1]->tnodez = nda[n2-1];
                      nda[n1-1]->bz = blen[bc];
		    }
	      }
            if( n2 <= nseq ){
                nda[n2-1]->tnodex = nda[n1-1];
                nda[n2-1]->bx = blen[bc];
	      }else{
                if( nda[n2-1]->tnodex == NULL ){
                      nda[n2-1]->tnodex = nda[n1-1];
                      nda[n2-1]->bx = blen[bc];
		    } else if( nda[n2-1]->tnodey == NULL ){
                      nda[n2-1]->tnodey = nda[n1-1];
                      nda[n2-1]->by = blen[bc];
		    }else if( nda[n2-1]->tnodez == NULL ){
                      nda[n2-1]->tnodez = nda[n1-1];
                      nda[n2-1]->bz = blen[bc];
		    }
	      }
              bc++;
   }

    
   return(0);
}
checknode(nseq,nda,blen)
int nseq;
Branch **blen;
Tnode **nda;
{
int i,j,*nd,*br,flg;
int *ivector();

  nd = ivector(2*nseq-2);
  br = ivector(2*nseq-3);
  for(i=0; i<2*nseq-2 ; i++) nd[i]=0;
  for(i=0; i<2*nseq-3 ; i++) br[i]=0;
  /* external nodes */
 if( dflg == 1){
    for(i=0; i<2*nseq -2 ; i++){
       printf("node %d",nda[i]->nkey);
       if( nda[i]->tnodex != NULL ) printf(" x %d",nda[i]->tnodex->nkey);
       if( nda[i]->tnodey != NULL ) printf(" y %d",nda[i]->tnodey->nkey);
       if( nda[i]->tnodez != NULL ) printf(" z %d",nda[i]->tnodez->nkey);
       printf("\n");
   }
  }
  for(i=0; i< nseq ; i++){
    nd[nda[i]->tnodex->nkey]++;
    if( nda[i]->tnodey != NULL ){
        fprintf(ERR,"topology file format error (1)\n");
        exit(1);
      }
    if( nda[i]->tnodez != NULL ){
        fprintf(ERR,"topology file format error (2)\n");
        exit(1);
      }
    flg=0;
    if( nda[i]->tnodex->tnodex == nda[i] ) flg++;
    if( nda[i]->tnodex->tnodey == nda[i] ) flg++;
    if( nda[i]->tnodex->tnodez == nda[i] ) flg++;
    if( flg != 1 ){
        fprintf(ERR,"i=%d topology file format error (3) flg=%d tnodex=%d nda[i]->nkey=%d\n",i,flg,nda[i]->tnodex->nkey,nda[i]->nkey);
        exit(1);
      }
    flg=0;
    if( dflg == 1) printf("b  i=%d  x=%d  y=%d\n",nda[i]->nkey,nda[i]->bx->tnodex->nkey,nda[i]->bx->tnodey->nkey);

    if(( nda[i]->bx->tnodex  == nda[i] && nda[i]->bx->tnodey == nda[i]->tnodex)
    || ( nda[i]->bx->tnodey  == nda[i] && nda[i]->bx->tnodex == nda[i]->tnodex)
    ) flg=1;
    if( flg == 0 ){
        fprintf(ERR,"topology file format error (4)\n");
        exit(1);
      }
     br[nda[i]->bx->nkey]++;
  }
  /* internal nodes */
   for(i=nseq ; i< 2*nseq-2 ; i++){
     if( nda[i]->tnodex == NULL ){
        fprintf(ERR,"topology file format error (5)\n");
        exit(1);
      }
     if( nda[i]->tnodey == NULL ){
        fprintf(ERR,"topology file format error (6)\n");
        exit(1);
      }
     if( nda[i]->tnodez == NULL ){
        fprintf(ERR,"topology file format error (7)\n");
        exit(1);
      }
      nd[nda[i]->tnodex->nkey]++;
      nd[nda[i]->tnodey->nkey]++;
      nd[nda[i]->tnodez->nkey]++;
      flg=0;
      if( nda[i]->tnodex->tnodex == nda[i] ) flg++;
      if( nda[i]->tnodex->tnodey == nda[i] ) flg++;
      if( nda[i]->tnodex->tnodez == nda[i] ) flg++;
      if( flg != 1 ){
        fprintf(ERR,"topology file format error (8)\n");
        exit(1);
      }
      flg=0;
      if( nda[i]->tnodey->tnodex == nda[i] ) flg++;
      if( nda[i]->tnodey->tnodey == nda[i] ) flg++;
      if( nda[i]->tnodey->tnodez == nda[i] ) flg++;
      if( flg != 1 ){
        fprintf(ERR,"topology file format error (9)\n");
        exit(1);
      }

      flg=0;
      if( nda[i]->tnodez->tnodex == nda[i] ) flg++;
      if( nda[i]->tnodez->tnodey == nda[i] ) flg++;
      if( nda[i]->tnodez->tnodez == nda[i] ) flg++;
      if( flg != 1 ){
        fprintf(ERR,"topology file format error (10)\n");
        exit(1);
      }
      br[nda[i]->bx->nkey]++;
      br[nda[i]->by->nkey]++;
      br[nda[i]->bz->nkey]++;
   }

   for( i=0; i<nseq ; i++){
    if( nd[i] != 1 ){
        fprintf(ERR,"topology file format error (11)\n");
        exit(1);
      }
  }
    for( i=nseq ; i< 2*nseq-2 ; i++){
     if( nd[i] != 3 ){
        fprintf(ERR,"topology file format error (12)\n");
        exit(1);
      }
    }
    for( i=0 ; i< 2*nseq-3 ; i++){
     if( br[i] != 2 ){
        fprintf(ERR,"topology file format error (13)\n");
        exit(1);
      }
    }

   free_ivector(nd,2*nseq-2);
   free_ivector(br,2*nseq-3);
  return(0);
}

   
   
     
rdline(fp,b,n)
int *n;
char *b;
FILE *fp;
{
int c,np;
   *n=0;

   np=0;
   for( ; ; ){
      c = fgetc(fp);
      if( c == EOF ) return(1);
      if( c != ' '  && c != '\t' ) np++;
      b[*n]=c;
      (*n)++;
      if( c == '\n' ) break;
    }
    if( np == 0 ) return(2);
   return(0);
}






getname(nid,snm,bf,nl,maxnm)
int *nid,nl,maxnm;
char *snm,*bf;
{
char bn[10];
int i,n,flg,nc,nst,nend;
 flg=0;
 n=0;
 for(i=0; i<= maxnm ; i++) snm[i]=0;
 for(i=0; i<10 ; i++) bn[i]=0;
 for( ; ; ){
  if( bf[n] == ' ' ){
     n++;
     continue;
   }
   break;
 }
 nc=0;
 for( ; ; ){
   if( bf[n] == ' ' ) break;
   bn[nc] = bf[n];
   if( bn[nc] > '9' || bn[nc] < '0' ) return(-1);
   nc++;
   n++;
 }
 sscanf(bn,"%d",nid);
 for( ; ; ){
   if( bf[n] == ' ' ) {
     n++;
     continue;
   }
   break;
 }

  nst=n;
  for(i=nl-1;  ; i--){
   if( bf[i] == ' ' || bf[i] == '\n' || bf[i] == '\t' ) continue;
   nend=i;
   break;
  }
  
  for(i=nst ; i<=nend ; i++) snm[i-nst]=bf[i];

  return(0);
}









zeroc(b,nc)
int nc;
char *b;
{
int i;

 for(i=0; i<nc ; i++) b[i]=0;
 return(0);
}

delchk(a,nseq0,nsite,npsite,nasite,psite,asite,cdnpos,sitef)
int nseq0,nsite,*npsite,*nasite,*psite,*asite,cdnpos[3],*sitef;
char **a;
{
int i,j,k,flg,iw,pol,del,nbs;
/* sitef
        0
        1   del/in
        2   polymorphic
*/
  (*npsite) =0;
  (*nasite) =0;
  for(i=0; i<nsite ; i++){
       del=0;
       pol=0;
       sitef[i]=0;
       if( cdnpos[i%3] != 1 ) continue;
       for(j=0; j<nseq0; j++){
          if( del != 0 ) break;
          flg=0;
          if( dflg == 3 ) printf("a[%d][%d]=%c %x\n",j,i,a[j][i],a[j][i]);
          if( a[j][i] == '.' ){
            a[j][i] = a[0][i];
	  }else{
             for(k=0; k<7 ; k++){
                if( a[j][i] == base[k] ) {
                   a[j][i]=k; 
                   flg=1;
                   break;
               }
             }
             if( flg == 0 ){
                printf("seq %d site %d  invalid base (%c) (%x)\n",j+1,i+1,a[j][i],a[j][i]);
              exit(1);
	     }
	   }
           if( a[j][i] > 3 ){
                  del=1;   
                  break;
		}
              if( a[j][i] != a[0][i] ) pol=1;


	}
    
         
        if( del != 0  ){
          sitef[i]=1;
          continue;
	}
        asite[(*nasite)]=i;
        (*nasite)++;
        if( pol == 1 ){
             sitef[i]=2;
             psite[(*npsite)]=i;
             (*npsite)++;
	   }
     }
    return(0);
}



delchka(a,nseq0,nsite,npsite,nasite,asite,psite,sitef)
int nseq0,nsite,*npsite,*nasite,*psite,*asite,*sitef;
char **a;
{
int i,j,k,flg,iw,pol,del,nbs;
  (*npsite) =0;
  (*nasite) =0;
  for(i=0; i<nsite ; i++){
       del=0;
       pol=0;
       for(j=0; j<nseq0; j++){
          if( del != 0 ) break;
          flg=0;
/*          if( dflg == 2 ) printf("a[%d][%d]=%c %x\n",i,j,a[i][j],a[i][j]); */
          if( a[j][i] == '.' ) {
             a[j][i] = a[0][i];
	   }else{
             for(k=0; k<23 ; k++){
               if( a[j][i] == amn[k] ) {
                 a[j][i]=k; 
                 flg=1;
                 break;
               }
             }
             if( flg == 0 ){
                printf("seq %d site %d  invalid amn %c %x\n",j+1,i+1,a[j][i],a[j][i]);
               exit(1);
	     }
	   }
           if( a[j][i] > 19 ){
                  del=1;   
                  break;
		}
              if( a[j][i] != a[0][i] ) pol=1;


	}
    
        if( del != 0  ){
           sitef[i]=1;
           continue;
	 }

        asite[(*nasite)]=i;
        (*nasite)++;
        if( pol == 1 ){
             sitef[i]=2;
             psite[(*npsite)]=i;
             (*npsite)++;
	   }
     }
    return(0);
}


ressite(nasite,asite,rsite,psite,npsite,sitef,seed1)
int nasite, *asite,*rsite,*psite,*npsite,*sitef,*seed1;
{
int i,rn;
extern float ran1();

*npsite=0;
for(i=0; i<nasite ; i++){
  /*   rn=random()%nasite;*/
   rn = ran1(seed1)*(float)nasite;
   rsite[i]=asite[rn];
   if( sitef[asite[rn]] == 2 ){
       psite[*npsite]=asite[rn];
       (*npsite)++;
     }
/*   printf("i=%d rn=%d asite[%d]=%d\n",i,rn,rn,asite[rn]); */
 }
/* printf("\n"); */
return(0);
}

caldist(nseq,a,fl,nasite,rsite,npsite,psite,dist,dop,fpo,gamma,bootflg,nrep)
FILE *fpo;
char **a/*[MAXSITE][MAXOTU]*/,**fl/*[MAXOTU][MAXNM]*/;
int nasite, *rsite,dop,npsite,*psite,bootflg,nrep;
double **dist/*[MAXOTU][MAXOTU]*/,gamma;
{
int rn,i,j,k,l,l1,cnch[4][4],cw,b1,b2,nts,ntv,nid,ndf,nts1,nts2,nb[5],na,nt;
double dp,ga,gt,gg,gc,gr,gy,dw1,dw2,dw3,dp1,dp2,dw,dq,max=0.00;

if( dop == 10 || dop == 11  || dop == 17){
  for(i=0; i<nseq-1 ; i++){
    for(j=i+1; j<nseq ; j++){
        nts1=0;nts2=0;ntv=0;
        nid=0;ndf=0;
         for(k=0; k<npsite ; k++){
            b1= a[i][psite[k]];
            b2= a[j][psite[k]];
            if( b1 >= 5 || b2 >= 5 ) continue;
            switch(trp[b1][b2]){
               case -1: nid++;
                        break;
               case 0 : ndf++;
                        break;
          }
        }
        if( nid+ndf == 0 ) return(-10);
        dist[i][j] = ndf;
/*         printf(" %4d",ndf); */
        if( dop == 17 ) continue;
        dist[i][j] /= nasite;
        dist[j][i] = dist[i][j];
/*        printf("%d %d %f\n",i,j,dist[i][j]); */
      }
/*      printf("\n"); */
  }
  return(0); 
}




if( dop == 5 || dop == 6 || dop == 7 ){
  for(i=0; i<nseq-1 ; i++){
    for(j=i+1; j<nseq ; j++){
        ndf=0;
        nid=0;
         for(k=0; k<npsite ; k++){
            b1= a[i][psite[k]];
            b2= a[j][psite[k]];
            if( b1 >= 20 || b2 >= 20 ) continue;
            if( b1 == b2 ) nid++;
            if( b1 != b2 ) ndf++;
        }
        if( nid+ndf == 0 ) return(-10);
        switch(dop){
           case 6: dist[i][j] = ndf;
                   dist[i][j] /= nasite;
                   dist[j][i] = dist[i][j];
                   break;
           case 5: dp = ndf;
                   dp /= nasite;
                   if( 1.0-dp/0.95 <= 0.0 ){
                      if( bootflg == 0 ) printf("inapplicable %d %d\n",i,j);
                      return(-1);
		    }
                   dist[i][j] = -0.95*log(1.0-dp/0.95);
                   dist[j][i] = dist[i][j];
                   break;
           case 7: dp = ndf;
                   dp /= nasite;
                   if( 1.0-dp/0.95 <= 0.0 ){
                      if( bootflg == 0 ) printf("inapplicable %d %d\n",i,j);
                      return(-1);
		    }
                   dw = 1.0-dp/0.95;
                   
                   dist[i][j] = 0.95*gamma*(pow(dw,-1.0/gamma)-1.0);
                   dist[j][i] = dist[i][j];
                   break;
	
	   }

      }
  }
  return(0);
}


if( dop == 8 || dop == 9  || dop == 15 || dop == 16 ){
  for(i=0; i<nseq-1 ; i++){
    for(j=i+1; j<nseq ; j++){
/*         printf("i=%d j=%d\n",i,j); */
         nts1=nts2=ntv=0;
         nid=0;
         nb[0]=nb[1]=nb[2]=nb[3]=nb[4]=0;
         for(k=0; k<nasite ; k++){
            b1= a[i][rsite[k]];
            b2= a[j][rsite[k]];
            if( b1 >= 4 ) continue;
            if( b2 >= 4 ) continue;
            nb[b1]++;
            nb[b2]++;
            switch(tr1[b1][b2]){
         	    case 0:   nid++;
                              break;
         	    case 1:   nts1++;
                              break;
         	    case 2:   nts2++;
                              break;
         	    case 3:   ntv++;
                              break;
		    }

        }
/*        printf("i=%d j=%d nid=%d nts1=%d nts2=%d ntv=%d \n",i,j,nid,nts1,nts2,ntv);  */
        if( nid+nts1+nts2+ntv == 0 ) return(-10);
        nt = nasite;
        na = (nid+nts1+nts2+ntv)*2;
        gt = nb[0];
        gt /= na;
        gc = nb[1];
        gc /= na;
        ga = nb[2];
        ga /= na;
        gg = nb[3];
        gg /= na;
        gr = ga + gg;
        gy = gt + gc;
        dp1 = nts1;
        dp2 = nts2;
        dq  = ntv;
        dp1 /= nt;
        dp2 /= nt;
        dq  /= nt;
        if( nts1+nts2+ntv == 0 ) {
            dist[i][j]=0.0;
            continue;
	  }
        dw1 = 1.0 - gr*dp1/(2.0*ga*gg) - dq/(2.0*gr);
        dw2 = 1.0 - gy*dp2/(2.0*gt*gc) - dq/(2.0*gy);
        dw3 = 1.0- dq/(2.0*gr*gy);
/*
        printf("gy %f gr %f a t g c %f %f %f %f\n",gy,gr,ga,gt,gg,gc);
        printf("dw %f %f %f\n",dw1,dw2,dw3);
*/

/*        printf("a t g c %f %f %f %f dw %f %f %f\n",ga,gt,gg,gc,dw1,dw2,dw3); */
        if( dop == 8 || dop == 9 ) if( 1.0 - gr*dp1/(2.0*ga*gg) - dq/(2.0*gr) <= 0.0 ) {
           if( bootflg == 0 ) printf("inapplicable1  %d %d\n",i,j);
           return(-1);
	 }
        if( dop == 8 || dop == 9 ) if( 1.0 - gy*dp2/(2.0*gt*gc) - dq/(2.0*gy) <=0.0 ) {
                    if( bootflg == 0 ) printf("inapplicable2 %d %d gy=%f dp2=%f gt=%f gc=%f dq=%f  %f\n",i,j,gy,dp2,gt,gc,dq,1.0 - gy*dp2/(2.0*gt*gc) - dq/(2.0*gy));
                    return(-1);
		  }
        if( 1.0- dq/(2.0*gr*gy) <= 0.0 ) {
           if( bootflg == 0 ) printf("inapplicable3  %d %d\n",i,j);
             return(-1);
	 }
        switch(dop){
           case 8: dist[i][j]= ga*gg/(gr)*log(dw1) + gt*gc/(gy)*log(dw2) + (gr*gy-ga*gg*gy/gr - gt*gc*gr/gy)*log(dw3);
                   dist[i][j] *= -2.0;
                   dist[j][i] = dist[i][j];
                   break;
           case 9:  dist[i][j] = ga*gg/(gr)*pow(dw1,-1.0/gamma)+gt*gc/gy*pow(dw2,-1.0/gamma)+(gr*gy-ga*gg*gy/gr-gt*gc*gr/gy)*pow(dw3,-1.0/gamma) -ga*gg-gt*gc-gr*gy;
                   dist[i][j] *= 2.0*gamma;
                   dist[j][i] = dist[i][j];
/*                   printf("gamma=%f %d %d %f\n",gamma,i,j,dist[i][j]); */
                   break;

           case 15:  dist[i][j] = -2.0*gr*gy*log(1.0-dq/(2.0*gr*gy));
                     dist[j][i] = dist[i][j];
                     break;
           case 16:  dist[i][j] = pow(1.0-dq/(2.0*gr*gy),-1.0/gamma)-1.0;
                     dist[i][j] *= 2.0*gamma*gr*gy;
                     dist[j][i] = dist[i][j];

                   break;
                   

	   }

      }
  }
/*  printf("max=%f\n",max); */
  return(0);

}

if( dop == 2 || dop == 3 ){


for(i=0; i<nseq-1 ; i++){
  for(j=i+1; j<nseq ; j++){
    for(k=0; k<4; k++){
      for(l=0; l<4 ; l++){
          cnch[k][l]=0;
      }
    }
   nts=0;
   ntv=0;
   nid=0;
    for(k=0; k<nasite ; k++){
          b1= a[i][rsite[k]];
          b2= a[j][rsite[k]];
          if( b1 >= 4 ) continue;
          if( b2 >= 4 ) continue;
          switch(tr[b1][b2]){
               case -1: nid++;
                        break;
               case 0 : nts++;
                        break;
                case 1: ntv++;
                        break;
          }
          cnch[b1][b2]++; 

     }
     if(  nid + nts+ntv == 0 ) return(-10);
/*    printf("%d %s  %d %s   %d %d %d\n",i,fl[i],j,fl[j],nid+nts+ntv,nts,ntv); */
    rn=caldis(cnch,i,j,fl,fpo,dist,dop,nid,nts,ntv,nasite,gamma,nrep);
/*    if( bootflg == 1 ) printf("%d %d %f\n",i,j,dist[i][j]); */

     if( dist[i][j] <  0.0 ||  dist[i][j] > 3.0 ) printf("%d %d %f\n",i,j,dist[i][j]);
    dist[j][i] = dist[i][j];
   if( rn != 0  ) return(rn);
  }
}
  return(0);

}

/*  printf("chkseq end\n"); */
for(i=0; i<nseq-1 ; i++){
  for(j=i+1; j<nseq ; j++){
   nts=0;
   ntv=0;
   nid=0;
    for(k=0; k<npsite ; k++){
          b1= a[i][psite[k]];
          b2= a[j][psite[k]];
          if( b1 >= 4 ) continue;
          if( b2 >= 4 ) continue;
          switch(tr[b1][b2]){
               case -1: nid++;
                        break;
               case 0 : nts++;
                        break;
                case 1: ntv++;
                        break;
          }
     }
     if(  nid + nts+ntv == 0 ) return(-10);
/*    printf("%d %s  %d %s   %d %d %d\n",i,fl[i],j,fl[j],nid+nts+ntv,nts,ntv);*/
    rn=caldis(cnch,i,j,fl,fpo,dist,dop,nid,nts,ntv,nasite,gamma,nrep);
    dist[j][i] = dist[i][j];
    if( rn != 0  ) return(rn);
  }
}


return(0);
}

caldis(cnch,s1,s2,fl,fpo,dist,dop,nid,nts,ntv,nasite,gammaa,nrep)
int cnch[4][4],s1,s2,dop,nid,nts,ntv,nasite,nrep;
char **fl/*[MAXOTU][20]*/;
FILE *fpo;
double **dist/*[MAXOTU][MAXOTU]*/,gammaa;
{
int rn,i,j,k;
double dda[2],dq;



/*  if( nts + ntv == 0  ) return(-2); */
  switch(dop){
   case 0:  
            rn=jcdis(&dda[0],nasite,nts+ntv);
            if( rn != 0 ) return(-1);
            dist[s1][s2]= dda[0];
            break;
   case 1:   rn=k2pdis(&dda[0],nasite,nts,ntv);
             if( rn != 0 ) return(-1);
             dist[s1][s2]= dda[0];
             break;
   case 2 :   rn=tndis(&dda[0],cnch,nid+nts+ntv,nts+ntv,nrep);
             if( rn != 0 ) return(-1);
             dist[s1][s2]= dda[0];
             break;
   case 3 :   rn=tm3dis(&dda[0],cnch,nid+nts+ntv,nts,ntv);
             if( rn != 0 ) return(-1);
             dist[s1][s2]= dda[0];
             break;
   case 4 :   
             rn=gmadis(&dda[0],nasite,nts,ntv,gammaa);
/*             printf("gamma %f %f\n",gammaa,dda[0]); */
             if( rn != 0 ) return(-1);
             dist[s1][s2]=dda[0];
             break;
   case 12 : dist[s1][s2] = ntv;
             dist[s1][s2] /= nasite;
             break;

   case 13 : dq = ntv;
             dq /= nasite;
             if( 1.0 - 2.0*dq <= 0.0 ) return(-1);
             dist[s1][s2] = -0.25*log(1.0-2.0*dq);
             break;

   case 14 : dq = ntv;
             dq /= nasite;
             if( 1.0 - 2.0*dq <= 0.0 ) return(-1);
             dist[s1][s2] = pow(1.0-2.0*dq,-1.0/gammaa)-1.0;
             dist[s1][s2] *= 0.25*gammaa;
             break;



   }


  return(0);
}
caldpro(nseq,a,fl,nasite,rsite,dist,fpo)
FILE *fpo;
char **a/*[MAXSITE][MAXOTU]*/,**fl/*[MAXOTU][MAXNM]*/;
int nasite, *rsite;
double **dist/*[MAXOTU][MAXOTU]*/;
{
int rn,i,j,k,l,l1,cw,b1,b2,nts,ntv,nid,ndf;


  for(i=0; i<nseq-1 ; i++){
    for(j=i+1; j<nseq ; j++){
        ndf=0;
        nid=0;
         for(k=0; k<nasite ; k++){
            b1= a[rsite[k]][i];
            b2= a[rsite[k]][j];
            if( b1 !=  b2  ) ndf++;
            if( b1 ==  b2  ) nid++;

        }
        if( nid+ndf != nasite ) return(-10);
        dist[i][j] = nid;
        dist[i][j] /= nasite;
        dist[i][j] = -log(dist[i][j]);
/*        printf("%d-%d nid=%d nasite=%d  %f\n",i,j,nid,nasite,dist[i][j]); */
      }

  }
        
return(0);
}


partition(ac,cur)
Tnodeptr ac,cur;
{
Tnodeptr tpw;
Branchptr  bpw;
double *bw,dsum,raw,rbw,rcw;
int flg,i,j,nw,nm,nc,na,nlp,nrp;
unsigned char nx,ny;
char *pc;

/* 
   tnodex  ancestor 
   tnodey  right
   tnodez  left
 */
     if( dflg == 1 ){
         printf("cur %d",cur->nkey);
         if( cur->tnodex != NULL ) printf(" x %d",cur->tnodex->nkey);
         if( cur->tnodey != NULL ) printf(" y %d",cur->tnodey->nkey);
         if( cur->tnodez != NULL ) printf(" z %d",cur->tnodez->nkey);
         printf(" bx x=%d y=%d\n",cur->bx->tnodex->nkey,cur->bx->tnodey->nkey);
         printf("\n"); fflush(stdout);
       }

    flg = 0;
    if( cur->tnodex  == ac ) flg += 1;
    if( cur->tnodey == ac ){
        flg += 2;
        tpw=cur->tnodey;
        cur->tnodey = cur->tnodex;
        cur->tnodex = tpw;
        bpw = cur->by;
        cur->by = cur->bx;
        cur->bx = bpw;

      }

    if( cur->tnodez == ac ){
        tpw=cur->tnodez;
        cur->tnodez = cur->tnodex;
        cur->tnodex = tpw;
        bpw = cur->bz;
        cur->bz = cur->bx;
        cur->bx = bpw;
        flg += 3;
      }

    if( flg < 1 || flg > 3 ){
       printf("flg =%d\n",flg);
       printf("cur %d",cur->nkey);
       if( cur->tnodex != NULL ) printf(" x %d",cur->tnodex->nkey);
       if( cur->tnodey != NULL ) printf(" y %d",cur->tnodey->nkey);
       if( cur->tnodez != NULL ) printf(" z %d",cur->tnodez->nkey);
        printf("\n");
       exit(1);
     }


    if( cur->tnodey != NULL) partition(cur,cur->tnodey);

    if( cur->tnodez != NULL) partition(cur,cur->tnodez);

    if( cur->tnodey == NULL && cur->tnodez == NULL ){
       if( cur->nkey >= comm.nseq ){
           fprintf(ERR,"tree node error %d\n",cur->nkey);
           exit(1);
	 }
        pc = cur->bx->partptr;
        if( dflg == 1 ) {
          printf("cur %d ",cur->nkey+1);
          prpart1(comm.nseq,pc);
	}
        biton(pc,cur->nkey+1);
        if( dflg == 1 ) {
          printf("cur %d ",cur->nkey+1);
          prpart1(comm.nseq,pc);
	}
        if( cur->bx->tnodey == cur ){
            tpw = cur->bx->tnodey;
            cur->bx->tnodey = cur->bx->tnodex;
            cur->bx->tnodex = tpw;
	  }
     }
  
   if( cur->tnodez != NULL && cur->tnodey != NULL && cur->tnodex->nkey >= comm.nseq ){
       for(i=0; i< (comm.nseq-1)/8 +1 ; i++){
         cur->bx->partptr[i] = cur->by->partptr[i] | cur->bz->partptr[i];
	 }
       if( cur->bx->tnodey == cur ){
            tpw = cur->bx->tnodey;
            cur->bx->tnodey = cur->bx->tnodex;
            cur->bx->tnodex = tpw;
	  }
     }
   if( cur->tnodez != NULL && cur->tnodey != NULL && cur->tnodex->nkey < comm.nseq ){
        biton(cur->bx->partptr,cur->tnodex->nkey+1);
        if( cur->bx->tnodey == cur->tnodex ){
            tpw = cur->bx->tnodey;
            cur->bx->tnodey = cur->bx->tnodex;
            cur->bx->tnodex = tpw;
	  }
      }


   if( dflg == 1 ) printf("cur %d\n",cur->nkey);
   return(0);
}


biton(cp,n)
char *cp;
int n;
{
int na,nm;
unsigned char nx,ny;


/*   printf("biton start n=%d\n",n); fflush(stdout); */

   nm = (n-1)/8;
   na = (n-1)%8;
   if( dflg == 1 ) printf("biton nm=%d na=%d\n",nm,na); fflush(stdout); 
   nx = 0x80;
   nx >>= na;
   if( dflg == 1 )  printf("biton nx=%02x",nx); fflush(stdout);
   cp[nm] = nx;
   if( dflg == 1 ) printf("biton end\n"); fflush(stdout);  
   return(0);
}


prpart(nseq,parttbl,branchv)
int nseq;
char **parttbl;
Branch **branchv;
{
int i,j,nb;

  for(i=0; i< 2*nseq-3 ; i++){
     printf("i=%3d %2d %2d  ",i,branchv[i]->tnodex->nkey+1,branchv[i]->tnodey->nkey+1);
     for(j=0; j<nseq ; j++){
       nb=getbit(parttbl,i,j);
       printf("%d",nb);
     }
     printf("\n");
   }
   return(0);
}




prpart1(nseq,part)
int nseq;
char *part;
{
int i,j,nb;

     for(j=0; j<nseq ; j++){
       nb=getbit1(part,j);
       printf("%d",nb);
     }
     printf("\n");

   return(0);
}




getbit(parttbl,i,j)
int i,j;
char **parttbl;
{
int nm,na;
unsigned char nx,ny,nz;

 
nx = 0x80;

 nm = j/8;
 na = j%8;

 nx >>= na;

  ny = nx & parttbl[i][nm];
  
  if( ny != 0 ) return(1);
  return(0);
}



getbit1(part,j)
int j;
char *part;
{
int nm,na;
unsigned char nx,ny,nz;

 
nx = 0x80;

 nm = j/8;
 na = j%8;

 nx >>= na;

  ny = nx & part[nm];
  
/*   printf("j=%d ny =%02x nx=%02x   part[%d]=%02x\n",ny,nx,part[nm]); */
  if( ny != 0 ) return(1);
  return(0);
}



prtree(fpo,nseq,branchv,seqname,dop,cdnpos,nsite,nasite,npsite,nrepn,tvalues,tnodev)
FILE *fpo;
int nseq,dop,cdnpos[3],nsite,nasite,npsite,nrepn;
Branch **branchv;
Tnode **tnodev;
char **seqname;
float *tvalues;
{
int i,n1,n2,nw,tw;
char c,c1;

    c =0xb1;
    c1 = '%';

    fprintf(fpo,"%d sequences",nseq);
/*    if( nrepn > 0 ) fprintf(fpo,"        %d bootstraping",nrepn); */
    fprintf(fpo,"\n");
    for(i=0; i<nseq ; i++){
      tw = tvalues[i]*100.0;
      if( tw < 0 ) fprintf(fpo,"%d %s\n",i+1,seqname[i]);
      else fprintf(fpo,"%d %s(%d)\n",i+1,seqname[i],tw);
    }

    for(i=0; i< 2*nseq - 3 ; i++){
      n1 = branchv[i]->tnodex->nkey+1;
      n2 = branchv[i]->tnodey->nkey+1;
      ilarg(&n1,&n2);
      fprintf(fpo,"%3d  and  %3d    %f",n1,n2,branchv[i]->blength);
/*       if( nrepn > 0 ) fprintf(fpo,"         %4d",branchv[i]->nbtbp); */
       fprintf(fpo,"\n");
    }

    fprintf(fpo,"\n");
    fprintf(fpo,"branch length reestimation: %s was used\n",dname[dop]);
    fprintf(fpo,"#sites %d   #actual sites %d   #polymorphic sites %d\n",nsite,
            nasite,npsite);
    if( cdnpos[0]+cdnpos[1]+cdnpos[2] != 3 ){
           fprintf(fpo,"codon position:");
           for(i=0; i<3 ; i++){
              if( cdnpos[i] == 1 ) fprintf(fpo," %d",i+1);
           } 
           fprintf(fpo,"\n");
     } 
     return(0);
}





ilarg(n1,n2)
int *n1,*n2;
{
int iw;

   if( *n1 < *n2 ){
      iw  =  *n1;
      *n1 =  *n2;
      *n2 =  iw;
}
    return(0);
} 

basefr(a,nseq,nasite,asite,nbal)
char **a;
int nseq,nasite,*asite,**nbal;
{
int i,j,n1;

for(i=0; i<nseq ; i++){
  for(j=0; j<4 ; j++) nbal[i][j]=0;
}
for(i=0; i<nseq ; i++){
  for(j=0; j<nasite ; j++){
      n1=a[i][asite[j]];
      if( n1 > 5 ) {
         printf("seq %d invalid base %d %c %d  i=%d j=%d asite[j]=%d\n",i,n1,n1,asite[j],i,j,asite[j]);
      } 
      nbal[i][n1]++;
    }
}
return(0);
}


brest(nseq,br,dist,ma,mb,mc,md)
int nseq,*ma,*mb,*mc,*md;
Branch **br;
double **dist;
{
int i,j;
int na,nb,nc,nd;
char *pa,*pb,*pc,*pd;
int fa,fb,fc,fd;
Branchptr ba,bb,bc,bd,be;
double getextb(),getintb();


  if( dflg == 1 ){
    printf("nseq=%d m a b c d %p %p %p %p   nseq %d\n",nseq,ma,mb,mc,md);
    printf("m a b c d  %p %p %p %p\n",&ma[nseq],&mb[nseq],&mc[nseq],&md[nseq]);
  }
  for(i=0; i<2*nseq-3 ; i++){
   if( dflg == 1 ) printf("i=%d nseq=%d br %p x %d y=%d\n",i,nseq,br[i],br[i]->tnodex->nkey,br[i]->tnodey->nkey);fflush(stdout);
   if( br[i]->tnodex->nkey <  nseq ){
                /* br[i]->tnodey -- N  */
      nc = 1;
      mc[0] = br[i]->tnodex->nkey;
     if( br[i]->tnodey->tnodex == br[i]->tnodex ){
         pa = br[i]->tnodey->by->partptr;
         pb = br[i]->tnodey->bz->partptr;
         if( br[i]->tnodey->by->tnodex == br[i]->tnodey ) fa = 0;
	 else fa = 1;
         if( br[i]->tnodey->bz->tnodex == br[i]->tnodey ) fb = 0;
	 else fb = 1;
       }
      if( br[i]->tnodey->tnodey == br[i]->tnodex ){
         pa = br[i]->tnodey->bx->partptr;
         pb = br[i]->tnodey->bz->partptr;
         if( br[i]->tnodey->bx->tnodex == br[i]->tnodey ) fa = 0;
	 else fa = 1;
         if( br[i]->tnodey->bz->tnodex == br[i]->tnodey ) fb = 0;
	 else fb = 1;
       }
      if( br[i]->tnodey->tnodez == br[i]->tnodex ){
         pa = br[i]->tnodey->bx->partptr;
         pb = br[i]->tnodey->by->partptr;
         if( br[i]->tnodey->bx->tnodex == br[i]->tnodey ) fa = 0;
	 else fa = 1;
         if( br[i]->tnodey->by->tnodex == br[i]->tnodey ) fb = 0;
	 else fb = 1;
       }
       if( fa == 1 ) geton(&na,ma,pa,nseq);
       else getoff(&na,ma,pa,nseq);
       if( fb == 1 ) geton(&nb,mb,pb,nseq);
       else getoff(&nb,mb,pb,nseq);
       br[i]->blength=getextb(na,nb,nc,ma,mb,mc,dist);     
      if( dflg == 1 ){
         printf("i=%d b x %d y %d ",i,br[i]->tnodex->nkey,br[i]->tnodey->nkey);
         printf("na =%d",na);
         for(j=0; j<na ; j++) printf(" %d",ma[j]);
         printf("\n");
         printf("nb =%d",nb);
         for(j=0; j<nb ; j++) printf(" %d",mb[j]);
         printf("\n");
         printf("nc =%d",nc);
         for(j=0; j<nc ; j++) printf(" %d",mc[j]);
         printf("\n");
         printf("i=%d b=%f\n",i,br[i]->blength);fflush(stdout);
       }

       continue;
    }


   if( br[i]->tnodey->nkey <  nseq ){
                /* br[i]->tnodey -- N  */
      nc = 1;
      mc[0] = br[i]->tnodey->nkey;
     if( br[i]->tnodex->tnodex == br[i]->tnodey ){
         pa = br[i]->tnodex->by->partptr;
         pb = br[i]->tnodex->bz->partptr;
         if( br[i]->tnodex->by->tnodex == br[i]->tnodey ) fa = 0;
	 else fa = 1;
         if( br[i]->tnodex->bz->tnodex == br[i]->tnodey ) fb = 0;
	 else fb = 1;
       }
      if( br[i]->tnodex->tnodey == br[i]->tnodey ){
         pa = br[i]->tnodex->bx->partptr;
         pb = br[i]->tnodex->bz->partptr;
         if( br[i]->tnodex->bx->tnodex == br[i]->tnodey ) fa = 0;
	 else fa = 1;
         if( br[i]->tnodex->bz->tnodex == br[i]->tnodey ) fb = 0;
	 else fb = 1;
       }
      if( br[i]->tnodey->tnodez == br[i]->tnodex ){
         pa = br[i]->tnodex->bx->partptr;
         pb = br[i]->tnodex->by->partptr;
         if( br[i]->tnodex->bx->tnodex == br[i]->tnodey ) fa = 0;
	 else fa = 1;
         if( br[i]->tnodex->by->tnodex == br[i]->tnodey ) fb = 0;
	 else fb = 1;
       }
       if( fa == 1 ) geton(&na,ma,pa,nseq);
       else getoff(&na,ma,pa,nseq);
       if( fb == 1 ) geton(&nb,mb,pb,nseq);
       else getoff(&nb,mb,pb,nseq);
       br[i]->blength=getextb(na,nb,nc,ma,mb,mc,dist);
       if( dflg == 1 ){
         printf("i=%d b x %d y %d ",i,br[i]->tnodex->nkey,br[i]->tnodey->nkey);
         printf("na =%d",na);
         for(j=0; j<na ; j++) printf(" %d",ma[j]);
         printf("\n");
         printf("nb =%d",nb);
         for(j=0; j<nb ; j++) printf(" %d",mb[j]);
         printf("\n");
         printf("nc =%d",nc);
         for(j=0; j<nc ; j++) printf(" %d",mc[j]);
         printf("\n");
         printf("i=%d b=%f\n",i,br[i]->blength);fflush(stdout);

       }
       
       continue;
    }
   if( dflg == 1 ) {
      printf("i=%d bx %d x %d y %d z %d   by %d x %d y %d z %d\n",i,br[i]->tnodex->nkey, 
      br[i]->tnodex->tnodex->nkey,br[i]->tnodex->tnodey->nkey,br[i]->tnodex->tnodez->nkey,
      br[i]->tnodey->nkey, 
      br[i]->tnodey->tnodex->nkey,br[i]->tnodey->tnodey->nkey,br[i]->tnodey->tnodez->nkey); fflush(stdout);
    }
   if( br[i]->tnodex->tnodex == br[i]->tnodey && br[i]->tnodey->tnodex == br[i]->tnodex ){
        ba = br[i]->tnodex->by;   
        bb = br[i]->tnodex->bz;   
        bc = br[i]->tnodey->by;   
        bd = br[i]->tnodey->bz;   
      }
   if( br[i]->tnodex->tnodex == br[i]->tnodey && br[i]->tnodey->tnodey == br[i]->tnodex ){
        ba = br[i]->tnodex->by;   
        bb = br[i]->tnodex->bz;   
        bc = br[i]->tnodey->bx;   
        bd = br[i]->tnodey->bz;   
      }
   if( br[i]->tnodex->tnodex == br[i]->tnodey && br[i]->tnodey->tnodez == br[i]->tnodex ){
        ba = br[i]->tnodex->by;   
        bb = br[i]->tnodex->bz;   
        bc = br[i]->tnodey->bx;   
        bd = br[i]->tnodey->by;   
      }
   if( br[i]->tnodex->tnodey == br[i]->tnodey && br[i]->tnodey->tnodex == br[i]->tnodex ){
        ba = br[i]->tnodex->bx;   
        bb = br[i]->tnodex->bz;   
        bc = br[i]->tnodey->by;   
        bd = br[i]->tnodey->bz;   
      }
   if( br[i]->tnodex->tnodey == br[i]->tnodey && br[i]->tnodey->tnodey == br[i]->tnodex ){
        ba = br[i]->tnodex->bx;   
        bb = br[i]->tnodex->bz;   
        bc = br[i]->tnodey->bx;   
        bd = br[i]->tnodey->bz;   
      }
     if( br[i]->tnodex->tnodey == br[i]->tnodey && br[i]->tnodey->tnodez == br[i]->tnodex ){
        ba = br[i]->tnodex->bx;   
        bb = br[i]->tnodex->bz;   
        bc = br[i]->tnodey->bx;   
        bd = br[i]->tnodey->by;   
      }
     if( br[i]->tnodex->tnodez == br[i]->tnodey && br[i]->tnodey->tnodex == br[i]->tnodex ){
        ba = br[i]->tnodex->bx;   
        bb = br[i]->tnodex->by;   
        bc = br[i]->tnodey->by;   
        bd = br[i]->tnodey->bz;   
      }
       if( br[i]->tnodex->tnodez == br[i]->tnodey && br[i]->tnodey->tnodey == br[i]->tnodex ){
        ba = br[i]->tnodex->bx;   
        bb = br[i]->tnodex->by;   
        bc = br[i]->tnodey->bx;   
        bd = br[i]->tnodey->bz;   
      }
       if( br[i]->tnodex->tnodez == br[i]->tnodey && br[i]->tnodey->tnodez == br[i]->tnodex ){
        ba = br[i]->tnodex->bx;   
        bb = br[i]->tnodex->by;   
        bc = br[i]->tnodey->bx;   
        bd = br[i]->tnodey->by;   
      }
    fa=fb=fc=fd=1;
    if( ba->tnodex == br[i]->tnodex ) fa=0;
    if( bb->tnodex == br[i]->tnodex ) fb=0;
    if( bc->tnodex == br[i]->tnodey ) fc=0;
    if( bd->tnodex == br[i]->tnodey ) fd=0;
/*    printf("f %d %d %d %d\n",fa,fb,fc,fd); fflush(stdout); */
    if( fa == 0 ) getoff(&na,ma,ba->partptr,nseq);
    if( fa == 1 ) geton(&na,ma,ba->partptr,nseq);
    if( fb == 0 ) getoff(&nb,mb,bb->partptr,nseq);
    if( fb == 1 ) geton(&nb,mb,bb->partptr,nseq);
    if( fc == 0 ) getoff(&nc,mc,bc->partptr,nseq);
    if( fc == 1 ) geton(&nc,mc,bc->partptr,nseq);
    if( fd == 0 ) getoff(&nd,md,bd->partptr,nseq);
    if( fd == 1 ) geton(&nd,md,bd->partptr,nseq);
    br[i]->blength=getintb(na,nb,nc,nd,ma,mb,mc,md,dist); 
    if( dflg == 1 ){
       printf("i=%d b x %d y %d ",i,br[i]->tnodex->nkey,br[i]->tnodey->nkey);
       printf("na =%d",na);
       for(j=0; j<na ; j++) printf(" %d",ma[j]);
       printf("\n");
       printf("nb =%d",nb);
       for(j=0; j<nb ; j++) printf(" %d",mb[j]);
       printf("\n");
       printf("nc =%d",nc);
       for(j=0; j<nc ; j++) printf(" %d",mc[j]);
       printf("\n");
       printf("nd =%d",nd);
       for(j=0; j<nd ; j++) printf(" %d",md[j]);
       printf("\n");
     }
/*    printf("f %d %d %d %d\n",fa,fb,fc,fd); fflush(stdout); */


 }

/*   printf("brest end\n"); fflush(stdout); */

   return(0);
 }















geton(nx,mx,part,nseq)
int *nx,*mx,nseq;
char *part;
{
int i,j,nm,nn;
unsigned char cw,cs;
  
  (*nx) = 0;
  for(i=0; i<nseq ; i++){
     nm = i/8;
     nn = i%8;
     cw = 0x80;
     cw >>= nn;
     cs = cw & part[nm];
     if( cs != 0 ){
        mx[(*nx)] = i;
        (*nx)++;
      }
   }

/*    printf("geton nx=%d\n",*nx); */
   return(0);
}


getoff(nx,mx,part,nseq)
int *nx,*mx,nseq;
char *part;
{
int i,j,nm,nn;
unsigned char cw,cs;
  
  (*nx) = 0;
  for(i=0; i<nseq ; i++){
     nm = i/8;
     nn = i%8;
     cw = 0x80;
     cw >>= nn;
     cs = cw & part[nm];
     if( cs == 0 ){
        mx[(*nx)] = i;
        (*nx)++;
      }
   }
/*    printf("getoff nx=%d\n",*nx); */
   return(0);
}

double getintb(na,nb,nc,nd,ma,mb,mc,md,dist)
int na,nb,nc,nd,*ma,*mb,*mc,*md;
double **dist;
{
int i,j,k,l;
double dac,dbd,dbc,dad,dab,dcd,gw,bw;
double getdsum();

   dac=dbd=dbc=dad=dab=dcd=0.0;
   dac=getdsum(na,nc,ma,mc,dist);
   dbd=getdsum(nb,nd,mb,md,dist);
   dbc=getdsum(nb,nc,mb,mc,dist);
   dad=getdsum(na,nd,ma,md,dist);
   dab=getdsum(na,nb,ma,mb,dist);
   dcd=getdsum(nc,nd,mc,md,dist);
 
   gw = nb*nc+na*nd;
   gw /= (na+nb)*(nc+nd);
   
  bw = 0.5*(gw*(dac + dbd) + (1.0-gw)*(dbc+dad) - dab - dcd);
  return(bw);
}

double getextb(na,nb,nc,ma,mb,mc,dist)
int na,nb,nc,*ma,*mb,*mc;
double **dist;
{
int i,j,k,l;
double dac,dbc,dab,bw;
double getdsum();

   dac=dbc=dab=0.0;
   dac=getdsum(na,nc,ma,mc,dist);
   dbc=getdsum(nb,nc,mb,mc,dist);
   dab=getdsum(na,nb,ma,mb,dist);

   bw = 0.5*(dac + dbc - dab );   

  return(bw);
}






double getdsum(nx,ny,mx,my,dist)
int nx,ny,*mx,*my;
double **dist;
{
int i,j,ni,nj;
double dxy;

  dxy=0.0;
  for(i=0; i<nx ; i++){
    for(j=0; j<ny ; j++){
      ni = mx[i];
      nj = my[j];
      smal(&ni,&nj);
      dxy += dist[ni][nj];
    }
  }
  dxy /= nx*ny;
  return(dxy);
}
     
smal(ni,nj)
int *ni,*nj;
{
int iw;
  if( *ni > *nj ){
     iw = *ni;
     *ni = *nj;
     *nj = iw;
   }
   return(0);
}


brestb(nseq,br,dist,ma,mb,mc,md)
int nseq,*ma,*mb,*mc,*md;
Branch **br;
double **dist;
{
int i,j;
int na,nb,nc,nd;
char *pa,*pb,*pc,*pd;
int fa,fb,fc,fd;
Branchptr ba,bb,bc,bd,be;
double getextb(),getintb();


  if( dflg == 1 ){
    printf("nseq=%d m a b c d %p %p %p %p   nseq %d\n",nseq,ma,mb,mc,md);
    printf("m a b c d  %p %p %p %p\n",&ma[nseq],&mb[nseq],&mc[nseq],&md[nseq]);
  }
  for(i=0; i<2*nseq-3 ; i++){
   if( dflg == 1 ) printf("i=%d nseq=%d br %p x %d y=%d\n",i,nseq,br[i],br[i]->tnodex->nkey,br[i]->tnodey->nkey);fflush(stdout);
   if( br[i]->tnodex->nkey <  nseq ){
                /* br[i]->tnodey -- N  */
      nc = 1;
      mc[0] = br[i]->tnodex->nkey;
     if( br[i]->tnodey->tnodex == br[i]->tnodex ){
         pa = br[i]->tnodey->by->partptr;
         pb = br[i]->tnodey->bz->partptr;
         if( br[i]->tnodey->by->tnodex == br[i]->tnodey ) fa = 0;
	 else fa = 1;
         if( br[i]->tnodey->bz->tnodex == br[i]->tnodey ) fb = 0;
	 else fb = 1;
       }
      if( br[i]->tnodey->tnodey == br[i]->tnodex ){
         pa = br[i]->tnodey->bx->partptr;
         pb = br[i]->tnodey->bz->partptr;
         if( br[i]->tnodey->bx->tnodex == br[i]->tnodey ) fa = 0;
	 else fa = 1;
         if( br[i]->tnodey->bz->tnodex == br[i]->tnodey ) fb = 0;
	 else fb = 1;
       }
      if( br[i]->tnodey->tnodez == br[i]->tnodex ){
         pa = br[i]->tnodey->bx->partptr;
         pb = br[i]->tnodey->by->partptr;
         if( br[i]->tnodey->bx->tnodex == br[i]->tnodey ) fa = 0;
	 else fa = 1;
         if( br[i]->tnodey->by->tnodex == br[i]->tnodey ) fb = 0;
	 else fb = 1;
       }
       if( fa == 1 ) geton(&na,ma,pa,nseq);
       else getoff(&na,ma,pa,nseq);
       if( fb == 1 ) geton(&nb,mb,pb,nseq);
       else getoff(&nb,mb,pb,nseq);
       br[i]->blengthb=getextb(na,nb,nc,ma,mb,mc,dist);     
      if( dflg == 1 ){
         printf("i=%d b x %d y %d ",i,br[i]->tnodex->nkey,br[i]->tnodey->nkey);
         printf("na =%d",na);
         for(j=0; j<na ; j++) printf(" %d",ma[j]);
         printf("\n");
         printf("nb =%d",nb);
         for(j=0; j<nb ; j++) printf(" %d",mb[j]);
         printf("\n");
         printf("nc =%d",nc);
         for(j=0; j<nc ; j++) printf(" %d",mc[j]);
         printf("\n");
         printf("i=%d b=%f\n",i,br[i]->blengthb);fflush(stdout);
       }

       continue;
    }


   if( br[i]->tnodey->nkey <  nseq ){
                /* br[i]->tnodey -- N  */
      nc = 1;
      mc[0] = br[i]->tnodey->nkey;
     if( br[i]->tnodex->tnodex == br[i]->tnodey ){
         pa = br[i]->tnodex->by->partptr;
         pb = br[i]->tnodex->bz->partptr;
         if( br[i]->tnodex->by->tnodex == br[i]->tnodey ) fa = 0;
	 else fa = 1;
         if( br[i]->tnodex->bz->tnodex == br[i]->tnodey ) fb = 0;
	 else fb = 1;
       }
      if( br[i]->tnodex->tnodey == br[i]->tnodey ){
         pa = br[i]->tnodex->bx->partptr;
         pb = br[i]->tnodex->bz->partptr;
         if( br[i]->tnodex->bx->tnodex == br[i]->tnodey ) fa = 0;
	 else fa = 1;
         if( br[i]->tnodex->bz->tnodex == br[i]->tnodey ) fb = 0;
	 else fb = 1;
       }
      if( br[i]->tnodey->tnodez == br[i]->tnodex ){
         pa = br[i]->tnodex->bx->partptr;
         pb = br[i]->tnodex->by->partptr;
         if( br[i]->tnodex->bx->tnodex == br[i]->tnodey ) fa = 0;
	 else fa = 1;
         if( br[i]->tnodex->by->tnodex == br[i]->tnodey ) fb = 0;
	 else fb = 1;
       }
       if( fa == 1 ) geton(&na,ma,pa,nseq);
       else getoff(&na,ma,pa,nseq);
       if( fb == 1 ) geton(&nb,mb,pb,nseq);
       else getoff(&nb,mb,pb,nseq);
       br[i]->blengthb =getextb(na,nb,nc,ma,mb,mc,dist);
       if( dflg == 1 ){
         printf("i=%d b x %d y %d ",i,br[i]->tnodex->nkey,br[i]->tnodey->nkey);
         printf("na =%d",na);
         for(j=0; j<na ; j++) printf(" %d",ma[j]);
         printf("\n");
         printf("nb =%d",nb);
         for(j=0; j<nb ; j++) printf(" %d",mb[j]);
         printf("\n");
         printf("nc =%d",nc);
         for(j=0; j<nc ; j++) printf(" %d",mc[j]);
         printf("\n");
         printf("i=%d b=%f\n",i,br[i]->blengthb);fflush(stdout);

       }
       
       continue;
    }
   if( dflg == 1 ) {
      printf("i=%d bx %d x %d y %d z %d   by %d x %d y %d z %d\n",i,br[i]->tnodex->nkey, 
      br[i]->tnodex->tnodex->nkey,br[i]->tnodex->tnodey->nkey,br[i]->tnodex->tnodez->nkey,
      br[i]->tnodey->nkey, 
      br[i]->tnodey->tnodex->nkey,br[i]->tnodey->tnodey->nkey,br[i]->tnodey->tnodez->nkey); fflush(stdout);
    }
   if( br[i]->tnodex->tnodex == br[i]->tnodey && br[i]->tnodey->tnodex == br[i]->tnodex ){
        ba = br[i]->tnodex->by;   
        bb = br[i]->tnodex->bz;   
        bc = br[i]->tnodey->by;   
        bd = br[i]->tnodey->bz;   
      }
   if( br[i]->tnodex->tnodex == br[i]->tnodey && br[i]->tnodey->tnodey == br[i]->tnodex ){
        ba = br[i]->tnodex->by;   
        bb = br[i]->tnodex->bz;   
        bc = br[i]->tnodey->bx;   
        bd = br[i]->tnodey->bz;   
      }
   if( br[i]->tnodex->tnodex == br[i]->tnodey && br[i]->tnodey->tnodez == br[i]->tnodex ){
        ba = br[i]->tnodex->by;   
        bb = br[i]->tnodex->bz;   
        bc = br[i]->tnodey->bx;   
        bd = br[i]->tnodey->by;   
      }
   if( br[i]->tnodex->tnodey == br[i]->tnodey && br[i]->tnodey->tnodex == br[i]->tnodex ){
        ba = br[i]->tnodex->bx;   
        bb = br[i]->tnodex->bz;   
        bc = br[i]->tnodey->by;   
        bd = br[i]->tnodey->bz;   
      }
   if( br[i]->tnodex->tnodey == br[i]->tnodey && br[i]->tnodey->tnodey == br[i]->tnodex ){
        ba = br[i]->tnodex->bx;   
        bb = br[i]->tnodex->bz;   
        bc = br[i]->tnodey->bx;   
        bd = br[i]->tnodey->bz;   
      }
     if( br[i]->tnodex->tnodey == br[i]->tnodey && br[i]->tnodey->tnodez == br[i]->tnodex ){
        ba = br[i]->tnodex->bx;   
        bb = br[i]->tnodex->bz;   
        bc = br[i]->tnodey->bx;   
        bd = br[i]->tnodey->by;   
      }
     if( br[i]->tnodex->tnodez == br[i]->tnodey && br[i]->tnodey->tnodex == br[i]->tnodex ){
        ba = br[i]->tnodex->bx;   
        bb = br[i]->tnodex->by;   
        bc = br[i]->tnodey->by;   
        bd = br[i]->tnodey->bz;   
      }
       if( br[i]->tnodex->tnodez == br[i]->tnodey && br[i]->tnodey->tnodey == br[i]->tnodex ){
        ba = br[i]->tnodex->bx;   
        bb = br[i]->tnodex->by;   
        bc = br[i]->tnodey->bx;   
        bd = br[i]->tnodey->bz;   
      }
       if( br[i]->tnodex->tnodez == br[i]->tnodey && br[i]->tnodey->tnodez == br[i]->tnodex ){
        ba = br[i]->tnodex->bx;   
        bb = br[i]->tnodex->by;   
        bc = br[i]->tnodey->bx;   
        bd = br[i]->tnodey->by;   
      }
    fa=fb=fc=fd=1;
    if( ba->tnodex == br[i]->tnodex ) fa=0;
    if( bb->tnodex == br[i]->tnodex ) fb=0;
    if( bc->tnodex == br[i]->tnodey ) fc=0;
    if( bd->tnodex == br[i]->tnodey ) fd=0;
/*    printf("f %d %d %d %d\n",fa,fb,fc,fd); fflush(stdout); */
    if( fa == 0 ) getoff(&na,ma,ba->partptr,nseq);
    if( fa == 1 ) geton(&na,ma,ba->partptr,nseq);
    if( fb == 0 ) getoff(&nb,mb,bb->partptr,nseq);
    if( fb == 1 ) geton(&nb,mb,bb->partptr,nseq);
    if( fc == 0 ) getoff(&nc,mc,bc->partptr,nseq);
    if( fc == 1 ) geton(&nc,mc,bc->partptr,nseq);
    if( fd == 0 ) getoff(&nd,md,bd->partptr,nseq);
    if( fd == 1 ) geton(&nd,md,bd->partptr,nseq);
    br[i]->blengthb =getintb(na,nb,nc,nd,ma,mb,mc,md,dist); 
    if( dflg == 1 ){
       printf("i=%d b x %d y %d ",i,br[i]->tnodex->nkey,br[i]->tnodey->nkey);
       printf("na =%d",na);
       for(j=0; j<na ; j++) printf(" %d",ma[j]);
       printf("\n");
       printf("nb =%d",nb);
       for(j=0; j<nb ; j++) printf(" %d",mb[j]);
       printf("\n");
       printf("nc =%d",nc);
       for(j=0; j<nc ; j++) printf(" %d",mc[j]);
       printf("\n");
       printf("nd =%d",nd);
       for(j=0; j<nd ; j++) printf(" %d",md[j]);
       printf("\n");
     }
/*    printf("f %d %d %d %d\n",fa,fb,fc,fd); fflush(stdout); */


 }
/*
   printf("brest end\n"); fflush(stdout);
*/
   return(0);
 }

rdseq(fpi,nseq,nsite,seq,seqnm)
FILE *fpi;
int nseq,nsite;
char **seq,**seqnm;
{
int i,cw,flg,fc,sc,flg1,cw1,seqc,sitec,cn;
/* flg  0   initial
        1   file name
        2   file name end
        3   sequence
   flg1 1   comment
 */
   cn=0;
   seqc=0;
   sitec=0;
   fc=0;
   sc=0;
   flg1=0;
   flg = 0;
   cw =0;
   cw1=0;
   for( ; ; ){
      cw1=cw;
      if( cw1 != EOF ) cw = getc(fpi);
      if( cw1 == EOF ) break;
      cn++;
      if( cn == 1 ) continue;
      if( cw1 == '/' && cw == '*' ){
          flg1 = 1;
          continue;
	}
      if( flg1 == 1 ) {
           if( cw1 == '*' && cw == '/' ){
               flg1=0;
	     }
            continue;
	 }
      

      switch(flg){
        case 0: if( cw1 == ' ' || cw1 == '\t' ) break;
                if( cw1 == '\n' ) break;
                flg=1;
                seqnm[seqc][fc]=cw1;
                fc++;
                break;
        case 1: if( cw1 == ' ' || cw1 == '\t' ) {
                  fc=0;
                  flg = 2;
                  break;
		}
                if( cw1 == '\n' ){
                   fprintf(ERR,"format error (1) in data file\n");
                   exit(1);
		 }
                seqnm[seqc][fc]=cw1;
                fc++;
                break;
        case 2: if( cw1 == ' ' || cw1 == '\t' ) break;
                if( cw1 == '\n' ){
                   fprintf(ERR,"format error (2) in data file\n");
                   exit(1);
		 }
                 flg=3;
                 seq[seqc][sc]=cw1;
                 sc++;
                 break;
         case 3: if( cw1 == '\n'){
                     if( sc != nsite ){
                        fprintf(stderr,"nsite is not the same %d (in seq %d)\n",sc,(seqc)+1);
                        exit(1);                                                                    }
                   seqc++;
                   flg=0;
                   sc=0;
                   fc=0;
                   break;
		   }
                 if( cw1 == ' ' || cw1 == '\t' ) break;
                 seq[seqc][sc]=cw1;
                 sc++;
                 break;
	default: break;
	}
     
    }
    if( sc != 0 ){
      if( sc != nsite ){
            fprintf(stderr,"nsite is not the same %d (in seq %d)\n",sc,seqc+1);
            exit(1);                                                                    }
      seqc++;
    }
   if( seqc != nseq ){
      printf("sequence number inconsistency seqc=%d nseq=%d\n",seqc,nseq);
      exit(1);
    }
   
/*   
   printf("rdseq seqc=%d\n",seqc);
   for(i=0; i<nseq ; i++) printf("%d %s\n",i+1,seqnm[i]);
*/
    return(0);
}






gettvalue(nseq,mseq,nmseq,tnodev,tvalues,nrepn)
int nseq,*mseq,nmseq,nrepn;
Tnode **tnodev;
float *tvalues;
{
int i,j,ndist,degrees;
double *delta,**deltav,dw,**B,**Temp,*dc,var,mean;
double *dvector(),**dmatrix();
char *dpm,*cvector(),cs;
float ttest();
/*   printf("gettvalue nmseq=%d\n",nmseq);*/
   for(i=0; i< nmseq ; i++){
/*       printf("dif %f sq %f\n",tnodev[mseq[i]]->havdifb,tnodev[mseq[i]]->havdifbsq); */
       tnodev[mseq[i]]->havdifb  /= nrepn;
       tnodev[mseq[i]]->havdifbsq /= nrepn;
       var = tnodev[mseq[i]]->havdifbsq - tnodev[mseq[i]]->havdifb*tnodev[mseq[i]]->havdifb;
       var *= nrepn;
       var /= nrepn-1;
       
       if( tnodev[mseq[i]]->havdif >= 0.0 ) mean = tnodev[mseq[i]]->havdif;
       else mean = -1.0*tnodev[mseq[i]]->havdif;
       tvalues[mseq[i]] = ttest(mean/sqrt(var));
       tnodev[mseq[i]]->dcount *= 100;
       tnodev[mseq[i]]->dcount /= nrepn;
       /*      printf("mseq[%d]=%d rtlength %f delta  %f se %f z=%f  tvalue=%f\n",i,mseq[i],tnodev[mseq[i]]->height,mean,sqrt(var),mean/sqrt(var),tvalues[mseq[i]]); FLUSH;*/

   }
    return(0);
}





prvalue(fpo,nseq,mseq,nmseq,tnodev,tvalues,seqname,nrepn)
FILE *fpo;
int nseq,*mseq,nmseq,nrepn;
Tnode **tnodev;
float *tvalues;
char **seqname;
{
int i,j,ndist,degrees;
char cw1;
double *delta,**deltav,dw,**B,**Temp,*dc,var,mean;
double *dvector(),**dmatrix();
char *dpm,*cvector(),cs,cw;

   cw = '%';
/*   printf("gettvalue nmseq=%d\n",nmseq);*/
   for(i=0; i< nmseq ; i++){
/*       printf("dif %f sq %f\n",tnodev[mseq[i]]->havdifb,tnodev[mseq[i]]->havdifbsq); */
       if( tnodev[mseq[i]]->havdif >= 0.0 ) mean = tnodev[mseq[i]]->havdif;
       else mean = -1.0*tnodev[mseq[i]]->havdif;
       var = tnodev[mseq[i]]->havdifbsq - tnodev[mseq[i]]->havdifb*tnodev[mseq[i]]->havdifb;
       var *= nrepn;
       var /= nrepn-1;
       if( tnodev[mseq[i]]->height - comm.dav > 0. ) cw1 = '+';
       if( tnodev[mseq[i]]->height - comm.dav < 0. ) cw1 = '-';
       if( tnodev[mseq[i]]->height - comm.dav <= 0.+ACU && tnodev[mseq[i]]->height - comm.dav >= 0. - ACU  ) cw1 = ' ';
       fprintf(fpo,"%2d %s %f delta %c %f se %f z=%f %2.0f%c\n",mseq[i],seqname[mseq[i]],tnodev[mseq[i]]->height,cw1,mean,sqrt(var),mean/sqrt(var),tvalues[mseq[i]]*100.,cw); FLUSH;

   }
    

return(0);
}


gethi(tnodea,tnodec)
Tnode *tnodea,*tnodec;
{
int i,flg;
Branchptr bw;
Tnode *tw;

  flg=0;
  if( tnodec->tnodex == tnodea ) flg=1;
  else if( tnodec->tnodey == tnodea){
           tw = tnodec->tnodey;
           tnodec->tnodey = tnodec->tnodex;
           tnodec->tnodex = tw;
           bw = tnodec->by;
           tnodec->by = tnodec->bx;
           tnodec->bx = bw;

           flg=2;
	 }
    else if( tnodec->tnodez == tnodea){
           tw = tnodec->tnodez;
           tnodec->tnodez = tnodec->tnodex;
           tnodec->tnodex = tw;
           bw = tnodec->bz;
           tnodec->bz = tnodec->bx;
           tnodec->bx = bw;
           flg=3;
	 }
     else{
        fprintf(ERR,"dcef node unmatch\n");
        exit(1);
      }

/*
     printf("dcef tnodea %d tnodec %d\n",tnodea->nkey,tnodec->nkey);
     fflush(stdout);

*/
     if( tnodec->tnodey != NULL ){
/*         printf("dcefy tnodea %d tnodec %d\n",tnodea->nkey,tnodec->nkey);
         fflush(stdout);
*/
          tnodec->tnodey->height = tnodec->height + tnodec->by->blength;
          if( tnodec->tnodey->nkey < comm.nseq ) comm.dav += tnodec->tnodey->height;

          gethi(tnodec,tnodec->tnodey);
       }

     if( tnodec->tnodez != NULL ){
/*         printf("dcefz tnodea %d tnodec %d\n",tnodea->nkey,tnodec->nkey);
         fflush(stdout); */
         tnodec->tnodez->height = tnodec->height + tnodec->bz->blength;
          if( tnodec->tnodez->nkey < comm.nseq ) comm.dav += tnodec->tnodez->height;
         gethi(tnodec,tnodec->tnodez);
       }
     if( tnodec->nkey < comm.nseq ){
/*         printf("comm.nseq=%d\n",comm.nseq); fflush(stdout); */
         comm.mseq[comm.ndwnseq] = tnodec->nkey;
         tnodec->dcount=0;
         tnodec->havdifb=0.0;
         tnodec->havdifbsq=0.0;
         comm.ndwnseq++;
/*         printf("comm.nseq=%d ndwnseq=%d\n",comm.nseq,comm.ndwnseq); fflush(stdout); */
       }

/*
        printf("dcef return tnodea %d tnodec %d\n",tnodea->nkey,tnodec->nkey); fflush(stdout);
*/
      return(0);
}



gethib(tnodea,tnodec)
Tnode *tnodea,*tnodec;
{
int i,flg;
Branchptr bw;
Tnode *tw;

  flg=0;
  if( tnodec->tnodex == tnodea ) flg=1;
  else if( tnodec->tnodey == tnodea){
           tw = tnodec->tnodey;
           tnodec->tnodey = tnodec->tnodex;
           tnodec->tnodex = tw;
           bw = tnodec->by;
           tnodec->by = tnodec->bx;
           tnodec->bx = bw;
           flg=2;
	 }
    else if( tnodec->tnodez == tnodea){
           tw = tnodec->tnodez;
           tnodec->tnodez = tnodec->tnodex;
           tnodec->tnodex = tw;
           bw = tnodec->bz;
           tnodec->bz = tnodec->bx;
           tnodec->bx = bw;
           flg=3;
	 }
     else{
        fprintf(ERR,"dcef node unmatch\n");
        exit(1);
      }


/*
     printf("dcef tnodea %d tnodec %d\n",tnodea->nkey,tnodec->nkey);
     fflush(stdout);
*/


     if( tnodec->tnodey != NULL ){
/*         printf("dcefy tnodea %d tnodec %d\n",tnodea->nkey,tnodec->nkey);
         fflush(stdout);
*/
          tnodec->tnodey->heightb = tnodec->heightb + tnodec->by->blengthb;
          if( tnodec->tnodey->nkey < comm.nseq ) comm.davb += tnodec->tnodey->heightb;

          gethib(tnodec,tnodec->tnodey);
       }

     if( tnodec->tnodez != NULL ){
/*         printf("dcefz tnodea %d tnodec %d\n",tnodea->nkey,tnodec->nkey);
         fflush(stdout); */
         tnodec->tnodez->heightb = tnodec->heightb + tnodec->bz->blengthb;
          if( tnodec->tnodez->nkey < comm.nseq ) comm.davb += tnodec->tnodez->heightb;
         gethib(tnodec,tnodec->tnodez);
       }
/*
        printf("dcef return tnodea %d tnodec %d\n",tnodea->nkey,tnodec->nkey); fflush(stdout);
*/
      return(0);
}

hddif(nseq,mseq,nmseq,tnodev,dav)
int nseq,*mseq,nmseq;
Tnode **tnodev;
double dav;
{
int i,j,ndist,degrees;
double *delta,**deltav,dw,**B,**Temp,*dc;
double *dvector(),**dmatrix();
char *dpm,*cvector(),cs;

   for(i=0; i< nmseq ; i++){
       tnodev[mseq[i]]->havdif = tnodev[mseq[i]]->height - dav;

/*       printf("mseq[%d]=%d height %f dav=%f\n",i,mseq[i],tnodev[mseq[i]]->height,dav); FLUSH; */
     }
    return(0);
}

hddifb(nseq,mseq,nmseq,tnodev,dav)
int nseq,*mseq,nmseq;
Tnode **tnodev;
double dav;
{
int i,j,ndist,degrees;
double *delta,**deltav,dw,**B,**Temp,*dc,dif;
double *dvector(),**dmatrix();
char *dpm,*cvector(),cs;
double getdv(),getdcvij();
   for(i=0; i< nmseq ; i++){
       
       dif = tnodev[mseq[i]]->heightb - dav;
       tnodev[mseq[i]]->havdifb += dif;
       tnodev[mseq[i]]->havdifbsq += dif*dif;
/*
       if( tnodev[mseq[i]]->havdif >= 0.0 && tnodev[mseq[i]]->havdifb > 0.0 )
         tnodev[mseq[i]]->dcount++;
       if( tnodev[mseq[i]]->havdif < 0.0 && tnodev[mseq[i]]->havdifb < 0.0 )
         tnodev[mseq[i]]->dcount++;
*/

/*        printf("%d dif %f count %d\n",i,dif,tnodev[mseq[i]]->dcount); */

     }


/*       printf("mseq[%d]=%d height %f dav=%f\n",i,mseq[i],tnodev[mseq[i]]->height,dav); FLUSH; */
    return(0);
}


chkoutg(nseq,parttbl,noutg,outg,tnodea,tnodec,branchv)
int nseq,noutg,*outg;
char **parttbl;
Tnode **tnodea,**tnodec;
Branch **branchv;
{
int i,j,iw,nx,ny,*mx,*my,flg;

  
/* printf("noutg=%d\n",noutg); */
 for(i=0; i<noutg ; i++){
   for(j=i+1; j<noutg ; j++){
      if( outg[i] > outg[j] ){
        iw = outg[i];
        outg[i] = outg[j];
        outg[j]=iw;
      }
    }
 }


  
  mx = ivector(nseq);
  my = ivector(nseq);
  for(i=0; i< 2*nseq-3; i++){
     getpart(&nx,mx,&ny,my,branchv[i]->partptr,nseq);
     if( nx == noutg ){
        flg=0;        
        for(j=0; j<nx ; j++){
          if( mx[j] != outg[j]-1 ) break;
          flg++;
	}
        if( flg == noutg ){
          *tnodea = branchv[i]->tnodex;
          *tnodec = branchv[i]->tnodey;
          free_ivector(mx,nseq);
          free_ivector(my,nseq);
          return(0);
	}

      }
     if( ny == noutg ){
        flg=0;        
        for(j=0; j<ny ; j++){
          if( my[j] != outg[j]-1 ) break;
          flg++;
	}
        if( flg == noutg ){
          *tnodea = branchv[i]->tnodey;
          *tnodec = branchv[i]->tnodex;
          free_ivector(mx,nseq);
          free_ivector(my,nseq);
          return(0);
	}
      }
   }
  free_ivector(mx,nseq);
  free_ivector(my,nseq);
   fprintf(ERR,"chkoutg   outgroups do not cluster\n");
   fprintf(ERR,"noutg=%d:\n",noutg);
   for(i=0; i<noutg ; i++){
     fprintf(ERR," %d",outg[i]);
    }
    fprintf(ERR,"\n");
   
   exit(1);
   
}


getpart(nx,mx,ny,my,part,nseq)
int *nx,*mx,*ny,*my,nseq;
char *part;
{
int i,j,nm,nn;
unsigned char cw,cs;
  
  (*nx) = 0;  (*ny) = 0;
  for(i=0; i<nseq ; i++){
     nm = i/8;
     nn = i%8;
     cw = 0x80;
     cw >>= nn;
     cs = cw & part[nm];
     if( cs != 0 ){
        mx[(*nx)] = i;
        (*nx)++;
      }else{
        my[(*ny)] = i;
        (*ny)++;
      }
   }

/*    printf("geton nx=%d\n",*nx); */
   return(0);
}


static float  Tdist[350]={
0.00,  0.01,  0.02,  0.03,  0.04,  0.05,  0.06,  0.07,  0.08,
0.09,  0.10,  0.11,  0.12,  0.13,  0.14,  0.15,  0.16,  0.17,  0.18,  0.19,
0.20,  0.21,  0.22,  0.23,  0.24,  0.25,  0.26,  0.27,  0.28,  0.29,  0.30,
0.31,  0.32,  0.33,  0.34,  0.35,  0.36,  0.37,  0.38,  0.39,  0.40,  0.41,
0.42,  0.43,  0.44,  0.45,  0.46,  0.47,  0.48,  0.49,  0.50,  0.51,  0.52,
0.53,  0.54,  0.55,  0.56,  0.57,  0.58,  0.59,  0.60,  0.61,  0.62,  0.63,
0.64,  0.65,  0.66,  0.67,  0.68,  0.69,  0.70,  0.71,  0.72,  0.73,  0.74,
0.75,  0.76,  0.77,  0.78,  0.79,  0.80,  0.81,  0.82,  0.83,  0.84,  0.85,
0.86,  0.87,  0.88,  0.89,  0.90,  0.91,  0.92,  0.93,  0.94,  0.95,  0.96,
0.97,  0.98,  0.99,  1.00,  1.01,  1.02,  1.03,  1.04,  1.05,  1.06,  1.07,
1.08,  1.09,  1.10,  1.11,  1.12,  1.13,  1.14,  1.15,  1.16,  1.17,  1.18,
1.19,  1.20,  1.21,  1.22,  1.23,  1.24,  1.25,  1.26,  1.27,  1.28,  1.29,
1.30,  1.31,  1.32,  1.33,  1.34,  1.35,  1.36,  1.37,  1.38,  1.39,  1.40,
1.41,  1.42,  1.43,  1.44,  1.45,  1.46,  1.47,  1.48,  1.49,  1.50,  1.51,
1.52,  1.53,  1.54,  1.55,  1.56,  1.57,  1.58,  1.59,  1.60,  1.61,  1.62,
1.63,  1.64,  1.65,  1.66,  1.67,  1.68,  1.69,  1.70,  1.71,  1.72,  1.73,
1.74,  1.75,  1.76,  1.77,  1.78,  1.79,  1.80,  1.81,  1.82,  1.83,  1.84,
1.85,  1.86,  1.87,  1.88,  1.89,  1.90,  1.91,  1.92,  1.93,  1.94,  1.95,
1.96,  1.97,  1.98,  1.99,  2.00,  2.01,  2.02,  2.03,  2.04,  2.05,  2.06,
2.07,  2.08,  2.09,  2.10,  2.11,  2.12,  2.13,  2.14,  2.15,  2.16,  2.17,
2.18,  2.19,  2.20,  2.21,  2.22,  2.23,  2.24,  2.25,  2.26,  2.27,  2.28,
2.29,  2.30,  2.31,  2.32,  2.33,  2.34,  2.35,  2.36,  2.37,  2.38,  2.39,
2.40,  2.41,  2.42,  2.43,  2.44,  2.45,  2.46,  2.47,  2.48,  2.49,  2.50,
2.51,  2.52,  2.53,  2.54,  2.55,  2.56,  2.57,  2.58,  2.59,  2.60,  2.61,
2.62,  2.63,  2.64,  2.65,  2.66,  2.67,  2.68,  2.69,  2.70,  2.71,  2.72,
2.73,  2.74,  2.75,  2.76,  2.77,  2.78,  2.79,  2.80,  2.81,  2.82,  2.83,
2.84,  2.85,  2.86,  2.87,  2.88,  2.89,  2.90,  2.91,  2.92,  2.93,  2.94,
2.95,  2.96,  2.97,  2.98,  2.99,  3.00,  3.01,  3.02,  3.03,  3.04,  3.05,
3.06,  3.07,  3.08,  3.09,  3.10,  3.11,  3.12,  3.13,  3.14,  3.15,  3.16,
3.17,  3.18,  3.19,  3.20,  3.21,  3.22,  3.23,  3.24,  3.25,  3.26,  3.27,
3.28,  3.29,  3.30,  3.31,  3.32,  3.33,  3.34,  3.35,  3.36,  3.37,  3.38,
3.39,  3.40,  3.41,  3.42,  3.43,  3.44,  3.45,  3.46,  3.47,  3.48,  3.49};

static float PP[350]={
0.5000,0.5040,0.5080,0.5120,0.5160,0.5199,0.5239,0.5279,0.5319,0.5359,0.5398,
0.5438,0.5478,0.5517,0.5557,0.5596,0.5636,0.5675,0.5714,0.5753,0.5793,0.5832,
0.5871,0.5910,0.5948,0.5987,0.6026,0.6064,0.6103,0.6141,0.6179,0.6217,0.6255,
0.6293,0.6331,0.6368,0.6406,0.6443,0.6480,0.6517,0.6554,0.6591,0.6628,0.6664,
0.6700,0.6736,0.6772,0.6808,0.6844,0.6879,0.6915,0.6950,0.6985,0.7019,0.7054,
0.7088,0.7123,0.7157,0.7190,0.7224,0.7257,0.7291,0.7324,0.7357,0.7389,0.7422,
0.7454,0.7486,0.7517,0.7549,0.7580,0.7611,0.7642,0.7673,0.7704,0.7738,0.7764,
0.7794,0.7823,0.7852,0.7881,0.7991,0.7939,0.7967,0.7995,0.8023,0.8051,0.8078,
0.8106,0.8133,0.8159,0.8186,0.8212,0.8238,0.8264,0.8289,0.8315,0.8340,0.8365,
0.8389,0.8413,0.8438,0.8461,0.8485,0.8508,0.8531,0.8554,0.8577,0.8599,0.8621,
0.8643,0.8665,0.8686,0.8708,0.8729,0.8749,0.8770,0.8790,0.8810,0.8830,0.8849,
0.8869,0.8888,0.8907,0.8925,0.8944,0.8962,0.8980,0.8997,0.9015,0.9032,0.9049,
0.9066,0.9082,0.9099,0.9115,0.9131,0.9147,0.9162,0.9177,0.9192,0.9207,0.9222,
0.9236,0.9251,0.9265,0.9279,0.9292,0.9306,0.9319,0.9332,0.9332,0.9345,0.9357,
0.9370,0.9382,0.9406,0.9418,0.9429,0.9441,0.9452,0.9463,0.9474,0.9484,0.9495,
0.9505,0.9515,0.9525,0.9535,0.9545,0.9554,0.9564,0.9573,0.9582,0.9591,0.9599,
0.9608,0.9616,0.9625,0.9633,0.9641,0.9649,0.9656,0.9664,0.9671,0.9678,0.9686,
0.9693,0.9699,0.9706,0.9713,0.9719,0.9726,0.9732,0.9738,0.9744,0.9750,0.9756,
0.9761,0.9767,0.9772,0.9778,0.9783,0.9788,0.9793,0.9798,0.9803,0.9808,0.9812,
0.9817,0.9821,0.9826,0.9830,0.9834,0.9838,0.9842,0.9846,0.9850,0.9854,0.9857,
0.9861,0.9864,0.9868,0.9871,0.9875,0.9878,0.9881,0.9884,0.9887,0.9890,0.9893,
0.9896,0.9898,0.9901,0.9904,0.9906,0.9909,0.9911,0.9913,0.9916,0.9918,0.9920,
0.9922,0.9925,0.9927,0.9929,0.9931,0.9932,0.9934,0.9936,0.9938,0.9940,0.9941,
0.9943,0.9945,0.9946,0.9948,0.9949,0.9950,0.9952,0.9953,0.9955,0.9956,0.9957,
0.9959,0.9960,0.9961,0.9962,0.9963,0.9964,0.9965,0.9967,0.9967,0.9968,0.9969,
0.9970,0.9971,0.9972,0.9972,0.9974,0.9974,0.9975,0.9976,0.9977,0.9977,0.9977,
0.9978,0.9979,0.9980,0.9980,0.9981,0.9981,0.9982,0.9983,0.9983,0.9984,0.9985,
0.9985,0.9986,0.9986,0.9987,0.9987,0.9987,0.9988,0.9988,0.9989,0.9989,0.9989,
0.9990,0.9990,0.9990,0.9990,0.9991,0.9991,0.9992,0.9992,0.9992,0.9992,0.9993,
0.9993,0.9993,0.9993,0.9994,0.9994,0.9994,0.9994,0.9994,0.9995,0.9995,0.9995,
0.9995,0.9995,0.9996,0.9996,0.9996,0.9996,0.9996,0.9996,0.9996,0.9997,0.9997,
0.9997,0.9997,0.9997,0.9997,0.9997,0.9997,0.9997,0.9998,0.9998};

float ttest(Value)
/***********************/
/*   float T_test(Value) */
/***********************/
float Value;
{
int i;
float Prob;
Prob = 0.;
if(Value < 0.) Value *= -1.;
i=349; while((float)Tdist[i] > (float)Value) i--; Prob = 2.*(PP[i]-0.5);
return Prob;
}



/* distance caluculation routines */
gmadis(dd,ntt,nts,ntv,gammaa)
double *dd,gammaa;
int ntt,nts,ntv;
{
double dp,dq,dc1,dc2,dnt,dw1,dw2;
double pow(),sqrt();
dnt=ntt;
dp=nts;
dp /= dnt;
dq = ntv;
dq /= dnt;

dw1 = pow(1.0-2.0*dp-dq,-1.0/gammaa);
dw2 = pow(1.0-2.0*dq,-1.0/gammaa);
*dd = gammaa*0.5*(dw1+0.5*dw2-1.5);
printf("gamma=%f %d %d %d\n",gammaa,ntt,nts,ntv);
return(0);
}


/* Tamura (3) diatance */
tm3dis(dd,cnh,ntt,nts,ntv)
double *dd;
int cnh[4][4],ntt,nts,ntv;
{
int i,j,ngc;
double p,q,dw,theta; /* theta: GC-content */
double da,db,dt,ds,dv,dl1,dl2;
double log(),sqrt();
dt=ntt;
ds=nts;
dv=ntv;
p=ds/dt;
q=dv/dt;

ngc=0;
for(i=0; i<4; i++){
  for(j=0; j<4 ; j++){
     if( i == 2 ) ngc += cnh[i][j];
     if( i == 3 ) ngc += cnh[i][j];
     if( j == 2 ) ngc += cnh[i][j];
     if( j == 3 ) ngc += cnh[i][j];
   }
}
theta = ngc;
theta /= 2.0*ntt;
dl1 = log(1.0-p/(2.0*theta*(1.0-theta))- q);
dl2= log(1.0-2.0*q);
*dd = -2.0*theta*(1.0-theta)*dl1-(1.0-2.0*theta*(1.0-theta))*dl2/2.0;
 return(0);
}      



/* calculate Tajima-Nei distance */
tndis(dd,cnh,ntt,ndif,nrep)
double *dd;
int cnh[4][4],ntt,ndif,nrep;
{
int i,j,nt,g[4];
extern double log(),sqrt();
double dw,dg[4],dnt,dc,db,dp,dt,dvar;


/* printf("nrep=%d\n",nrep); */
 
dt=ntt;
dp=ndif;
dp /= dt;
if( ndif == 0 ){
     *dd=0.0;
     return(0);
   }
for(i=0; i<4; i++) g[i]=0;
nt=0;
for(i=0; i<4; i++){
 for(j=0; j<4 ; j++){
    g[i] += cnh[i][j];
    g[j] += cnh[i][j];
    nt += 2*cnh[i][j];
  }
}

/* printf("dp=%f  g %d %d %d %d ",dp,g[0],g[1],g[2],g[3]);  */
dnt = nt;
for(i=0; i<4; i++){
  dg[i] = g[i];
  dg[i] /= dnt;
}

/* printf("gt=%f\n g=%d",dg[0]+dg[1]+dg[2]+dg[3],g[0]+g[1]+g[2]+g[3]); */
dc=0.0;
for(i=0; i<3; i++){
  for(j=i+1; j<4 ; j++){
     if( cnh[i][j]+cnh[j][i]  == 0 ) continue;
     dw = cnh[i][j]+cnh[j][i];
     dw /= dt;

     dc += dw*dw/(2.0*dg[i]*dg[j]);
   }
}
db = 1.0+dp*dp/dc;
for(i=0; i<4; i++) db -= dg[i]*dg[i];
db /= 2.0;
if( 1.0 - dp/db <= 0.0  + ACU ) return(-1);
 /* printf("dp=%f db=%f 1.0-dp/db %f\n",dp,db,1.0-dp/db); */

*dd = -db*log(1.0 - dp/db);

return(0);
}
/* calculate Jukes-Cantor distance */
int jcdis(dd,nt,nd)
double *dd;
int nd,nt;
{
double dn,dp,dva,log(),sqrt();
dn = nt;
dp  = nd;
dp /= dn;
if( 1.0-dp*4.0/3.0 <= 0.0 ) return(-1);
*dd = log(1.0-dp*4.0/3.0);
*dd *= -0.75;
/* printf("dd=%f dp=%f\n",*dd,dp); */
return(0);
}
/* calculate Kimura's two parameter distance */

int k2pdis(dd,nt,ns,nv)
double *dd;
int nt,ns,nv;
{
double dt,dn, da,db,dp,dq,log(),sqrt(),dva,dsq;
dp = ns;
dq = nv;
dt = nt;
dp /= dt;
dq /= dt;
/* printf("nt=%d ns=%d nv=%d\n",nt,ns,nv); */
if( 1.0 - 2.0*dq <= 0.0 ) return(-1);
if( 1.0-2.0*dp-dq <= 0.0 ) return(-1);
dsq = sqrt(1.0- 2.0*dq);
*dd = log((1.0-2.0*dp-dq)*dsq);

*dd *= -0.5;
return(0);
}


#include <sys/types.h>
#include <unistd.h>


/* RAND_MAX is a machine dependent constant, equal to the maximum value
 * random() can return (probably (2^31)-1 = 017777777777 octal).
 */
/* Get an integer to use as a seed for the random number generator */
int getseed()
{
  /****************************************************************
   getpid() returns an integer identifying the current process.  I
   am using this as a random number seed.
   ****************************************************************/
  pid_t getpid();
  int seed;

  seed = getpid();
/*  fprintf(stdout,"getseed(): seed=%d\n", seed); */
  return(seed);
}

#define M1 259200
#define IA1 7141
#define IC1 54773
#define RM1 (1.0/M1)
#define M2 134456
#define IA2 8121
#define IC2 28411
#define RM2 (1.0/M2)
#define M3 243000
#define IA3 4561
#define IC3 51349
/* generate uniform random number >= 0 && < 1 */
/* if you want generate random number from 0 to n-1
 *  multiply by n
 *  set *idum by any negative value. The sequence is reset.
 */
float ran1(idum)
int *idum;
{
static long ix1,ix2,ix3;
static float r[98];
float temp;
static int iff=0;
int j;

if( *idum < 0 || iff == 0 ){
   iff = 1;
   ix1 = (IC1 - (*idum)) % M1;
   ix1 = (IA1*ix1+IC1) % M1;
   ix2 = ix1 % M2;
   ix1 = (IA1*ix1+IC1) % M1;
   ix3 = ix1 % M3;
   for(j=1 ; j<97 ; j++){
     ix1 =(IA1*ix1+IC1) % M1;
     ix2 =(IA2*ix2+IC2) % M2;
     r[j] =(ix1+ix2*RM2)*RM1;
   }
   *idum = 1;
 }

 ix1 = (IA1*ix1+IC1) % M1;
 ix2 = (IA2*ix2+IC2) % M2;
 ix3 = (IA3*ix3+IC3) % M3;
 j = 1 + ((97*ix3)/M3);
 if( j > 97 || j < 1 ) {
   printf("ran1(): j = %d \n");
   exit(1);
 }
 temp = r[j];
 r[j]=(ix1 + ix2*RM2)*RM1;
 return(temp);
}









  























































main(argc,argv)
int argc;
char **argv;
{
int i,j,k;
int nseq,nsite,nasite,npsite,cdnpos[3];
int itc,ifc,iw,dop,maxnm;
double gamma;
char outfl[100],cw;
FILE *fpi,*fpt,*fpo=stdout;
Branch **branchv;
Tnode **tnodev,*tnodec,*tnodea;
double **distv,delq;
char **sequence,**seqname,**parttbl;
int *psite,*asite,**ndif,**ndif1,**nbal,rn,bootflg,*sitef;
int npsiteb,nrepn,nrep,ninap,*rsite,seed,seed1,*outg,noutg,ioutc,igin;
float fw;
float *tvalues;
extern float ran1();

itc=ifc=ioutc=igin=0;
dop = 0;
dflg = 0;
cdnpos[0]=cdnpos[1]=cdnpos[2]=1;
nrepn=1000;
ninap=0;
noutg=0;
gamma = 1.0;

seed = getseed();
        if( argc == 1 ){
            printf("branbst  inputfile -t[treefile] -d[distance] -o[outgroup] -c[codon position] -g[gamma a  value] -b[bootstrap replications] -s[seed]\n");
            printf("distance option\n");
            for(i=0; i<NDIST ; i++) printf("%d %s\n",i,dname[i]);
            exit(0);
	  }
        for(i=1; i<argc; i++){
           if(argv[i][0] == '-' ){
              switch(argv[i][1]){
                   case 'c' : cdnpos[0]=cdnpos[1]=cdnpos[2]=0;
                               if( argv[i][2] >= '0' && argv[i][2] <= '9' ) {
                                sscanf(argv[i]+2,"%d",&iw);
                                if( iw > 3 ){
                                    fprintf(ERR,"invalid codon position %d\n",iw);
                                    exit(1);
				  }
                                cdnpos[iw-1]=1;
                              }
                              for(j=i+1 ; j<argc ; j++){
                                if( argv[j][0] == '-' ) break;
                                if( argv[j][0] <= '3' && argv[j][0] >= '1' ){
                                   cdnpos[argv[j][0]-'1']=1;
                                   i++;
				 }
			      }
                             /* printf("cdnpos %d %d %d\n",cdnpos[0],cdnpos[1],cdnpos[2]); */
                              break;
                   case 'u' : if( (fpo = fopen(argv[i]+2,"w")) == NULL){
                                 fprintf(ERR,"Can't open file %s\n",argv[i]+2);
                                 exit(1);
			       }
                               break;
                   case 'o' :  ioutc=i;
                               if( argv[i][2] >= '0' && argv[i][2] <= '9' ) {
                                sscanf(argv[i]+2,"%d",&iw);
                                noutg++;
			      }
                              for(j=i+1 ; j<argc ; j++){
                                if( argv[j][0] == '-' ) break;
                                if( argv[j][0] <= '9' && argv[j][0] >= '0' ){
                                   i++;
                                   noutg++;
				 }
			      }
                               break;

                   case 's' : sscanf(argv[i]+2,"%d",&seed);
                              break;


                   case 'd' : if( argv[i][2] == 'b' ){
                                 sscanf(argv[i]+2,"%d",&dflg);
                                 break;
			       }
                              sscanf(argv[i]+2,"%d",&dop);
                              break;
                   case 'g' : if( argv[i][2] != 0 ) {
                                
                                sscanf(argv[i]+2,"%f",&fw);
                                gamma=fw;
                                igin=1;
                                break;
                              }else{
                               sscanf(argv[i+1],"%f",&fw);
                               gamma = fw;
                               igin=1;
                               i++;
                               break;
			      }
                   case 'b' : sscanf(argv[i]+2,"%d",&nrepn);
                              break;
                   case 't' : if( (fpt = fopen(argv[i]+2,"r")) == NULL ){
                                 printf("Can't open %s\n",argv[i]+2);
                                 exit(1);
			       }
                              itc=i;
                              break;
        
			      }
               }else{
                         if((fpi = fopen(argv[i],"r")) == NULL ){
                                 printf("Can't open file %s\n",argv[i]);
                                 exit(1);
                               }
                         strcpy(outfl,argv[i]);
                         strcat(outfl,".rb");
                         ifc=i;
		       }


         }
    if( ifc == 0 ){
       printf("input file is not specified\n");
       exit(1);

    }
    if( itc == 0 ){
       printf("topology file is not specified\n");
       exit(1);
    }
    if( ioutc == 0 || noutg == 0  ){
       printf("outgroup is not specified\n");
       exit(1);
    }
   if( dop >=  NDIST ) {
       printf("invalid distance option %d\n",dop);
       exit(1);
     }

    if( dop == 4 || dop == 7 || dop == 9 || dop == 14 || dop == 16 ) {
      if( igin == 0 ){
      printf("gamma parameter is not specified\n");
      exit(1);
    }
    }
   checkfl(fpi,&nseq,&nsite,&maxnm);
/*  memory allocation */
    if( dflg == 1){
      printf("nseq=%d nsite=%d maxnm=%d noutg=%d\n",nseq,nsite,maxnm,noutg); 
      fflush(stdout);
    }
    seqname = cmatrix(nseq,maxnm+1);
    sequence = cmatrix(nseq,nsite);
    parttbl = cmatrix(2*nseq-3,(nseq-1)/8+1);
    distv = dmatrix(nseq,nseq);
    nbal = imatrix(nseq,4);
    asite = ivector(nsite);
    psite = ivector(nsite);
    rsite = ivector(nsite);
    outg = ivector(noutg);
    sitef = ivector(nsite);
    branchv = brvector(2*nseq-3);
    tnodev = tnvector(2*nseq -2);
    comm.ma = ivector(nseq);
    comm.mb = ivector(nseq);
    comm.mc = ivector(nseq);
    comm.md = ivector(nseq);
    tvalues = fvector(nseq);
    if( dflg == 1) printf("m a b c d %p %p %p %p\n",comm.ma,comm.mb,comm.mc,comm.md);
    comm.nmseq = nseq - noutg;
    comm.mseq = ivector(comm.nmseq);
    iw = nseq*(nseq-1)/2;
    if( dflg == 1){
         printf("m a b c d %p %p %p %p\n",comm.ma,comm.mb,comm.mc,comm.md);
         printf("m a b c d %p %p %p %p\n",&comm.ma[nseq],&comm.mb[nseq],&comm.mc[nseq],&comm.md[nseq]);
       }
    if((fpi = freopen(argv[ifc],"r",fpi)) == NULL ){
       printf("Can't open file %s\n",argv[ifc]);
       exit(1);
    }
   for(i=0; i< 2*nseq-3 ; i++){
     for(j=0; j< (nseq-1)/8+1 ; j++){
       parttbl[i][j]=0;
     }
   }
   for(i=0; i<nseq ; i++) {
     tvalues[i] = -1.0;
     for(j=0; j< maxnm+1 ; j++) seqname[i][j]=0;
   }
   
   rdseq(fpi,nseq,nsite,sequence,seqname);
   rdtv(fpt,nseq,seqname,tnodev,branchv,maxnm,parttbl);
   fclose(fpi);
   fclose(fpt);
   checknode(nseq,tnodev,branchv);
   noutg=0;   
   if( argv[ioutc][2] >= '0' && argv[ioutc][2] <= '9' ) {
      sscanf(argv[ioutc]+2,"%d",&iw);
      if( iw > nseq  || iw < 1 ){
         fprintf(ERR,"invalid outgroup %d %s\n",iw,argv[ioutc]);
         exit(1);
       }
      outg[0]=iw;
      noutg++;
    }
    for(j=ioutc+1 ; j<argc ; j++){
         if( argv[j][0] == '-' ) break;
           if( argv[j][0] <= '9' && argv[j][0] >= '0' ){
               sscanf(argv[j],"%d",&iw);
               if( iw > nseq  || iw < 1 ){
                 fprintf(ERR,"invalid outgroup %d\n",iw);
                 exit(1);
               }
               outg[noutg]=iw;
               noutg++;
	     }
       }


    
   if( dop == 5 || dop == 6  || dop == 7 ){
    delchka(sequence,nseq,nsite,&npsite,&nasite,psite,asite,sitef);
    }else{
     delchk(sequence,nseq,nsite,&npsite,&nasite,psite,asite,cdnpos,sitef);
   }
   /*   srandom(seed); */
   seed1 = -seed;
   ran1(&seed1);
   comm.nseq = nseq;
   if( dflg == 1 ){
      fprintf(fpo,"/* sequence file: %s: treefile: %s  nseq=%d nsite=%d npsite=%d nasite=%d %s",argv[ifc],argv[itc]+2,nseq,nsite,npsite,nasite,dname[dop]);
      if( dop == 4 || dop == 7 || dop == 9 || dop == 14 || dop == 16 ) fprintf(fpo," a=%f",gamma);
      if( cdnpos[0]+cdnpos[1]+cdnpos[2] != 3 ){
        fprintf(fpo," codon position:");
        for(i=0; i<3 ; i++) if( cdnpos[i] == 1 ) fprintf(fpo," %d",i+1);
      }

      fprintf(fpo,"*/\n");
    }

   partition(tnodev[0], tnodev[0]->tnodex);
   if( dflg == 1) prpart(nseq,parttbl,branchv);fflush(stdout);
/*   printf("noutg=%d\n",noutg); */
   chkoutg(nseq,parttbl,noutg,outg,&tnodea,&tnodec,branchv);
   bootflg=0;
   rn=caldist(nseq,sequence,seqname,nasite,asite,npsite,psite,distv,dop,fpo,gamma,bootflg,nrep);
    if( rn != 0){
      printf("inapplicable distance\n");
      exit(1);
    }
/*
    printf("caldist end nseq=%d\n",nseq); fflush(stdout);
    for(i=0; i<nseq ; i++){
     for(j=i+1; j<nseq ; j++){
        printf("%d %d %f %f\n",i,j,distv[i][j],distv[j][i]);
      }
   }
*/
    brest(nseq,branchv,distv,comm.ma,comm.mb,comm.mc,comm.md);
    comm.ndwnseq=0;
    comm.dav=0.0; tnodec->height=0.0;
/*    printf("tnodea %d tnodec %d\n",tnodea->nkey,tnodec->nkey); */
    gethi(tnodea,tnodec);
/*    printf("dcef end comm.dav %f\n",comm.dav); fflush(stdout); */
    comm.dav /= comm.ndwnseq;
    hddif(nseq,comm.mseq,comm.nmseq,tnodev,comm.dav);

    bootflg=1;
    for(nrep=0; nrep < nrepn ;){
       ressite(nasite,asite,rsite,psite,&npsiteb,sitef,&seed1);
       rn=caldist(nseq,sequence,seqname,nasite,rsite,npsiteb,psite,distv,dop,fpo,gamma,bootflg,nrep);
       if( rn != 0 ) {
        ninap++;
        continue;
      }
       brestb(nseq,branchv,distv,comm.ma,comm.mb,comm.mc,comm.md);
       comm.davb=0.0; tnodec->heightb=0.0;
       gethib(tnodea,tnodec);
       comm.davb /= comm.ndwnseq;
/*       printf("nrep=%d  comm.davb %f\n",nrep,comm.davb); fflush(stdout); */
       hddifb(nseq,comm.mseq,comm.nmseq,tnodev,comm.davb);
       nrep++;
     }

    gettvalue(nseq,comm.mseq,comm.nmseq,tnodev,tvalues,nrepn);
/*    printf("gettvalue end\n"); fflush(stdout); */

    prtree(fpo,nseq,branchv,seqname,dop,cdnpos,nsite,nasite,npsite,nrepn,tvalues,tnodev);

   fprintf(fpo,"sequence file: %s: treefile: %s  nseq=%d nsite=%d npsite=%d nasite=%d %s",argv[ifc],argv[itc]+2,nseq,nsite,npsite,nasite,dname[dop]);
  if( dop == 4 || dop == 7 || dop == 9 || dop == 14 || dop == 16) fprintf(fpo," a=%f",gamma);
  if( cdnpos[0]+cdnpos[1]+cdnpos[2] != 3 ){
        fprintf(fpo," codon position:");
        for(i=0; i<3 ; i++) if( cdnpos[i] == 1 ) fprintf(fpo," %d",i+1);
      }
  fprintf(fpo,"\n\n");
    fprintf(fpo," %d bootstrap  seed=%d\n",nrepn,seed);
    fprintf(fpo,"outgroup:\n");
    for(i=0; i<noutg ; i++){
      fprintf(fpo,"%d %s\n",outg[i],seqname[outg[i]-1]);
    }

    fprintf(fpo,"\n");
    /*
     cw = '%';
     fprintf(fpo,"average root-to-tip length %f\n",comm.dav);
     for(i=0; i<comm.nmseq; i++){
       if( deltavw[i] >= 0.){
       fprintf(fpo,"%d %s delta %f (%f) Z=%f  %5.2f%c\n",comm.mseq[i]+1,seqname[comm.mseq[i]],delta[i],sqrt(deltavw[i]),delta[i]/sqrt(deltavw[i]),tvalues[comm.mseq[i]]*100.,cw);
     }else{
   fprintf(fpo,"%d %s delta %f V=%f Z=NA\n",comm.mseq[i]+1,seqname[comm.mseq[i]],delta[i],deltavw[i]);
 }
   fprintf(fpo,"Q=%f\n",delq); fflush(fpo);
   */

    fprintf(fpo,"average root-to-tip distance:%f\n",comm.dav);
    prvalue(fpo,nseq,comm.mseq,comm.nmseq,tnodev,tvalues,seqname,nrepn);

   
    if( dflg == 1) printf("prpart end nseq=%d anseq %p\n",nseq,&nseq); fflush(stdout);
    if( dflg == 1 ) printf("prtree end nseq=%d\n",nseq); fflush(stdout);
    free_cmatrix(seqname,nseq,maxnm);
    free_cmatrix(sequence,nseq,nsite);
    free_cmatrix(parttbl,2*nseq-3,nseq/8+1);
    free_dmatrix(distv,nseq,nseq);
    free_imatrix(nbal,nseq,4);
    free_ivector(asite,nsite);
    free_ivector(psite,nsite);
    free_ivector(rsite,nsite);
    free_ivector(sitef,nsite);
    free_brvector(branchv,2*nseq-3);
    free_tnvector(tnodev,2*nseq -2);
    free_ivector(comm.ma,nseq);
    free_ivector(comm.mb,nseq);
    free_ivector(comm.mc,nseq);
    free_ivector(comm.md,nseq);
    free_ivector(tvalues,nseq);
    free_ivector(comm.mseq,comm.nmseq);

    exit(0);
}






