#include <stdio.h>
#include <string.h>
#include <math.h>
/* #include <malloc.h> */
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>
#define NDIST 15
#define ACU  0.0000000001
#define TINY  0.0000000001
#define ACUB 0.0000001
#define DEL  4
#define DEL1  6
#define DELA  20
#define DELA1  22
#define MISS 5
#define MISSA 21
#define ERR   stdout
#define FLUSH  fflush(stdout)
typedef struct branch *Branchptr;
typedef struct tnode *Tnodeptr;
typedef struct tnode {
   int nkey;
   Tnodeptr tnodex,tnodey,tnodez;
   Branchptr bx,by,bz;
   double *dcoef,height;
} Tnode;
typedef struct branch {
  int nkey,nbtbp;
  double blength0,blength,bvar;
  float bprob;
  Tnodeptr tnodex,tnodey;
  char *partptr;
} Branch;
struct com{
      int nseq,*ma,*mb,*mc,*md;
      int ndwnseq,nmseq,*mseq;
      int covflg,fpcov;
      double *davcf,dav;
    };
extern float *fvector();
extern int *ivector(),**imatrix();
extern char *cvector(),**cmatrix();
extern double *dvector(),*dvectorc(),**dmatrix();
extern Tnode **tnvector();
extern Branch **brvector();

extern int tr1[4][4],tr[4][4],trp[5][5],dflg;
extern char base[11];
extern char amn[26];
extern char *dname[NDIST];
extern struct com comm;









int dflg;
int tr1[4][4]={0,2,3,3,
               2,0,3,3,
               3,3,0,1,
               3,3,1,0};

int tr[4][4]={-1, 0, 1, 1,
               0,-1, 1, 1,
               1, 1,-1, 0,
               1, 1, 0,-1};
int trp[5][5]={-1,0 ,0,0,0,
                0,-1,0,0,0,
                0,0,-1,0,0,
                0,0,0,-1,0,
                0,0,0,0,-1};
char base[11]={'A','T','G','C','-','*','X','?','N','R','Y'};
char amn[26]={'A','C','D','E','F','G','H','I','K','L','M','N','P','Q',
                     'R','S','T','V','W','Y','-','?','*','X','B','Z'};
char *dname[NDIST]={"p-distance","JC-distance","K2P-distance",
                           "amino acid p-distance",
                           "amino acid Poisson correction",
                           "JC distance gamma",
                           "K2P distance gamma",
                           "amino acid gamma","Tajima and Nei","V K2P",
                           "V K2P gamma","V Hasegawa","V Hasegawa gamma",
                           "Tamura Nei","Tamura Nei gamma"};

struct com comm;





int *ivector(n)
int n;
{
int *vp;

   vp = (int *)malloc((unsigned) n*sizeof(int));
   if( !vp ) {
       fprintf(ERR,"memory allocation error\n");
       fprintf(ERR,"integer vector[%d]\n",n);
       exit(1);
     }
    return(vp);
}
char *cvector(n)
int n;
{
char *vp;

   vp = (char *)malloc((unsigned) n*sizeof(char));
   if( !vp ) {
       fprintf(ERR,"memory allocation error\n");
       fprintf(ERR,"char vector[%d]\n",n);
       exit(1);
     }
    return(vp);
}


float *fvector(n)
int n;
{
float *vp;

   vp = (float *)malloc((unsigned) n*sizeof(float));
   if( !vp ) {
       fprintf(ERR,"memory allocation error\n");
       fprintf(ERR,"char vector[%d]\n",n);
       exit(1);
     }
    return(vp);
}

double *dvector(n)
int n;
{
double *vp;

   vp = (double *)malloc((unsigned) n*sizeof(double));
   if( !vp ) {
       fprintf(ERR,"memory allocation error\n");
       fprintf(ERR,"double vector[%d]\n",n);
       exit(1);
     }
    return(vp);
}
double *dvectorc(n,covflg)
int n,*covflg;
{
double *vp;

   vp = (double *)malloc((unsigned) n*sizeof(double));
   if( !vp ) {
     /*
       fprintf(ERR,"memory allocation error\n");
       fprintf(ERR,"double vector[%d]\n",n);
       */
       *covflg=1;
     }
    return(vp);
}

int **imatrix(n1,n2)
int n1,n2;
{
int i,**ip;

 ip = (int **) malloc((unsigned ) n1*sizeof(int*) );
 if( !ip ) {
    fprintf(ERR,"memory allocation error\n");
    fprintf(ERR,"step1 integer matrix %d %d\n",n1,n2);
    exit(1);
  }
 for(i=0; i<n1 ; i++){
   ip[i] = (int *) malloc((unsigned) n2*sizeof(int));
   if( !ip[i] ) {
    fprintf(ERR,"memory allocation error\n");
    fprintf(ERR,"step2(i=%d) integer matrix %d %d\n",i,n1,n2);
    exit(1);

  }
 }
 
  return(ip);
				 
}




char **cmatrix(n1,n2)
int n1,n2;
{
int i;
char **ip;

 ip = (char **) malloc((unsigned ) n1*sizeof(char*) );
 if( !ip ) {
    fprintf(ERR,"memory allocation error\n");
    fprintf(ERR,"step1 char matrix %d %d\n",n1,n2);
    exit(1);
  }
 for(i=0; i<n1 ; i++){
   ip[i] = (char *) malloc((unsigned) n2*sizeof(char));
   if( !ip[i] ) {
    fprintf(ERR,"memory allocation error\n");
    fprintf(ERR,"step2(i=%d) integer matrix %d %d\n",i,n1,n2);
    exit(1);

  }
 }
 
  return(ip);
				 
}


double **dmatrix(n1,n2)
int n1,n2;
{
int i;
double **ip;

 ip = (double **) malloc((unsigned ) n1*sizeof(double*) );
 if( !ip ) {
    fprintf(ERR,"memory allocation error\n");
    fprintf(ERR,"step1 char matrix %d %d\n",n1,n2);
    exit(1);
  }
 for(i=0; i<n1 ; i++){
   ip[i] = (double *) malloc((unsigned) n2*sizeof(double));
   if( !ip[i] ) {
    fprintf(ERR,"memory allocation error\n");
    fprintf(ERR,"step2(i=%d) double matrix %d %d\n",i,n1,n2);
    exit(1);

  }
 }
 
  return(ip);
				 
}


Tnode **tnvector(n)
int n;
{
int i;
Tnode **ip;

 ip = (Tnode **) malloc((unsigned ) n*sizeof(Tnode*) );
 if( !ip ) {
    fprintf(ERR,"memory allocation error\n");
    fprintf(ERR,"Tnode step1 %d\n",n);
    exit(1);
  }
 for(i=0; i<n ; i++){
   ip[i] = (Tnode *) malloc(sizeof(Tnode));
   if( !ip[i] ) {
    fprintf(ERR,"memory allocation error\n");
    fprintf(ERR,"step2(i=%d) Tnode %d\n",i,n);
    exit(1);

  }
 }
 
  return(ip);
				 
}


Branch **brvector(n)
int n;
{
int i;
Branch **ip;

/*  printf("n=%d\n",n); */
 ip = (Branch **) malloc((unsigned ) n*sizeof(Branch*) );
 if( !ip ) {
    fprintf(ERR,"memory allocation error\n");
    fprintf(ERR,"Branch step1 %d\n",n);
    exit(1);
  }
 for(i=0; i<n ; i++){
   ip[i] = (Branch *) malloc(sizeof(Branch));
   if( !ip[i] ) {
    fprintf(ERR,"memory allocation error\n");
    fprintf(ERR,"step2(i=%d) Tnode %d\n",i,n);
    exit(1);
   }
/*
   ip[i]->partptr = (char *) malloc( (unsigned ) ((n1-1)/8+1)*sizeof(char));
   if( !(ip[i]->partptr) ) {
     fprintf(ERR,"memory allocation error\n");
     fprintf(ERR,"Branch step3 %d\n",i);
     exit(1);
   }
*/
 }
 
  return(ip);
				 
}

void free_ivector(v,n)
int *v,n;
{
   free((char*) v );
   return ;
 }

void free_fvector(v,n)
float *v;
int n;
{
   free((char*) v );
   return ;
 }

void free_dvector(v,n)
double *v;
int n;
{
   free((char*) v );
   return ;
 }


void free_cvector(v,n)
char *v;
int n;
{
   free((char*) v );
   return ;
 }


void free_cmatrix(m,n1,n2)
char **m;
int n1,n2;
{
int i;

    for(i=n1-1 ; i >= 0 ; i-- ){
       free((char *) (m[i]));
     }
    free((char *) m);
}

void free_imatrix(m,n1,n2)
int  **m;
int n1,n2;
{
int i;

    for(i=n1-1 ; i >= 0 ; i-- ){
       free((char *) (m[i]));
     }
    free((char *) m);
}


void free_dmatrix(m,n1,n2)
double  **m;
int n1,n2;
{
int i;

    for(i=n1-1 ; i >= 0 ; i-- ){
       free((char *) (m[i]));
     }
    free((char *) m);
}


void free_tnvector(ip,n)
Tnode **ip;
int n;
{
int i;


 for(i=n-1; i=0 ; i--){
   free((char*) ip[i]);
 }
 free((char *)ip); 
  return ;
				 
}

void free_brvector(ip,n)
Branch **ip;
int n;
{
int i;


 for(i=n-1; i=0 ; i--){
   free((char*) ip[i]->partptr);
   free((char*) ip[i]);
 }
 free((char *)ip); 
 return;
}


checkfl(fpi,nseq,nsite,maxnm)
FILE *fpi;
int *nseq,*nsite,*maxnm;
{
int cw,flg,fc,sc,flg1,cw1;
/* flg  0   initial
        1   file name
        2   file name end
        3   sequence
   flg1 1   comment
 */

   *nseq=0;
   *nsite =0;
   *maxnm=0;
   fc=0;
   sc=0;
   flg1=0;
   flg = 0;
   cw =0;
   cw1=0;
   for( ; ; ){
      cw1=cw;
      if( cw1 != EOF ) cw = getc(fpi);
      if( cw1 == EOF ) break;
      if( cw1 == '/' && cw == '*' ){
          flg1 = 1;
          continue;
	}
      if( flg1 == 1 ) {
           if( cw1 == '*' && cw == '/' ){
               flg1=0;
	     }
            continue;
	 }
      switch(flg){
        case 0: if( cw1 == ' ' || cw1 == '\t' ) break;
                if( cw1 == '\n' ) break;
                flg=1;
                fc++;
                break;
        case 1: if( cw1 == ' ' || cw1 == '\t' ) {
                  if( fc > *maxnm ) *maxnm=fc;
                  fc=0;
                  flg = 2;
                  break;
		}
                if( cw1 == '\n' ){
                   fprintf(ERR,"format error (1) in data file\n");
                   exit(1);
		 }
                fc++;
                break;
        case 2: if( cw1 == ' ' || cw1 == '\t' ) break;
                if( cw1 == '\n' ){
                   fprintf(ERR,"format error (2) in data file\n");
                   exit(1);
		 }
                 flg=3;
                 sc++;
                 break;
         case 3: if( cw1 == '\n'){
                   if( *nseq == 0 ) {
                     *nsite = sc;
                   }else{
                     if( sc != *nsite ){
                        fprintf(ERR,"nsite is not the same %d (in seq %d)\n",sc,(*nseq)+1);
                        exit(1);                                                                    }
                   }
                   (*nseq)++;
                   flg=0;
                   sc=0;
                   fc=0;
                   break;
		 }
                 if( cw1 == ' ' || cw1 == '\t' ) break;
                 sc++;
	}
     
    }
    if( sc != 0 ){
      if( sc != *nsite ){
            fprintf(ERR,"nsite is not the same %d (in seq %d)\n",sc,(*nseq)+1);
            exit(1);                                                                    }
      (*nseq)++;
    }
    return(0);
}


getseq(fpi,nseq,nsite,seq,seqnm)
FILE *fpi;
int nseq,nsite;
char **seq,**seqnm;
{
int cw,flg,fc,sc,flg1,cw1,seqc,sitec,cn;
/* flg  0   initial
        1   file name
        2   file name end
        3   sequence
   flg1 1   comment
 */
   cn=0;
   seqc=0;
   sitec=0;
   fc=0;
   sc=0;
   flg1=0;
   flg = 0;
   cw =0;
   cw1=0;
   for( ; ; ){
      cw1=cw;
      if( cw1 != EOF ) cw = getc(fpi);
      if( cw1 == EOF ) break;
      if( cn == 0 ) continue;
      cn++;
      if( cw1 == '/' && cw == '*' ){
          flg1 = 1;
          continue;
	}
      if( flg1 == 1 ) {
           if( cw1 == '*' && cw == '/' ){
               flg1=0;
	     }
            continue;
	 }
      switch(flg){
        case 0: if( cw1 == ' ' || cw1 == '\t' ) break;
                if( cw1 == '\n' ) break;
                flg=1;
                seqnm[seqc][fc]=cw1;
                fc++;
                break;
        case 1: if( cw1 == ' ' || cw1 == '\t' ) {
                  fc=0;
                  flg = 2;
                  break;
		}
                if( cw1 == '\n' ){
                   fprintf(stderr,"format error (1) in data file\n");
                   exit(1);
		 }
                seqnm[seqc][fc]=cw1;
                fc++;
                break;
        case 2: if( cw1 == ' ' || cw1 == '\t' ) break;
                if( cw1 == '\n' ){
                   fprintf(stderr,"format error (2) in data file\n");
                   exit(1);
		 }
                 flg=3;
                 seq[seqc][sc]=cw1;
                 sc++;
                 break;
         case 3: if( cw1 == '\n'){
                     if( sc != nsite ){
                        fprintf(stderr,"nsite is not the same %d (in seq %d)\n",sc,(seqc)+1);
                        exit(1);                                                                    }
                   seqc++;
                   flg=0;
                   sc=0;
                   fc=0;
                   break;
		 }
                 if( cw1 == ' ' || cw1 == '\t' ) break;
                 seq[seqc][sc]=cw1;
                 sc++;
	}
     
    }
    if( sc != 0 ){
      if( sc != nsite ){
            fprintf(stderr,"nsite is not the same %d (in seq %d)\n",sc,seqc+1);
            exit(1);                                                                    }
      seqc++;
    }
   if( seqc != nseq ){
      printf("sequence number inconsistency seqc=%d nseq=%d\n",seqc,nseq);
      exit(1);
    }
    return(0);
}



rdtv(fp,nseq,fl,nda,blen,maxnm,parttbl,dcf) 
Tnode **nda;
FILE *fp;
int nseq,maxnm;
Branch **blen;
char **fl,**parttbl;
double **dcf;
{
int i,j, rn,n,nw,n1,n2,n3,bstn,nl,bc,nseqw;
char b[1000],bw[200],bw1[200];
float fw,fw1,fw2;


    for(i=0; i<1000 ; i++) b[i]=0;
    for(i=0; i<200 ; i++) bw[i]=0;
    for(i=0; i<200 ; i++) bw1[i]=0;
/*
    printf("rdtv nseq=%d\n",nseq);
    for(i=0; i<nseq ; i++){
       printf("%d %s\n",i+1,fl[i]);
     }
*/
    nl=0;
    bc = 0;

   for(i=0; i< 2*nseq -2 ; i++){
       nda[i]->nkey = i;
       nda[i]->tnodex = NULL;
       nda[i]->tnodey = NULL;
       nda[i]->tnodez = NULL;
       nda[i]->bx = NULL;
       nda[i]->by = NULL;
       nda[i]->bz = NULL;
       nda[i]->height = 0.0;
       nda[i]->dcoef = dcf[i];
     }
   for(i=0; i< 2*nseq -3 ; i++){
        blen[i]->nkey = i;
        blen[i]->nbtbp = 0;
        blen[i]->blength0=-999999.9;
        blen[i]->blength =-999999.9;
        blen[i]->tnodex=NULL;
        blen[i]->tnodey=NULL;
        blen[i]->partptr=parttbl[i];
      }
   for(i=0; i<200; i++){
       bw[i]=bw1[i]=0;
     }
   for( ; ; ){
     for(i=0; i<1000 ; i++) b[i]=0;
     rn=rdline(fp,b,&n);
     nl++;
/*     printf("nl=%d\n",nl); */


     if( rn == 2 ) continue;
     if( rn == 1 ){
        printf("first line read error\n");
        exit(1);
    }
     break;
   }
   for(i=0; i<200 ; i++) bw[i]=0;
   for(i=0; i<200 ; i++) bw1[i]=0;
   sscanf(b,"%d %s %d %s\n",&nseqw,bw,&bstn,bw1);
   if( strcmp(bw,"sequences") != 0 && strcmp(bw,"otus") !=  0){
      printf("first line invalid format nseq=%d %s %d %s\n",nseqw,bw,bstn,bw1);
      exit(1);
    }
   if( nseqw != nseq ){
       printf("number of sequences inconsistent %d (data) %d (treefile)\n",nseq,nseqw);
       exit(1);
     }
   for(i=0; i< nseqw ; i++){
     zeroc(b,1000);
     if( (rn=rdline(fp,b,&n)) != 0 ){
        printf("sequence names read error\n");
      }
     nl++;
/*     printf("nl=%d\n",nl); */

       zeroc(bw,200);
       getname(&nw,bw,b,n,maxnm);
/*     sscanf(b,"%d %s",&nw,bw); */     
      if( nw != i+1 ){
        printf("sequence number read error %d %d\n",nw,i+1);
        exit(1);
      }
      nw = strlen(bw);
      if( nw > maxnm){
        printf("sequence name too long %s\n",bw);
        exit(1);
      }

      if( strcmp(fl[i],bw) != 0 ) {
         printf("sequence name inconsistency %d fl:%s bw:%s:\n",i+1,fl[i],bw);
         exit(1);
       }
/*       strcpy(fl[i],bw); */
/*       printf("bw %s fl %s\n",bw,fl[i]); */
   }
/*  printf("bootstap =%d\n",comm.bstflg); */
  for(i=0; i< 2*(nseqw)-3 ; i++){
     for( ; ; ){
        zeroc(b,1000);
        rn = rdline(fp,b,&n);
        nl++;
/*        printf("nl=%d\n",nl); */
        if( rn == 2 ) continue;
        if( rn == 1 ){
             printf("format error\n");
              exit(1);
	   }
         break;
     }
            sscanf(b,"%d and %d %f",&n1,&n2,&fw);
            if( n1 < 1 || n1 > 2*nseq-2 ){
                 fprintf(ERR,"invalid node number %d\n",n1);
                 exit(1);
	       }

            if( n2 < 1 || n2 > 2*nseq-2 ){
                 fprintf(ERR,"invalid node number %d\n",n2);
                 exit(1);
	       }
            blen[bc]->blength0 = fw;
            blen[bc]->tnodex = nda[n1-1];
            blen[bc]->tnodey = nda[n2-1];
            if( n1 <= nseq ){
                nda[n1-1]->tnodex = nda[n2-1];
                nda[n1-1]->bx = blen[bc];
	      }else{
                if( nda[n1-1]->tnodex == NULL ){
                      nda[n1-1]->tnodex = nda[n2-1];
                      nda[n1-1]->bx = blen[bc];
		    }else if( nda[n1-1]->tnodey == NULL ){
                      nda[n1-1]->tnodey = nda[n2-1];
                      nda[n1-1]->by = blen[bc];
		    }else if( nda[n1-1]->tnodez == NULL ){
                      nda[n1-1]->tnodez = nda[n2-1];
                      nda[n1-1]->bz = blen[bc];
		    }
	      }
            if( n2 <= nseq ){
                nda[n2-1]->tnodex = nda[n1-1];
                nda[n2-1]->bx = blen[bc];
	      }else{
                if( nda[n2-1]->tnodex == NULL ){
                      nda[n2-1]->tnodex = nda[n1-1];
                      nda[n2-1]->bx = blen[bc];
		    } else if( nda[n2-1]->tnodey == NULL ){
                      nda[n2-1]->tnodey = nda[n1-1];
                      nda[n2-1]->by = blen[bc];
		    }else if( nda[n2-1]->tnodez == NULL ){
                      nda[n2-1]->tnodez = nda[n1-1];
                      nda[n2-1]->bz = blen[bc];
		    }
	      }
              bc++;
   }

    
   return(0);
}
checknode(nseq,nda,blen)
int nseq;
Branch **blen;
Tnode **nda;
{
int i,j,*nd,*br,flg;
int *ivector();

  nd = ivector(2*nseq-2);
  br = ivector(2*nseq-3);
  for(i=0; i<2*nseq-2 ; i++) nd[i]=0;
  for(i=0; i<2*nseq-3 ; i++) br[i]=0;
  /* external nodes */
 if( dflg == 1){
    for(i=0; i<2*nseq -2 ; i++){
       printf("node %d",nda[i]->nkey);
       if( nda[i]->tnodex != NULL ) printf(" x %d",nda[i]->tnodex->nkey);
       if( nda[i]->tnodey != NULL ) printf(" y %d",nda[i]->tnodey->nkey);
       if( nda[i]->tnodez != NULL ) printf(" z %d",nda[i]->tnodez->nkey);
       printf("\n");
   }
  }
  for(i=0; i< nseq ; i++){
    nd[nda[i]->tnodex->nkey]++;
    if( nda[i]->tnodey != NULL ){
        fprintf(ERR,"topology file format error (1)\n");
        exit(1);
      }
    if( nda[i]->tnodez != NULL ){
        fprintf(ERR,"topology file format error (2)\n");
        exit(1);
      }
    flg=0;
    if( nda[i]->tnodex->tnodex == nda[i] ) flg++;
    if( nda[i]->tnodex->tnodey == nda[i] ) flg++;
    if( nda[i]->tnodex->tnodez == nda[i] ) flg++;
    if( flg != 1 ){
        fprintf(ERR,"i=%d topology file format error (3) flg=%d tnodex=%d nda[i]->nkey=%d\n",i,flg,nda[i]->tnodex->nkey,nda[i]->nkey);
        exit(1);
      }
    flg=0;
    if( dflg == 1) printf("b  i=%d  x=%d  y=%d\n",nda[i]->nkey,nda[i]->bx->tnodex->nkey,nda[i]->bx->tnodey->nkey);

    if(( nda[i]->bx->tnodex  == nda[i] && nda[i]->bx->tnodey == nda[i]->tnodex)
    || ( nda[i]->bx->tnodey  == nda[i] && nda[i]->bx->tnodex == nda[i]->tnodex)
    ) flg=1;
    if( flg == 0 ){
        fprintf(ERR,"topology file format error (4)\n");
        exit(1);
      }
     br[nda[i]->bx->nkey]++;
  }
  /* internal nodes */
   for(i=nseq ; i< 2*nseq-2 ; i++){
     if( nda[i]->tnodex == NULL ){
        fprintf(ERR,"topology file format error (5)\n");
        exit(1);
      }
     if( nda[i]->tnodey == NULL ){
        fprintf(ERR,"topology file format error (6)\n");
        exit(1);
      }
     if( nda[i]->tnodez == NULL ){
        fprintf(ERR,"topology file format error (7)\n");
        exit(1);
      }
      nd[nda[i]->tnodex->nkey]++;
      nd[nda[i]->tnodey->nkey]++;
      nd[nda[i]->tnodez->nkey]++;
      flg=0;
      if( nda[i]->tnodex->tnodex == nda[i] ) flg++;
      if( nda[i]->tnodex->tnodey == nda[i] ) flg++;
      if( nda[i]->tnodex->tnodez == nda[i] ) flg++;
      if( flg != 1 ){
        fprintf(ERR,"topology file format error (8)\n");
        exit(1);
      }
      flg=0;
      if( nda[i]->tnodey->tnodex == nda[i] ) flg++;
      if( nda[i]->tnodey->tnodey == nda[i] ) flg++;
      if( nda[i]->tnodey->tnodez == nda[i] ) flg++;
      if( flg != 1 ){
        fprintf(ERR,"topology file format error (9)\n");
        exit(1);
      }

      flg=0;
      if( nda[i]->tnodez->tnodex == nda[i] ) flg++;
      if( nda[i]->tnodez->tnodey == nda[i] ) flg++;
      if( nda[i]->tnodez->tnodez == nda[i] ) flg++;
      if( flg != 1 ){
        fprintf(ERR,"topology file format error (10)\n");
        exit(1);
      }
      br[nda[i]->bx->nkey]++;
      br[nda[i]->by->nkey]++;
      br[nda[i]->bz->nkey]++;
   }

   for( i=0; i<nseq ; i++){
    if( nd[i] != 1 ){
        fprintf(ERR,"topology file format error (11)\n");
        exit(1);
      }
  }
    for( i=nseq ; i< 2*nseq-2 ; i++){
     if( nd[i] != 3 ){
        fprintf(ERR,"topology file format error (12)\n");
        exit(1);
      }
    }
    for( i=0 ; i< 2*nseq-3 ; i++){
     if( br[i] != 2 ){
        fprintf(ERR,"topology file format error (13)\n");
        exit(1);
      }
    }

   free_ivector(nd,2*nseq-2);
   free_ivector(br,2*nseq-3);
  return(0);
}

   
   
     
rdline(fp,b,n)
int *n;
char *b;
FILE *fp;
{
int c,np;
   *n=0;

   np=0;
   for( ; ; ){
      c = fgetc(fp);
      if( c == EOF ) return(1);
      if( c != ' '  && c != '\t' ) np++;
      b[*n]=c;
      (*n)++;
      if( c == '\n' ) break;
    }
    if( np == 0 ) return(2);
   return(0);
}






getname(nid,snm,bf,nl,maxnm)
int *nid,nl,maxnm;
char *snm,*bf;
{
char bn[10];
int i,n,flg,nc,nst,nend;
 flg=0;
 n=0;
 for(i=0; i<= maxnm ; i++) snm[i]=0;
 for(i=0; i<10 ; i++) bn[i]=0;
 for( ; ; ){
  if( bf[n] == ' ' ){
     n++;
     continue;
   }
   break;
 }
 nc=0;
 for( ; ; ){
   if( bf[n] == ' ' ) break;
   bn[nc] = bf[n];
   if( bn[nc] > '9' || bn[nc] < '0' ) return(-1);
   nc++;
   n++;
 }
 sscanf(bn,"%d",nid);
 for( ; ; ){
   if( bf[n] == ' ' ) {
     n++;
     continue;
   }
   break;
 }

  nst=n;
  for(i=nl-1;  ; i--){
   if( bf[i] == ' ' || bf[i] == '\n' || bf[i] == '\t' ) continue;
   nend=i;
   break;
  }
  
  for(i=nst ; i<=nend ; i++) snm[i-nst]=bf[i];

  return(0);
}









zeroc(b,nc)
int nc;
char *b;
{
int i;

 for(i=0; i<nc ; i++) b[i]=0;
 return(0);
}

rdseq(fpi,nseq,nsite,seq,seqnm)
FILE *fpi;
int nseq,nsite;
char **seq,**seqnm;
{
int i,cw,flg,fc,sc,flg1,cw1,seqc,sitec,cn;
/* flg  0   initial
        1   file name
        2   file name end
        3   sequence
   flg1 1   comment
 */
   cn=0;
   seqc=0;
   sitec=0;
   fc=0;
   sc=0;
   flg1=0;
   flg = 0;
   cw =0;
   cw1=0;
   for( ; ; ){
      cw1=cw;
      if( cw1 != EOF ) cw = getc(fpi);
      if( cw1 == EOF ) break;
      cn++;
      if( cn == 1 ) continue;
      if( cw1 == '/' && cw == '*' ){
          flg1 = 1;
          continue;
	}
      if( flg1 == 1 ) {
           if( cw1 == '*' && cw == '/' ){
               flg1=0;
	     }
            continue;
	 }
      

      switch(flg){
        case 0: if( cw1 == ' ' || cw1 == '\t' ) break;
                if( cw1 == '\n' ) break;
                flg=1;
                seqnm[seqc][fc]=cw1;
                fc++;
                break;
        case 1: if( cw1 == ' ' || cw1 == '\t' ) {
                  fc=0;
                  flg = 2;
                  break;
		}
                if( cw1 == '\n' ){
                   fprintf(ERR,"format error (1) in data file\n");
                   exit(1);
		 }
                seqnm[seqc][fc]=cw1;
                fc++;
                break;
        case 2: if( cw1 == ' ' || cw1 == '\t' ) break;
                if( cw1 == '\n' ){
                   fprintf(ERR,"format error (2) in data file\n");
                   exit(1);
		 }
                 flg=3;
                 seq[seqc][sc]=cw1;
                 sc++;
                 break;
         case 3: if( cw1 == '\n'){
                     if( sc != nsite ){
                        fprintf(stderr,"nsite is not the same %d (in seq %d)\n",sc,(seqc)+1);
                        exit(1);                                                                    }
                   seqc++;
                   flg=0;
                   sc=0;
                   fc=0;
                   break;
		   }
                 if( cw1 == ' ' || cw1 == '\t' ) break;
                 seq[seqc][sc]=cw1;
                 sc++;
                 break;
	default: break;
	}
     
    }
    if( sc != 0 ){
      if( sc != nsite ){
            fprintf(stderr,"nsite is not the same %d (in seq %d)\n",sc,seqc+1);
            exit(1);                                                                    }
      seqc++;
    }
   if( seqc != nseq ){
      printf("sequence number inconsistency seqc=%d nseq=%d\n",seqc,nseq);
      exit(1);
    }
   
/*   
   printf("rdseq seqc=%d\n",seqc);
   for(i=0; i<nseq ; i++) printf("%d %s\n",i+1,seqnm[i]);
*/
    return(0);
}

delchk(a,nseq0,nsite,npsite,nasite,psite,asite,cdnpos,sitef)
int nseq0,nsite,*npsite,*nasite,*psite,*asite,cdnpos[3];
char **a,*sitef;
{
int i,j,k,flg,iw,pol,del,nbs;
/* sitef
        0
        1   del/in
        2   polymorphic
*/
  (*npsite) =0;
  (*nasite) =0;
  for(i=0; i<nsite ; i++){
       del=0;
       pol=0;
       sitef[i]=0;
       if( cdnpos[i%3] != 1 ) continue;
       for(j=0; j<nseq0; j++){
          if( del != 0 ) break;
          flg=0;
          if( dflg == 3 ) printf("a[%d][%d]=%c %x\n",j,i,a[j][i],a[j][i]);
          if( a[j][i] == '.' ){
            a[j][i] = a[0][i];
	  }else{
             if( a[j][i] >= 'a' && a[j][i] <= 'z' ) a[j][i] += 'A' - 'a';
             for(k=0; k<11 ; k++){
                if( a[j][i] == base[k] ) {
                   a[j][i]=k; 
                   flg=1;
                   break;
               }
             }
             if( flg == 0 ){
                printf("seq %d site %d  invalid base (%c) (%x)\n",j+1,i+1,a[j][i],a[j][i]);
              exit(1);
	     }
	   }
           if( a[j][i] == DEL || a[j][i] == DEL1 || a[j][i] == MISS ){
                  del=1;   
                  break;
		}
              if( a[j][i] != a[0][i] ) pol=1;


	}
    
         
        if( del != 0  ){
          sitef[i]=1;
          continue;
	}
        asite[(*nasite)]=i;
        (*nasite)++;
        if( pol == 1 ){
             sitef[i]=2;
             psite[(*npsite)]=i;
             (*npsite)++;
	   }
     }
    return(0);
}



delchka(a,nseq0,nsite,npsite,nasite,asite,psite,sitef)
int nseq0,nsite,*npsite,*nasite,*psite,*asite;
char **a,*sitef;
{
int i,j,k,flg,iw,pol,del,nbs;

/*   fprintf(stderr,"delchka nseq0=%d\n",nseq0);   */
  (*npsite) =0;
  (*nasite) =0;
  for(i=0; i<nsite ; i++){
/*       fprintf(stderr,"i=%d\n",i);   */
       del=0;
       pol=0;
       for(j=0; j<nseq0; j++){
          if( del != 0 ) break;
          flg=0;
/*          if( dflg == 2 ) printf("a[%d][%d]=%c %x\n",i,j,a[j][i],a[j][i]); */
          if( a[j][i] == '.' ) {
             a[j][i] = a[0][i];
	   }else{
             if( a[j][i] >= 'a' && a[j][i] <= 'z' ) a[j][i] += 'A' - 'a';
             for(k=0; k<26 ; k++){
               if( a[j][i] == amn[k] ) {
                 a[j][i]=k; 
                 flg=1;
                 break;
               }
             }
             if( flg == 0 ){
                printf("seq %d site %d  invalid amn %c %x\n",j+1,i+1,a[j][i],a[j][i]);
               exit(1);
	     }
	   }
           if( a[j][i] == DELA || a[j][i] == DELA1 || a[j][i] == MISSA ){
                  del=1;   
                  break;
		}
              if( a[j][i] != a[0][i] ) pol=1;


	}
    
        if( del != 0  ){
           sitef[i]=1;
           continue;
	 }

        asite[(*nasite)]=i;
        (*nasite)++;
        if( pol == 1 ){
             sitef[i]=2;
             psite[(*npsite)]=i;
             (*npsite)++;
	   }
     }
    return(0);
}



calcov(a,nseq0,nsite,nasite,npsite,asite,dop,dist,ndif,ndif1,gamma,asite0,nbal,cov)
char **a/*[MAXSITE][MAXOTU]*/;
int nseq0,nsite,nasite,*asite,dop,*asite0;
double **dist/*[MAXOTU][MAXOTU]*/,gamma,*cov;
int **ndif/*[MAXOTU][MAXOTU]*/,**ndif1/*[MAXOTU][MAXOTU]*/,**nbal/*[MAXOTU][4]*/;
{
int i,j,k,l,npb,np1,np2,np3,ns1,ns2,ns21,ns22,nv1,nv2,nd1,nd2,n,nts1,nts2;
int n1,n2,n3,n4,rn,nbx[4],nby[4],na,ndist;
double sp,dp,dq,dsp,da,db1,db2,dw,db;
int *ppsite/*[MAXSITE]*/,*pqsite/*[MAXSITE]*/,nppsite,npqsite,*p2site/*[MAXSITE]*/,np2site;
float fw,*fwp;

   ndist = nseq0*(nseq0-1)/2;

    if( dflg == 1 ) {
       printf("dop=%d nseq0=%d nsite=%d\n",dop,nseq0,nsite);
       fflush(stdout);
     }

   ppsite = ivector(nsite);
   pqsite = ivector(nsite);
   p2site = ivector(nsite);
/*   printf("ppsite pqsite p2site %p %p %p\n",ppsite,pqsite,p2site); */
   nd1=0;
   n=0;
   for(i=0; i<nseq0-1; i++){
     for(j=i+1; j<nseq0; j++){
     rn=distv(nasite,npsite,asite,nd1,a,i,j,dop,dist,&np1,&ns1,&nv1,&nts1,&nts2,gamma,&db,asite0,nbal);
     if( rn != 0 ){
       printf("inapplicable case i=%d j=%d\n",i,j);
       exit(1);
     }
/*
      printf("distv i=%d j=%d npsite=%d\n",i,j,npsite);
      fflush(stdout);
*/

     n++;
     switch(dop){
        case 0: ndif[i][j]=ndif[j][i]=np1;
                break;
        case 1: ndif[i][j]=ndif[j][i]=np1;
                break;
        case 2: ndif[i][j]=ns1;
                ndif[j][i]=nv1;
                break;
        case 5: ndif[i][j]=ndif[j][i]=np1;

                break;
        case 6: ndif[i][j]=ns1;
                ndif[j][i]=nv1;
                break;
        case 9: 
        case 10: 
        case 11: 
        case 12: 
                ndif[i][j]=nv1;
                ndif[j][i]=nv1;
                break;
        case 8: fwp = &ndif[j][i];
                fw = db;
                *fwp = fw;
                ndif[i][j]=np1;
                break;
        case 13:
        case 14:
                 ndif[i][j]=ns1;
                 ndif[j][i]=nv1;
                 ndif1[i][j]=nts1;
                 ndif1[j][i]=nts2;
                 break;
	}
      nd1++;
   }
   }
 
   if( n != nseq0*(nseq0-1)/2 ){
     printf("calcov n=%d  %d\n",n,nseq0*(nseq0-1)/2);
     exit(1);
   }
    if( dflg == 1 ) printf("dop=%d\n",dop);
     nd1=0;
     n=0;
     for(i=0; i<nseq0; i++){
       for(j=i+1; j<nseq0 ; j++){
       getpsite(ppsite,pqsite,p2site,&nppsite,&npqsite,&np2site,i,j,a,dop,asite,npsite);
       if( dflg == 1 ) {
           printf("get psite dop=%d\n",dop);
           fflush(stdout);
	 }
       switch(dop){
         case 0: np1 = ndif[i][j];
                 break;
         case 1: np1 = ndif[i][j];
                 break;
         case 2: ns1 = ndif[i][j];nv1 = ndif[j][i];
                 break;
         case 5: np1 = ndif[i][j];
                 break;
         case 6: ns1 = ndif[i][j];nv1 = ndif[j][i];
                 break;
         case 9: 
         case 10: 
                 nv1 = ndif[i][j];
                 break;
         case 11: 
         case 12: 
                  nv1 = ndif[i][j];
                  nbx[0] = nbal[i][0]+nbal[j][0];
                  nbx[1] = nbal[i][1]+nbal[j][1];
                  nbx[2] = nbal[i][2]+nbal[j][2];
                  nbx[3] = nbal[i][3]+nbal[j][3];
                  break;

         case 13: 
         case 14: 
                  ns1 = ndif1[i][j];
                  ns21 = ndif1[i][j];
                  nv1 = ndif[j][i];
                  nbx[0] = nbal[i][0]+nbal[j][0];
                  nbx[1] = nbal[i][1]+nbal[j][1];
                  nbx[2] = nbal[i][2]+nbal[j][2];
                  nbx[3] = nbal[i][3]+nbal[j][3];
                  break;
         case 8: np1 = ndif[i][j]; fwp = &ndif[j][i];
                 db1 = *fwp;
                 break;
          
	 }
       k=i;
       nd2=nd1;


       for(l=j+1; l<nseq0 ; l++){
          n++;
          switch(dop){
             case 0: np2 = ndif[k][l];
                     break;
             case 1: np2 = ndif[k][l];
                     break;
             case 2: ns2 = ndif[k][l];nv2 = ndif[l][k];
                      break;
             case 5: np2 = ndif[k][l];
                     break;
             case 6: ns2 = ndif[k][l];nv2 = ndif[l][k];
                      break;
             case 9: 
             case 10: 
                      nv2 = ndif[k][l];
                      break;
             case 11: 
             case 12: 
                      nv2 = ndif[k][l];
                      nby[0] = nbal[k][0]+nbal[l][0];
                      nby[1] = nbal[k][1]+nbal[l][1];
                      nby[2] = nbal[k][2]+nbal[l][2];
                      nby[3] = nbal[k][3]+nbal[l][3];
                      break; 
             case 13: 
             case 14: 
                      ns2 = ndif1[k][l];
                      ns22 = ndif1[l][k];
                      nv2 = ndif[l][k];
                      nby[0] = nbal[k][0]+nbal[l][0];
                      nby[1] = nbal[k][1]+nbal[l][1];
                      nby[2] = nbal[k][2]+nbal[l][2];
                      nby[3] = nbal[k][3]+nbal[l][3];
                      break;
            case 8: np2 = ndif[k][l]; fwp = &ndif[l][k];
                     db2 = *fwp;
                      break;
          }
          

        nd2++;
/*       printf("dop=%d\n",dop);    */
/*       printf("ns2=%d nv2=%d\n",ns2,nv2); */
       calcv1(nasite,asite,a,i,j,k,l,nd1,nd2,dop,np1,ns1,nv1,ns21,np2,ns2,nv2,ns22,nppsite,npqsite,np2site,ppsite,pqsite,p2site,gamma,db1,db2,nbx,nby,ndist,cov);
       /*       printf("calcv1 gamma=%f\n",gamma);*/
       }
     for(k=i+1; k<nseq0 ; k++){
       for(l=k+1; l<nseq0 ; l++){
        nd2++;
        n++;
       switch(dop){
         case 0: np2 = ndif[k][l];
                 break;
         case 1: np2 = ndif[k][l];
                 break;
         case 2: ns2 = ndif[k][l];nv2 = ndif[l][k];
                 break;
         case 5: np2 = ndif[k][l];
                 break;
         case 6: ns2 = ndif[k][l];nv2 = ndif[l][k];
                 break;
         case 9: 
         case 10: 
                 nv2 = ndif[k][l];
                 break;
         case 11: 
         case 12: 
                 nv2 = ndif[k][l];
                 nby[0] = nbal[k][0]+nbal[l][0];
                 nby[1] = nbal[k][1]+nbal[l][1];
                 nby[2] = nbal[k][2]+nbal[l][2];
                 nby[3] = nbal[k][3]+nbal[l][3];
                break; 
         case 13: 
          case 14: 
                 ns2 = ndif1[k][l];
                 ns22 = ndif1[l][k];
                 nv2 = ndif[l][k];
                 nby[0] = nbal[k][0]+nbal[l][0];
                 nby[1] = nbal[k][1]+nbal[l][1];
                 nby[2] = nbal[k][2]+nbal[l][2];
                 nby[3] = nbal[k][3]+nbal[l][3];
                 break;
         case 8: np2 = ndif[k][l]; fwp = &ndif[l][k]; db2 = *fwp; 
                 break;
	 }
/*       printf("dop=%d\n",dop); */
/*       printf("ns2=%d nv2=%d",ns2,nv2);*/
       calcv1(nasite,asite,a,i,j,k,l,nd1,nd2,dop,np1,ns1,nv1,ns21,np2,ns2,nv2,ns22,nppsite,npqsite,np2site,ppsite,pqsite,p2site,gamma,db1,db2,nbx,nby,ndist,cov);
/*      printf(" %d %d %d %d   %d %d %e\n",i,j,k,l,nd1,nd2,cov[nd1][nd2]); */
      }
     }
     nd1++;
   }
   }
   if( n != nseq0*(nseq0-1)/2*(nseq0*(nseq0-1)/2-1)/2 ){
     printf("calcov n=%d nseq0*(nseq-1)/2*(nseq0*(nseq0-1)/2-1)/2=%d\n",n,nseq0*(nseq0-1)/2*(nseq0*(nseq0-1)/2-1)/2);
     exit(1);
   }


   free_ivector(ppsite,nsite);
   free_ivector(pqsite,nsite);
   free_ivector(p2site,nsite);
   return(0);

}
getpsite(ppsite,pqsite,p2site,nppsite,npqsite,np2site,s1,s2,a,dop,asite,npsite)
int *ppsite,*pqsite,*p2site,*nppsite,*npqsite,*np2site,s1,s2,dop,*asite,npsite;
char **a/*[MAXSITE][MAXOTU]*/;
{
int i,n;

/*   printf("npsite=%d\n",npsite); */
   *nppsite=0;
   *npqsite=0;
   *np2site=0;

   for(i=0; i<npsite; i++){
      n = asite[i];
      switch(dop){
        case 0:
        case 1:
        case 5:
        case 8:
                switch(tr[a[s1][n]][a[s2][n]]){
                   case -1:
                            break;
		   default: ppsite[*nppsite] = n;
                            (*nppsite)++;
                            break;
			  }
                 break;
        case 6:
        case 2:
                switch(tr[a[s1][n]][a[s2][n]]){
                   case -1:
                            break;
    		   case 0 : ppsite[*nppsite] = n;
                            (*nppsite)++;
                            break;
    		   case 1 : pqsite[*npqsite] = n;
                            (*npqsite)++;
                            break;
			  }
                 break;
        case 9:
        case 10:
        case 11:
        case 12:
                switch(tr[a[s1][n]][a[s2][n]]){
                   case -1:
                            break;
    		   case 0 : ppsite[*nppsite] = n;
                            (*nppsite)++;
                            break;
    		   case 1 : pqsite[*npqsite] = n;
                            (*npqsite)++;
                            break;
			  }
                 break;

       case 13:
       case 14:
                fflush(stdout);
                 switch(tr1[a[s1][n]][a[s2][n]]){
                   case 0:
                            break;
    		   case 1 : ppsite[*nppsite] = n;
                            (*nppsite)++;
                            break;
    		   case 2 : p2site[*np2site] = n;
                            (*np2site)++;
                            break;
    		   case 3 : pqsite[*npqsite] = n;
/*                            printf("n=%d\n",n); fflush(stdout); */
                            (*npqsite)++;
                            break;
			  }
                 break;
	      }
    }




    return(0);
}


distv(nasite,npsite,asite,nd1,a,s1,s2,dop,dist,np,nts,ntv,nts1,nts2,gamma,db0,asite0,nbal)
int s1,s2,dop,nasite,npsite,*asite,*np,*nts,*ntv,*nts1,*nts2,nd1,*asite0;
int **nbal/*[MAXOTU][4]*/;
char **a/*[MAXSITE][MAXOTU]*/;
double **dist/*[MAXOTU][MAXOTU]*/,gamma,*db0;
{
int k,l,np1,ns1,nv1,i1,j1,cnch[4][4],b1,b2,nt,ns2,nid,na;
double sp,dp,dq,da,db,dsq,dc,g[4],dw;
double c1,c2,c3,c4,c5,ga,gt,gg,gc,gr,gy,dp1,dp2,dw1,dw2,dw3;

/*         printf("distv s1=%d s2=%d nd1=%d dop=%d",s1,s2,nd1,dop);         */
/*         if( dflg == 1 ) printf("dop=%d\n",dop);*/
         switch(dop){
            case 0:   np1=0;
                      for(k=0; k<npsite ; k++){
                        switch(tr[a[s1][asite[k]]][a[s2][asite[k]]]){
	         		case -1: /* no difference */
                                           break;
			        default:   np1++;
                                           break;
				       }
		      }
                      sp = np1;
                      sp /= nasite;
                      dist[s1][s2]=sp;
                      dist[s2][s1] = sp*(1.0-sp);
                      dist[s2][s1] /= nasite;
                      (*np) = np1;
                      return(0);

            case 1: /* JC */
                    np1=0;
                      for(k=0; k<npsite ; k++){
                        switch(tr[a[s1][asite[k]]][a[s2][asite[k]]]){
	         		case -1: /* no difference */
                                           break;
			        default:   np1++;
                                           break;
				       }
		      }
                      sp = np1;
                      sp /= nasite;
                      if( 1.0-sp*4.0/3.0  <= 0.0 ) return(-1);
                      dist[s1][s2] = -0.75*log(1.0-sp*4.0/3.0);
                      dist[s2][s1] = sp*(1.0-sp)/(1.0-sp/0.75)/(1.0-sp/0.75);
                      dist[s2][s1] /= nasite;
                      (*np) = np1;
                      return(0);
            case 8: /* Tajima Nei */
                    np1=0;
                    for(k=0; k<4 ; k++){
                        for(l=0; l<4 ; l++){
                          cnch[k][l]=0;
			}
		      }
                      for(k=0; k<nasite ; k++){
                        b1 = a[s1][asite0[k]];
                        b2 = a[s2][asite0[k]];
                        cnch[b1][b2]++; 
                        switch(tr[b1][b2]){
        			case -1: break;
        			default: np1++;
                                         break;
				}
		      }
                      dp = np1;
                      dp /= nasite;
                      if( np1 == 0){
                          printf("distance 0  seq %d %d\n",s1+1,s2+1);
                          exit(1);
                      }
                      nt=0;
                      for(i1=0; i1<4 ; i1++) g[i1]=0.0;
                      for(i1=0; i1<4 ; i1++){
                        for(j1=0; j1<4 ; j1++){
                            g[i1] += cnch[i1][j1];
                            g[j1] += cnch[i1][j1];
                            nt += 2*cnch[i1][j1];
			  }
		      }
                      for(i1=0; i1<4 ; i1++)   g[i1] /= nt;
                      dc = 0.0;
                      for(i1=0; i1<3 ; i1++){
                       for(j1=i1+1 ; j1<4 ; j1++){
                          dw = cnch[i1][j1] + cnch[j1][i1];
                          dw /= nasite;
                          dc += dw*dw/(2.0*g[i1]*g[j1]);
			}
		     } 
                      db = (1.0 + dp*dp/dc - g[0]*g[0] - g[1]*g[1] - g[2]*g[2]- g[3]*g[3])/2.0;
                     if( 1.0 - dp/db <= 0.0 ) return(-1);
                     dist[s1][s2] = -db*log(1.0 - dp/db);
                     dist[s2][s1] = db*db*dp*(1.0-dp)/((db-dp)*(db-dp));
                     dist[s2][s1] /= nasite;
                      (*np) = np1;
                      (*db0) = db;

/*                      printf("%d %d %f nasite %d ndif %d\n",s1,s2,dist[s1][s2],nasite,np1); */
                      return(0);
            case 5: /* JC  gamma*/
                    np1=0;
                      for(k=0; k<npsite ; k++){
                        switch(tr[a[s1][asite[k]]][a[s2][asite[k]]]){
	         		case -1: /* no difference */
                                           break;
			        default:   np1++;
                                           break;
				       }
		      }
                      sp = np1;
                      sp /= nasite;
                      if( 1.0-sp*4.0/3.0  <= 0.0 ) return(-1);
                      dist[s1][s2] = 0.75*gamma*pow(1.0-sp/0.75,-1.0/gamma);
                      dist[s2][s1] = sp*(1.0-sp)*pow(1.0-sp/0.75, -2.0*(1.0/gamma+1.0));
                      dist[s2][s1] /= nasite;
                      (*np) = np1;
                      return(0);
	    case 2 :  /*k2p */
                       ns1=0;
                       nv1=0;
                       for(k=0; k<npsite ; k++){
                          switch(tr[a[s1][asite[k]]][a[s2][asite[k]]]){
	         		case -1: /* no difference */
                                           break;
				case 0 : ns1++;
                                         break;
			        case 1 : nv1++;
                                         break;
			        default:   printf("invalid code s1 =%d s2=%d %c %02x %c %02x\n",s1,s2,a[s1][asite[k]],a[s2][asite[k]]);
                                           exit(1);
				       }
	                }
                      if( dflg == 1 ) printf("ns1=%d nv1=%d\n",ns1,nv1);
                      dp = ns1;
         	      dq = nv1;
                      dp /= nasite;
                      dq /= nasite;
                      if( nasite - 2*nv1 <= 0 ) return(-1);
                      if( nasite -2*ns1 -nv1 <= 0 ) return(-1);

                      dsq = sqrt(1.0- 2.0*dq);
                      dist[s1][s2] = -0.5*log((1.0-2.0*dp-dq)*dsq);
                      da = 1.0/(1.0-2.0*dp-dq);
                      db = 0.5*(da + 1.0/(1.0-2.0*dq));
                      dist[s2][s1] = (da*da*dp+db*db*dq-(da*dp+db*dq)*(da*dp+db*dq));
                      dist[s2][s1] /= nasite;
/*                      printf("cov =%e\n",cov[nd1][nd1]); */
                      (*np) = ns1+nv1;
                      (*nts) = ns1;
                      (*ntv) = nv1;
                      return(0);

	    case 6 :  /*k2p */
                       ns1=0;
                       nv1=0;
                       for(k=0; k<npsite ; k++){
                          switch(tr[a[s1][asite[k]]][a[s2][asite[k]]]){
	         		case -1: /* no difference */
                                           break;
				case 0 : ns1++;
                                         break;
			        case 1 : nv1++;
                                         break;
			        default:   printf("invalid code s1 =%d s2=%d %c %02x %c %02x\n",s1,s2,a[s1][asite[k]],a[s2][asite[k]]);
                                           exit(1);
				       }
	                }
                      if( dflg == 1 ) printf("ns1=%d nv1=%d\n",ns1,nv1);
                      dp = ns1;
         	      dq = nv1;
                      dp /= nasite;
                      dq /= nasite;
                      if( nasite - 2*nv1 <= 0 ) return(-1);
                      if( nasite -2*ns1 -nv1 <= 0 ) return(-1);

                      dsq = sqrt(1.0- 2.0*dq);
                      dist[s1][s2] = 0.5*gamma*(pow(1.0-2.0*dp-dq,-1.0/gamma)+0.5*pow(1.0-2.0*dq,-1.0/gamma) -1.5);
                      da = pow(1.0-2.0*dp-dq,-(1.0/gamma+1.0));
                      db = 0.5*(pow(1.0-2.0*dp-dq,-(1.0/gamma+1.0)) + pow(1.0-2.0*dq,-(1.0/gamma+1.0)));
                      dist[s2][s1] = (da*da*dp+db*db*dq-(da*dp+db*dq)*(da*dp+db*dq));
                      dist[s2][s1] /= nasite;
/*                      printf("cov =%e\n",cov[nd1][nd1]); */
                      (*np) = ns1+nv1;
                      (*nts) = ns1;
                      (*ntv) = nv1;
                      return(0);
	    case 9 :  /*k2p transversion */
                       ns1=0;
                       nv1=0;
                       for(k=0; k<npsite ; k++){
                          switch(tr[a[s1][asite[k]]][a[s2][asite[k]]]){
	         		case -1: /* no difference */
                                           break;
				case 0 : ns1++;
                                         break;
			        case 1 : nv1++;
                                         break;
			        default:   printf("invalid code s1 =%d s2=%d %c %02x %c %02x\n",s1,s2,a[asite[k]][s1],a[asite[k]][s2]);
                                           exit(1);
				       }
	                }
                      if( dflg == 1 ) printf("ns1=%d nv1=%d\n",ns1,nv1);
                      dp = ns1;
         	      dq = nv1;
                      dp /= nasite;
                      dq /= nasite;
                      if( nasite - 2*nv1 <= 0 ) return(-1);
                      dist[s1][s2] = -0.5*log(1.0-2.0*dq);
                      dist[s2][s1] = dq*(1.0-dq)/((1.0-2.0*dq)*(1.0-2.0*dq));
                      dist[s2][s1] /= nasite;
/*                      printf("cov =%e\n",cov[nd1][nd1]); */
                      (*np) = ns1+nv1;
                      (*nts) = ns1;
                      (*ntv) = nv1;
                      return(0);

	    case 10 :  /*k2p transversion gamma*/
                       ns1=0;
                       nv1=0;
                       for(k=0; k<npsite ; k++){
                          switch(tr[a[s1][asite[k]]][a[s2][asite[k]]]){
	         		case -1: /* no difference */
                                           break;
				case 0 : ns1++;
                                         break;
			        case 1 : nv1++;
                                         break;
			        default:   printf("invalid code s1 =%d s2=%d %c %02x %c %02x\n",s1,s2,a[s1][asite[k]],a[s2][asite[k]]);
                                           exit(1);
				       }
	                }
                      if( dflg == 1 ) printf("ns1=%d nv1=%d\n",ns1,nv1);
                      dp = ns1;
         	      dq = nv1;
                      dp /= nasite;
                      dq /= nasite;
                      if( nasite - 2*nv1 <= 0 ) return(-1);
                      dist[s1][s2] = pow(1.0-2.0*dq,-1.0/gamma)-1.0;
                      dist[s1][s2] *= 0.5*gamma;
                      c5 = pow(1.0-2.0*dq,-(1.0+1.0/gamma));
                      dist[s2][s1] = c5*c5*dq*(1.0-dq);
                      dist[s2][s1] /= nasite;
/*                      printf("cov =%e\n",cov[nd1][nd1]); */
                      (*np) = ns1+nv1;
                      (*nts) = ns1;
                      (*ntv) = nv1;
                      return(0);
	    case 11 :  /*Hasegawa transversion*/
            case 12 :  /*Hasegawa transversion gamma*/
            case 13 :  /* Tamura Nei*/
            case 14 :  /* Tamura Nei gamma*/
                         ns1=ns2=nv1=0;
                         nid=0;
                         for(k=0; k<npsite ; k++){
                           b1= a[s1][asite[k]];
                           b2= a[s2][asite[k]];
                           if( b1 >= 4 ) continue;
                           if( b2 >= 4 ) continue;
                           switch(tr1[b1][b2]){
         	            case 0:   nid++;
                                      break;
                 	    case 1:   ns1++;
                                      break;
                  	    case 2:   ns2++;
                                      break;
                 	    case 3:   nv1++;
                                      break;
			    }

         	       }
/*                       printf("dop=%d ns1=%d ns2=%d nv1=%d nid=%d\n",dop,ns1,ns2,nv1,nid); */
                       if( nid+ns1+ns2+nv1 == 0 ) return(-10);
                       (*np) = ns1+ns2+nv1;
                       (*nts) = ns1+ns2;
                       (*ntv) = nv1;
                       (*nts1) = ns1;
                       (*nts2) = ns2;
                        nt = nasite;
                        if ( nt != nbal[s1][0]+nbal[s1][1]+nbal[s1][2]+nbal[s1][3] ){
                        printf("inconsistent number of nucleotides\n");
                        printf("i=%d  nasite=%d   %d %d %d %d\n",s1,nasite,nbal[s1][0],nbal[s1][1],nbal[s1][2],nbal[s1][3]);
                        exit(1);
		      }
                      if ( nt != nbal[s2][0]+nbal[s2][1]+nbal[s2][2]+nbal[s2][3] ){
                        printf("inconsistent number of nucleotides\n");
                        printf("j=%d  nasite=%d   %d %d %d %d\n",s2,nasite,nbal[s2][0],nbal[s2][1],nbal[s2][2],nbal[s2][3]);
                        exit(1);
	              }
	    
                     na = nt*2;
                     ga = nbal[s1][2]+nbal[s2][2];
                     gt = nbal[s1][0]+nbal[s2][0];
                     gg = nbal[s1][3]+nbal[s2][3];
                     gc = nbal[s1][1]+nbal[s2][1];
                     ga /= na;
                     gt /= na;
                     gg /= na;
                     gc /= na;
                     gr = ga + gg;
                     gy = gt + gc;
                     dp1 = ns1;
                     dp2 = ns2;
                     dq  = nv1;
                     dp1 /= nt;
                     dp2 /= nt;
                     dq  /= nt;
                     /*        printf("g %f %f %f %f  %f %f\n",ga,gt,gg,gc,gr,gy); */
                     /*        printf("%d %d  %d %d %d  %f %f %f %f %f\n",i,j,nts1,nts2,ntv,ga,gg,gt,gc,ga+gg+gt+gc); */
                    if( ns1+ns2+nv1 == 0 ) {
                     dist[s1][s2]=0.0;
                     dist[s2][s1]=0.0;
                     return(0);
                    }



                    dw1 = 1.0 - gr*dp1/(2.0*ga*gg) - dq/(2.0*gr);
                    dw2 = 1.0 - gy*dp2/(2.0*gt*gc) - dq/(2.0*gy);
                    dw3 = 1.0 - dq/(2.0*gr*gy);
/*                    printf("dw %f %f %f\n",dw1,dw2,dw3); */
/*                         printf("a t g c %f %f %f %f dw %f %f %f\n",ga,gt,gg,gc,dw1,dw2,dw3);  */
                  if( dop == 13 || dop == 14 ) if( 1.0 - gr*dp1/(2.0*ga*gg) - dq/(2.0*gr) <= 0.0 ) return(-1);
                  if( dop == 13 || dop == 14 ) if( 1.0 - gy*dp2/(2.0*gt*gc) - dq/(2.0*gy) <=0.0 ) return(-1);
                  if( 1.0- dq/(2.0*gr*gy) <= 0.0 ) return(-1);
                  switch(dop){
                     case 13: dist[s1][s2]= ga*gg/(gr)*log(dw1) + gt*gc/(gy)*log(dw2) + (gr*gy-ga*gg*gy/gr - gt*gc*gr/gy)*log(dw3);
                              dist[s1][s2] *= -2.0;
                              c1 = 2.0*ga*gg*gr/(2.0*ga*gg*gr-gr*gr*dp1-ga*gg*dq);
                              c2 = 2.0*gt*gc*gy/(2.0*gt*gc*gy-gy*gy*dp2-gt*gc*dq);
                              c3 = c1*ga*gg/(gr*gr) + c2*gt*gc/(gy*gy)
                                  +(1.0- ga*ga/(gr*gr) - gt*gc/(gy*gy))/dw3;
                             dist[s2][s1] = (c1*c1*dp1+c2*c2*dp2+c3*c3*dq)-(c1*dp1+c2*dp2+c3*dq)*(c1*dp1+c2*dp2+c3*dq);
                             dist[s2][s1] /= nt;
/*                   printf("i=%d j=%d  %f %f ns1=%d ns2=%d nv1=%d\n",s1,s2,dist[s1][s2],sqrt(cov[nd1][nd1]),ns1,ns2,nv1);  */

                              break;
                    case 14:  dist[s1][s2] = ga*gg/(gr)*pow(dw1,-1.0/gamma)+gt*gc/gy*pow(dw2,-1.0/gamma)+(gr*gy-ga*gg*gy/gr-gt*gc*gr/gy)*pow(dw3,-1.0/gamma) -ga*gg-gt*gc-gr*gy;
                              dist[s1][s2] *= 2.0*gamma;
                              c1 = pow(1.0-gr*dp1/(2.0*ga*gg) - dq/(2.0*gr),-(1.0+1.0/gamma));
                              c2 = pow(1.0-gy*dp2/(2.0*gt*gc) - dq/(2.0*gy),-(1.0+1.0/gamma));
                              c3 = c1*ga*gg/gr/gr+c2*gt*gc/gy/gy + ((ga*ga+gg*gg)/(2.0*gr*gr)+(gt*gt+gc*gc)/(2.0*gy*gy))*pow(dw3,-(1.0+1.0/gamma));
                              dist[s2][s1] = (c1*c1*dp1+c2*c2*dp2+c3*c3*dq)-(c1*dp1+c2*dp2+c3*dq)*(c1*dp1+c2*dp2+c3*dq);
                              dist[s2][s1] /= nt;
 /*                   printf("i=%d j=%d  %f %f %f\n",i,j,dist[i][j],dist[j][i],sqrt(dist[j][i])); */
                              break;

           case 11:  dist[s1][s2] = -2.0*gr*gy*log(dw3);
                     c5 = 1.0/(dw3);
                     dist[s2][s1] = c5*c5*dq*(1.0-dq);
                     dist[s2][s1] /= nt;
                     break;
           case 12:  dist[s1][s2] = pow(dw3,-1.0/gamma)-1.0;
                     dist[s1][s2] *= 2.0*gamma*gr*gy;
                     c5 = pow(dw3,-(1.0+1.0/gamma));
                     dist[s2][s1] = c5*c5*dq*(1.0-dq);
                     dist[s2][s1] /= nt;
                   break;
                   

		     }



                      return(0);

	    }





	    
    }

calcv1(nasite,asite,a,n1,n2,n3,n4,nd1,nd2,dop,np1,ns1,nv1,ns21,np2,ns2,nv2,ns22,nppsite,npqsite,np2site,ppsite,pqsite,p2site,gamma,tnb1,tnb2,nbx,nby,ndist,cov)
int nasite,*asite,n1,n2,n3,n4,nd1,nd2,dop,np1,ns1,nv1,np2,ns2,nv2,ns21,ns22,nppsite,np2site,npqsite,*ppsite,*pqsite,*p2site;
int nbx[4],nby[4];
char **a/*[MAXSITE][MAXOTU]*/;
double gamma,tnb1,tnb2,*cov;
{
int i,n,nps,nss,nvs,nr,nss1,pflg,pflg1,nad;
int np11,np12,np1q,np21,np22,np2q,nqp1,nqp2,nqq;
double da1,db1,da2,db2,dp1,dp2,dps,sp1,sp2,dq1,dq2,dr,ds,dqs,dw,c1,c2,d1,d2;
double dp11,dp12,dp1q,dp21,dp22,dp2q,dqp1,dqp2,dqq,dp1x,dp1y,dp2x,dp2y,dqx,dqy;
double xcp1,ycp1,xcp2,ycp2,xcq,ycq,gax,gtx,ggx,gcx,gyx,grx,gay,gty,ggy,gcy,gyy,gry;
double dwx,dwy;




    nad = covad(nd1,nd2,ndist);
/*   printf("n1 n2 n3 n4 %d %d %d %d  nd1=%d nd2=%d\n",n1,n2,n3,n4,nd1,nd2);*/
   switch(dop){
      case 0:
             nps=0;
             for(i=0; i<nppsite ; i++){
               n = ppsite[i];
               switch(tr[a[n3][n]][a[n4][n]]){
         	       case -1: 
                               break;
   		       default: nps++;
                                break;
			     }
		    }
             dps = nps;
             dps /= nasite;
             dp1 = np1;
             dp1 /= nasite;
             dp2 = np2;
             dp2 /= nasite;
             dw = (dps-dp1*dp2)*sqrt(dp1*(1.0-dp1)*dp2*(1.0-dp2));
             dw /= nasite;
             if( comm.covflg == 0 ) cov[nad]=dw;
             else{
                 if( write(comm.fpcov,&dw,sizeof(double)) == -1 ){
                     printf("write error\n");
                     exit(1);
                   }
	     }
/*             printf("nps=%d np1=%d np2=%d cov=%e\n",nps,np1,np2,cov[nd1][nd2]); */
/*             cov[nd2][nd1]=cov[nd1][nd2]; */
             break;
     

     case 1:
             nps=0;
             for(i=0; i<nppsite ; i++){
               n = ppsite[i];
               switch(tr[a[n3][n]][a[n4][n]]){
         	       case -1: 
                                break;
   		       default: nps++;
                                break;

			      }
	     }
             dps = nps;
             dps /= nasite;
             dp1 = np1;
             dp1 /= nasite;
             dp2 = np2;
             dp2 /= nasite;

             dw = (dps-dp1*dp2)/(1.0-dp1/0.75)/(1.0-dp2/0.75);
             dw /= nasite;
             if( comm.covflg == 0 ) cov[nad] =dw;
             else{
                 if( write(comm.fpcov,&dw,sizeof(double)) == -1 ){
                     printf("write error\n");
                     exit(1);
                   }
	     }

             break;

     case 5:
             nps=0;
             for(i=0; i<nppsite ; i++){
               n = ppsite[i];
               switch(tr[a[n3][n]][a[n4][n]]){
         	       case -1: 
                                break;
   		       default: nps++;
                                break;

			      }
	     }
             dps = nps;
             dps /= nasite;
             dp1 = np1;
             dp1 /= nasite;
             dp2 = np2;
             dp2 /= nasite;
             dw=pow((1.0-dp1/0.75)*(1.0-dp2/0.75),-(1.0/gamma+1.0));
             dw = (dps-dp1*dp2)*dw;
             dw /= nasite;
             if( comm.covflg == 0 ) cov[nad] = dw;
             else{
                 if( write(comm.fpcov,&dw,sizeof(double)) == -1 ){
                     printf("write error\n");
                     exit(1);
                   }
	     }

             break;
     
     case 8:
             nps=0;
             for(i=0; i<nppsite ; i++){
               n = ppsite[i];
               switch(tr[a[n3][n]][a[n4][n]]){
         	       case -1: 
                                break;
   		       default: nps++;
                                break;

			      }
	     }
             dps = nps;
             dps /= nasite;
             dp1 = np1;
             dp1 /= nasite;
             dp2 = np2;
             dp2 /= nasite;

             dw = (dps-dp1*dp2)/(1.0-dp1/tnb1)/(1.0-dp2/tnb2);
             dw /= nasite;
             if( comm.covflg == 0 ) cov[nad] = dw;
             else{
                 if( write(comm.fpcov,&dw,sizeof(double)) == -1 ){
                     printf("write error\n");
                     exit(1);
                   }
	     }

/*             printf("np1=%d np2=%d b1=%f b2=%f\n",np1,np2,tnb1,tnb2); */
             break;

      case 2 :  nps=0;
                nss=0;
                nvs=0;
                nr=0;
                nss1=0;
                for(i=0; i<nppsite; i++){
                   n=ppsite[i];
                   switch(tr[a[n3][n]][a[n4][n]]){
	         		case -1: /* no difference */
                                           break;
				case 0 : nss++;
                                         break;
			        case 1 : nr++;
                                         break;
			        default:   printf("invalid code\n");
                                           exit(1);

			 }
		 }
                for(i=0; i<npqsite; i++){
                   n=pqsite[i];
                   switch(tr[a[n3][n]][a[n4][n]]){
	         		case -1: /* no difference */
                                           break;
				case 0 : nss1++;
                                         break;
			        case 1 : nvs++;
                                         break;
			        default:   printf("invalid code\n");
                                           exit(1);

			 }
		 }
	   
	   
                 dp1 = ns1;  dp1 /= nasite;
                 dp2 = ns2;  dp2 /= nasite;
                 dq1 = nv1;  dq1 /= nasite;
                 dq2 = nv2;  dq2 /= nasite;
                 dps = nss; dps /= nasite;
                 dqs = nvs; dqs /= nasite;
                 dr = nr;   dr /= nasite;
                 ds = nss1; ds /= nasite;	   
                 da1 = 1.0/(1.0-2.0*dp1-dq1);	   
                 db1 = 0.5*da1 + 0.5/(1.0-2.0*dq1);
                 da2 = 1.0/(1.0-2.0*dp2-dq2);
                 db2 = 0.5*da2 + 0.5/(1.0-2.0*dq2);
	   
                 
                 dw = da1*da2*(dps-dp1*dp2)+da1*db2*(dr-dp1*dq2)
                                 + da2*db1*(ds-dq1*dp2)+db1*db2*(dqs-dq1*dq2);
                 dw /= nasite;
                 if( comm.covflg == 0 )  cov[nad] = dw;
                 else{
                   if( write(comm.fpcov,&dw,sizeof(double)) == -1 ){
                     printf("write error\n");
                     exit(1);
                   }
                 }


   if( dflg == 1 ) {
      printf("calcv1 n1=%d n2=%d n3=%d n4=%d nd1=%d nd2=%d nasite=%d ns1=%d nv1=%d ns2=%d nv2=%d nss=%d nvs=%d nr=%d nss1=%d  %e\n",n1,n2,n3,n4,nd1,nd2,nasite,ns1,nv1,ns2,nv2,nss,nvs,nr,nss1,cov[nad]);fflush(stdout);
   }         
/*             
   if( pflg == 2 || pflg1 ==2  ) {
      printf("calcv1 n1=%d n2=%d n3=%d n4=%d nd1=%d nd2=%d nasite=%d ns1=%d nv1=%d ns2=%d nv2=%d nss=%d nvs=%d nr=%d nss1=%d  %e\n",n1,n2,n3,n4,nd1,nd2,nasite,ns1,nv1,ns2,nv2,nss,nvs,nr,nss1,cov[nd1][nd2]);
   }         
*/
                break;
	   case 9:
	   case 10:
                nps=0;
                nss=0;
                nvs=0;
                nr=0;
                nss1=0;
                for(i=0; i<npqsite; i++){
                   n=pqsite[i];
                   switch(tr[a[n3][n]][a[n4][n]]){
	         		case -1: /* no difference */
                                           break;
				case 0 : nss1++;
                                         break;
			        case 1 : nvs++;
                                         break;
			        default:   printf("invalid code\n");
                                           exit(1);

			 }
		 }
	   
	   
                 dq1 = nv1;  dq1 /= nasite;
                 dq2 = nv2;  dq2 /= nasite;
                 dqs = nvs; dqs /= nasite;
                 if( dop == 9 ) dw = (dqs -dq1*dq2)/(1.0-2.0*dq1)/(1.0-2.0*dq2);
                 if( dop == 10 ){
                        c1 = pow(1.0-2.0*dq1,-(1.0+1.0/gamma));
                        c2 = pow(1.0-2.0*dq2,-(1.0+1.0/gamma));
                        dw = (dqs -dq1*dq2)*c1*c2;
		      }
                 dw /= nasite;
                 if( comm.covflg == 0 ) cov[nad] = dw;
                 else{
                   if( write(comm.fpcov,&dw,sizeof(double)) == -1 ){
                     printf("write error\n");
                     exit(1);
                   }
                 }
                 break;

     case 11:
     case 12:
                nps=0;
                nss=0;
                nvs=0;
                nr=0;
                nss1=0;
                for(i=0; i<npqsite; i++){
                   n=pqsite[i];
                   switch(tr[a[n3][n]][a[n4][n]]){
	         		case -1: /* no difference */
                                           break;
				case 0 : nss1++;
                                         break;
			        case 1 : nvs++;
                                         break;
			        default:   printf("invalid code\n");
                                           exit(1);

			 }
		 }
                 dq1 = nv1;  dq1 /= nasite;
                 dq2 = nv2;  dq2 /= nasite;
                 dqs = nvs; dqs /= nasite;
                 grx = nbx[0]+nbx[2];
                 gyx = nbx[1]+nbx[3];
                 grx /= 2*nasite;
                 gyx /= 2*nasite;
                 gry = nby[0]+nby[2];
                 gyy = nby[1]+nby[3];
                 gry /= 2*nasite;
                 gyy /= 2*nasite;
                 if( dop == 11 ){
                    d1 = 1.0/(1.0 - dq1/(2.0*grx*gyx));
                    d2 = 1.0/(1.0 - dq2/(2.0*gry*gyy));
                    dw = (dqs -dq1*dq2)*d1*d2;
		  }
                 if( dop == 12 ){
                    d1 = pow(1.0 - dq1/(2.0*grx*gyx),-(1.0+1.0/gamma));
                    d2 = pow(1.0 - dq2/(2.0*gry*gyy),-(1.0+1.0/gamma));
                    dw = (dqs -dq1*dq2)*d1*d2;
		  }
                 dw /= nasite;
                if( comm.covflg == 0 ) cov[nad] =dw ;
                else{
                 if( write(comm.fpcov,&dw,sizeof(double)) == -1 ){
                     printf("write error\n");
                     exit(1);
                   }
                }
                

                 break;
      case 6 :  nps=0;
                nss=0;
                nvs=0;
                nr=0;
                nss1=0;
                for(i=0; i<nppsite; i++){
                   n=ppsite[i];
                   switch(tr[a[n3][n]][a[n4][n]]){
	         		case -1: /* no difference */
                                           break;
				case 0 : nss++;
                                         break;
			        case 1 : nr++;
                                         break;
			        default:   printf("invalid code\n");
                                           exit(1);

			 }
		 }
                for(i=0; i<npqsite; i++){
                   n=pqsite[i];
                   switch(tr[a[n3][n]][a[n4][n]]){
	         		case -1: /* no difference */
                                           break;
				case 0 : nss1++;
                                         break;
			        case 1 : nvs++;
                                         break;
			        default:   printf("invalid code\n");
                                           exit(1);

			 }
		 }
	   
	   
                 dp1 = ns1;  dp1 /= nasite;
                 dp2 = ns2;  dp2 /= nasite;
                 dq1 = nv1;  dq1 /= nasite;
                 dq2 = nv2;  dq2 /= nasite;
                 dps = nss; dps /= nasite;
                 dqs = nvs; dqs /= nasite;
                 dr = nr;   dr /= nasite;
                 ds = nss1; ds /= nasite;	   
                 da1 = pow(1.0-2.0*dp1-dq1,-(1.0/gamma+1.0));	   
                 db1 = da1 + pow(1.0-2.0*dq1,-(1.0/gamma+1.0));
                 db1 /= 2.0;

                 da2 = pow(1.0-2.0*dp2-dq2,-(1.0/gamma+1.0));	   
                 db2 = da2 + pow(1.0-2.0*dq1,-(1.0/gamma+1.0));
                 db2 /= 2.0;
                 dw = da1*da2*(dps-dp1*dp2)+da1*db2*(dr-dp1*dq2)
                                 + da2*db1*(ds-dq1*dp2)+db1*db2*(dqs-dq1*dq2);
                 dw /= nasite;
                 if( comm.covflg == 0 ) dw = cov[nad];
                 else{
                   if( write(comm.fpcov,&dw,sizeof(double)) == -1 ){
                     printf("write error\n");
                     exit(1);
                   }
	        }
               
   if( dflg == 1 ) {
      printf("calcv1 n1=%d n2=%d n3=%d n4=%d nd1=%d nd2=%d nasite=%d ns1=%d nv1=%d ns2=%d nv2=%d nss=%d nvs=%d nr=%d nss1=%d  %e\n",n1,n2,n3,n4,nd1,nd2,nasite,ns1,nv1,ns2,nv2,nss,nvs,nr,nss1,cov[nad]);fflush(stdout);
   }         
                break;


      case 13 :  
                gax = nbx[2];
                gtx = nbx[0];
                ggx = nbx[3];
                gcx = nbx[1];
                gax /= 2*nasite;
                gtx /= 2*nasite;
                ggx /= 2*nasite;
                gcx /= 2*nasite;
                grx = gax+ggx;
                gyx = gtx+gcx;

                gay = nby[2];
                gty = nby[0];
                ggy = nby[3];
                gcy = nby[1];
                gay /= 2*nasite;
                gty /= 2*nasite;
                ggy /= 2*nasite;
                gcy /= 2*nasite;
                gry = gay+ggy;
                gyy = gty+gcy;
                np11=np12=np1q=np21=np22=np2q=nqp1=nqp2=nqq=0;
                for(i=0; i<nppsite; i++){
                   n=ppsite[i];
                   switch(tr1[a[n3][n]][a[n4][n]]){
	         		case 0: /* no difference */
                                           break;
				case 1: np11++;
                                         break;
			        case 2 : np12++;
                                         break;
			        case 3 : np1q++;
                                         break;
			        default:   printf("invalid code\n");
                                           exit(1);

			 }
		 }


                for(i=0; i<np2site; i++){
                   n=p2site[i];
                   switch(tr1[a[n3][n]][a[n4][n]]){
	         		case 0: /* no difference */
                                           break;
				case 1: np21++;
                                         break;
			        case 2 : np22++;
                                         break;
			        case 3 : np2q++;
                                         break;
			        default:   printf("invalid code\n");
                                           exit(1);

			 }
		 }
	   
	     for(i=0; i<npqsite; i++){
                   n=pqsite[i];
                   switch(tr1[a[n3][n]][a[n4][n]]){
	         		case 0: /* no difference */
                                           break;
				case 1: nqp1++;
                                         break;
			        case 2 : nqp2++;
                                         break;
			        case 3 : nqq++;
                                         break;
			        default:   printf("invalid code\n");
                                           exit(1);

			 }
		 }
	   
                dp11=np11;
                dp12=np12;
                dp1q=np1q;
                dp21=np21;
                dp22=np22;
                dp2q=np2q;
                dqp1=nqp1;
                dqp2=nqp2;
                dqq=nqq;	   
	   
                dp11 /= nasite;
                dp12 /= nasite;
                dp1q /= nasite;
                dp21 /= nasite;
                dp22 /= nasite;
                dp2q /= nasite;
                dqp1 /= nasite;
                dqp2 /= nasite;
                dqq /= nasite;
                dp1x = ns1;  dp1x /= nasite;
                dp2x = ns21;  dp2x /= nasite;
                dp1y = ns2;  dp1y /= nasite;
                dp2y = ns22;  dp2y /= nasite;
                dqx = nv1;  dqx /= nasite;
                dqy = nv2;  dqy /= nasite; 
                dwx = 1.0/(1.0 - dqx/(2.0*grx*gyx));
                dwy = 1.0/(1.0 - dqy/(2.0*gry*gyy));
                if( dop == 13 ){
                   xcp1 = 1.0/(1.0-grx*dp1x/(2.0*gax*ggx)-dqx/(2.0*grx));
                   ycp1 = 1.0/(1.0-gry*dp1y/(2.0*gay*ggy)-dqy/(2.0*gry));
                   xcp2 = 1.0/(1.0-gyx*dp2x/(2.0*gtx*gcx)-dqx/(2.0*gyx));
                   ycp2 = 1.0/(1.0-gyy*dp2y/(2.0*gty*gcy)-dqy/(2.0*gyy));
                   xcq  = gax*ggx*xcp1/(grx*grx) + gtx*gcx*xcp2/(gyx*gyx)
                       + (1.0-gax*ggx/(grx*grx)-gtx*gcx/(gyx*gyx))*dwx;
                   ycq  = gay*ggy*ycp1/(gry*gry) + gty*gcy*ycp2/(gyy*gyy)
                       + (1.0-gay*ggy/(gry*gry)-gty*gcy/(gyy*gyy))*dwy;
		 }
                 if( dop == 14 ){
                   xcp1 = pow(1.0-grx*dp1x/(2.0*gax*ggx)-dqx/(2.0*grx),-(1.0+1.0/gamma));
                   ycp1 = pow(1.0-gry*dp1y/(2.0*gay*ggy)-dqy/(2.0*gry),-(1.0+1.0/gamma));
                   xcp2 = pow(1.0-gyx*dp2x/(2.0*gtx*gcx)-dqx/(2.0*gyx),-(1.0+1.0/gamma));
                   ycp2 = pow(1.0-gyy*dp2y/(2.0*gty*gcy)-dqy/(2.0*gyy),-(1.0+1.0/gamma));
                   xcq  = xcp1*gax*ggx/grx/grx + xcp2*gtx*gcx/gyx/gyx;
                   xcq  += (1.0- gax*ggx/grx/grx-gtx*gcx/gyx/gyx)*pow(1.0-dqx/(2.0*grx*gyx),-(1.0+1.0/gamma));

                   ycq  = ycp1*gay*ggy/gry/gry + ycp2*gty*gcy/gyy/gyy;
                   ycq  += (1.0- gay*ggy/gry/gry-gty*gcy/gyy/gyy)*pow(1.0-dqy/(2.0*gry*gyy),-(1.0+1.0/gamma));
		}
                
                    dw = (dp11-dp1x*dp1y)*xcp1*ycp1
                    + (dp12-dp1x*dp2y)*xcp1*ycp2
                    + (dp1q-dp1x*dqy)*xcp1*ycq
                    + (dp21-dp2x*dp1y)*xcp2*ycp1
                    + (dp22-dp2x*dp2y)*xcp2*ycp2
                    + (dp2q-dp2x*dqy)*xcp2*ycq
                    + (dqp1-dqx*dp1y)*xcq*ycp1
                    + (dqp2-dqx*dp2y)*xcq*ycp2
                    + (dqq-dqx*dqy)*xcq*ycq;
                dw /= nasite;
                if( comm.covflg == 0 ) cov[nad]=dw;
                else{
                 if( write(comm.fpcov,&dw,sizeof(double)) == -1 ){
                     printf("write error\n");
                     exit(1);
                   }
                }
                break;

	   }


    if( dflg == 2 ){
             printf("nd1=%d nd2=%d nad=%d cov=%f\n",nd1,nd2,nad,cov[nad]);
            fflush(stdout);
    }
   return(0);
    


	   }




covad(nd1,nd2,ndist)
int nd1,nd2,ndist;
{
int m,iw;

  if( nd1 > nd2 ){
      iw = nd1;
      nd1 = nd2;
      nd2 = iw;
  }
  m = ndist;
 
  iw = nd1*(2*m-nd1-1)/2 + nd2 - nd1-1;
  return(iw);
}

int distad(s1,s2,nseq)
int s1,s2,nseq;
{
int iw;
  if( s1 > s2 ){
    iw = s1;
    s1 = s2;
    s2 = iw;
  }

  return( s1*(2*nseq-s1-1)/2 + s2 - s1-1);
}



calcova(a,nseq0,nsite,nasite,npsite,asite,dop,dist,ndif,gamma,cov)
char **a/*[MAXSITE][MAXOTU]*/;
int nseq0,nsite,nasite,*asite,dop;
double **dist/*[MAXOTU][MAXOTU]*/,gamma,*cov;
int **ndif/*[MAXOTU][MAXOTU]*/;
{
int i,j,k,l,npb,np1,np2,np3,ns1,ns2,nv1,nv2,nd1,nd2,n;
int n1,n2,n3,n4,rn,ndist;
double sp,dp,dq,dsp,da,db,dw;
int *ppsite/*[MAXSITE]*/,*pqsite/*[MAXSITE]*/,nppsite,npqsite;
   ppsite = ivector(nsite);
   pqsite = ivector(nsite);

    if( dflg == 1 ) printf("dop=%d nseq0=%d gamma=%f\n",dop,nseq0,gamma);

   ndist = nseq0*(nseq0-1)/2;
   nd1=0;
   n=0;
   for(i=0; i<nseq0-1; i++){
     for(j=i+1; j<nseq0; j++){
     rn=distva(nasite,npsite,asite,nd1,a,i,j,dop,dist,&np1,gamma);
     n++;
     switch(dop){
        case 3: ndif[i][j]=ndif[j][i]=np1;
                break;
        case 4: ndif[i][j]=ndif[j][i]=np1;
                break;
        case 7: ndif[i][j]=ndif[j][i]=np1;
                break;
        default: printf("invalid option dop=%d\n",dop);
                 exit(1);
	}
      nd1++;
   }
   }
 
   if( n != nseq0*(nseq0-1)/2 ){
     printf("calcov n=%d  %d\n",n,nseq0*(nseq0-1)/2);
     exit(1);
   }
    if( dflg == 1 ) printf("dop=%d\n",dop);
     nd1=0;
     n=0;
     for(i=0; i<nseq0; i++){
       for(j=i+1; j<nseq0 ; j++){
       getpsitea(ppsite,pqsite,&nppsite,&npqsite,i,j,a,dop,asite,npsite);
       if( dflg == 1 ) printf("get psite dop=%d\n",dop);
       switch(dop){
         case 3: np1 = ndif[i][j];
                 break;
         case 4: np1 = ndif[i][j];
                 break;
         case 7: np1 = ndif[i][j];
                 break;
	 }
       k=i;
       nd2=nd1;


       for(l=j+1; l<nseq0 ; l++){
          n++;
          switch(dop){
             case 3: np2 = ndif[k][l];
                     break;
             case 4: np2 = ndif[k][l];
                     break;
             case 7: np2 = ndif[k][l];
                     break;
          }
          

        nd2++;
/*       printf("dop=%d\n",dop);    */
       if( dflg == 1 ) {
          printf("ns2=%d nv2=%d gamma=%f\n",ns2,nv2,gamma); fflush(stdout);
         }          
       calcv1a(nasite,asite,a,i,j,k,l,nd1,nd2,dop,np1,np2,nppsite,ppsite,gamma,ndist,cov);
       }
       if( dflg == 1) {
            printf("after calcv1a\n");fflush(stdout);
	  }
     for(k=i+1; k<nseq0 ; k++){
       for(l=k+1; l<nseq0 ; l++){
        nd2++;
        n++;
        switch(dop){
         case 3: np2 = ndif[k][l];
                 break;
         case 4: np2 = ndif[k][l];
                 break;
         case 7: np2 = ndif[k][l];
                 break;
	 }
/*       printf("dop=%d\n",dop); */
/*       printf("ns2=%d nv2=%d",ns2,nv2);*/
       calcv1a(nasite,asite,a,i,j,k,l,nd1,nd2,dop,np1,np2,nppsite,ppsite,gamma,ndist,cov);
/*      printf(" %d %d %d %d   %d %d %e\n",i,j,k,l,nd1,nd2,cov[nd1][nd2]); */
      }
     }
     nd1++;
   }
   }
   if( n != nseq0*(nseq0-1)/2*(nseq0*(nseq0-1)/2-1)/2 ){
     printf("calcov n=%d nseq0*(nseq0-1)/2*(nseq0*(nseq0-1)/2-1)/2=%d\n",n,nseq0*(nseq0-1)/2*(nseq0*(nseq0-1)/2-1)/2);
     exit(1);
   }

   free_ivector(ppsite,nsite);
   free_ivector(pqsite,nsite);
     return(0);

}
getpsitea(ppsite,pqsite,nppsite,npqsite,s1,s2,a,dop,asite,npsite)
int *ppsite/*[MAXSITE]*/,*pqsite/*[MAXSITE]*/,*nppsite,*npqsite,s1,s2,dop,*asite,npsite;
char **a/*[MAXSITE][MAXOTU]*/;
{
int i,n;

   *nppsite=0;
   *npqsite=0;
   for(i=0; i<npsite; i++){
      n = asite[i];
      switch(dop){
        case 3:
        case 4:
        case 7:

                   if( a[s1][n] !=  a[s2][n] ){
                        ppsite[*nppsite] = n;
                        (*nppsite)++;
		      }
                   break;
       default : printf("invalid distance option\n");
                 exit(1);
	      }
    }
    return(0);
}

distva(nasite,npsite,asite,nd1,a,s1,s2,dop,dist,np,gamma)
int s1,s2,dop,nasite,npsite,*asite,*np,nd1;
char **a/*[MAXSITE][MAXOTU]*/;
double **dist/*[MAXOTU][MAXOTU]*/,gamma;
{
int k,np1;
double sp,dp,dq,da,db,dsq,dw;

/*         printf("distv s1=%d s2=%d nd1=%d",s1,s2,nd1);            */
/*         if( dflg == 1 ) printf("dop=%d\n",dop);*/
         switch(dop){
            case 3:   np1=0;
                      for(k=0; k<npsite ; k++){
                        if(a[s1][asite[k]] != a[s2][asite[k]] ){
			         np1++;
		         }
		      }
                      sp = np1;
                      sp /= nasite;
                      dist[s1][s2]=sp;
                      dist[s2][s1] = sp*(1.0-sp);
                      dist[s2][s1] /= nasite;
                      (*np) = np1;
                      return(0);

            case 4:   np1=0;   /* Poisson correction */
                      for(k=0; k<npsite ; k++){
                        if(a[s1][asite[k]] != a[s2][asite[k]] ){
			         np1++;
		         }
		      }
                      sp = np1;
                      sp /= nasite;
                      dw = 1.0-sp/0.95;
                      if( dw <= 0.0 ){
                        printf("inapplicable distance %d %d sp=%f\n",s1,s2,sp);
                        exit(1);
		      }
                      dist[s1][s2]=-0.95*log(dw);
                      dist[s2][s1] = sp*(1.0-sp)/(dw)/(dw);
                      dist[s2][s1] /= nasite;
                      (*np) = np1;
                      return(0);
            case 7:   np1=0;   /* Poisson correction */
                      for(k=0; k<npsite ; k++){
                        if(a[s1][asite[k]] != a[s2][asite[k]] ){
			         np1++;
		         }
		      }
                      sp = np1;
                      sp /= nasite;
                      dw = 1.0-sp/0.95;
                      if( dw <= 0.0 ){
                        printf("inapplicable distance %d %d sp=%f\n",s1,s2,sp);
                        exit(1);
		      }
                      dist[s1][s2] = 0.95*gamma*(pow(dw,-1.0/gamma)-1.0);
                        
                      dist[s2][s1] = sp*(1.0-sp)*pow(dw,-2.0*(1.0/gamma+1.0));
                      dist[s2][s1] /= nasite;
/*                      printf("var[%d][%d]=%f\n",dist[s2][s1]);*/
                      (*np) = np1;
                      return(0);



	    }
}
calcv1a(nasite,asite,a,n1,n2,n3,n4,nd1,nd2,dop,np1,np2,nppsite,ppsite,gamma,ndist,cov)
int nasite,*asite,n1,n2,n3,n4,nd1,nd2,dop,np1,np2,nppsite,*ppsite,ndist;
char **a/*[MAXSITE][MAXOTU]*/;
double gamma,*cov;
{
int i,n,nps,nss,nvs,nr,nss1,pflg,pflg1,nad;
double da1,db1,da2,db2,dp1,dp2,dps,sp1,sp2,dq1,dq2,dr,ds,dqs,dw;

 if( dflg ==  1 ){
      printf("calcv1a start gamma=%f\n",gamma); fflush(stdout);
    }
   nad = covad(nd1,nd2,ndist);

 if( dflg == 1 ){
      printf("nad=%d\n",nad);
/*      printf("n1 n2 n3 n4 %d %d %d %d  nd1=%d nd2=%d gamma=%f\n",n1,n2,n3,n4,nd1,nd2,gamma); */
      fflush(stdout);
      printf("cov[0]=%f\n",cov[0]);
      fflush(stdout);
    }
   switch(dop){
      case 3:
             nps=0;
             for(i=0; i<nppsite ; i++){
               n = ppsite[i];
               if( a[n3][n] != a[n4][n] )  nps++;
             }
             dps = nps;
             dps /= nasite;
             dp1 = np1;
             dp1 /= nasite;
             dp2 = np2;
             dp2 /= nasite;
             dw = (dps-dp1*dp2)*sqrt(dp1*(1.0-dp1)*dp2*(1.0-dp2));
             dw /= nasite;
             if( comm.covflg == 0 ) cov[nad] = dw;
             else{
                 if( write(comm.fpcov,&dw,sizeof(double)) == -1 ){
                     printf("write error\n");
                     exit(1);
                   }
	     }

/*             printf("nps=%d np1=%d np2=%d cov=%e\n",nps,np1,np2,cov[nd1][nd2]); */
             break;
     

     case 4:
             nps=0;
             for(i=0; i<nppsite ; i++){
               n = ppsite[i];
               if( a[n3][n] != a[n4][n] ) nps++;
	     }
             dps = nps;
             dps /= nasite;
             dp1 = np1;
             dp1 /= nasite;
             dp2 = np2;
             dp2 /= nasite;
             dw = (dps-dp1*dp2)/(1.0-dp1/0.95)/(1.0-dp2/0.95);
             dw /= nasite;
             if( comm.covflg == 0 ) cov[nad] =dw;
             else{
                 if( write(comm.fpcov,&dw,sizeof(double)) == -1 ){
                     printf("write error\n");
                     exit(1);
                   }
	     }

             break;

     case 7:
            if( dflg ==1 ){
              printf("nps=%d\n"); fflush(stdout);
              printf("gamma=%f nppsite=%d\n",gamma,nppsite); fflush(stdout);
	    }
             nps=0;
             for(i=0; i<nppsite ; i++){
               n = ppsite[i];
               if( a[n3][n] != a[n4][n] ) nps++;
	     }
            if( dflg ==1 ){
              printf("nppsite=%d\n",nppsite); fflush(stdout);
              printf("gamma=%f nad=%d nasite=%d\n",gamma,nad,nasite); fflush(stdout);
	    }
             nps=0;
             dps = nps;
             dps /= nasite;
             dp1 = np1;
             dp1 /= nasite;
             dp2 = np2;
             dp2 /= nasite;
             dw = (dps-dp1*dp2)*pow((1.0-dp1/0.95)*(1.0-dp2/0.95),-(1.0/gamma+1.0));
             dw /= nasite;
             if( comm.covflg == 0 ) cov[nad] = dw ;
             else{
                 if( write(comm.fpcov,&dw,sizeof(double)) == -1 ){
                     printf("write error\n");
                     exit(1);
                   }
	     }
             if( dflg == 1 ){
               fflush(stdout);
	     }
/*            printf("cov[%d]=%f\n",nad,cov[nad]); */
            break;
     
	   }


                                             

if( dflg == 1) {
   printf("calcv1a end\n"); fflush(stdout);
 }
return(0);

    
}
                 

partition(ac,cur)
Tnodeptr ac,cur;
{
Tnodeptr tpw;
Branchptr  bpw;
double *bw,dsum,raw,rbw,rcw;
int flg,i,j,nw,nm,nc,na,nlp,nrp;
unsigned char nx,ny;
char *pc;

/* 
   tnodex  ancestor 
   tnodey  right
   tnodez  left
 */
     if( dflg == 1 ){
         printf("cur %d",cur->nkey);
         if( cur->tnodex != NULL ) printf(" x %d",cur->tnodex->nkey);
         if( cur->tnodey != NULL ) printf(" y %d",cur->tnodey->nkey);
         if( cur->tnodez != NULL ) printf(" z %d",cur->tnodez->nkey);
         printf(" bx x=%d y=%d\n",cur->bx->tnodex->nkey,cur->bx->tnodey->nkey);
         printf("\n"); fflush(stdout);
       }

    flg = 0;
    if( cur->tnodex  == ac ) flg += 1;
    if( cur->tnodey == ac ){
        flg += 2;
        tpw=cur->tnodey;
        cur->tnodey = cur->tnodex;
        cur->tnodex = tpw;
        bpw = cur->by;
        cur->by = cur->bx;
        cur->bx = bpw;

      }

    if( cur->tnodez == ac ){
        tpw=cur->tnodez;
        cur->tnodez = cur->tnodex;
        cur->tnodex = tpw;
        bpw = cur->bz;
        cur->bz = cur->bx;
        cur->bx = bpw;
        flg += 3;
      }

    if( flg < 1 || flg > 3 ){
       printf("flg =%d\n",flg);
       printf("cur %d",cur->nkey);
       if( cur->tnodex != NULL ) printf(" x %d",cur->tnodex->nkey);
       if( cur->tnodey != NULL ) printf(" y %d",cur->tnodey->nkey);
       if( cur->tnodez != NULL ) printf(" z %d",cur->tnodez->nkey);
        printf("\n");
       exit(1);
     }


    if( cur->tnodey != NULL) partition(cur,cur->tnodey);

    if( cur->tnodez != NULL) partition(cur,cur->tnodez);

    if( cur->tnodey == NULL && cur->tnodez == NULL ){
       if( cur->nkey >= comm.nseq ){
           fprintf(ERR,"tree node error %d\n",cur->nkey);
           exit(1);
	 }
        pc = cur->bx->partptr;
        if( dflg == 1 ) {
          printf("cur %d ",cur->nkey+1);
          prpart1(comm.nseq,pc);
	}
        biton(pc,cur->nkey+1);
        if( dflg == 1 ) {
          printf("cur %d ",cur->nkey+1);
          prpart1(comm.nseq,pc);
	}
        if( cur->bx->tnodey == cur ){
            tpw = cur->bx->tnodey;
            cur->bx->tnodey = cur->bx->tnodex;
            cur->bx->tnodex = tpw;
	  }
     }
  
   if( cur->tnodez != NULL && cur->tnodey != NULL && cur->tnodex->nkey >= comm.nseq ){
       for(i=0; i< (comm.nseq-1)/8 +1 ; i++){
         cur->bx->partptr[i] = cur->by->partptr[i] | cur->bz->partptr[i];
	 }
       if( cur->bx->tnodey == cur ){
            tpw = cur->bx->tnodey;
            cur->bx->tnodey = cur->bx->tnodex;
            cur->bx->tnodex = tpw;
	  }
     }
   if( cur->tnodez != NULL && cur->tnodey != NULL && cur->tnodex->nkey < comm.nseq ){
        biton(cur->bx->partptr,cur->tnodex->nkey+1);
        if( cur->bx->tnodey == cur->tnodex ){
            tpw = cur->bx->tnodey;
            cur->bx->tnodey = cur->bx->tnodex;
            cur->bx->tnodex = tpw;
	  }
      }


   if( dflg == 1 ) printf("cur %d\n",cur->nkey);
   return(0);
}


biton(cp,n)
char *cp;
int n;
{
int na,nm;
unsigned char nx,ny;


/*   printf("biton start n=%d\n",n); fflush(stdout); */

   nm = (n-1)/8;
   na = (n-1)%8;
   if( dflg == 1 ) printf("biton nm=%d na=%d\n",nm,na); fflush(stdout); 
   nx = 0x80;
   nx >>= na;
   if( dflg == 1 )  printf("biton nx=%02x",nx); fflush(stdout);
   cp[nm] = nx;
   if( dflg == 1 ) printf("biton end\n"); fflush(stdout);  
   return(0);
}


prpart(nseq,parttbl,branchv)
int nseq;
char **parttbl;
Branch **branchv;
{
int i,j,nb;

  for(i=0; i< 2*nseq-3 ; i++){
     printf("i=%3d %2d %2d  ",i,branchv[i]->tnodex->nkey+1,branchv[i]->tnodey->nkey+1);
     for(j=0; j<nseq ; j++){
       nb=getbit(parttbl,i,j);
       printf("%d",nb);
     }
     printf("\n");
   }
   return(0);
}




prpart1(nseq,part)
int nseq;
char *part;
{
int i,j,nb;

     for(j=0; j<nseq ; j++){
       nb=getbit1(part,j);
       printf("%d",nb);
     }
     printf("\n");

   return(0);
}




getbit(parttbl,i,j)
int i,j;
char **parttbl;
{
int nm,na;
unsigned char nx,ny,nz;

 
nx = 0x80;

 nm = j/8;
 na = j%8;

 nx >>= na;

  ny = nx & parttbl[i][nm];
  
  if( ny != 0 ) return(1);
  return(0);
}



getbit1(part,j)
int j;
char *part;
{
int nm,na;
unsigned char nx,ny,nz;

 
nx = 0x80;

 nm = j/8;
 na = j%8;

 nx >>= na;

  ny = nx & part[nm];
  
/*   printf("j=%d ny =%02x nx=%02x   part[%d]=%02x\n",ny,nx,part[nm]); */
  if( ny != 0 ) return(1);
  return(0);
}


prtree(fpo,nseq,branchv,seqname,dop,cdnpos,nsite,nasite,npsite,nrepn,tvalues)
FILE *fpo;
int nseq,dop,cdnpos[3],nsite,nasite,npsite,nrepn;
Branch **branchv;
char **seqname;
float *tvalues;
{
int i,n1,n2,nw,tw;
char c,c1;

    c =0xb1;
    c1 = '%';

    fprintf(fpo,"%d sequences",nseq); fflush(fpo);
/*    if( nrepn > 0 ) fprintf(fpo,"        %d bootstraping",nrepn); */
    fprintf(fpo,"\n");
    for(i=0; i<nseq ; i++){
      if( tvalues[i] < -90. ){
         fprintf(fpo,"%d %s(NA)\n",i+1,seqname[i]);
       }else{
          tw = tvalues[i]*100.0;
          if( tw < 0 ) fprintf(fpo,"%d %s\n",i+1,seqname[i]);
          else fprintf(fpo,"%d %s(%d)\n",i+1,seqname[i],tw);
	}
    }

    for(i=0; i< 2*nseq - 3 ; i++){
      n1 = branchv[i]->tnodex->nkey+1;
      n2 = branchv[i]->tnodey->nkey+1;
      ilarg(&n1,&n2);
      fprintf(fpo,"%3d  and  %3d    %f",n1,n2,branchv[i]->blength);
/*       if( nrepn > 0 ) fprintf(fpo,"         %4d",branchv[i]->nbtbp); */
       fprintf(fpo,"\n");
    }

    fprintf(fpo,"\n");
    fprintf(fpo,"branch length reestimation: %s was used\n",dname[dop]);
    fprintf(fpo,"#sites %d   #actual sites %d   #polymorphic sites %d\n",nsite,
            nasite,npsite);
    if( cdnpos[0]+cdnpos[1]+cdnpos[2] != 3 ){
           fprintf(fpo,"codon position:");
           for(i=0; i<3 ; i++){
              if( cdnpos[i] == 1 ) fprintf(fpo," %d",i+1);
           } 
           fprintf(fpo,"\n");
     } 
     return(0);
}








ilarg(n1,n2)
int *n1,*n2;
{
int iw;

   if( *n1 < *n2 ){
      iw  =  *n1;
      *n1 =  *n2;
      *n2 =  iw;
}
    return(0);
} 

basefr(a,nseq,nasite,asite,nbal)
char **a;
int nseq,nasite,*asite,**nbal;
{
int i,j,n1;

for(i=0; i<nseq ; i++){
  for(j=0; j<4 ; j++) nbal[i][j]=0;
}
for(i=0; i<nseq ; i++){
  for(j=0; j<nasite ; j++){
      n1=a[i][asite[j]];
      if( n1 > 5 ) {
         printf("seq %d invalid base %d %c %d  i=%d j=%d asite[j]=%d\n",i,n1,n1,asite[j],i,j,asite[j]);
      } 
      nbal[i][n1]++;
    }
}
return(0);
}


brest(nseq,br,dist,ma,mb,mc,md)
int nseq,*ma,*mb,*mc,*md;
Branch **br;
double **dist;
{
int i,j;
int na,nb,nc,nd;
char *pa,*pb,*pc,*pd;
int fa,fb,fc,fd;
Branchptr ba,bb,bc,bd,be;
double getextb(),getintb();


  if( dflg == 1 ){
    printf("nseq=%d m a b c d %p %p %p %p   nseq %d\n",nseq,ma,mb,mc,md);
    printf("m a b c d  %p %p %p %p\n",&ma[nseq],&mb[nseq],&mc[nseq],&md[nseq]);
  }
  for(i=0; i<2*nseq-3 ; i++){
   if( dflg == 1 ) printf("i=%d nseq=%d br %p x %d y=%d\n",i,nseq,br[i],br[i]->tnodex->nkey,br[i]->tnodey->nkey);fflush(stdout);
   if( br[i]->tnodex->nkey <  nseq ){
                /* br[i]->tnodey -- N  */
      nc = 1;
      mc[0] = br[i]->tnodex->nkey;
     if( br[i]->tnodey->tnodex == br[i]->tnodex ){
         pa = br[i]->tnodey->by->partptr;
         pb = br[i]->tnodey->bz->partptr;
         if( br[i]->tnodey->by->tnodex == br[i]->tnodey ) fa = 0;
	 else fa = 1;
         if( br[i]->tnodey->bz->tnodex == br[i]->tnodey ) fb = 0;
	 else fb = 1;
       }
      if( br[i]->tnodey->tnodey == br[i]->tnodex ){
         pa = br[i]->tnodey->bx->partptr;
         pb = br[i]->tnodey->bz->partptr;
         if( br[i]->tnodey->bx->tnodex == br[i]->tnodey ) fa = 0;
	 else fa = 1;
         if( br[i]->tnodey->bz->tnodex == br[i]->tnodey ) fb = 0;
	 else fb = 1;
       }
      if( br[i]->tnodey->tnodez == br[i]->tnodex ){
         pa = br[i]->tnodey->bx->partptr;
         pb = br[i]->tnodey->by->partptr;
         if( br[i]->tnodey->bx->tnodex == br[i]->tnodey ) fa = 0;
	 else fa = 1;
         if( br[i]->tnodey->by->tnodex == br[i]->tnodey ) fb = 0;
	 else fb = 1;
       }
       if( fa == 1 ) geton(&na,ma,pa,nseq);
       else getoff(&na,ma,pa,nseq);
       if( fb == 1 ) geton(&nb,mb,pb,nseq);
       else getoff(&nb,mb,pb,nseq);
       br[i]->blength=getextb(na,nb,nc,ma,mb,mc,dist);     
      if( dflg == 1 ){
         printf("i=%d b x %d y %d ",i,br[i]->tnodex->nkey,br[i]->tnodey->nkey);
         printf("na =%d",na);
         for(j=0; j<na ; j++) printf(" %d",ma[j]);
         printf("\n");
         printf("nb =%d",nb);
         for(j=0; j<nb ; j++) printf(" %d",mb[j]);
         printf("\n");
         printf("nc =%d",nc);
         for(j=0; j<nc ; j++) printf(" %d",mc[j]);
         printf("\n");
         printf("i=%d b=%f\n",i,br[i]->blength);fflush(stdout);
       }

       continue;
    }


   if( br[i]->tnodey->nkey <  nseq ){
                /* br[i]->tnodey -- N  */
      nc = 1;
      mc[0] = br[i]->tnodey->nkey;
     if( br[i]->tnodex->tnodex == br[i]->tnodey ){
         pa = br[i]->tnodex->by->partptr;
         pb = br[i]->tnodex->bz->partptr;
         if( br[i]->tnodex->by->tnodex == br[i]->tnodey ) fa = 0;
	 else fa = 1;
         if( br[i]->tnodex->bz->tnodex == br[i]->tnodey ) fb = 0;
	 else fb = 1;
       }
      if( br[i]->tnodex->tnodey == br[i]->tnodey ){
         pa = br[i]->tnodex->bx->partptr;
         pb = br[i]->tnodex->bz->partptr;
         if( br[i]->tnodex->bx->tnodex == br[i]->tnodey ) fa = 0;
	 else fa = 1;
         if( br[i]->tnodex->bz->tnodex == br[i]->tnodey ) fb = 0;
	 else fb = 1;
       }
      if( br[i]->tnodey->tnodez == br[i]->tnodex ){
         pa = br[i]->tnodex->bx->partptr;
         pb = br[i]->tnodex->by->partptr;
         if( br[i]->tnodex->bx->tnodex == br[i]->tnodey ) fa = 0;
	 else fa = 1;
         if( br[i]->tnodex->by->tnodex == br[i]->tnodey ) fb = 0;
	 else fb = 1;
       }
       if( fa == 1 ) geton(&na,ma,pa,nseq);
       else getoff(&na,ma,pa,nseq);
       if( fb == 1 ) geton(&nb,mb,pb,nseq);
       else getoff(&nb,mb,pb,nseq);
       br[i]->blength=getextb(na,nb,nc,ma,mb,mc,dist);
       if( dflg == 1 ){
         printf("i=%d b x %d y %d ",i,br[i]->tnodex->nkey,br[i]->tnodey->nkey);
         printf("na =%d",na);
         for(j=0; j<na ; j++) printf(" %d",ma[j]);
         printf("\n");
         printf("nb =%d",nb);
         for(j=0; j<nb ; j++) printf(" %d",mb[j]);
         printf("\n");
         printf("nc =%d",nc);
         for(j=0; j<nc ; j++) printf(" %d",mc[j]);
         printf("\n");
         printf("i=%d b=%f\n",i,br[i]->blength);fflush(stdout);

       }
       
       continue;
    }
   if( dflg == 1 ) {
      printf("i=%d bx %d x %d y %d z %d   by %d x %d y %d z %d\n",i,br[i]->tnodex->nkey, 
      br[i]->tnodex->tnodex->nkey,br[i]->tnodex->tnodey->nkey,br[i]->tnodex->tnodez->nkey,
      br[i]->tnodey->nkey, 
      br[i]->tnodey->tnodex->nkey,br[i]->tnodey->tnodey->nkey,br[i]->tnodey->tnodez->nkey); fflush(stdout);
    }
   if( br[i]->tnodex->tnodex == br[i]->tnodey && br[i]->tnodey->tnodex == br[i]->tnodex ){
        ba = br[i]->tnodex->by;   
        bb = br[i]->tnodex->bz;   
        bc = br[i]->tnodey->by;   
        bd = br[i]->tnodey->bz;   
      }
   if( br[i]->tnodex->tnodex == br[i]->tnodey && br[i]->tnodey->tnodey == br[i]->tnodex ){
        ba = br[i]->tnodex->by;   
        bb = br[i]->tnodex->bz;   
        bc = br[i]->tnodey->bx;   
        bd = br[i]->tnodey->bz;   
      }
   if( br[i]->tnodex->tnodex == br[i]->tnodey && br[i]->tnodey->tnodez == br[i]->tnodex ){
        ba = br[i]->tnodex->by;   
        bb = br[i]->tnodex->bz;   
        bc = br[i]->tnodey->bx;   
        bd = br[i]->tnodey->by;   
      }
   if( br[i]->tnodex->tnodey == br[i]->tnodey && br[i]->tnodey->tnodex == br[i]->tnodex ){
        ba = br[i]->tnodex->bx;   
        bb = br[i]->tnodex->bz;   
        bc = br[i]->tnodey->by;   
        bd = br[i]->tnodey->bz;   
      }
   if( br[i]->tnodex->tnodey == br[i]->tnodey && br[i]->tnodey->tnodey == br[i]->tnodex ){
        ba = br[i]->tnodex->bx;   
        bb = br[i]->tnodex->bz;   
        bc = br[i]->tnodey->bx;   
        bd = br[i]->tnodey->bz;   
      }
     if( br[i]->tnodex->tnodey == br[i]->tnodey && br[i]->tnodey->tnodez == br[i]->tnodex ){
        ba = br[i]->tnodex->bx;   
        bb = br[i]->tnodex->bz;   
        bc = br[i]->tnodey->bx;   
        bd = br[i]->tnodey->by;   
      }
     if( br[i]->tnodex->tnodez == br[i]->tnodey && br[i]->tnodey->tnodex == br[i]->tnodex ){
        ba = br[i]->tnodex->bx;   
        bb = br[i]->tnodex->by;   
        bc = br[i]->tnodey->by;   
        bd = br[i]->tnodey->bz;   
      }
       if( br[i]->tnodex->tnodez == br[i]->tnodey && br[i]->tnodey->tnodey == br[i]->tnodex ){
        ba = br[i]->tnodex->bx;   
        bb = br[i]->tnodex->by;   
        bc = br[i]->tnodey->bx;   
        bd = br[i]->tnodey->bz;   
      }
       if( br[i]->tnodex->tnodez == br[i]->tnodey && br[i]->tnodey->tnodez == br[i]->tnodex ){
        ba = br[i]->tnodex->bx;   
        bb = br[i]->tnodex->by;   
        bc = br[i]->tnodey->bx;   
        bd = br[i]->tnodey->by;   
      }
    fa=fb=fc=fd=1;
    if( ba->tnodex == br[i]->tnodex ) fa=0;
    if( bb->tnodex == br[i]->tnodex ) fb=0;
    if( bc->tnodex == br[i]->tnodey ) fc=0;
    if( bd->tnodex == br[i]->tnodey ) fd=0;
/*    printf("f %d %d %d %d\n",fa,fb,fc,fd); fflush(stdout); */
    if( fa == 0 ) getoff(&na,ma,ba->partptr,nseq);
    if( fa == 1 ) geton(&na,ma,ba->partptr,nseq);
    if( fb == 0 ) getoff(&nb,mb,bb->partptr,nseq);
    if( fb == 1 ) geton(&nb,mb,bb->partptr,nseq);
    if( fc == 0 ) getoff(&nc,mc,bc->partptr,nseq);
    if( fc == 1 ) geton(&nc,mc,bc->partptr,nseq);
    if( fd == 0 ) getoff(&nd,md,bd->partptr,nseq);
    if( fd == 1 ) geton(&nd,md,bd->partptr,nseq);
    br[i]->blength=getintb(na,nb,nc,nd,ma,mb,mc,md,dist); 
    if( dflg == 1 ){
       printf("i=%d b x %d y %d ",i,br[i]->tnodex->nkey,br[i]->tnodey->nkey);
       printf("na =%d",na);
       for(j=0; j<na ; j++) printf(" %d",ma[j]);
       printf("\n");
       printf("nb =%d",nb);
       for(j=0; j<nb ; j++) printf(" %d",mb[j]);
       printf("\n");
       printf("nc =%d",nc);
       for(j=0; j<nc ; j++) printf(" %d",mc[j]);
       printf("\n");
       printf("nd =%d",nd);
       for(j=0; j<nd ; j++) printf(" %d",md[j]);
       printf("\n");
     }
/*    printf("f %d %d %d %d\n",fa,fb,fc,fd); fflush(stdout); */


 }

/*   printf("brest end\n"); fflush(stdout); */

   return(0);
 }















geton(nx,mx,part,nseq)
int *nx,*mx,nseq;
char *part;
{
int i,j,nm,nn;
unsigned char cw,cs;
  
  (*nx) = 0;
  for(i=0; i<nseq ; i++){
     nm = i/8;
     nn = i%8;
     cw = 0x80;
     cw >>= nn;
     cs = cw & part[nm];
     if( cs != 0 ){
        mx[(*nx)] = i;
        (*nx)++;
      }
   }

/*    printf("geton nx=%d\n",*nx); */
   return(0);
}


getoff(nx,mx,part,nseq)
int *nx,*mx,nseq;
char *part;
{
int i,j,nm,nn;
unsigned char cw,cs;
  
  (*nx) = 0;
  for(i=0; i<nseq ; i++){
     nm = i/8;
     nn = i%8;
     cw = 0x80;
     cw >>= nn;
     cs = cw & part[nm];
     if( cs == 0 ){
        mx[(*nx)] = i;
        (*nx)++;
      }
   }
/*    printf("getoff nx=%d\n",*nx); */
   return(0);
}

double getintb(na,nb,nc,nd,ma,mb,mc,md,dist)
int na,nb,nc,nd,*ma,*mb,*mc,*md;
double **dist;
{
int i,j,k,l;
double dac,dbd,dbc,dad,dab,dcd,gw,bw;
double getdsum();

   dac=dbd=dbc=dad=dab=dcd=0.0;
   dac=getdsum(na,nc,ma,mc,dist);
   dbd=getdsum(nb,nd,mb,md,dist);
   dbc=getdsum(nb,nc,mb,mc,dist);
   dad=getdsum(na,nd,ma,md,dist);
   dab=getdsum(na,nb,ma,mb,dist);
   dcd=getdsum(nc,nd,mc,md,dist);
 
   gw = nb*nc+na*nd;
   gw /= (na+nb)*(nc+nd);
   
  bw = 0.5*(gw*(dac + dbd) + (1.0-gw)*(dbc+dad) - dab - dcd);
  return(bw);
}

double getextb(na,nb,nc,ma,mb,mc,dist)
int na,nb,nc,*ma,*mb,*mc;
double **dist;
{
int i,j,k,l;
double dac,dbc,dab,bw;
double getdsum();

   dac=dbc=dab=0.0;
   dac=getdsum(na,nc,ma,mc,dist);
   dbc=getdsum(nb,nc,mb,mc,dist);
   dab=getdsum(na,nb,ma,mb,dist);

   bw = 0.5*(dac + dbc - dab );   

  return(bw);
}






double getdsum(nx,ny,mx,my,dist)
int nx,ny,*mx,*my;
double **dist;
{
int i,j,ni,nj;
double dxy;

  dxy=0.0;
  for(i=0; i<nx ; i++){
    for(j=0; j<ny ; j++){
      ni = mx[i];
      nj = my[j];
      smal(&ni,&nj);
      dxy += dist[ni][nj];
    }
  }
  dxy /= nx*ny;
  return(dxy);
}
     
smal(ni,nj)
int *ni,*nj;
{
int iw;
  if( *ni > *nj ){
     iw = *ni;
     *ni = *nj;
     *nj = iw;
   }
   return(0);
}



chi2test(nseq,mseq,nmseq,tnodev,dav,davcf,dist,cov,delq,tvalues,delta,deltav,deltavw)
int nseq,*mseq,nmseq;
Tnode **tnodev;
double dav,*davcf,**dist,*cov,*delq,*delta,**deltav,*deltavw;
float *tvalues;
{
int i,j,ndist,degrees;
double dw,**B,**Temp,*dc;
double *dvector(),**dmatrix();
char *dpm,*cvector(),cs;
double getdv(),getdcvij();
extern float ttest();

/*   printf("nmseq=%d\n",nmseq); FLUSH; */
   dc = dvector(nmseq);
   dpm = cvector(nmseq);
   B = dmatrix(nmseq,nmseq);
   Temp = dmatrix(nmseq,nmseq);
   ndist = nseq*(nseq-1)/2;

/*   printf("dav=%f\n",dav); */
   for(i=0; i< nmseq ; i++){
       dw = tnodev[mseq[i]]->height - dav;
/*       printf("mseq[%d]=%d height %f dav=%f\n",i,mseq[i],tnodev[mseq[i]]->height,dav); FLUSH; */
       dpm[i]=0;
       if( dw < 0.0 ){
         dpm[i] = 1;
         dw *= -1.0;
       }
       delta[i]=dw;
       deltav[i][i] = getdv(nseq,tnodev[mseq[i]]->dcoef,davcf,dist,dpm[i],cov);
       deltavw[i] = deltav[i][i];
       if( dpm[i] == 0 ) cs = 'L';
       if( dpm[i] == 1 ) cs = 'S';
       if( deltav[i][i] < 0. ) {
            tvalues[mseq[i]]  = -99.;
	  }else{
            tvalues[mseq[i]] = ttest(delta[i]/sqrt(deltav[i][i]));
	  }
/*       printf("seq %d %c rtlength %f delta %f se %f z=%f t=%f \n",mseq[i],cs,tnodev[mseq[i]]->height,delta[i],sqrt(deltav[i][i]),delta[i]/sqrt(deltav[i][i]),ttest(delta[i]/sqrt(deltav[i][i]))); */

     }
    for(i=0; i<nmseq ; i++){
     for(j=i+1; j<nmseq ; j++){
      dw = getdcvij(nseq,tnodev[mseq[i]]->dcoef,tnodev[mseq[j]]->dcoef,dist,cov); 
/*      printf("deltavij %d %d %f\n",i,j,dw); */
      deltav[i][j] = deltav[j][i] = dw; 
/*      printf("dw =%f deltav[%d][%d]=%f\n",dw,i,j,deltav[i][j]); */
    }
   }
  
/*   printf("before decompose\n"); FLUSH;   */
   decompose(&degrees,nmseq,deltav,B,Temp);
/*   printf("degrees =%d\n",degrees); */
   for(i=0; i<nmseq ; i++){
     dc[i]=0.0;
     for(j=0; j<nmseq ; j++){
       dc[i] += delta[j]*deltav[j][i];
     }
     
   }
   *delq = 0.0;
   for(i=0; i<nmseq ; i++) *delq += dc[i]*delta[i];
/*   printf("delq=%f\n",*delq); */
   free_dvector(dc,nmseq);
   free_cvector(dpm,nmseq);
   free_dmatrix(B,nmseq,nmseq);
   free_dmatrix(Temp,nmseq,nmseq);
   return(0);
}
double getdv(nseq,dcoef,davcoef,dist,dpm,cov)
int nseq;
double *dcoef,*davcoef,**dist,*cov;
char dpm;
{
int i,j,k,l,n,m,nad,ndist;
double vw;
   n=0; vw=0.0;
   ndist = nseq*(nseq-1)/2;
   for(i=0; i<nseq ; i++){
      for(j=i+1; j<nseq ; j++){
        dcoef[n] -= davcoef[n];
        if( dpm != 0 ) dcoef[n] *= -1.0;
        vw += dcoef[n]*dcoef[n]*dist[j][i];
        n++;
      }
    }
   
    n=0;
    for(i=0; i< ndist ; i++){
       for(j=i+1; j<ndist ; j++){
          vw += 2.0*dcoef[i]*dcoef[j]*cov[n];
           n++;
        }
     }

   return(vw);
}

double getdcvij(nseq,dcoefi,dcoefj,dist,cov)
int nseq;
double *dcoefi,*dcoefj,**dist,*cov;
{
int i,j,n,ndist;
double cw,wi,wj;

  ndist = nseq*(nseq-1)/2;

/*  printf("start getdcvij\n"); FLUSH; */
  cw=0.0;
  n=0;
  for(i=0; i<nseq ; i++){
    for(j=i+1; j<nseq ; j++){
      cw += dcoefi[n]*dcoefj[n]*dist[j][i];
      n++;
    }
  }
/*n  printf("mid getdcvij cw=%f\n",cw); FLUSH; */
  n=0;
  for(i=0; i< nseq*(nseq-1)/2 ; i++){
     for(j=i+1 ; j< nseq*(nseq-1)/2 ; j++){

/*       cw += 2.0*dcoefi[i]*dcoefj[j]*cov[n]; */
       cw += (dcoefi[i]*dcoefj[j]+dcoefi[j]*dcoefj[i]) *cov[n];
/*       printf("dcoefi %f dcoefj %f cov=%f\n",dcoefi[i],dcoefi[j],cov[n]); FLUSH; */
      n++;
     }
   }
/*   printf("cw=%f\n",cw); FLUSH; */
   return(cw);
}
  

/************************************/
   decompose(degrees, dim, V, B,Temp)
   int *degrees, dim;
   double **V,**B,**Temp;
/************************************/
{
double f;
double lambda;
int i, j, k;

           for(i=0; i<dim; i++)
              {
              for(j=i; j<dim; j++)
                 {
                 if( i == j ) B[i][j] = 1.;
                 else         B[i][j] = B[j][i] = 0.;
                 }
              }

for(i=0; i<dim; i++)
   {
   if(fabs(V[i][i]) <= (double) TINY) V[i][i] = 0.;

   if( V[i][i] == 0. && i < dim-1)
     {
     for( j=i+1; j<dim; j++)
        {
        if( fabs(V[i][j]) > (double) TINY )
          {
/* i := i + j rows and columns */

          for(k=0; k<dim; k++)
             {
             V[i][k] += V[j][k];
             B[i][k] += B[j][k];
             }

          for(k=0; k<dim; k++)
             V[k][i] += V[k][j];

          break;
          }
    }
     }

   if(V[i][i] > 0.)
     {

     if(i < dim-1)
       {
        for( j=i+1; j<dim; j++)
           {

        /* j + i * lambda  rows and columns */
      lambda = -V[i][j]/V[i][i];

          for(k=0; k<dim; k++)
             {
             V[j][k] += V[i][k]*lambda;
             B[j][k] += B[i][k]*lambda;
             }

          for(k=0; k<dim; k++)
             V[k][j] += V[k][i]*lambda;

           }
       }

/* i := i*lambda, for rows and columns  */

          lambda = 1./sqrt(V[i][i]);
          for(k=0; k<dim; k++)
             {
             V[i][k] *= lambda;
             V[k][i] *= lambda;
             B[i][k] *= lambda;
             }
     }
   }

f = 0.;
for(i=0; i<dim; i++) f += V[i][i];
*degrees = (int)(f+0.5);

multiply_Bt_B(dim,V,B,Temp);

return;
}

/**************************/
   multiply_Bt_B( dim,V,B,Temp)
   int dim;
   double **V,**B,**Temp;
/**************************/
{
int i, j, k;

for(i=0; i<dim; i++)
   for(j=0; j<dim; j++)
      {
      Temp[i][j] = 0.;
      for(k=0; k<dim; k++)
         Temp[i][j] += (double) B[k][i] * B[k][j];
      }

for(i=0; i<dim; i++)
   for(j=0; j<dim; j++)
      V[i][j] = Temp[i][j];

return;
}

dcef(tnodea,tnodec)
Tnode *tnodea,*tnodec;
{
int i,flg;
Branchptr bw;
Tnode *tw;

  flg=0;
  if( tnodec->tnodex == tnodea ) flg=1;
  else if( tnodec->tnodey == tnodea){
           tw = tnodec->tnodey;
           tnodec->tnodey = tnodec->tnodex;
           tnodec->tnodex = tw;
           bw = tnodec->by;
           tnodec->by = tnodec->bx;
           tnodec->bx = bw;
           flg=2;
	 }
    else if( tnodec->tnodez == tnodea){
           tw = tnodec->tnodez;
           tnodec->tnodez = tnodec->tnodex;
           tnodec->tnodex = tw;
           bw = tnodec->bz;
           tnodec->bz = tnodec->bx;
           tnodec->bx = bw;
           flg=3;
	 }
     else{
        fprintf(ERR,"dcef node unmatch\n");
        exit(1);
      }


/*     printf("dcef tnodea %d tnodec %d\n",tnodea->nkey,tnodec->nkey);
     fflush(stdout);
*/



     if( tnodec->tnodey != NULL ){
/*
         printf("dcefy tnodea %d tnodec %d\n",tnodea->nkey,tnodec->nkey);
         fflush(stdout);
*/
         getcoef(comm.nseq,tnodec->by,comm.ma,comm.mb,comm.mc,comm.md,tnodec->tnodey->dcoef);
         for(i=0; i<comm.nseq*(comm.nseq-1)/2 ; i++) tnodec->tnodey->dcoef[i] += tnodec->dcoef[i];
          tnodec->tnodey->height = tnodec->height + tnodec->by->blength;
          if( tnodec->tnodey->nkey < comm.nseq ) comm.dav += tnodec->tnodey->height;

          dcef(tnodec,tnodec->tnodey);
       }

     if( tnodec->tnodez != NULL ){
/*         printf("dcefz tnodea %d tnodec %d\n",tnodea->nkey,tnodec->nkey);
         fflush(stdout); */
         getcoef(comm.nseq,tnodec->bz,comm.ma,comm.mb,comm.mc,comm.md,tnodec->tnodez->dcoef);
         for(i=0; i<comm.nseq*(comm.nseq-1)/2 ; i++) tnodec->tnodez->dcoef[i] += tnodec->dcoef[i];
         tnodec->tnodez->height = tnodec->height + tnodec->bz->blength;
          if( tnodec->tnodez->nkey < comm.nseq ) comm.dav += tnodec->tnodez->height;
         dcef(tnodec,tnodec->tnodez);
       }
     if( tnodec->nkey < comm.nseq ){
/*         printf("comm.nseq=%d\n",comm.nseq); fflush(stdout); */
         for(i=0; i< comm.nseq*(comm.nseq-1)/2 ; i++) comm.davcf[i] += tnodec->dcoef[i];
         comm.mseq[comm.ndwnseq] = tnodec->nkey;
         comm.ndwnseq++;
/*         printf("comm.nseq=%d ndwnseq=%d\n",comm.nseq,comm.ndwnseq); fflush(stdout); */
       }


/*        printf("dcef return tnodea %d tnodec %d\n",tnodea->nkey,tnodec->nkey); fflush(stdout);
*/
      return(0);
}




getcoef(nseq,br,ma,mb,mc,md,dcoef)
int nseq,*ma,*mb,*mc,*md;
Branch *br;
double *dcoef;
{
int i,j;
int na,nb,nc,nd;
char *pa,*pb,*pc,*pd;
int fa,fb,fc,fd,flg;
Branchptr ba,bb,bc,bd,be;


/*   printf("getcoef\n");fflush(stdout); */
   if( br->tnodex->nkey <  nseq ){
      nc = 1;
      mc[0] = br->tnodex->nkey;
      if( br->tnodey->tnodex == br->tnodex ){
         pa = br->tnodey->by->partptr;
         pb = br->tnodey->bz->partptr;
         if( br->tnodey->by->tnodex == br->tnodey ) fa = 0;
	 else fa = 1;
         if( br->tnodey->bz->tnodex == br->tnodey ) fb = 0;
	 else fb = 1;
       }
      if( br->tnodey->tnodey == br->tnodex ){
         pa = br->tnodey->bx->partptr;
         pb = br->tnodey->bz->partptr;
         if( br->tnodey->bx->tnodex == br->tnodey ) fa = 0;
	 else fa = 1;
         if( br->tnodey->bz->tnodex == br->tnodey ) fb = 0;
	 else fb = 1;
       }
      if( br->tnodey->tnodez == br->tnodex ){
         pa = br->tnodey->bx->partptr;
         pb = br->tnodey->by->partptr;
         if( br->tnodey->bx->tnodex == br->tnodey ) fa = 0;
	 else fa = 1;
         if( br->tnodey->by->tnodex == br->tnodey ) fb = 0;
	 else fb = 1;
       }
       if( fa == 1 ) geton(&na,ma,pa,nseq);
       else getoff(&na,ma,pa,nseq);
       if( fb == 1 ) geton(&nb,mb,pb,nseq);
       else getoff(&nb,mb,pb,nseq);
       getextc(na,nb,nc,ma,mb,mc,dcoef,nseq);
       return(0);
    }


   if( br->tnodey->nkey <  nseq ){
                /* br[i]->tnodey -- N  */
      nc = 1;
      mc[0] = br->tnodey->nkey;
     if( br->tnodex->tnodex == br->tnodey ){
         pa = br->tnodex->by->partptr;
         pb = br->tnodex->bz->partptr;
         if( br->tnodex->by->tnodex == br->tnodey ) fa = 0;
	 else fa = 1;
         if( br->tnodex->bz->tnodex == br->tnodey ) fb = 0;
	 else fb = 1;
       }
      if( br->tnodex->tnodey == br->tnodey ){
         pa = br->tnodex->bx->partptr;
         pb = br->tnodex->bz->partptr;
         if( br->tnodex->bx->tnodex == br->tnodey ) fa = 0;
	 else fa = 1;
         if( br->tnodex->bz->tnodex == br->tnodey ) fb = 0;
	 else fb = 1;
       }
      if( br->tnodey->tnodez == br->tnodex ){
         pa = br->tnodex->bx->partptr;
         pb = br->tnodex->by->partptr;
         if( br->tnodex->bx->tnodex == br->tnodey ) fa = 0;
	 else fa = 1;
         if( br->tnodex->by->tnodex == br->tnodey ) fb = 0;
	 else fb = 1;
       }
       if( fa == 1 ) geton(&na,ma,pa,nseq);
       else getoff(&na,ma,pa,nseq);
       if( fb == 1 ) geton(&nb,mb,pb,nseq);
       else getoff(&nb,mb,pb,nseq);
       getextc(na,nb,nc,ma,mb,mc,dcoef,nseq);
       if( dflg == 1 ){
         printf("b x %d y %d ",br->tnodex->nkey,br->tnodey->nkey);
         printf("na =%d",na);
         for(j=0; j<na ; j++) printf(" %d",ma[j]);
         printf("\n");
         printf("nb =%d",nb);
         for(j=0; j<nb ; j++) printf(" %d",mb[j]);
         printf("\n");
         printf("nc =%d",nc);
         for(j=0; j<nc ; j++) printf(" %d",mc[j]);
         printf("\n");
         printf("b=%f\n",br->blength);fflush(stdout);

       }
       
       return(0);
    }
   if( dflg == 1 ) {
      printf("bx %d x %d y %d z %d   by %d x %d y %d z %d\n",br->tnodex->nkey, 
      br->tnodex->tnodex->nkey,br->tnodex->tnodey->nkey,br->tnodex->tnodez->nkey,
      br->tnodey->nkey, 
      br->tnodey->tnodex->nkey,br->tnodey->tnodey->nkey,br->tnodey->tnodez->nkey); fflush(stdout);
    }
    flg=0;
   if( br->tnodex->tnodex == br->tnodey && br->tnodey->tnodex == br->tnodex ){
        ba = br->tnodex->by;   
        bb = br->tnodex->bz;   
        bc = br->tnodey->by;   
        bd = br->tnodey->bz;   
        flg=1;
      }
   if( br->tnodex->tnodex == br->tnodey && br->tnodey->tnodey == br->tnodex ){
        ba = br->tnodex->by;   
        bb = br->tnodex->bz;   
        bc = br->tnodey->bx;   
        bd = br->tnodey->bz;   
        flg=2;
      }
   if( br->tnodex->tnodex == br->tnodey && br->tnodey->tnodez == br->tnodex ){
        ba = br->tnodex->by;   
        bb = br->tnodex->bz;   
        bc = br->tnodey->bx;   
        bd = br->tnodey->by;   
        flg=3;
      }
   if( br->tnodex->tnodey == br->tnodey && br->tnodey->tnodex == br->tnodex ){
        ba = br->tnodex->bx;   
        bb = br->tnodex->bz;   
        bc = br->tnodey->by;   
        bd = br->tnodey->bz;   
        flg=4;
      }
   if( br->tnodex->tnodey == br->tnodey && br->tnodey->tnodey == br->tnodex ){
        ba = br->tnodex->bx;   
        bb = br->tnodex->bz;   
        bc = br->tnodey->bx;   
        bd = br->tnodey->bz;   
        flg=5;
      }
     if( br->tnodex->tnodey == br->tnodey && br->tnodey->tnodez == br->tnodex ){
        ba = br->tnodex->bx;   
        bb = br->tnodex->bz;   
        bc = br->tnodey->bx;   
        bd = br->tnodey->by;   
        flg=6;
      }
     if( br->tnodex->tnodez == br->tnodey && br->tnodey->tnodex == br->tnodex ){
        ba = br->tnodex->bx;   
        bb = br->tnodex->by;   
        bc = br->tnodey->by;   
        bd = br->tnodey->bz;   
        flg=7;
      }
       if( br->tnodex->tnodez == br->tnodey && br->tnodey->tnodey == br->tnodex ){
        ba = br->tnodex->bx;   
        bb = br->tnodex->by;   
        bc = br->tnodey->bx;   
        bd = br->tnodey->bz;   
        flg=8;
      }
       if( br->tnodex->tnodez == br->tnodey && br->tnodey->tnodez == br->tnodex ){
        ba = br->tnodex->bx;   
        bb = br->tnodex->by;   
        bc = br->tnodey->bx;   
        bd = br->tnodey->by;   
        flg=9;
      }
/*    printf("flg =%d\n",flg); fflush(stdout); */
    fa=fb=fc=fd=1;
    if( ba->tnodex == br->tnodex ) fa=0;
    if( bb->tnodex == br->tnodex ) fb=0;
    if( bc->tnodex == br->tnodey ) fc=0;
    if( bd->tnodex == br->tnodey ) fd=0;
/*    printf("f %d %d %d %d\n",fa,fb,fc,fd); fflush(stdout); */
    if( fa == 0 ) getoff(&na,ma,ba->partptr,nseq);
    if( fa == 1 ) geton(&na,ma,ba->partptr,nseq);
    if( fb == 0 ) getoff(&nb,mb,bb->partptr,nseq);
    if( fb == 1 ) geton(&nb,mb,bb->partptr,nseq);
    if( fc == 0 ) getoff(&nc,mc,bc->partptr,nseq);
    if( fc == 1 ) geton(&nc,mc,bc->partptr,nseq);
    if( fd == 0 ) getoff(&nd,md,bd->partptr,nseq);
    if( fd == 1 ) geton(&nd,md,bd->partptr,nseq);
/*    printf("before getinc\n"); fflush(stdout); */
    getintc(na,nb,nc,nd,ma,mb,mc,md,dcoef,nseq);
/*    printf("after getinc\n"); fflush(stdout); */
    if( dflg == 1 ){
       printf("b x %d y %d ",br->tnodex->nkey,br->tnodey->nkey);
       printf("na =%d",na);
       for(j=0; j<na ; j++) printf(" %d",ma[j]);
       printf("\n");
       printf("nb =%d",nb);
       for(j=0; j<nb ; j++) printf(" %d",mb[j]);
       printf("\n");
       printf("nc =%d",nc);
       for(j=0; j<nc ; j++) printf(" %d",mc[j]);
       printf("\n");
       printf("nd =%d",nd);
       for(j=0; j<nd ; j++) printf(" %d",md[j]);
       printf("\n");
     }
/*    printf("f %d %d %d %d\n",fa,fb,fc,fd); fflush(stdout); */


   return(0);
 }


















getintc(na,nb,nc,nd,ma,mb,mc,md,dcoef,nseq)
int na,nb,nc,nd,*ma,*mb,*mc,*md,nseq;
double *dcoef;
{
int i,j,k,l;
double dac,dbd,dbc,dad,dab,dcd,gw,bw;
int getdsumc();

/*   printf("getintc\n"); fflush(stdout); */
   dac=dbd=dbc=dad=dab=dcd=0.0;
   gw = nb*nc+na*nd;
   gw /= (na+nb)*(nc+nd);

   /* dac= */ getdsumc(na,nc,ma,mc,dcoef,0.5*gw,nseq);
   /* dbd= */ getdsumc(nb,nd,mb,md,dcoef,0.5*gw,nseq);
   /* dbc= */ getdsumc(nb,nc,mb,mc,dcoef,0.5*(1.0-gw),nseq);
   /* dad= */ getdsumc(na,nd,ma,md,dcoef,0.5*(1.0-gw),nseq);
   /* dab= */ getdsumc(na,nb,ma,mb,dcoef,-0.5,nseq);
   /* dcd= */ getdsumc(nc,nd,mc,md,dcoef,-0.5,nseq);
 
   
/*   bw = 0.5*(gw*(dac + dbd) + (1.0-gw)*(dbc+dad) - dab - dcd); */
  return(0);
}

getextc(na,nb,nc,ma,mb,mc,dcoef,nseq)
int na,nb,nc,*ma,*mb,*mc;
double *dcoef;
{
int i,j,k,l;
double dac,dbc,dab,bw,dc;

   dac=dbc=dab=0.0;
   /* dac= */ getdsumc(na,nc,ma,mc,dcoef,0.5,nseq);
   /* dbc= */ getdsumc(nb,nc,mb,mc,dcoef,0.5,nseq);
   /* dab= */ getdsumc(na,nb,ma,mb,dcoef,-0.5,nseq);

/*   bw = 0.5*(dac + dbc - dab );   */

  return(0);
}






getdsumc(nx,ny,mx,my,dcoef,dc,nseq)
int nx,ny,*mx,*my,nseq;
double *dcoef,dc;
{
int i,j,ni,nj,n;
double dxy;


/*  printf("getdsumc nx=%d ny=%d dc=%f nseq=%d\n",nx,ny,dc,nseq); fflush(stdout);
*/
  for(i=0; i<nx ; i++){
    for(j=0; j<ny ; j++){
      ni = mx[i];
      nj = my[j];
      smal(&ni,&nj);
/*      dxy += dist[ni][nj]; */
        n = distad(ni,nj,nseq);
/*        printf("n=%d ni=%d nj=%d\n",n,ni,nj); fflush(stdout); */
        dcoef[n] = dc;
        dcoef[n] /= nx*ny;
    }
  }
/*  dxy /= nx*ny; */
  return(0);
}

     
chkoutg(nseq,parttbl,noutg,outg,tnodea,tnodec,branchv)
int nseq,noutg,*outg;
char **parttbl;
Tnode **tnodea,**tnodec;
Branch **branchv;
{
int i,j,iw,nx,ny,*mx,*my,flg;

 for(i=0; i<noutg ; i++){
   for(j=i+1; j<noutg ; j++){
      if( outg[i] > outg[j] ){
        iw = outg[i];
        outg[i] = outg[j];
        outg[j]=iw;
      }
    }
 }

/*
  printf("outg ");
  for(i=0; i<noutg ; i++) printf(" %d",outg[i]);
  printf("\n");
*/
  mx = ivector(nseq);
  my = ivector(nseq);
  for(i=0; i< 2*nseq-3; i++){
     getpart(&nx,mx,&ny,my,branchv[i]->partptr,nseq);
/*
     printf("nx=%d  ny=%d\n",nx,ny);
     printf("outgx ");
     for(j=0; j<nx ; j++) printf(" %d",mx[j]);
     printf("\n");
     printf("outgy ");
     for(j=0; j<ny ; j++) printf(" %d",my[j]);
     printf("\n");
*/
     if( nx == noutg ){
        flg=0;        
        for(j=0; j<nx ; j++){
          if( mx[j] != outg[j]-1 ) break;
          flg++;
	}
        if( flg == noutg ){
          *tnodea = branchv[i]->tnodex;
          *tnodec = branchv[i]->tnodey;
          free_ivector(mx,nseq);
          free_ivector(my,nseq);
          return(0);
	}

      }
     if( ny == noutg ){
        flg=0;        
        for(j=0; j<ny ; j++){
          if( my[j] != outg[j]-1 ) break;
          flg++;
	}
        if( flg == noutg ){
          *tnodea = branchv[i]->tnodey;
          *tnodec = branchv[i]->tnodex;
          free_ivector(mx,nseq);
          free_ivector(my,nseq);
          return(0);
	}
      }
   }
   
   fprintf(ERR,"chkoutg   outgroups do not cluster\n");
   exit(1);
   
}


getpart(nx,mx,ny,my,part,nseq)
int *nx,*mx,*ny,*my,nseq;
char *part;
{
int i,j,nm,nn;
unsigned char cw,cs;
  
  (*nx) = 0;  (*ny) = 0;
  for(i=0; i<nseq ; i++){
     nm = i/8;
     nn = i%8;
     cw = 0x80;
     cw >>= nn;
     cs = cw & part[nm];
     if( cs != 0 ){
        mx[(*nx)] = i;
        (*nx)++;
      }else{
        my[(*ny)] = i;
        (*ny)++;
      }
   }

/*    printf("geton nx=%d\n",*nx); */
   return(0);
}



static float  Tdist[350]={
0.00,  0.01,  0.02,  0.03,  0.04,  0.05,  0.06,  0.07,  0.08,
0.09,  0.10,  0.11,  0.12,  0.13,  0.14,  0.15,  0.16,  0.17,  0.18,  0.19,
0.20,  0.21,  0.22,  0.23,  0.24,  0.25,  0.26,  0.27,  0.28,  0.29,  0.30,
0.31,  0.32,  0.33,  0.34,  0.35,  0.36,  0.37,  0.38,  0.39,  0.40,  0.41,
0.42,  0.43,  0.44,  0.45,  0.46,  0.47,  0.48,  0.49,  0.50,  0.51,  0.52,
0.53,  0.54,  0.55,  0.56,  0.57,  0.58,  0.59,  0.60,  0.61,  0.62,  0.63,
0.64,  0.65,  0.66,  0.67,  0.68,  0.69,  0.70,  0.71,  0.72,  0.73,  0.74,
0.75,  0.76,  0.77,  0.78,  0.79,  0.80,  0.81,  0.82,  0.83,  0.84,  0.85,
0.86,  0.87,  0.88,  0.89,  0.90,  0.91,  0.92,  0.93,  0.94,  0.95,  0.96,
0.97,  0.98,  0.99,  1.00,  1.01,  1.02,  1.03,  1.04,  1.05,  1.06,  1.07,
1.08,  1.09,  1.10,  1.11,  1.12,  1.13,  1.14,  1.15,  1.16,  1.17,  1.18,
1.19,  1.20,  1.21,  1.22,  1.23,  1.24,  1.25,  1.26,  1.27,  1.28,  1.29,
1.30,  1.31,  1.32,  1.33,  1.34,  1.35,  1.36,  1.37,  1.38,  1.39,  1.40,
1.41,  1.42,  1.43,  1.44,  1.45,  1.46,  1.47,  1.48,  1.49,  1.50,  1.51,
1.52,  1.53,  1.54,  1.55,  1.56,  1.57,  1.58,  1.59,  1.60,  1.61,  1.62,
1.63,  1.64,  1.65,  1.66,  1.67,  1.68,  1.69,  1.70,  1.71,  1.72,  1.73,
1.74,  1.75,  1.76,  1.77,  1.78,  1.79,  1.80,  1.81,  1.82,  1.83,  1.84,
1.85,  1.86,  1.87,  1.88,  1.89,  1.90,  1.91,  1.92,  1.93,  1.94,  1.95,
1.96,  1.97,  1.98,  1.99,  2.00,  2.01,  2.02,  2.03,  2.04,  2.05,  2.06,
2.07,  2.08,  2.09,  2.10,  2.11,  2.12,  2.13,  2.14,  2.15,  2.16,  2.17,
2.18,  2.19,  2.20,  2.21,  2.22,  2.23,  2.24,  2.25,  2.26,  2.27,  2.28,
2.29,  2.30,  2.31,  2.32,  2.33,  2.34,  2.35,  2.36,  2.37,  2.38,  2.39,
2.40,  2.41,  2.42,  2.43,  2.44,  2.45,  2.46,  2.47,  2.48,  2.49,  2.50,
2.51,  2.52,  2.53,  2.54,  2.55,  2.56,  2.57,  2.58,  2.59,  2.60,  2.61,
2.62,  2.63,  2.64,  2.65,  2.66,  2.67,  2.68,  2.69,  2.70,  2.71,  2.72,
2.73,  2.74,  2.75,  2.76,  2.77,  2.78,  2.79,  2.80,  2.81,  2.82,  2.83,
2.84,  2.85,  2.86,  2.87,  2.88,  2.89,  2.90,  2.91,  2.92,  2.93,  2.94,
2.95,  2.96,  2.97,  2.98,  2.99,  3.00,  3.01,  3.02,  3.03,  3.04,  3.05,
3.06,  3.07,  3.08,  3.09,  3.10,  3.11,  3.12,  3.13,  3.14,  3.15,  3.16,
3.17,  3.18,  3.19,  3.20,  3.21,  3.22,  3.23,  3.24,  3.25,  3.26,  3.27,
3.28,  3.29,  3.30,  3.31,  3.32,  3.33,  3.34,  3.35,  3.36,  3.37,  3.38,
3.39,  3.40,  3.41,  3.42,  3.43,  3.44,  3.45,  3.46,  3.47,  3.48,  3.49};

static float PP[350]={
0.5000,0.5040,0.5080,0.5120,0.5160,0.5199,0.5239,0.5279,0.5319,0.5359,0.5398,
0.5438,0.5478,0.5517,0.5557,0.5596,0.5636,0.5675,0.5714,0.5753,0.5793,0.5832,
0.5871,0.5910,0.5948,0.5987,0.6026,0.6064,0.6103,0.6141,0.6179,0.6217,0.6255,
0.6293,0.6331,0.6368,0.6406,0.6443,0.6480,0.6517,0.6554,0.6591,0.6628,0.6664,
0.6700,0.6736,0.6772,0.6808,0.6844,0.6879,0.6915,0.6950,0.6985,0.7019,0.7054,
0.7088,0.7123,0.7157,0.7190,0.7224,0.7257,0.7291,0.7324,0.7357,0.7389,0.7422,
0.7454,0.7486,0.7517,0.7549,0.7580,0.7611,0.7642,0.7673,0.7704,0.7738,0.7764,
0.7794,0.7823,0.7852,0.7881,0.7991,0.7939,0.7967,0.7995,0.8023,0.8051,0.8078,
0.8106,0.8133,0.8159,0.8186,0.8212,0.8238,0.8264,0.8289,0.8315,0.8340,0.8365,
0.8389,0.8413,0.8438,0.8461,0.8485,0.8508,0.8531,0.8554,0.8577,0.8599,0.8621,
0.8643,0.8665,0.8686,0.8708,0.8729,0.8749,0.8770,0.8790,0.8810,0.8830,0.8849,
0.8869,0.8888,0.8907,0.8925,0.8944,0.8962,0.8980,0.8997,0.9015,0.9032,0.9049,
0.9066,0.9082,0.9099,0.9115,0.9131,0.9147,0.9162,0.9177,0.9192,0.9207,0.9222,
0.9236,0.9251,0.9265,0.9279,0.9292,0.9306,0.9319,0.9332,0.9332,0.9345,0.9357,
0.9370,0.9382,0.9406,0.9418,0.9429,0.9441,0.9452,0.9463,0.9474,0.9484,0.9495,
0.9505,0.9515,0.9525,0.9535,0.9545,0.9554,0.9564,0.9573,0.9582,0.9591,0.9599,
0.9608,0.9616,0.9625,0.9633,0.9641,0.9649,0.9656,0.9664,0.9671,0.9678,0.9686,
0.9693,0.9699,0.9706,0.9713,0.9719,0.9726,0.9732,0.9738,0.9744,0.9750,0.9756,
0.9761,0.9767,0.9772,0.9778,0.9783,0.9788,0.9793,0.9798,0.9803,0.9808,0.9812,
0.9817,0.9821,0.9826,0.9830,0.9834,0.9838,0.9842,0.9846,0.9850,0.9854,0.9857,
0.9861,0.9864,0.9868,0.9871,0.9875,0.9878,0.9881,0.9884,0.9887,0.9890,0.9893,
0.9896,0.9898,0.9901,0.9904,0.9906,0.9909,0.9911,0.9913,0.9916,0.9918,0.9920,
0.9922,0.9925,0.9927,0.9929,0.9931,0.9932,0.9934,0.9936,0.9938,0.9940,0.9941,
0.9943,0.9945,0.9946,0.9948,0.9949,0.9950,0.9952,0.9953,0.9955,0.9956,0.9957,
0.9959,0.9960,0.9961,0.9962,0.9963,0.9964,0.9965,0.9967,0.9967,0.9968,0.9969,
0.9970,0.9971,0.9972,0.9972,0.9974,0.9974,0.9975,0.9976,0.9977,0.9977,0.9977,
0.9978,0.9979,0.9980,0.9980,0.9981,0.9981,0.9982,0.9983,0.9983,0.9984,0.9985,
0.9985,0.9986,0.9986,0.9987,0.9987,0.9987,0.9988,0.9988,0.9989,0.9989,0.9989,
0.9990,0.9990,0.9990,0.9990,0.9991,0.9991,0.9992,0.9992,0.9992,0.9992,0.9993,
0.9993,0.9993,0.9993,0.9994,0.9994,0.9994,0.9994,0.9994,0.9995,0.9995,0.9995,
0.9995,0.9995,0.9996,0.9996,0.9996,0.9996,0.9996,0.9996,0.9996,0.9997,0.9997,
0.9997,0.9997,0.9997,0.9997,0.9997,0.9997,0.9997,0.9998,0.9998};

float ttest(Value)
/***********************/
/*   float T_test(Value) */
/***********************/
float Value;
{
int i;
float Prob;
Prob = 0.;
if(Value < 0.) Value *= -1.;
i=349; while((float)Tdist[i] > (float)Value) i--; Prob = 2.*(PP[i]-0.5);
return Prob;
}





























































main(argc,argv)
int argc;
char **argv;
{
int i,j,k;
int nseq,nsite,nasite,npsite,cdnpos[3];
int itc,ifc,iw,dop,maxnm;
double gamma;
char outfl[100];
FILE *fpi,*fpt,*fpo=stdout;
Branch **branchv;
Tnode **tnodev,*tnodec,*tnodea;
double **distv,*cov,**dcf,delq,*delta,**deltav,*deltavw;
char **sequence,**seqname,**parttbl,*sitef;
int *psite,*asite,**ndif,**ndif1,**nbal,rn;
int npsiteb,nrepn,nrep,*rsite,seed,*outg,noutg,ioutc;
char cw,cw1;
float fw;
float *tvalues;

comm.covflg=0;
gamma = 1.0;
itc=ifc=ioutc=0;
dop = 0;
dflg = 0;
cdnpos[0]=cdnpos[1]=cdnpos[2]=1;
nrep=0;
noutg=0;
        if( argc == 1 ){
            printf("branch  inputfile -t[treefile] -o[outgroup ..] -d[distance] -c[codon position] -g[gamma a  value]\n");
            printf("distance option\n");
            for(i=0; i<NDIST ; i++) printf("%d %s\n",i,dname[i]);
            exit(0);
	  }
        for(i=1; i<argc; i++){
           if(argv[i][0] == '-' ){
              switch(argv[i][1]){
                   case 'c' : cdnpos[0]=cdnpos[1]=cdnpos[2]=0;
                               if( argv[i][2] >= '0' && argv[i][2] <= '9' ) {
                                sscanf(argv[i]+2,"%d",&iw);
                                if( iw > 3 ){
                                    fprintf(ERR,"invalid codon position %d\n",iw);
                                    exit(1);
				  }
                                cdnpos[iw-1]=1;
                              }
                              for(j=i+1 ; j<argc ; j++){
                                if( argv[j][0] == '-' ) break;
                                if( argv[j][0] <= '3' && argv[j][0] >= '1' ){
                                   cdnpos[argv[j][0]-'1']=1;
                                   i++;
				 }
			      }
                             /* printf("cdnpos %d %d %d\n",cdnpos[0],cdnpos[1],cdnpos[2]); */
                              break;
                   case 'f' : if( (fpo = fopen(argv[i]+2,"w")) == NULL){
                                 fprintf(ERR,"Can't open file %s\n",argv[i]+2);
                                 exit(1);
			       }
                               break;
                   case 'o' :  ioutc=i;
                               if( argv[i][2] >= '0' && argv[i][2] <= '9' ) {
                                sscanf(argv[i]+2,"%d",&iw);
                                noutg++;
			      }
                              for(j=i+1 ; j<argc ; j++){
                                if( argv[j][0] == '-' ) break;
                                if( argv[j][0] <= '9' && argv[j][0] >= '0' ){
                                   i++;
                                   noutg++;
				 }
			      }
                               break;

/*                   case 's' : sscanf(argv[i]+2,"%d",&seed);
                              break;
*/
                   case 'd' : sscanf(argv[i]+2,"%d",&dop);
                              break;
                   case 'g' : if( argv[i][2] != 0 ) {
                                sscanf(argv[i]+2,"%f",&fw);
                                gamma=fw;
                                break;
                              }else{
                               sscanf(argv[i+1],"%f",&fw);
                               gamma = fw;
                               i++;
                               break;
			      }
                   case 'b' : sscanf(argv[i]+2,"%d",&dflg);
                              break;
                   case 't' : if( (fpt = fopen(argv[i]+2,"r")) == NULL ){
                                 printf("Can't open treefile %s\n",argv[i]+2);
                                 exit(1);
			       }
                              itc=i;
                              break;
        
			      }
               }else{
                         if((fpi = fopen(argv[i],"r")) == NULL ){
                                 printf("Can't open file %s\n",argv[i]);
                                 exit(1);
                               }
                         strcpy(outfl,argv[i]);
                         strcat(outfl,".rb");
                         ifc=i;
		       }


         }
    if( ifc == 0 ){
       printf("input file is not specified\n");
       exit(1);

    }
    if( itc == 0 ){
       printf("topology file is not specified\n");
       exit(1);
    }
    if( ioutc == 0 || noutg == 0  ){
       printf("outgroup is not specified\n");
       exit(1);
    }
   if( dop >=  NDIST ) {
       printf("invalid distance option %d\n",dop);
       exit(1);
     }

   checkfl(fpi,&nseq,&nsite,&maxnm);
/*  memory allocation */
    if( dflg == 1){
      printf("nseq=%d nsite=%d maxnm=%d noutg=%d\n",nseq,nsite,maxnm,noutg); 
      fflush(stdout);
    }
    seqname = cmatrix(nseq,maxnm+1);
    sequence = cmatrix(nseq,nsite);
    parttbl = cmatrix(2*nseq-3,(nseq-1)/8+1);
    dcf = dmatrix(2*nseq-2,nseq*(nseq-1)/2);
    comm.davcf = dvector(nseq*(nseq-1)/2);
    distv = dmatrix(nseq,nseq);
    ndif = imatrix(nseq,nseq);
    ndif1 = imatrix(nseq,nseq);
    nbal = imatrix(nseq,4);
    asite = ivector(nsite);
    psite = ivector(nsite);
    rsite = ivector(nsite);
/*    fprintf(stderr,"noutg:%d\n",noutg);*/
    outg = ivector(noutg);
    sitef = cvector(nsite);
    branchv = brvector(2*nseq-3);
    tnodev = tnvector(2*nseq -2);
    comm.ma = ivector(nseq);
    comm.mb = ivector(nseq);
    comm.mc = ivector(nseq);
    comm.md = ivector(nseq);
    tvalues = fvector(nseq);
    if( dflg == 1) printf("m a b c d %p %p %p %p\n",comm.ma,comm.mb,comm.mc,comm.md);
    comm.nmseq = nseq - noutg;
    comm.mseq = ivector(comm.nmseq);
    iw = nseq*(nseq-1)/2;
    cov = dvector(iw*(iw-1)/2,comm.covflg);
    if( comm.covflg == 1 ){
      if( (comm.fpcov = open ("COV",O_RDWR | O_TRUNC | O_CREAT ) ) == -1 ){
            printf("Can't open file %s\n","COV");
            exit(1);
      }
      system("chmod 755 COV");
    }

    if( dflg == 1){
         printf("m a b c d %p %p %p %p\n",comm.ma,comm.mb,comm.mc,comm.md);
         printf("m a b c d %p %p %p %p\n",&comm.ma[nseq],&comm.mb[nseq],&comm.mc[nseq],&comm.md[nseq]);
       }
    if((fpi = freopen(argv[ifc],"r",fpi)) == NULL ){
       printf("Can't open file %s\n",argv[ifc]);
       exit(1);
    }
   for(i=0; i< 2*nseq-3 ; i++){
     for(j=0; j< (nseq-1)/8+1 ; j++){
       parttbl[i][j]=0;
     }
     for(j=0; j<nseq*(nseq-1)/2 ; j++) dcf[i][j]=0.0;
   }
   for(i=0; i< nseq  ; i++){
    for(j=0; j< maxnm+1 ; j++) seqname[i][j]=0;
  }
   for(i=0; i<nseq ; i++) tvalues[i] = -1.0;
   rdseq(fpi,nseq,nsite,sequence,seqname);
   rdtv(fpt,nseq,seqname,tnodev,branchv,maxnm,parttbl,dcf);
   fclose(fpi);
   fclose(fpt);
   checknode(nseq,tnodev,branchv);
   noutg=0;   
   if( argv[ioutc][2] >= '0' && argv[ioutc][2] <= '9' ) {
      sscanf(argv[ioutc]+2,"%d",&iw);
      if( iw > nseq  || iw < 1 ){
         fprintf(ERR,"invalid outgroup %d %s\n",iw,argv[ioutc]);
         exit(1);
       }
      outg[0]=iw;
      noutg++;
    }
      for(j=ioutc+1 ; j<argc ; j++){
         if( argv[j][0] == '-' ) break;
           if( argv[j][0] <= '9' && argv[j][0] >= '0' ){
               sscanf(argv[j],"%d",&iw);
               if( iw > nseq  || iw < 1 ){
                 fprintf(ERR,"invalid outgroup %d\n",iw);
                 exit(1);
               }
               outg[noutg]=iw;
               noutg++;
	     }
       }

/*   fprintf(stderr,"noutg=%d\n",noutg);*/
    
   if( dop == 3 || dop == 4  || dop == 7 ){
    delchka(sequence,nseq,nsite,&npsite,&nasite,asite,psite,sitef);
    }else{
     delchk(sequence,nseq,nsite,&npsite,&nasite,psite,asite,cdnpos,sitef);
     if( dop >= 11 && dop <= 14 ) basefr(sequence,nseq,nasite,asite,nbal);
   }
/*   fprintf(stderr,"delchk\n");*/



   comm.nseq = nseq;
   if( dflg == 1 ){
      fprintf(fpo,"/* sequence file: %s: treefile: %s  nseq=%d nsite=%d npsite=%d nasite=%d %s",argv[ifc],argv[itc]+2,nseq,nsite,npsite,nasite,dname[dop]);
      if( dop >= 5 && dop < 8 ) fprintf(fpo," a=%f",gamma);
      if( cdnpos[0]+cdnpos[1]+cdnpos[2] != 3 ){
        fprintf(fpo," codon position:");
        for(i=0; i<3 ; i++) if( cdnpos[i] == 1 ) fprintf(fpo," %d",i+1);
      }
      fprintf(fpo,"*/\n");
    }
   partition(tnodev[0], tnodev[0]->tnodex);


   if( dflg == 1) prpart(nseq,parttbl,branchv);fflush(stdout);
/*   printf("outgroup:"); */
/*   for(i=0; i< noutg ; i++) fprintf(fpo," %d %s",outg[i],seqname[outg[i]-1]);fflush(fpo); */
/*   printf("noutg=%d\n",noutg); */
   chkoutg(nseq,parttbl,noutg,outg,&tnodea,&tnodec,branchv);
   if( (dop > 2 && dop < 5) || dop == 7 ) {
/*   fprintf(stderr,"calcova\n");*/
   rn=calcova(sequence,nseq,nsite,nasite,npsite,psite,dop,distv,ndif,gamma,cov);
      }else{
   rn=calcov(sequence,nseq,nsite,nasite,npsite,psite,dop,distv,ndif,ndif1,gamma,asite,nbal,cov);
 }

  if( comm.covflg == 1 ) {
     close(comm.fpcov);
     if( (comm.fpcov = open ("COV",O_RDONLY) ) == -1 ){
            printf("Can't open file %s\n","COV");
            exit(1);
      }
   }

/*
    for(i=0; i<nseq ; i++){
     for(j=i+1; j<nseq ; j++){
       printf("%d %d %f %f\n",i,j,distv[i][j],distv[j][i]);
     }
   }
    printf("caldist end nseq=%d\n",nseq); fflush(stdout);
*/
    brest(nseq,branchv,distv,comm.ma,comm.mb,comm.mc,comm.md);
    comm.ndwnseq=0;
    for(i=0; i<nseq*(nseq-1)/2 ; i++) comm.davcf[i]=0.0;
    comm.dav=0.0;
  /*  printf("tnodea %d tnodec %d\n",tnodea->nkey,tnodec->nkey); */
    dcef(tnodea,tnodec);
/*    printf("dcef end comm.dav %f\n",comm.dav); fflush(stdout); */
    comm.dav /= comm.ndwnseq;
    for(i=0; i<nseq*(nseq-1)/2 ; i++) comm.davcf[i] /= comm.ndwnseq;
/*    printf("chi2 start\n"); fflush(stdout);     */
   
   delta = dvector(comm.nmseq);
   deltavw = dvector(comm.nmseq);
   deltav = dmatrix(comm.nmseq,comm.nmseq);


    chi2test(nseq,comm.mseq,comm.nmseq,tnodev,comm.dav,comm.davcf,distv,cov,&delq,tvalues,delta,deltav,deltavw);


    if( comm.covflg == 1 ){
          close(comm.fpcov);
          system("rm COV");
    }

/*    printf("brest end\n"); fflush(stdout); */
    prtree(fpo,nseq,branchv,seqname,dop,cdnpos,nsite,nasite,npsite,nrepn,tvalues);
   fprintf(fpo,"sequence file: %s: treefile: %s\n  nseq=%d nsite=%d npsite=%d nasite=%d %s",argv[ifc],argv[itc]+2,nseq,nsite,npsite,nasite,dname[dop]);
  if( (dop >= 5 && dop < 8) || dop == 10 || dop == 12 || dop == 14 ) fprintf(fpo," a=%f",gamma);
  if( cdnpos[0]+cdnpos[1]+cdnpos[2] != 3 ){
        fprintf(fpo," codon position:");
        for(i=0; i<3 ; i++) if( cdnpos[i] == 1 ) fprintf(fpo," %d",i+1);
      }
   fprintf(fpo,"\n");
   fprintf(fpo,"outgroup:");
   for(i=0; i< noutg ; i++) fprintf(fpo," %d %s",outg[i],seqname[outg[i]-1]);fflush(fpo);
  fprintf(fpo,"\n\n");
     cw = '%';
     fprintf(fpo,"average root-to-tip length %f\n",comm.dav);
     for(i=0; i<comm.nmseq; i++){
       if( tnodev[comm.mseq[i]]->height - comm.dav > 0. ) cw1 = '+';
       if( tnodev[comm.mseq[i]]->height - comm.dav < 0. ) cw1 = '-';
       if( tnodev[comm.mseq[i]]->height - comm.dav <= 0.+ACU && tnodev[comm.mseq[i]]->height - comm.dav >= 0.-ACU  ) cw1 = ' ';
       if( deltavw[i] >= 0.){
       fprintf(fpo,"%d %s  %f delta %c %f (%f) Z=%f  %5.2f%c\n",comm.mseq[i]+1,seqname[comm.mseq[i]],tnodev[comm.mseq[i]]->height,cw1,delta[i],sqrt(deltavw[i]),delta[i]/sqrt(deltavw[i]),tvalues[comm.mseq[i]]*100.,cw);
     }else{
   fprintf(fpo,"%d %s %f delta %c %f V=%f Z=NA\n",comm.mseq[i]+1,seqname[comm.mseq[i]],tnodev[comm.mseq[i]]->height,cw1,delta[i],deltavw[i]);
 }
    
     }
   fprintf(fpo,"Q=%f\n",delq); fflush(fpo);



    if( dflg == 1) printf("prpart end nseq=%d anseq %p\n",nseq,&nseq); fflush(stdout);
    if( dflg == 1 ) printf("prtree end nseq=%d\n",nseq); fflush(stdout);

    free_cmatrix(seqname,nseq,maxnm+1);
    free_cmatrix(sequence,nseq,nsite);
    free_cmatrix(parttbl,2*nseq-3,nseq/8+1);
    free_dmatrix(distv,nseq,nseq);
    free_dmatrix(dcf,2*nseq-2,nseq*(nseq-1)/2);
    free_imatrix(ndif,nseq,nseq);
    free_dvector(comm.davcf,nseq*(nseq-1));
    free_imatrix(ndif1,nseq,nseq);
    free_imatrix(ndif,nseq,nseq);
    free_imatrix(nbal,nseq,4);
    free_ivector(asite,nsite);
    free_ivector(psite,nsite);
    free_ivector(rsite,nsite);
    free_ivector(outg,noutg);
    free_cvector(sitef,nsite);
    free_brvector(branchv,2*nseq-3);
    free_tnvector(tnodev,2*nseq -2);
    free_ivector(comm.ma,nseq);
    free_ivector(comm.mb,nseq);
    free_ivector(comm.mc,nseq);
    free_ivector(comm.md,nseq);
    free_fvector(tvalues,nseq);
    iw = nseq*(nseq-1)/2;
    free_dvector(cov,iw*(iw-1)/2);
    free_dvector(delta,comm.nmseq);
    free_dvector(deltavw,comm.nmseq);
    free_dmatrix(deltav,comm.nmseq,comm.nmseq);

    exit(0);
}





