#include <math.h>
/* #include <malloc.h>*/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>

typedef struct nds Nds;
typedef struct nds *Ndsptr;
struct nds{
    int nkey,deln;
    double height,height1,heightv;
    Nds *b, *lc,*rc;
    double *bbx,*blcx,*brcx;
    double *bbx1,*blcx1,*brcx1;
    double *bbx2,*blcx2,*brcx2;
    unsigned char *pbx,*plcx,*prcx;
  };



#define NDIST 23
#define ERR stdout
#define TER 21
#define INAP -99999.0
#define ACU  0.00000000001
#define TINY  0.00000000001

#define DEL  4
#define DEL1  6
#define DELA  20
#define DELA1  2
#define MISS 5
#define MISS1 7
#define MISSA 21
#define MISSA1 23










int dflg,dflg1;
int nseq,npc,maxnm,covflg,fpcov;
int tr1[4][4]={0,2,3,3,
               2,0,3,3,
               3,3,0,1,
               3,3,1,0};

int tr[4][4]={-1, 0, 1, 1,
               0,-1, 1, 1,
               1, 1,-1, 0,
               1, 1, 0,-1};
int trp[5][5]={-1,0 ,0,0,0,
                0,-1,0,0,0,
                0,0,-1,0,0,
                0,0,0,-1,0,
                0,0,0,0,-1};
char base[8]={'T','C','A','G','-','?','*','N'};
char amn[24]={'A','C','D','E','F','G','H','I','K','L','M','N','P','Q',
                     'R','S','T','V','W','Y','-','?','*','X'};

char *dname[NDIST]={"p-distance","JC-distance","K2P-distance","amino acid p-distance","amino acid Poisson correction","JC distance gamma","K2P distance gamma","amino acid gamma","Tajima and Nei","V K2P","V K2P gamma","V Hasegawa","V Hasegawa gamma","Tamura Nei","Tamura Nei gamma","ps (Nei and Gojobori)","pn (Nei and Gojobori)","ds (Nei and Gojobori)", "dn (Nei and Gojobori)","ps (Tv)","pn (Tv)","ds (Tv)", "dn (Tv)"};

Nds **addelta/*[MAXOTU-2]*/,**adpart/*[MAXOTU-2]*/;
unsigned char **part/*[MAXOTU-2][(MAXOTU-1)/8+1]*/;
int mr,ml,mb,*nlr/*[MAXOTU]*/,*nll/*[MAXOTU]*/,*nlb/*[MAXOTU]*/,bc,ngflg;
double **dist0/*[MAXOTU][MAXOTU]*/,*blen1/*[2*MAXOTU-2]*/,*blen2/*[2*MAXOTU-2]*/;
double *cov/*[MAXOTU*(MAXOTU-1)/2]*/,*delta/*[MAXOTU-2]*/,*ra/*[MAXOTU-2]*/,*rb/*[MAXOTU-2]*/,*rc/*[MAXOTU-2]*/;
double **deltav/*[MAXOTU-2][MAXOTU-2]*/;
double *rav/*[MAXOTU-2]*/,*rbv/*[MAXOTU-2]*/,*rcv/*[MAXOTU-2]*/;
int *dcoef/*[MAXOTU-2]*/,**nbal/*[MAXOTU][4]*/;
/*
#include "rdtv.c"
#include "preargv.c"
#include "posargv.c"
#include "ararg.c"
#include "outchk.c"
#include "under.c"
#include "reestb.c"
#include "calcov.c"
#include "calcova.c"
#include "caldcv.c"
#include "calq.c"
#include "delv.c"
#include "delchk.c"
#include "countln.c"
#include "basef.c"
#include "decomposu.c"
#include "ttest.c"
*/

int *ivector(n)
int n;
{
int *vp;

   vp = (int *)malloc((unsigned) n*sizeof(int));
   if( !vp ) {
       fprintf(ERR,"memory allocation error\n");
       fprintf(ERR,"integer vector[%d]\n",n);
       exit(1);
     }
    return(vp);
}
char *cvector(n)
int n;
{
char *vp;

   vp = (char *)malloc((unsigned) n*sizeof(char));
   if( !vp ) {
       fprintf(ERR,"memory allocation error\n");
       fprintf(ERR,"char vector[%d]\n",n);
       exit(1);
     }
    return(vp);
}

unsigned char *ucvector(n)
int n;
{
unsigned char *vp;

   vp = (unsigned char *)malloc((unsigned) n*sizeof(char));
   if( !vp ) {
       fprintf(ERR,"memory allocation error\n");
       fprintf(ERR,"char vector[%d]\n",n);
       exit(1);
     }
    return(vp);
}

double *dvectorc(n,covflg)
int n,*covflg;
{
double *vp;


   vp = (double *)malloc((unsigned) n*sizeof(double));
   if( !vp  ) {
     if( *covflg != 10 ){
       fprintf(ERR,"memory allocation error\n");
       fprintf(ERR,"double vector[%d]\n",n);
       exit(1);
     }else{
      *covflg=1;
       }
     }
     
    return(vp);

}


double *dvector(n)
int n;
{
double *vp;

   vp = (double *)malloc((unsigned) n*sizeof(double));
   if( !vp  ) {
       fprintf(ERR,"memory allocation error\n");
       fprintf(ERR,"double vector[%d]\n",n);
       exit(1);
     }
    return(vp);

}

int **imatrix(n1,n2)
int n1,n2;
{
int i,**ip;

 ip = (int **) malloc((unsigned ) n1*sizeof(int*) );
 if( !ip ) {
    fprintf(ERR,"memory allocation error\n");
    fprintf(ERR,"step1 integer matrix %d %d\n",n1,n2);
    exit(1);
  }
 for(i=0; i<n1 ; i++){
   ip[i] = (int *) malloc((unsigned) n2*sizeof(int));
   if( !ip[i] ) {
    fprintf(ERR,"memory allocation error\n");
    fprintf(ERR,"step2(i=%d) integer matrix %d %d\n",i,n1,n2);
    exit(1);

  }
 }
 
  return(ip);
				 
}




char **cmatrix(n1,n2)
int n1,n2;
{
int i;
char **ip;

 ip = (char **) malloc((unsigned ) n1*sizeof(char*) );
 if( !ip ) {
    fprintf(ERR,"memory allocation error\n");
    fprintf(ERR,"step1 char matrix %d %d\n",n1,n2);
    exit(1);
  }
 for(i=0; i<n1 ; i++){
   ip[i] = (char *) malloc((unsigned) n2*sizeof(char));
   if( !ip[i] ) {
    fprintf(ERR,"memory allocation error\n");
    fprintf(ERR,"step2(i=%d) integer matrix %d %d\n",i,n1,n2);
    exit(1);

  }
 }
 
  return(ip);
				 
}


unsigned char **ucmatrix(n1,n2)
int n1,n2;
{
int i;
unsigned char **ip;

 ip = (unsigned char **) malloc((unsigned ) n1*sizeof(char*) );
 if( !ip ) {
    fprintf(ERR,"memory allocation error\n");
    fprintf(ERR,"step1 char matrix %d %d\n",n1,n2);
    exit(1);
  }
 for(i=0; i<n1 ; i++){
   ip[i] = (unsigned char *) malloc((unsigned) n2*sizeof(char));
   if( !ip[i] ) {
    fprintf(ERR,"memory allocation error\n");
    fprintf(ERR,"step2(i=%d) integer matrix %d %d\n",i,n1,n2);
    exit(1);

  }
 }
 
  return(ip);
				 
}


double **dmatrix(n1,n2)
int n1,n2;
{
int i;
double **ip;

 ip = (double **) malloc((unsigned ) n1*sizeof(double*) );
 if( !ip ) {
    fprintf(ERR,"memory allocation error\n");
    fprintf(ERR,"step1 char matrix %d %d\n",n1,n2);
    exit(1);
  }
 for(i=0; i<n1 ; i++){
   ip[i] = (double *) malloc((unsigned) n2*sizeof(double));
   if( !ip[i] ) {
    fprintf(ERR,"memory allocation error\n");
    fprintf(ERR,"step2(i=%d) double matrix %d %d\n",i,n1,n2);
    exit(1);

  }
 }
 
  return(ip);
				 
}

double ***d3matrix(n1,n2,n3)
int n1,n2,n3;
{
int i,j;
double ***ip;

 ip = (double ***) malloc((unsigned ) n1*sizeof(double**) );
 if( !ip ) {
    fprintf(ERR,"memory allocation error\n");
    fprintf(ERR,"step1 char matrix %d %d\n",n1,n2);
    exit(1);
  }
 for(i=0; i<n1 ; i++){
   ip[i] = (double **) malloc((unsigned) n2*sizeof(double*));
   if( !ip[i] ) {
    fprintf(ERR,"memory allocation error\n");
    fprintf(ERR,"step2(i=%d) double matrix %d %d\n",i,n1,n2);
    exit(1);

  }
   for(j=0; j<n2 ; j++){
        ip[i][j] = (double *) malloc((unsigned) n3*sizeof(double));
        if( !ip[i][j] ) {
        fprintf(ERR,"memory allocation error\n");
        fprintf(ERR,"step3(i=%d j=%d) double matrix %d %d %d\n",i,j,n1,n2,n3);
        exit(1);

     }
   }
     
 }
 
  return(ip);
				 
}
double ******d6matrix(n1,n2,n3,n4,n5,n6)
int n1,n2,n3,n4,n5,n6;
{
int i,j,k,l,m,n;
double ******ip;

 ip = (double ******) malloc((unsigned ) n1*sizeof(double*****) );
 if( !ip ) {
    fprintf(ERR,"memory allocation error\n");
    fprintf(ERR,"d6matrix step1 char matrix %d %d\n",n1,n2);
    exit(1);
  }
 for(i=0; i<n1 ; i++){
   ip[i] = (double *****) malloc((unsigned) n2*sizeof(double****));
   if( !ip[i] ) {
    fprintf(ERR,"memory allocation error\n");
    fprintf(ERR,"step2(i=%d) double matrix %d %d\n",i,n1,n2);
    exit(1);

  }
   for(j=0; j<n2 ; j++){
        ip[i][j] = (double ****) malloc((unsigned) n3*sizeof(double***));
        if( !ip[i][j] ) {
         fprintf(ERR,"memory allocation error\n");
         fprintf(ERR,"step3(i=%d j=%d) double matrix %d %d %d\n",i,j,n1,n2,n3);
         exit(1);
	}
        for(k=0; k<n3 ; k++){
          ip[i][j][k] = (double ***) malloc((unsigned) n4*sizeof(double**));
          if( !ip[i][j][k] ) {
           fprintf(ERR,"memory allocation error\n");
           fprintf(ERR,"step3(i=%d j=%d) double matrix %d %d %d\n",i,j,n1,n2,n3);
           exit(1);
          }
          for(l=0; l<n4 ; l++){
            ip[i][j][k][l] = (double **) malloc((unsigned) n5*sizeof(double*));
            if( !ip[i][j][k][l] ) {
             fprintf(ERR,"memory allocation error\n");
             fprintf(ERR,"step3(i=%d j=%d) double matrix %d %d %d\n",i,j,n1,n2,n3);
             exit(1);
            }
	    for(m=0; m<n5 ; m++){
              ip[i][j][k][l][m] = (double *) malloc((unsigned) n6*sizeof(double));
             if( !ip[i][j][k][l][m] ) {
             fprintf(ERR,"memory allocation error\n");
             fprintf(ERR,"step3(i=%d j=%d) double matrix %d %d %d\n",i,j,n1,n2,n3);
             exit(1);
	     }
	    }

	  }
	}
   }
     
 }
 
  return(ip);
				 
}







Nds *Ndsvector(n)
int n;
{
int i;
Nds *ip;
 ip = (Nds *) malloc((unsigned ) n*sizeof(Nds) );
 if( !ip ) {
    fprintf(ERR,"memory allocation error\n");
    fprintf(ERR,"Nds step1 %d\n",n);
    exit(1);
  }

 
  return(ip);
				 
}

Ndsptr *Ndsptrvector(n)
int n;
{
int i;
Ndsptr *ip;
 ip = (Ndsptr *) malloc((unsigned ) n*sizeof(Ndsptr) );
 if( !ip ) {
    fprintf(ERR,"memory allocation error\n");
    fprintf(ERR,"Nds step1 %d\n",n);
    exit(1);
  }
  return(ip);
				 
}


void free_ivector(v,n)
int *v,n;
{
   free((char*) v );
   return ;
 }

void free_dvector(v,n)
double *v;
int n;
{
   free((char*) v );
   return ;
 }


void free_cvector(v,n)
char *v;
int n;
{
   free((char*) v );
   return ;
 }


void free_cmatrix(m,n1,n2)
char **m;
int n1,n2;
{
int i;

    for(i=n1-1 ; i >= 0 ; i-- ){
       free((char *) (m[i]));
     }
    free((char *) m);
}

void free_imatrix(m,n1,n2)
int  **m;
int n1,n2;
{
int i;

    for(i=n1-1 ; i >= 0 ; i-- ){
       free((char *) (m[i]));
     }
    free((char *) m);
}


void free_dmatrix(m,n1,n2)
double  **m;
int n1,n2;
{
int i;

    for(i=n1-1 ; i >= 0 ; i-- ){
       free((char *) (m[i]));
     }
    free((char *) m);
}

rdtv(fp,nseqw,fl,nda,blen)
Nds *nda/*[2*MAXOTU-2]*/;
FILE *fp;
int *nseqw;
double *blen/*[2*MAXOTU-2]*/;
char **fl/*[MAXOTU][MAXNM]*/;
{
int i,j, rn,n,**ntb/*[2*MAXOTU-3][2]*/,nw,n1,n2,n3,bstn,nl,nb;
char *b/*[1000]*/,*bw/*[200]*/,*bw1/*[200]*/;
float fw,fw1,fw2;
extern int  **imatrix();
extern char *cvector(); 
/*   printf("rdtv nseq=%d\n",nseq); */
   nb = maxnm+300;
   ntb = imatrix(2*nseq-3,2);
   b = cvector(nb);
   bw = cvector(nb);
   bw1 = cvector(nb);
/*   printf("rdtv b: %s\n::",b); */
    nl=0;

   for(i=0; i<nb; i++){
       b[i]=bw[i]=bw1[i]=0;
     }
   for( ; ; ){
     zeroc(b,nb);
     rn=rdline(fp,b,&n);
     nl++;
/*     printf("nl=%d\n",nl); */
     if( rn == 2 ) continue;
     if( rn == 1 ){
        printf("first line read error\n");
        exit(1);
    }
     break;
   }

   sscanf(b,"%d %s %d %s\n",nseqw,bw,&bstn,bw1);
   if( strcmp(bw,"sequences") != 0 ){
      printf("treefile first line invalid format nseqw=%d  bw:(%s)n",*nseqw,bw);
      exit(1);
    }
   if( *nseqw > nseq ){
       printf("too many sequences\n");
       exit(1);
     }
   for(i=0; i<*nseqw ; i++){
     zeroc(b,nb);
     if( (rn=rdline(fp,b,&n)) != 0 ){
        printf("sequence names read error\n");
      }
/*      printf("after b:%s::\n",b);
      printf("after n=%d\n",n);
*/
     nl++;
/*     printf("nl=%d\n",nl); */
     zeroc(bw,nb);
     getname(&nw,bw,b,n);
/*     sscanf(b,"%d %s",&nw,bw); */     if( nw != i+1 ){
        printf("sequence number read error %d %d\n",nw,i+1);
        exit(1);
      }
      nw = strlen(bw);
      if( nw > maxnm){
        printf("sequence name too long %s nw=%d maxnm=%d\n",bw,nw,maxnm);
        printf("b:%s\n");
        exit(1);
      }

/*
      if( strcmp(fl[i],bw) != 0 ) {
         printf("sequence name inconsistency %d %s %s\n",i+1,fl[i],bw);
         exit(1);
       }
*/
       strcpy(fl[i],bw);
/*       printf("bw %s fl %s\n",bw,fl[i]); */
   }
/*  printf("bootstap =%d\n",comm.bstflg); */
  for(i=0; i< 2*(*nseqw)-3 ; i++){
     for( ; ; ){
        zeroc(b,nb);
        rn = rdline(fp,b,&n);
        nl++;
/*        printf("nl=%d\n",nl); */
        if( rn == 2 ) continue;
        if( rn == 1 ){
             printf("format error\n");
              exit(1);
	   }
         break;
     }
/*      printf("comm.bstflg=%d\n",comm.bstflg); */
        /* no bootstrap nor confidence level */
                 sscanf(b,"%d and %d %f",&n1,&n2,&fw);
                 ntb[i][0]=n1;
                 ntb[i][1]=n2;
                 blen[i]=fw;

   }
   
   rn=trnd(*nseqw,ntb,nda,blen);
   free_imatrix(ntb,2*nseq-3,2);
   free_cvector(b,nb);
   free_cvector(bw,nb);
   free_cvector(bw1,nb);

   return(0);
}

brm(b,n)
char b[];
{
 int i,psflg;
  psflg=0;
  for(i=0; i<n ; i++){
    if( b[i] == '%' ) psflg++;
    if( b[i] < 0x26 || b[i] > 0x7e ) b[i] = ' ';
  }
  if( psflg != 1 ){
    printf("invalid format in input file confidence level is assumed %d\n%s\n",psflg,b);
    exit(1);
  }
  return(0);
}


trnd(nseqw,ntb,nda,blen)
int nseqw,**ntb/*[2*MAXOTU-3][2]*/;
Nds *nda/*[2*MAXOTU-2]*/;
double *blen/*[2*MAXOTU-2]*/;
{
int i,j,k,n1,ns;

  for(i=0; i<2*nseqw-2; i++){
     nda[i].nkey = i+1;
     nda[i].lc=NULL;
     nda[i].rc=NULL;
     nda[i].b=NULL;
     nda[i].plcx=NULL;
     nda[i].prcx=NULL;
     nda[i].pbx=NULL;
     nda[i].blcx=NULL;
     nda[i].brcx=NULL;
     nda[i].bbx=NULL;
     nda[i].height=0.0;
   }
  for(i=0; i<nseqw ; i++){
     ns=0;
     for(j=0; j<2*nseqw-3; j++){
         if( ntb[j][1] == i+1 ){
             nda[i].b = &nda[ntb[j][0]-1];
             nda[i].bbx = &blen[j];
             nda[i].bbx1 = &blen[j];
             nda[i].bbx2 = &blen[j];
/*             printf(" %d %d %f\n",i+1,ntb[j][0],blen[j]); */
             ns++;
	   }
         if( ntb[j][0] == i+1 ){
             nda[i].b = &nda[ntb[j][1]-1];
             nda[i].bbx = &blen[j];
             nda[i].bbx1 = &blen[j];
             nda[i].bbx2 = &blen[j];
/*             printf(" %d %d %f\n",i+1,ntb[j][1],blen[j]); */
             ns++;
	   }
       }
      if( ns != 1 ){
         printf("sequence %d format error\n",i+1);
       }
   }

    
    for( i=nseqw+1 ; i<= 2*nseqw-2 ; i++){
       ns=0;
       for(j=0; j<2*nseqw-3 ; j++){
         for(k=0; k<2 ; k++){
           if( ntb[j][k] == i ){
              switch(k){
                  case 0: n1 = ntb[j][1];
                          break;
                  case 1: n1 = ntb[j][0];
                          break;
		  }
               switch(ns){
 	         case 0: nda[i-1].lc = &nda[n1-1];
                         nda[i-1].blcx = &blen[j];
                         nda[i-1].blcx1 = &blen[j];
                         nda[i-1].blcx2 = &blen[j];
                         break;
 	         case 1: nda[i-1].rc = &nda[n1-1];
                         nda[i-1].brcx = &blen[j];
                         nda[i-1].brcx1 = &blen[j];
                         nda[i-1].brcx2 = &blen[j];
                         break;
      	         case 2: nda[i-1].b = &nda[n1-1];
                         nda[i-1].bbx = &blen[j];
                         nda[i-1].bbx1 = &blen[j];
                         nda[i-1].bbx2 = &blen[j];
                         break;
                 default: printf("format error node%d ns=%d\n",i,ns);
                          exit(1);
		 }
               ns++;  
               break;
	    }
	 }
       }
       if( ns != 3 ){
          printf("format error node%d ns=%d\n",i,ns);
          exit(1);
        }
     }

/*for(i=0; i<2*nseqw-3 ; i++){
   if( nda[i].nkey <= nseqw ) printf("%d b:%d\n",nda[i].nkey,nda[i].b->nkey);
   if( nda[i].nkey > nseqw ) printf("%d b:%d l:%d r:%d\n",nda[i].nkey,nda[i].b->nkey,nda[i].lc->nkey,nda[i].rc->nkey);

 }
*/
return(0);
}

rdline(fp,b,n)
int *n;
char *b;
FILE *fp;
{
int c,np,i;
   (*n)=0;
   np=0;
   for( ; ; ){
      c = fgetc(fp);
      if( c == EOF ) return(1);
      if( c != ' ' ) np++;
      b[*n]=c;
      (*n)++;
      if( c == '\n' ) break;
    }
    if( np == 0 ) return(2);
/*    printf("rdline bs %s\n",b);
    printf("rdline b:");
    for(i=0; i< *n ; i++) printf("%c",b[i]);
    printf("\n");
*/
/*   printf("b:%s\n",b); */
/*   printf("n=%d\n",*n); */
   return(0);
}





getname(nid,snm,bf,nl)
int *nid,nl;
char *snm,*bf;
{
char bn[50];
int i,n,flg,nc,nst,nend;
 flg=0;
 n=0;
 for(i=0; i<maxnm ; i++) snm[i]=0;
 for(i=0; i<50 ; i++) bn[i]=0;
 for( ; ; ){
  if( bf[n] == ' ' ){
     n++;
     continue;
   }
   break;
 }
 nc=0;
 for( ; ; ){
   if( bf[n] == ' ' ) break;
   bn[nc] = bf[n];
   if( bn[nc] > '9' || bn[nc] < '0' ) return(-1);
   nc++;
   n++;
 }
 sscanf(bn,"%d",nid);
 for( ; ; ){
   if( bf[n] == ' ' ) {
     n++;
     continue;
   }
   break;
 }
 
  nst=n;
  for(i=nl-1;  ; i--){
   if( bf[i] == ' ' || bf[i] == '\n' ) continue;
   nend=i;
   break;
  }
  
  for(i=nst ; i<=nend ; i++) snm[i-nst]=bf[i];

  return(0);
}


zeroc(b,nb)
char *b;
int nb;
{
int i;

 for(i=0; i<nb ; i++) b[i]=0;
 return(0);
}


preargv(ac,cur)
struct nds *ac,*cur;
{
Nds *pw;
double *bw,dsum,ra,rb;
int flg,i,j,nw,nm,nc,na,nlp,nrp;
unsigned char nx,ny, *pc;
/* printf("nseq=%d bc=%d  cur=%d\n",nseq,bc,cur->nkey); 
fflush(stdout); 
*/
    flg = 0;
    if( cur->b  == ac ) flg += 1;
    if( cur->lc == ac ){
        flg += 2;
        pw=cur->lc;
        cur->lc = cur->b;
        cur->b = pw;
        bw = cur->blcx;
        cur->blcx = cur->bbx;
        cur->bbx=bw;
        bw = cur->blcx1;
        cur->blcx1 = cur->bbx1;
        cur->bbx1=bw;
        bw = cur->blcx2;
        cur->blcx2 = cur->bbx2;
        cur->bbx2=bw;



        pc = cur->plcx;
        cur->plcx = cur->pbx;
        cur->pbx=pc;
      }

    if( cur->rc == ac ){
        pw=cur->rc;
        cur->rc = cur->b;
        cur->b = pw;
        bw = cur->brcx;
        cur->brcx = cur->bbx;
        cur->bbx=bw;
        bw = cur->brcx1;
        cur->brcx1 = cur->bbx1;
        cur->bbx1=bw;
        bw = cur->brcx2;
        cur->brcx2 = cur->bbx2;
        cur->bbx2=bw;
        pc = cur->prcx;
        cur->prcx = cur->pbx;
        cur->pbx=pc;
        flg += 3;
      }

    if( flg < 1 || flg > 3 ){
       printf("flg =%d\n",flg);
       exit(1);
     }


    if( cur->rc != NULL) {
       preargv(cur,cur->rc);
     }

    if( cur->lc != NULL) {
       preargv(cur,cur->lc);
     }
   if( cur->lc != NULL && cur->rc != NULL){
       if( cur->lc->nkey <= nseq ) {
              cur->plcx=NULL;
              nw=cur->lc->nkey;
              nm = (nw-1)/8;
              na = (nw-1)%8;
              nx = 0x80;
              nx = nx >> na;
              part[npc][nm] |= nx;
              ml=1;
              nll[0]=nw-1;
	   }else{
              cur->plcx = cur->lc->pbx;
               for(i=0; i< (nseq-1)/8+1 ; i++) {
                part[npc][i]  |= cur->plcx[i];
	      }
              
              getmem(cur->plcx,&ml,nll);
              nc=0;
	    }
     
       if( cur->rc->nkey <= nseq ) {
              cur->prcx=NULL;
              nw=cur->rc->nkey;
              nm = (nw-1)/8;
              na = (nw-1)%8;
              nx = 0x80;
              nx = nx >> na;
              part[npc][nm] |=nx;
              mr=1;
              nlr[0]=nw-1;
	    
	    }else{
              cur->prcx = cur->rc->pbx;
              for(i=0; i< (nseq-1)/8+1 ; i++) {
                part[npc][i]  |= cur->prcx[i];
	      }
              getmem(cur->prcx,&mr,nlr);
              nc=0;
	    }







   adpart[npc]=cur;
   cur->pbx = part[npc];
   npc++;
/*
   printf("cur %d\n",cur->nkey);
   fflush(stdout);
*/

   /*
    mb=0;
    for(i=0; i<nseq ; i++){
      nm = i/8;
      na = i%8;
      nx = 0x80;
      nx >>= na;
      ny = part[npc][nm] & nx;
      if( ny == 0 ){
        nlb[mb]=i;
        mb++;
      }
    }
*/
     }


   return(0);
     }


getmem(cpo,mx,nlx)
unsigned char *cpo;
int *mx,*nlx;

{
unsigned char nx,ny;
int i,j,nc,nm;
     nc=0;
     *mx=0;
     nm=0;
     for(i=0; i< (nseq-1)/8+1 ; i++){
        for(j=0; j<8 ; j++){
            nx = 0x80;
            nx = nx >> j;
            ny = cpo[i] & nx;
/*            printf("x=%02x p=%d y=%d ",nx,cpo[i],ny);  */
            ny = ny >> (7-j);
/*            printf("y=%d\n",ny);*/
            switch(ny){
                  case 0: break;
                  case 1: nlx[nm]=nc;
                          nm++;
                          if( dflg == 1 ) printf("getmem nm=%d\n",nm);
                          break;
                 default: printf("invalid ny=%d\n",ny);
                      exit(1);
	     }
       nc++;
       if( nc >= nseq ) {
            *mx=nm;
            return(0);
	  }

	      }
	    }


}

posargv(ac,cur)
Nds *ac,*cur;
{
struct nds *pw;
double *bw,dsum,ra,rb;
int flg,i,j,nw,nm,nc,na,nlp,nrp;
unsigned char nx,ny, *pc;
/* printf("nseq=%d bc=%d  cur=%d\n",nseq,bc,cur->nkey); 
fflush(stdout); 
*/
    flg = 0;
    if( cur->b  == ac ) flg += 1;
    if( cur->lc == ac ){
        flg += 2;
        pw=cur->lc;
        cur->lc = cur->b;
        cur->b = pw;
        bw = cur->blcx;
        cur->blcx = cur->bbx;
        cur->bbx=bw;
        bw = cur->blcx1;
        cur->blcx1 = cur->bbx1;
        cur->bbx1=bw;
        bw = cur->blcx2;
        cur->blcx2 = cur->bbx2;
        cur->bbx2=bw;

        pc = cur->plcx;
        cur->plcx = cur->pbx;
        cur->pbx=pc;
      }

    if( cur->rc == ac ){
        pw=cur->rc;
        cur->rc = cur->b;
        cur->b = pw;
        bw = cur->brcx;
        cur->brcx = cur->bbx;
        cur->bbx=bw;
        bw = cur->brcx1;
        cur->brcx1 = cur->bbx1;
        cur->bbx1=bw;
        bw = cur->brcx2;
        cur->brcx2 = cur->bbx2;
        cur->bbx2=bw;
        pc = cur->prcx;
        cur->prcx = cur->pbx;
        cur->pbx=pc;
        flg += 3;
      }

    if( flg < 1 || flg > 3 ){
       printf("flg =%d\n",flg);
       exit(1);
     }


    if( cur->rc != NULL) {
       posargv(cur,cur->rc);
     }

    if( cur->lc != NULL) {
       posargv(cur,cur->lc);
     }

   return(0);
     }




arargv(ac,cur)
Nds *ac,*cur;
{
struct nds *pw;
double *bw,dsum,raw,rbw,rcw,dw;
int flg,i,j,nw,nm,nc,na,nlp,nrp,s1,s2;
unsigned char nx,ny, *pc;
double delc(),caldev(),calhv();
/*    printf("arargv nseq=%d bc=%d cur %d anc %d npc=%d\n",nseq,bc,cur->nkey,ac->nkey,npc); 
*/
    fflush(stdout); 
    flg = 0;
    if( cur->b  == ac ) flg += 1;
    if( cur->lc == ac ){
        flg += 2;
        pw=cur->lc;
        cur->lc = cur->b;
        cur->b = pw;
        bw = cur->blcx;
        cur->blcx = cur->bbx;
        cur->bbx=bw;

        bw = cur->blcx1;
        cur->blcx1 = cur->bbx1;
        cur->bbx1=bw;
        bw = cur->blcx2;
        cur->blcx2 = cur->bbx2;
        cur->bbx2=bw;


        pc = cur->plcx;
        cur->plcx = cur->pbx;
        cur->pbx=pc;
      }

    if( cur->rc == ac ){
        pw=cur->rc;
        cur->rc = cur->b;
        cur->b = pw;
        bw = cur->brcx;
        cur->brcx = cur->bbx;
        cur->bbx=bw;
        bw = cur->brcx1;
        cur->brcx1 = cur->bbx1;
        cur->bbx1=bw;

        bw = cur->brcx2;
        cur->brcx2 = cur->bbx2;
        cur->bbx2=bw;

        pc = cur->prcx;
        cur->prcx = cur->pbx;
        cur->pbx=pc;
        flg += 3;
      }

    if( flg < 1 || flg > 3 ){
       printf("flg =%d\n",flg);
       exit(1);
     }


    if( cur->rc != NULL) {
       pw = cur->rc;
       if( dflg == 1 ) {
           printf("cur->rc>nkey =%d\n",pw->nkey);
           fflush(stdout);
	 }
       arargv(cur,cur->rc);
     }

    if( cur->lc != NULL) {
       pw = cur->lc;
       if( dflg == 1 ) {
           printf("cur->lc->nkey =%d\n",pw->nkey);
           fflush(stdout);
	 }
       arargv(cur,cur->lc);
     }
   if( cur->lc != NULL && cur->rc != NULL){
       if( cur->lc->nkey <= nseq ) {
              cur->plcx=NULL;
              nw=cur->lc->nkey;
              nm = (nw-1)/8;
              na = (nw-1)%8;
              nx = 0x80;
              nx = nx >> na;
              part[npc][nm] |= nx;
              if( dflg == 1 ) printf("nkey=%d nm=%d na=%d nx=%d %d\n",cur->lc->nkey,nm,na,nx,part[npc][nm]);
              ml=1;
              nll[0]=nw-1;
	   }else{
              cur->plcx = cur->lc->pbx;
              if( dflg == 1){
                 if( cur->lc->pbx != NULL ) printf("lc: b:%d",cur->lc->pbx[0]);
                 if( cur->lc->prcx != NULL ) printf("lc: r:%d",cur->lc->prcx[0]);
                 if( cur->lc->plcx != NULL ) printf("lc: l:%d",cur->lc->plcx[0]);
                printf("\n");
	       }
               for(i=0; i< (nseq-1)/8+1 ; i++) {
                part[npc][i]  |= cur->plcx[i];
	      }
              
              getmem(cur->plcx,&ml,nll);
              if( dflg == 1 ) printf("ml=%d\n",ml);
              nc=0;
if( dflg == 1 ){
              for(i=0; i<(nseq-1)/8+1; i++){
                for(j=0; j<8 ; j++){
                nx = 0x80;
                nx >>= j;
                ny = part[npc][i] & nx;
                ny = ny >> (7-j);
                printf("%d",ny);
                nc++;
                if( nc >= nseq ){
                    printf("\n");
                    goto S2;
		  }
                }
	      }
	    
S2:	 nc=0;
	    }
	    }
     
       if( cur->rc->nkey <= nseq ) {
              cur->prcx=NULL;
              nw=cur->rc->nkey;
              nm = (nw-1)/8;
              na = (nw-1)%8;
              nx = 0x80;
              nx = nx >> na;
              part[npc][nm] |=nx;
              if( dflg == 1 )  printf("nkey=%d nm=%d na=%d nx=%d %d\n",cur->rc->nkey,nm,na,nx,part[npc][nm]);
              mr=1;
              nlr[0]=nw-1;
	    
	    }else{
              cur->prcx = cur->rc->pbx;
              if( dflg == 1 ){
                if( cur->rc->pbx != NULL ) printf("rc: b:%d",cur->rc->pbx[0]);
                if( cur->rc->prcx != NULL ) printf("rc: r:%d",cur->rc->prcx[0]);
                if( cur->rc->plcx != NULL ) printf("rc: l:%d",cur->rc->plcx[0]);
             }    
              for(i=0; i< (nseq-1)/8+1 ; i++) {
                part[npc][i]  |= cur->prcx[i];
	      }
              getmem(cur->prcx,&mr,nlr);
              /* printf("ml=%d\n",ml); */
              nc=0;
	      if( dflg == 1 ){
                   for(i=0; i<(nseq-1)/8+1; i++){
                      for(j=0; j<8 ; j++){
                          nx = 0x80;
                          nx >>= j;
                          ny = part[npc][i] & nx;
                          ny = ny >> (7-j);
                          printf("%d",ny);
                          nc++;
                          if( nc >= nseq ){
                        printf("\n");
                        goto S3;
		      }
	      }
	      }

S3:	    nc=0;
		 }
	    }








   cur->pbx = part[npc];
   if( dflg == 1){
       printf("node %d l=%d r=%d\n",cur->nkey,cur->lc->nkey,cur->rc->nkey);
       nc=0;
       printf("ml=%d  ",ml);
       for(i=0; i<ml; i++) printf(" %d",nll[i]);
       printf("\n");
       printf("mr=%d  ",mr);
       for(i=0; i<mr; i++) printf(" %d",nlr[i]);
       printf("\n");

      for(i=0; i<(nseq-1)/8+1; i++){
       for(j=0; j<8 ; j++){
       nx = 0x80;
       nx >>= j;

/*       printf("x=%02x p=%d",nx,part[npc][i]); */
       ny = part[npc][i] & nx;
       ny = ny >> (7-j);
       printf("%d",ny);
       nc++;
       if( nc >= nseq ) goto S1;
     }
   }

    S1:  printf("\n");
}  
    mb=0;
    for(i=0; i<nseq ; i++){
      nm = i/8;
      na = i%8;
      nx = 0x80;
      nx >>= na;
      ny = part[npc][nm] & nx;
      if( ny == 0 ){
        nlb[mb]=i;
        mb++;
      }
    }
if( dflg ==2 ){
    printf("node %d  npc=%d ml=%d mr=%d mb=%d\n",cur->nkey,npc,ml,mr,mb); fflush(stdout);
    printf("nll:");
    for(i=0; i<ml ; i++) printf(" %d",nll[i]);
    printf("\n");
    printf("nlr:");
    for(i=0; i<mr ; i++) printf(" %d",nlr[i]);
    printf("\n");
    printf("nlb:");
    for(i=0; i<mb ; i++) printf(" %d",nlb[i]);
    printf("\n");
  }

    delta[npc]=delc(&raw,&rbw,&rcw);
    ra[npc] = raw;
    rb[npc] = rbw;
    rc[npc] = rcw;
    addelta[npc]=cur;
/*    deltav[npc][npc]=caldev(); */
    dw = caldev(&raw,&rbw,&raw);
    rav[npc]=raw;
    rbv[npc]=rbw;
    deltav[npc][npc]= dw;
    if( dflg == 1 ) printf("delta[%d]=%f %f\n",npc,delta[npc],dw);
    if( dflg == 1 ) printf("delv %f %f %f\n",delta[npc],deltav[npc][npc],sqrt(deltav[npc][npc])); fflush(stdout);
    cur->deln = npc;
    cur->heightv=calhv();
    if( dflg == 1 ) {
       printf("calhv %f\n",cur->heightv); fflush(stdout);
     }
    npc++;
    dsum=0.0;
      
   for(i=0; i<ml ; i++){
      for(j=0; j<mr; j++){
        s1 = nll[i]; s2 = nlr[j];
        if( s1 < s2 ) dsum += dist0[s1][s2];
        if( s2 < s1 ) dsum += dist0[s2][s1];
/*        dsum += dist0[nll[i]][nlr[j]]; */
      }
    }
    
    dsum /= 2*ml*mr;
    cur->height = dsum;
    cur->height1 = dsum;
    if( dflg == 1 ){
      printf("height=%f bc=%d ml=%d mr=%d\n",dsum,bc,ml,mr);
      fflush(stdout);
    }
    if( cur->lc->nkey <= nseq ){
      cur->lc->height=0.0;
      cur->lc->height1=0.0;
      blen1[bc]=dsum;
      blen2[bc]=dsum;
      cur->lc->bbx1 = &blen1[bc];
      cur->lc->bbx2 = &blen2[bc];
    }else{
      blen1[bc] = dsum - cur->lc->height;
      blen2[bc] = dsum - cur->lc->height;
      if( blen1[bc] < 0.0 ) ngflg++;
    }

    cur->lc->bbx1 = &blen1[bc];
    cur->blcx1 = &blen1[bc];
    cur->lc->bbx2 = &blen2[bc];
    cur->blcx2 = &blen2[bc];

    if( cur->rc->nkey <= nseq ){
      cur->rc->height=0.0;
      cur->rc->height1=0.0;
      blen1[bc+1]=dsum;
      blen2[bc+1]=dsum;
      cur->rc->bbx1 = &blen1[bc+1];
      cur->rc->bbx2 = &blen2[bc+1];
    }
    else{
      blen1[bc+1] = dsum - cur->rc->height;
      blen2[bc+1] = dsum - cur->rc->height;
      if( blen1[bc+1] < 0.0 ) ngflg++;
    }
    cur->rc->bbx1 = &blen1[bc+1];
    cur->brcx1 = &blen1[bc+1];
    cur->rc->bbx2 = &blen2[bc+1];
    cur->brcx2 = &blen2[bc+1];
    bc += 2;

     }
   if( dflg == 1 ){
       printf("return\n");
       fflush(stdout);
     }
   return(0);
}


outchk(nseq0,noutg,outg,cur0,anc0)
int nseq0,noutg,outg[];
Nds **anc0,**cur0;

{
int i,j,k,*a0/*[MAXOTU]*/,*a1/*[MAXOTU]*/,n0,n1,nm,na,flg,bn,ln,rn,*bm/*[MAXOTU]*/,*lm/*[MAXOTU]*/,
*rm/*[MAXOTU]*/;
unsigned char nx,ny;
extern int *ivector();

  a0 = ivector(nseq0);
  a1 = ivector(nseq0);
  bm = ivector(nseq0);
  lm = ivector(nseq0);
  rm = ivector(nseq0);
/* printf("outchk\n");fflush(stdout); */

for(i=0; i<nseq0-2; i++){
  n0=0;
  n1=0;
/*  printf("outchk %d\n",i);fflush(stdout);  */
  for(j=0; j<nseq0 ; j++){
     nm = j/8;
     na = j%8;
     nx = 0x80;
     nx >>= na;
     ny = nx & part[i][nm];
     if( ny == 0 ) {
           a0[n0]=j;
           n0++;
	 }
     else{
           a1[n1]=j;
           n1++;
	 }
/*    printf("j=%d n0=%d n1=%d\n",j,n0,n1);fflush(stdout);  */

   }
/*    printf("%d n1=%d n0=%d\n",i,n1,n0); */
    flg=0;
    if( n0 == noutg || n1 == noutg){
        if( n0 == noutg ){
          for(j=0; j<noutg ; j++){
            if( a0[j]+1 != outg[j] ) break;
            flg++;
	  }
	}
        if( n1 == noutg ){
         for(j=0; j<noutg ; j++){
            if( a1[j]+1 != outg[j] ) break;
            flg++;
	  }
        }
        if( flg == noutg ){

            if( adpart[i]->b->nkey <= nseq0 ){
                bn=1;
                bm[0]=adpart[i]->b->nkey;
	      }else{
                bn=0;
                under(adpart[i],adpart[i]->b,&bn,bm);
	      }
/*             printf("bn=%d :");
             for(j=0; j<bn ; j++) printf(" %d",bm[j]);
             printf("\n");


*/
            if( adpart[i]->lc->nkey <= nseq0 ){
                ln=1;
                lm[0]=adpart[i]->lc->nkey;
	      }else{
                ln=0;
                under(adpart[i],adpart[i]->lc,&ln,lm);
	      }
/*
             printf("ln=%d :");
             for(j=0; j<ln ; j++) printf(" %d",lm[j]);
             printf("\n");
*/
            if( adpart[i]->rc->nkey <= nseq0 ){
                rn=1;
                rm[0]=adpart[i]->rc->nkey;
	      }else{
                rn=0;
                under(adpart[i],adpart[i]->rc,&rn,rm);
	      }
/*             printf("rn=%d :");
             for(j=0; j<rn ; j++) printf(" %d",rm[j]);
             printf("\n");
*/
             flg =0;
             for(j=0; j<noutg ; j++){
               for(k=0; k<bn ; k++){
                 if( bm[k] == outg[j] ) flg++;
	       }
	     }
/*             printf("b: flg=%d\n",flg); */
             if( flg == noutg ){
                  *cur0 = adpart[i];
                  *anc0 = adpart[i]->b;
/*                  printf("out cur0 %d anc0 %d",(*cur0)->nkey,(*anc0)->nkey); */
                  free_ivector(a0,nseq0);
                  free_ivector(a1,nseq0);
                  free_ivector(bm,nseq0);
                  free_ivector(lm,nseq0);
                  free_ivector(rm,nseq0);

                  return(0);
		}
             flg =0;
             for(j=0; j<noutg ; j++){
               for(k=0; k<ln ; k++){
                 if( lm[k] == outg[j] ) flg++;
	       }
	     }
/*             printf("l: flg=%d\n",flg); */
             if( flg ==noutg ){
                  *cur0 = adpart[i];
                  *anc0 = adpart[i]->lc;
/*                  printf("out cur0 %d anc0 %d",(*cur0)->nkey,(*anc0)->nkey); */
                  free_ivector(a0,nseq0);
                  free_ivector(a1,nseq0);
                  free_ivector(bm,nseq0);
                  free_ivector(lm,nseq0);
                  free_ivector(rm,nseq0);

                  return(0);
		}
             flg =0;
             for(j=0; j<noutg ; j++){
               for(k=0; k<rn ; k++){
                 if( rm[k] == outg[j] ) flg++;
	       }
	     }
/*             printf("r: flg=%d\n",flg); */
             if( flg == noutg  ){
                  *cur0 = adpart[i];
                  *anc0 = adpart[i]->rc;
                  free_ivector(a0,nseq0);
                  free_ivector(a1,nseq0);
                  free_ivector(bm,nseq0);
                  free_ivector(lm,nseq0);
                  free_ivector(rm,nseq0);

                  return(0);
		}
                  free_ivector(a0,nseq0);
                  free_ivector(a1,nseq0);
                  free_ivector(bm,nseq0);
                  free_ivector(lm,nseq0);
                  free_ivector(rm,nseq0);

              return(-1);
	  }
      }


}


    return(-1);
}


under(ac,cur,nmem,nmeml)
Nds *ac,*cur;
int *nmem,*nmeml;
{
struct nds *pw;
double *bw,dsum,ra,rb;
int flg,i,j,nw;
unsigned char nx,ny, *pc;
/* printf("nseq=%d  cur=%d\n",nseq,cur->nkey); 
fflush(stdout); 
*/
    flg = 0;
    if( cur->b  == ac ) flg += 1;
    if( cur->lc == ac ){
        flg += 2;
        pw=cur->lc;
        cur->lc = cur->b;
        cur->b = pw;
        bw = cur->blcx;
        cur->blcx = cur->bbx;
        cur->bbx=bw;
        bw = cur->blcx1;
        cur->blcx1 = cur->bbx1;
        cur->bbx1=bw;
        bw = cur->blcx2;
        cur->blcx2 = cur->bbx2;
        cur->bbx2=bw;



        pc = cur->plcx;
        cur->plcx = cur->pbx;
        cur->pbx=pc;
      }

    if( cur->rc == ac ){
        pw=cur->rc;
        cur->rc = cur->b;
        cur->b = pw;
        bw = cur->brcx;
        cur->brcx = cur->bbx;
        cur->bbx=bw;
        bw = cur->brcx1;
        cur->brcx1 = cur->bbx1;
        cur->bbx1=bw;
        bw = cur->brcx2;
        cur->brcx2 = cur->bbx2;
        cur->bbx2=bw;
        pc = cur->prcx;
        cur->prcx = cur->pbx;
        cur->pbx=pc;
        flg += 3;
      }

    if( flg < 1 || flg > 3 ){
       printf("flg =%d\n",flg);
       exit(1);
     }


    if( cur->rc != NULL) {
       under(cur,cur->rc,nmem,nmeml);
     }

    if( cur->lc != NULL) {
       under(cur,cur->lc,nmem,nmeml);
     }
   if( cur->lc != NULL && cur->rc != NULL){
       if( cur->lc->nkey <= nseq ) {
              cur->plcx=NULL;
              nw=cur->lc->nkey;
              nmeml[*nmem]=nw;
              (*nmem)++;
	   }
       if( cur->rc->nkey <= nseq ) {
              cur->prcx=NULL;
              nw=cur->rc->nkey;
	      nmeml[*nmem]=nw;
              (*nmem)++;
	    }
	    }







   return(0);
     }




reestb(ac,cur)
Nds *ac,*cur;
{
struct nds *pw;
double *bw,dsum;
int flg,i,j,nw,nm,nc,na;
unsigned char nx,ny, *pc;
if( dflg == 1 ) printf("reestb nseq=%d\n",nseq);
fflush(stdout); 
    if( cur->lc != NULL) {
       *cur->blcx2 = cur->height1 - cur->lc->height1;
       if( cur->height1 < cur->lc->height1 ){
             *cur->blcx2=0.0;
             cur->lc->height1 = cur->height1;
	   }
       pw = cur->lc;
       if( dflg == 1 ) {
           printf("cur->lc->nkey =%d\n",pw->nkey);
           fflush(stdout);
	 }
       reestb(cur,cur->lc);
    }
    if( cur->rc != NULL) {
       *cur->brcx2 = cur->height1 - cur->rc->height1;
       if( cur->height1 < cur->rc->height1 ){
            *cur->brcx2=0.0;
            cur->rc->height1 = cur->height1;
	  }
       pw = cur->rc;
       if( dflg == 1 ){
          printf("cur->rc>nkey =%d\n",pw->nkey);
          fflush(stdout);
	}
       reestb(cur,cur->rc);
       }




   return(0);
}






calcov(a,nseq0,nsite,nasite,npsite,asite,dop,dist,ndif,ndif1,gamma,asite0,nbal,cdn,fl,maxnm,pflg)
char **a/*[MAXSITE][MAXOTU]*/,**fl;
int nseq0,nsite,nasite,*asite,dop,*asite0,cdn[4][4][4],maxnm,pflg;
double **dist/*[MAXOTU][MAXOTU]*/,gamma;
int **ndif/*[MAXOTU][MAXOTU]*/,**ndif1/*[MAXOTU][MAXOTU]*/,**nbal/*[MAXOTU][4]*/;
{
int i,j,k,l,npb,np1,np2,np3,ns1,ns2,ns21,ns22,nv1,nv2,nd1,nd2,n,nts1,nts2;
int n1,n2,n3,n4,rn,nbx[4],nby[4],na,ndist;
double sp,dp,dq,dsp,da,db1,db2,dw,db;
int *ppsite/*[MAXSITE]*/,*pqsite/*[MAXSITE]*/,nppsite,npqsite,*p2site/*[MAXSITE]*/,np2site;
float fw,*fwp;
extern int *ivector();
    ppsite = ivector(nsite);
    pqsite = ivector(nsite);
    p2site = ivector(nsite);
    if( dflg == 1 ) printf("dop=%d nseq0=%d\n",dop,nseq0);

   nd1=0;
   n=0;
   ndist = nseq0*(nseq0-1)/2;
   for(i=0; i<nseq0-1; i++){
     for(j=i+1; j<nseq0; j++){
     rn=distv(nasite,npsite,asite,nd1,a,i,j,dop,dist,&np1,&ns1,&nv1,&nts1,&nts2,gamma,&db,asite0,nbal,cdn,fl,maxnm,pflg);
     if( rn != 0 ){
       printf("inapplicable case i=%d j=%d\n",i,j);
       exit(1);
     }
/*      printf("distv i=%d j=%d npsite=%d\n",i,j,npsite);
      fflush(stdout);
*/
     n++;
     switch(dop){
        case 0: ndif[i][j]=ndif[j][i]=np1;
                break;
        case 1: ndif[i][j]=ndif[j][i]=np1;
                break;
        case 2: ndif[i][j]=ns1;
                ndif[j][i]=nv1;
                break;
        case 5: ndif[i][j]=ndif[j][i]=np1;
                break;
        case 6: ndif[i][j]=ns1;
                ndif[j][i]=nv1;
                break;
        case 9: 
        case 10: 
        case 11: 
        case 12: 
                ndif[i][j]=nv1;
                ndif[j][i]=nv1;
                break;
        case 8: fwp = &ndif[j][i];
                fw = db;
                *fwp = fw;
                ndif[i][j]=np1;
                break;
        case 13:
        case 14:
                 ndif[i][j]=ns1;
                 ndif[j][i]=nv1;
                 ndif1[i][j]=nts1;
                 ndif1[j][i]=nts2;
        case 15:
        case 16:
        case 17:
        case 18:
                 break;
	}
      nd1++;
   }
   }
 
   if( n != nseq0*(nseq0-1)/2 ){
     printf("calcov n=%d  %d\n",n,nseq0*(nseq0-1)/2);
     exit(1);
   }
    if( dflg == 1 ) printf("dop=%d\n",dop);
     nd1=0;
     n=0;
     for(i=0; i<nseq0; i++){
       for(j=i+1; j<nseq0 ; j++){
       getpsite(ppsite,pqsite,p2site,&nppsite,&npqsite,&np2site,i,j,a,dop,asite,npsite);
       if( dflg == 1 ) printf("get psite dop=%d\n",dop);
       switch(dop){
         case 0: np1 = ndif[i][j];
                 break;
         case 1: np1 = ndif[i][j];
                 break;
         case 2: ns1 = ndif[i][j];nv1 = ndif[j][i];
                 break;
         case 5: np1 = ndif[i][j];
                 break;
         case 6: ns1 = ndif[i][j];nv1 = ndif[j][i];
                 break;
         case 9: 
         case 10: 
                 nv1 = ndif[i][j];
                 break;
         case 11: 
         case 12: 
                  nv1 = ndif[i][j];
                  nbx[0] = nbal[i][0]+nbal[j][0];
                  nbx[1] = nbal[i][1]+nbal[j][1];
                  nbx[2] = nbal[i][2]+nbal[j][2];
                  nbx[3] = nbal[i][3]+nbal[j][3];
                  break;

         case 13: 
         case 14: 
                  ns1 = ndif1[i][j];
                  ns21 = ndif1[i][j];
                  nv1 = ndif[j][i];
                  nbx[0] = nbal[i][0]+nbal[j][0];
                  nbx[1] = nbal[i][1]+nbal[j][1];
                  nbx[2] = nbal[i][2]+nbal[j][2];
                  nbx[3] = nbal[i][3]+nbal[j][3];
                  break;
         case 8: np1 = ndif[i][j]; fwp = &ndif[j][i];
                 db1 = *fwp;
                 break;
          
	 }
       k=i;
       nd2=nd1;


       for(l=j+1; l<nseq0 ; l++){
          n++;
          switch(dop){
             case 0: np2 = ndif[k][l];
                     break;
             case 1: np2 = ndif[k][l];
                     break;
             case 2: ns2 = ndif[k][l];nv2 = ndif[l][k];
                      break;
             case 5: np2 = ndif[k][l];
                     break;
             case 6: ns2 = ndif[k][l];nv2 = ndif[l][k];
                      break;
             case 9: 
             case 10: 
                      nv2 = ndif[k][l];
                      break;
             case 11: 
             case 12: 
                      nv2 = ndif[k][l];
                      nby[0] = nbal[k][0]+nbal[l][0];
                      nby[1] = nbal[k][1]+nbal[l][1];
                      nby[2] = nbal[k][2]+nbal[l][2];
                      nby[3] = nbal[k][3]+nbal[l][3];
                      break; 
             case 13: 
             case 14: 
                      ns2 = ndif1[k][l];
                      ns22 = ndif1[l][k];
                      nv2 = ndif[l][k];
                      nby[0] = nbal[k][0]+nbal[l][0];
                      nby[1] = nbal[k][1]+nbal[l][1];
                      nby[2] = nbal[k][2]+nbal[l][2];
                      nby[3] = nbal[k][3]+nbal[l][3];
                      break;
            case 8: np2 = ndif[k][l]; fwp = &ndif[l][k];
                     db2 = *fwp;
                      break;
          }
          

        nd2++;
/*       printf("dop=%d\n",dop);    */
/*       printf("ns2=%d nv2=%d\n",ns2,nv2); */
       calcv1(nasite,asite,a,i,j,k,l,nd1,nd2,dop,np1,ns1,nv1,ns21,np2,ns2,nv2,ns22,nppsite,npqsite,np2site,ppsite,pqsite,p2site,gamma,db1,db2,nbx,nby,ndist);
       }
/*      printf(" %d %d %d %d   %d %d %e\n",i,j,k,l,nd1,nd2,cov[nd1][nd2]); */
     for(k=i+1; k<nseq0 ; k++){
       for(l=k+1; l<nseq0 ; l++){
        nd2++;
        n++;
       switch(dop){
         case 0: np2 = ndif[k][l];
                 break;
         case 1: np2 = ndif[k][l];
                 break;
         case 2: ns2 = ndif[k][l];nv2 = ndif[l][k];
                 break;
         case 5: np2 = ndif[k][l];
                 break;
         case 6: ns2 = ndif[k][l];nv2 = ndif[l][k];
                 break;
         case 9: 
         case 10: 
                 nv2 = ndif[k][l];
                 break;
         case 11: 
         case 12: 
                 nv2 = ndif[k][l];
                 nby[0] = nbal[k][0]+nbal[l][0];
                 nby[1] = nbal[k][1]+nbal[l][1];
                 nby[2] = nbal[k][2]+nbal[l][2];
                 nby[3] = nbal[k][3]+nbal[l][3];
                break; 
         case 13: 
          case 14: 
                 ns2 = ndif1[k][l];
                 ns22 = ndif1[l][k];
                 nv2 = ndif[l][k];
                 nby[0] = nbal[k][0]+nbal[l][0];
                 nby[1] = nbal[k][1]+nbal[l][1];
                 nby[2] = nbal[k][2]+nbal[l][2];
                 nby[3] = nbal[k][3]+nbal[l][3];
                 break;
         case 8: np2 = ndif[k][l]; fwp = &ndif[l][k]; db2 = *fwp; 
                 break;
	 }
/*       printf("dop=%d\n",dop); */
/*       printf("ns2=%d nv2=%d",ns2,nv2);*/
       calcv1(nasite,asite,a,i,j,k,l,nd1,nd2,dop,np1,ns1,nv1,ns21,np2,ns2,nv2,ns22,nppsite,npqsite,np2site,ppsite,pqsite,p2site,gamma,db1,db2,nbx,nby,ndist);
/*      printf(" %d %d %d %d   %d %d %e\n",i,j,k,l,nd1,nd2,cov[nd1][nd2]); */
      }
     }
     nd1++;
   }
   }
   if( n != nseq0*(nseq-1)/2*(nseq0*(nseq-1)/2-1)/2 ){
     printf("calcov n=%d nseq0*(nseq-1)/2*(nseq0*(nseq-1)/2-1)/2=%d\n",n,nseq0*(nseq-1)/2*(nseq0*(nseq-1)/2-1)/2);
     exit(1);
   }

    free_ivector(ppsite,nsite);
    free_ivector(pqsite,nsite);
    free_ivector(p2site,nsite);
    return(0);

}
getpsite(ppsite,pqsite,p2site,nppsite,npqsite,np2site,s1,s2,a,dop,asite,npsite)
int *ppsite/*[MAXSITE]*/,*pqsite/*[MAXSITE]*/,*p2site/*[MAXSITE]*/,*nppsite,*npqsite,*np2site,s1,s2,dop,*asite,npsite;
char **a/*[MAXSITE][MAXOTU]*/;
{
int i,n;

   *nppsite=0;
   *npqsite=0;
   *np2site=0;

   for(i=0; i<npsite; i++){
      n = asite[i];
      switch(dop){
        case 0:
        case 1:
        case 5:
        case 8:
                switch(tr[a[n][s1]][a[n][s2]]){
                   case -1:
                            break;
		   default: ppsite[*nppsite] = n;
                            (*nppsite)++;
                            break;
			  }
                 break;
        case 6:
        case 2:
                switch(tr[a[n][s1]][a[n][s2]]){
                   case -1:
                            break;
    		   case 0 : ppsite[*nppsite] = n;
                            (*nppsite)++;
                            break;
    		   case 1 : pqsite[*npqsite] = n;
                            (*npqsite)++;
                            break;
			  }
                 break;
        case 9:
        case 10:
        case 11:
        case 12:
                switch(tr[a[n][s1]][a[n][s2]]){
                   case -1:
                            break;
    		   case 0 : ppsite[*nppsite] = n;
                            (*nppsite)++;
                            break;
    		   case 1 : pqsite[*npqsite] = n;
                            (*npqsite)++;
                            break;
			  }
                 break;

       case 13:
       case 14:
                 switch(tr1[a[n][s1]][a[n][s2]]){
                   case 0:
                            break;
    		   case 1 : ppsite[*nppsite] = n;
                            (*nppsite)++;
                            break;
    		   case 2 : p2site[*np2site] = n;
                            (*np2site)++;
                            break;
    		   case 3 : pqsite[*npqsite] = n;
                            (*npqsite)++;
                            break;
			  }
                 break;
	      }
    }




    return(0);
}


calcv1(nasite,asite,a,n1,n2,n3,n4,nd1,nd2,dop,np1,ns1,nv1,ns21,np2,ns2,nv2,ns22,nppsite,npqsite,np2site,ppsite,pqsite,p2site,gamma,tnb1,tnb2,nbx,nby,ndist)
int nasite,*asite,n1,n2,n3,n4,nd1,nd2,dop,np1,ns1,nv1,np2,ns2,nv2,ns21,ns22,nppsite,np2site,npqsite,*ppsite,*pqsite,*p2site;
int nbx[4],nby[4],ndist;
char **a/*[MAXSITE][MAXOTU]*/;
double gamma,tnb1,tnb2;
{
int i,n,nps,nss,nvs,nr,nss1,pflg,pflg1,nad;
int np11,np12,np1q,np21,np22,np2q,nqp1,nqp2,nqq;
double da1,db1,da2,db2,dp1,dp2,dps,sp1,sp2,dq1,dq2,dr,ds,dqs,dw,c1,c2,d1,d2;
double dp11,dp12,dp1q,dp21,dp22,dp2q,dqp1,dqp2,dqq,dp1x,dp1y,dp2x,dp2y,dqx,dqy;
double xcp1,ycp1,xcp2,ycp2,xcq,ycq,gax,gtx,ggx,gcx,gyx,grx,gay,gty,ggy,gcy,gyy,gry;
double dwx,dwy;



    nad = covad(nd1,nd2,ndist);

/*   printf("n1 n2 n3 n4 %d %d %d %d  nd1=%d nd2=%d\n",n1,n2,n3,n4,nd1,nd2);*/
   switch(dop){
      case 0:
             nps=0;
             for(i=0; i<nppsite ; i++){
               n = ppsite[i];
               switch(tr[a[n][n3]][a[n][n4]]){
         	       case -1: 
                               break;
   		       default: nps++;
                                break;
			     }
		    }
             dps = nps;
             dps /= nasite;
             dp1 = np1;
             dp1 /= nasite;
             dp2 = np2;
             dp2 /= nasite;
             dw = (dps-dp1*dp2)*sqrt(dp1*(1.0-dp1)*dp2*(1.0-dp2));
             dw /= nasite;

             if( covflg == 0 ){
                cov[nad] = dw;
	     }else{
                 if( write(fpcov,&dw,sizeof(double)) == -1 ){
                     printf("write error\n");
                     exit(1);
                   }
	     }

/*             if( nad >= 77 ) printf("nad=%d nd1=%d nd2=%d ndist=%d cov=%f\n",nad,nd1,nd2,ndist,cov[nad]); */

/*             printf("nps=%d np1=%d np2=%d cov=%e\n",nps,np1,np2,cov[nd1][nd2]); */
             break;
     

     case 1:
             nps=0;
             for(i=0; i<nppsite ; i++){
               n = ppsite[i];
               switch(tr[a[n][n3]][a[n][n4]]){
         	       case -1: 
                                break;
   		       default: nps++;
                                break;

			      }
	     }
             dps = nps;
             dps /= nasite;
             dp1 = np1;
             dp1 /= nasite;
             dp2 = np2;
             dp2 /= nasite;
             dw = (dps-dp1*dp2)/(1.0-dp1/0.75)/(1.0-dp2/0.75);
             dw /= nasite;

             if( covflg == 0 )  cov[nad] = dw;
             else{
              if( write(fpcov,&dw,sizeof(double)) == -1 ){
                     printf("write error\n");
                     exit(1);
                   }
	     }
             break;

     case 5:
             nps=0;
             for(i=0; i<nppsite ; i++){
               n = ppsite[i];
               switch(tr[a[n][n3]][a[n][n4]]){
         	       case -1: 
                                break;
   		       default: nps++;
                                break;

			      }
	     }
             dps = nps;
             dps /= nasite;
             dp1 = np1;
             dp1 /= nasite;
             dp2 = np2;
             dp2 /= nasite;
             dw=pow((1.0-dp1/0.75)*(1.0-dp2/0.75),-(1.0/gamma+1.0));
             dw = (dps-dp1*dp2)*dw;
             dw /= nasite;
             if( covflg == 0 ) cov[nad] = dw;
             else if( write(fpcov,&dw,sizeof(double)) == -1 ){
                     printf("write error\n");
                     exit(1);
                   }
             break;
     
     case 8:
             nps=0;
             for(i=0; i<nppsite ; i++){
               n = ppsite[i];
               switch(tr[a[n][n3]][a[n][n4]]){
         	       case -1: 
                                break;
   		       default: nps++;
                                break;

			      }
	     }
             dps = nps;
             dps /= nasite;
             dp1 = np1;
             dp1 /= nasite;
             dp2 = np2;
             dp2 /= nasite;
             dw = (dps-dp1*dp2)/(1.0-dp1/tnb1)/(1.0-dp2/tnb2);
             dw /= nasite;
             if( covflg ==  0 ) cov[nad] = dw;
             else if( write(fpcov,&dw,sizeof(double)) == -1 ){
                     printf("write error\n");
                     exit(1);
                   }
/*             printf("np1=%d np2=%d b1=%f b2=%f\n",np1,np2,tnb1,tnb2); */
             break;

      case 2 :  nps=0;
                nss=0;
                nvs=0;
                nr=0;
                nss1=0;
                for(i=0; i<nppsite; i++){
                   n=ppsite[i];
                   switch(tr[a[n][n3]][a[n][n4]]){
	         		case -1: /* no difference */
                                           break;
				case 0 : nss++;
                                         break;
			        case 1 : nr++;
                                         break;
			        default:   printf("invalid code\n");
                                           exit(1);

			 }
		 }
                for(i=0; i<npqsite; i++){
                   n=pqsite[i];
                   switch(tr[a[n][n3]][a[n][n4]]){
	         		case -1: /* no difference */
                                           break;
				case 0 : nss1++;
                                         break;
			        case 1 : nvs++;
                                         break;
			        default:   printf("invalid code\n");
                                           exit(1);

			 }
		 }
	   
	   
                 dp1 = ns1;  dp1 /= nasite;
                 dp2 = ns2;  dp2 /= nasite;
                 dq1 = nv1;  dq1 /= nasite;
                 dq2 = nv2;  dq2 /= nasite;
                 dps = nss; dps /= nasite;
                 dqs = nvs; dqs /= nasite;
                 dr = nr;   dr /= nasite;
                 ds = nss1; ds /= nasite;	   
                 da1 = 1.0/(1.0-2.0*dp1-dq1);	   
                 db1 = 0.5*da1 + 0.5/(1.0-2.0*dq1);
                 da2 = 1.0/(1.0-2.0*dp2-dq2);
                 db2 = 0.5*da2 + 0.5/(1.0-2.0*dq2);
	   
                 
                 dw = da1*da2*(dps-dp1*dp2)+da1*db2*(dr-dp1*dq2)
                                 + da2*db1*(ds-dq1*dp2)+db1*db2*(dqs-dq1*dq2);
                 dw /= nasite;
                 if( covflg == 0 ) cov[nad] = dw;
                 else if( write(fpcov,&dw,sizeof(double)) == -1 ){
                     printf("write error\n");
                     exit(1);
                   }
   if( dflg == 1 ) {
      printf("calcv1 n1=%d n2=%d n3=%d n4=%d nd1=%d nd2=%d nasite=%d ns1=%d nv1=%d ns2=%d nv2=%d nss=%d nvs=%d nr=%d nss1=%d  %e\n",n1,n2,n3,n4,nd1,nd2,nasite,ns1,nv1,ns2,nv2,nss,nvs,nr,nss1,cov[nad]);fflush(stdout);
   }         
             pflg=0;
             pflg1=0;
             if( n1 == 21 ) pflg++;
             if( n2 == 21 ) pflg++;
             if( n3 == 21 ) pflg++;
             if( n4 == 21 ) pflg++;
             if( n1 == 25 ) pflg1++;
             if( n2 == 25 ) pflg1++;
             if( n3 == 25 ) pflg1++;
             if( n4 == 25 ) pflg1++;
/*             
   if( pflg == 2 || pflg1 ==2  ) {
      printf("calcv1 n1=%d n2=%d n3=%d n4=%d nd1=%d nd2=%d nasite=%d ns1=%d nv1=%d ns2=%d nv2=%d nss=%d nvs=%d nr=%d nss1=%d  %e\n",n1,n2,n3,n4,nd1,nd2,nasite,ns1,nv1,ns2,nv2,nss,nvs,nr,nss1,cov[nad]);
   }         
*/
                break;
	   case 9:
	   case 10:
                nps=0;
                nss=0;
                nvs=0;
                nr=0;
                nss1=0;
                for(i=0; i<npqsite; i++){
                   n=pqsite[i];
                   switch(tr[a[n][n3]][a[n][n4]]){
	         		case -1: /* no difference */
                                           break;
				case 0 : nss1++;
                                         break;
			        case 1 : nvs++;
                                         break;
			        default:   printf("invalid code\n");
                                           exit(1);

			 }
		 }
	   
	   
                 dq1 = nv1;  dq1 /= nasite;
                 dq2 = nv2;  dq2 /= nasite;
                 dqs = nvs; dqs /= nasite;
                 if( dop == 9 ) dw = (dqs -dq1*dq2)/(1.0-2.0*dq1)/(1.0-2.0*dq2);
                 if( dop == 10 ){
                        c1 = pow(1.0-2.0*dq1,-(1.0+1.0/gamma));
                        c2 = pow(1.0-2.0*dq2,-(1.0+1.0/gamma));
                        dw = (dqs -dq1*dq2)*c1*c2;
		      }
                 dw /= nasite;
                 if( covflg == 0 ) cov[nad] = dw;
	         else if( write(fpcov,&dw,sizeof(double)) == -1 ){
                     printf("write error\n");
                     exit(1);
                   }

                 break;

     case 11:
     case 12:
                nps=0;
                nss=0;
                nvs=0;
                nr=0;
                nss1=0;
                for(i=0; i<npqsite; i++){
                   n=pqsite[i];
                   switch(tr[a[n][n3]][a[n][n4]]){
	         		case -1: /* no difference */
                                           break;
				case 0 : nss1++;
                                         break;
			        case 1 : nvs++;
                                         break;
			        default:   printf("invalid code\n");
                                           exit(1);

			 }
		 }
                 dq1 = nv1;  dq1 /= nasite;
                 dq2 = nv2;  dq2 /= nasite;
                 dqs = nvs; dqs /= nasite;
                 grx = nbx[0]+nbx[2];
                 gyx = nbx[1]+nbx[3];
                 grx /= 2*nasite;
                 gyx /= 2*nasite;
                 gry = nby[0]+nby[2];
                 gyy = nby[1]+nby[3];
                 gry /= 2*nasite;
                 gyy /= 2*nasite;
                 if( dop == 11 ){
                    d1 = 1.0/(1.0 - dq1/(2.0*grx*gyx));
                    d2 = 1.0/(1.0 - dq2/(2.0*gry*gyy));
                    dw = (dqs -dq1*dq2)*d1*d2;
		  }
                 if( dop == 12 ){
                    d1 = pow(1.0 - dq1/(2.0*grx*gyx),-(1.0+1.0/gamma));
                    d2 = pow(1.0 - dq2/(2.0*gry*gyy),-(1.0+1.0/gamma));
                    dw = (dqs -dq1*dq2)*d1*d2;
		  }
                 dw /= nasite;
                 if(covflg == 0 ) cov[nad] = dw;
                 else if( write(fpcov,&dw,sizeof(double)) == -1 ){
                     printf("write error\n");
                     exit(1);
                   }

                 break;
      case 6 :  nps=0;
                nss=0;
                nvs=0;
                nr=0;
                nss1=0;
                for(i=0; i<nppsite; i++){
                   n=ppsite[i];
                   switch(tr[a[n][n3]][a[n][n4]]){
	         		case -1: /* no difference */
                                           break;
				case 0 : nss++;
                                         break;
			        case 1 : nr++;
                                         break;
			        default:   printf("invalid code\n");
                                           exit(1);

			 }
		 }
                for(i=0; i<npqsite; i++){
                   n=pqsite[i];
                   switch(tr[a[n][n3]][a[n][n4]]){
	         		case -1: /* no difference */
                                           break;
				case 0 : nss1++;
                                         break;
			        case 1 : nvs++;
                                         break;
			        default:   printf("invalid code\n");
                                           exit(1);

			 }
		 }
	   
	   
                 dp1 = ns1;  dp1 /= nasite;
                 dp2 = ns2;  dp2 /= nasite;
                 dq1 = nv1;  dq1 /= nasite;
                 dq2 = nv2;  dq2 /= nasite;
                 dps = nss; dps /= nasite;
                 dqs = nvs; dqs /= nasite;
                 dr = nr;   dr /= nasite;
                 ds = nss1; ds /= nasite;	   
                 da1 = pow(1.0-2.0*dp1-dq1,-(1.0/gamma+1.0));	   
                 db1 = da1 + pow(1.0-2.0*dq1,-(1.0/gamma+1.0));
                 db1 /= 2.0;

                 da2 = pow(1.0-2.0*dp2-dq2,-(1.0/gamma+1.0));	   
                 db2 = da2 + pow(1.0-2.0*dq1,-(1.0/gamma+1.0));
                 db2 /= 2.0;
                 dw = da1*da2*(dps-dp1*dp2)+da1*db2*(dr-dp1*dq2)
                                 + da2*db1*(ds-dq1*dp2)+db1*db2*(dqs-dq1*dq2);
                 dw /= nasite;
                 if( covflg == 0 ) cov[nad] = dw;
	         else if( write(fpcov,&dw,sizeof(double)) == -1 ){
                     printf("write error\n");
                     exit(1);
                   }


   if( dflg == 1 ) {
      printf("calcv1 n1=%d n2=%d n3=%d n4=%d nd1=%d nd2=%d nasite=%d ns1=%d nv1=%d ns2=%d nv2=%d nss=%d nvs=%d nr=%d nss1=%d  %e\n",n1,n2,n3,n4,nd1,nd2,nasite,ns1,nv1,ns2,nv2,nss,nvs,nr,nss1,cov[nad]);fflush(stdout);
   }         
                break;


      case 13 :  
                gax = nbx[2];
                gtx = nbx[0];
                ggx = nbx[3];
                gcx = nbx[1];
                gax /= 2*nasite;
                gtx /= 2*nasite;
                ggx /= 2*nasite;
                gcx /= 2*nasite;
                grx = gax+ggx;
                gyx = gtx+gcx;

                gay = nby[2];
                gty = nby[0];
                ggy = nby[3];
                gcy = nby[1];
                gay /= 2*nasite;
                gty /= 2*nasite;
                ggy /= 2*nasite;
                gcy /= 2*nasite;
                gry = gay+ggy;
                gyy = gty+gcy;
                np11=np12=np1q=np21=np22=np2q=nqp1=nqp2=nqq=0;
                for(i=0; i<nppsite; i++){
                   n=ppsite[i];
                   switch(tr1[a[n][n3]][a[n][n4]]){
	         		case 0: /* no difference */
                                           break;
				case 1: np11++;
                                         break;
			        case 2 : np12++;
                                         break;
			        case 3 : np1q++;
                                         break;
			        default:   printf("invalid code\n");
                                           exit(1);

			 }
		 }


                for(i=0; i<np2site; i++){
                   n=p2site[i];
                   switch(tr1[a[n][n3]][a[n][n4]]){
	         		case 0: /* no difference */
                                           break;
				case 1: np21++;
                                         break;
			        case 2 : np22++;
                                         break;
			        case 3 : np2q++;
                                         break;
			        default:   printf("invalid code\n");
                                           exit(1);

			 }
		 }
	   
	     for(i=0; i<npqsite; i++){
                   n=pqsite[i];
                   switch(tr1[a[n][n3]][a[n][n4]]){
	         		case 0: /* no difference */
                                           break;
				case 1: nqp1++;
                                         break;
			        case 2 : nqp2++;
                                         break;
			        case 3 : nqq++;
                                         break;
			        default:   printf("invalid code\n");
                                           exit(1);

			 }
		 }
	   
                dp11=np11;
                dp12=np12;
                dp1q=np1q;
                dp21=np21;
                dp22=np22;
                dp2q=np2q;
                dqp1=nqp1;
                dqp2=nqp2;
                dqq=nqq;	   
	   
                dp11 /= nasite;
                dp12 /= nasite;
                dp1q /= nasite;
                dp21 /= nasite;
                dp22 /= nasite;
                dp2q /= nasite;
                dqp1 /= nasite;
                dqp2 /= nasite;
                dqq /= nasite;
                dp1x = ns1;  dp1x /= nasite;
                dp2x = ns21;  dp2x /= nasite;
                dp1y = ns2;  dp1y /= nasite;
                dp2y = ns22;  dp2y /= nasite;
                dqx = nv1;  dqx /= nasite;
                dqy = nv2;  dqy /= nasite; 
                dwx = 1.0/(1.0 - dqx/(2.0*grx*gyx));
                dwy = 1.0/(1.0 - dqy/(2.0*gry*gyy));
                if( dop == 13 ){
                   xcp1 = 1.0/(1.0-grx*dp1x/(2.0*gax*ggx)-dqx/(2.0*grx));
                   ycp1 = 1.0/(1.0-gry*dp1y/(2.0*gay*ggy)-dqy/(2.0*gry));
                   xcp2 = 1.0/(1.0-gyx*dp2x/(2.0*gtx*gcx)-dqx/(2.0*gyx));
                   ycp2 = 1.0/(1.0-gyy*dp2y/(2.0*gty*gcy)-dqy/(2.0*gyy));
                   xcq  = gax*ggx*xcp1/(grx*grx) + gtx*gcx*xcp2/(gyx*gyx)
                       + (1.0-gax*ggx/(grx*grx)-gtx*gcx/(gyx*gyx))*dwx;
                   ycq  = gay*ggy*ycp1/(gry*gry) + gty*gcy*ycp2/(gyy*gyy)
                       + (1.0-gay*ggy/(gry*gry)-gty*gcy/(gyy*gyy))*dwy;
		 }
                 if( dop == 14 ){
                   xcp1 = pow(1.0-grx*dp1x/(2.0*gax*ggx)-dqx/(2.0*grx),-(1.0+1.0/gamma));
                   ycp1 = pow(1.0-gry*dp1y/(2.0*gay*ggy)-dqy/(2.0*gry),-(1.0+1.0/gamma));
                   xcp2 = pow(1.0-gyx*dp2x/(2.0*gtx*gcx)-dqx/(2.0*gyx),-(1.0+1.0/gamma));
                   ycp2 = pow(1.0-gyy*dp2y/(2.0*gty*gcy)-dqy/(2.0*gyy),-(1.0+1.0/gamma));
                   xcq  = xcp1*gax*ggx/grx/grx + xcp2*gtx*gcx/gyx/gyx;
                   xcq  += (1.0- gax*ggx/grx/grx-gtx*gcx/gyx/gyx)*pow(1.0-dqx/(2.0*grx*gyx),-(1.0+1.0/gamma));

                   ycq  = ycp1*gay*ggy/gry/gry + ycp2*gty*gcy/gyy/gyy;
                   ycq  += (1.0- gay*ggy/gry/gry-gty*gcy/gyy/gyy)*pow(1.0-dqy/(2.0*gry*gyy),-(1.0+1.0/gamma));
		}
                
                   dw = (dp11-dp1x*dp1y)*xcp1*ycp1
                    + (dp12-dp1x*dp2y)*xcp1*ycp2
                    + (dp1q-dp1x*dqy)*xcp1*ycq
                    + (dp21-dp2x*dp1y)*xcp2*ycp1
                    + (dp22-dp2x*dp2y)*xcp2*ycp2
                    + (dp2q-dp2x*dqy)*xcp2*ycq
                    + (dqp1-dqx*dp1y)*xcq*ycp1
                    + (dqp2-dqx*dp2y)*xcq*ycp2
                    + (dqq-dqx*dqy)*xcq*ycq;
                dw /= nasite;
                if( covflg == 0 ) cov[nad] = dw;
                else if( write(fpcov,&dw,sizeof(double)) == -1 ){
                     printf("write error\n");
                     exit(1);
                   }
                break;

	   }


return(0);

    
	   }






covad(nd1,nd2,ndist)
int nd1,nd2,ndist;
{
int m,iw;

  if( nd1 > nd2 ){
      iw = nd1;
      nd1 = nd2;
      nd2 = iw;
  }
  m = ndist;
 
  iw = nd1*(2*m-nd1-1)/2 + nd2 - nd1-1;
  return(iw);
}

int distad(s1,s2,nseq0)
int s1,s2,nseq0;
{
int iw;
  if( s1 > s2 ){
    iw = s1;
    s1 = s2;
    s2 = iw;
  }

  return( s1*(2*nseq0-s1-1)/2 + s2 - s1-1);
}




calcova(a,nseq0,nsite,nasite,npsite,asite,dop,dist,ndif,gamma)
char **a/*[MAXSITE][MAXOTU]*/;
int nseq0,nsite,nasite,*asite,dop;
double **dist/*[MAXOTU][MAXOTU]*/,gamma;
int **ndif/*[MAXOTU][MAXOTU]*/;
{
int i,j,k,l,npb,np1,np2,np3,ns1,ns2,nv1,nv2,nd1,nd2,n,ndist;
int n1,n2,n3,n4,rn;
double sp,dp,dq,dsp,da,db,dw;
int *ppsite/*[MAXSITE]*/,*pqsite/*[MAXSITE]*/,nppsite,npqsite;
extern int *ivector();
extern void free_ivector();

    ndist = nseq0*(nseq0-1)/2;
    ppsite = ivector(nsite);
    pqsite = ivector(nsite);
    if( dflg == 1 ) printf("dop=%d nseq0=%d\n",dop,nseq0);

   nd1=0;
   n=0;
   for(i=0; i<nseq0-1; i++){
     for(j=i+1; j<nseq0; j++){
     rn=distva(nasite,npsite,asite,nd1,a,i,j,dop,dist,&np1,gamma);
     /*     printf("%d %d n-%d\n",i,j,np1);*/
     n++;
     switch(dop){
        case 3: ndif[i][j]=ndif[j][i]=np1;
                break;
        case 4: ndif[i][j]=ndif[j][i]=np1;
                break;
        case 7: ndif[i][j]=ndif[j][i]=np1;
                break;
        default: printf("invalid option dop=%d\n",dop);
                 exit(1);
	}
      nd1++;
   }
   }
 
   if( n != nseq0*(nseq0-1)/2 ){
     printf("calcov n=%d  %d\n",n,nseq0*(nseq0-1)/2);
     exit(1);
   }
    if( dflg == 1 ) printf("dop=%d\n",dop);
     nd1=0;
     n=0;
     for(i=0; i<nseq0; i++){
       for(j=i+1; j<nseq0 ; j++){
       getpsitea(ppsite,pqsite,&nppsite,&npqsite,i,j,a,dop,asite,npsite);
       if( dflg == 1 ) printf("get psite dop=%d\n",dop);
       switch(dop){
         case 3: np1 = ndif[i][j];
                 break;
         case 4: np1 = ndif[i][j];
                 break;
         case 7: np1 = ndif[i][j];
                 break;
	 }
       k=i;
       nd2=nd1;


       for(l=j+1; l<nseq0 ; l++){
          n++;
          switch(dop){
             case 3: np2 = ndif[k][l];
                     break;
             case 4: np2 = ndif[k][l];
                     break;
             case 7: np2 = ndif[k][l];
                     break;
          }
          
        nd2++;
/*       printf("dop=%d\n",dop);    */
/*       printf("ns2=%d nv2=%d\n",ns2,nv2); */
       calcv1a(nasite,asite,a,i,j,k,l,nd1,nd2,dop,np1,np2,nppsite,ppsite,gamma,ndist);
       }
/*      printf(" %d %d %d %d   %d %d %e\n",i,j,k,l,nd1,nd2,cov[nd1][nd2]); */
     for(k=i+1; k<nseq0 ; k++){
       for(l=k+1; l<nseq0 ; l++){
        nd2++;
        n++;
        switch(dop){
         case 3: np2 = ndif[k][l];
                 break;
         case 4: np2 = ndif[k][l];
                 break;
         case 7: np2 = ndif[k][l];
                 break;
	 }
/*       printf("dop=%d\n",dop); */
/*       printf("ns2=%d nv2=%d",ns2,nv2);*/
       calcv1a(nasite,asite,a,i,j,k,l,nd1,nd2,dop,np1,np2,nppsite,ppsite,gamma,ndist);
/*      printf(" %d %d %d %d   %d %d %e\n",i,j,k,l,nd1,nd2,cov[nd1][nd2]); */
      }
     }
     nd1++;
   }
   }
   if( n != nseq0*(nseq-1)/2*(nseq0*(nseq-1)/2-1)/2 ){
     printf("calcov n=%d nseq0*(nseq-1)/2*(nseq0*(nseq-1)/2-1)/2=%d\n",n,nseq0*(nseq-1)/2*(nseq0*(nseq-1)/2-1)/2);
     exit(1);
   }
    free_ivector(ppsite,nseq0);
    free_ivector(pqsite,nseq0);

     return(0);

}
getpsitea(ppsite,pqsite,nppsite,npqsite,s1,s2,a,dop,asite,npsite)
int *ppsite/*[MAXSITE]*/,*pqsite/*[MAXSITE]*/,*nppsite,*npqsite,s1,s2,dop,*asite,npsite;
char **a/*[MAXSITE][MAXOTU]*/;
{
int i,n;

   *nppsite=0;
   *npqsite=0;
   for(i=0; i<npsite; i++){
      n = asite[i];
      /*      printf("n=%d\n",n);*/
      switch(dop){
        case 3:
        case 4:
        case 7:
                  if( a[n][s1] !=  a[n][s2] ){
                        ppsite[*nppsite] = n;
                        (*nppsite)++;
		      }
                   break;
       default : printf("invalid distance option\n");
                 exit(1);
	      }
    }
    return(0);
}

distva(nasite,npsite,asite,nd1,a,s1,s2,dop,dist,np,gamma)
int s1,s2,dop,nasite,npsite,*asite,*np,nd1;
char **a/*[MAXSITE][MAXOTU]*/;
double **dist/*[MAXOTU][MAXOTU]*/,gamma;
{
int k,np1,n;
double sp,dp,dq,da,db,dsq,dw;

/*         printf("distv s1=%d s2=%d nd1=%d",s1,s2,nd1);            */
/*         if( dflg == 1 ) printf("dop=%d\n",dop);*/
         switch(dop){
            case 3:   np1=0;
                      for(k=0; k<npsite ; k++){
                         n = asite[k];
                        if(a[n][s1] != a[n][s2] ){
			         np1++;
		         }
		      }
                      sp = np1;
                      sp /= nasite;
                      dist[s1][s2]=sp;
                      dist[s2][s1] = sp*(1.0-sp);
                      dist[s2][s1] /= nasite;
                      (*np) = np1;
                      return(0);

            case 4:   np1=0;   /* Poisson correction */
                      for(k=0; k<npsite ; k++){
                         n = asite[k];
                        if(a[n][s1] != a[n][s2] ){
			         np1++;
		         }
		      }
                      sp = np1;
                      sp /= nasite;
                      dw = 1.0-sp/0.95;
                      if( dw <= 0.0 ){
                        printf("inapplicable distance %d %d sp=%f\n",s1,s2,sp);
                        exit(1);
		      }
                      dist[s1][s2]=-0.95*log(dw);
                      dist[s2][s1] = sp*(1.0-sp)/(dw)/(dw);
                      dist[s2][s1] /= nasite;
                      (*np) = np1;
                      return(0);
            case 7:   np1=0;   /* Poisson correction */
                      for(k=0; k<npsite ; k++){
                         n = asite[k];
                        if(a[n][s1] != a[n][s2] ){
			         np1++;
		         }
		      }
                      sp = np1;
                      sp /= nasite;
                      dw = 1.0-sp/0.95;
                      if( dw <= 0.0 ){
                        printf("inapplicable distance %d %d sp=%f\n",s1,s2,sp);
                        exit(1);
		      }
                      dist[s1][s2]=0.95*gamma*(pow(dw,-1.0/gamma)-1.0);
                        
                      dist[s2][s1] = sp*(1.0-sp)*pow(dw,-2.0*(1.0/gamma+1.0));
                      dist[s2][s1] /= nasite;
                      (*np) = np1;
                      return(0);



	    }
}

calcv1a(nasite,asite,a,n1,n2,n3,n4,nd1,nd2,dop,np1,np2,nppsite,ppsite,gamma,ndist)
int nasite,*asite,n1,n2,n3,n4,nd1,nd2,dop,np1,np2,nppsite,*ppsite,ndist;
char **a/*[MAXSITE][MAXOTU]*/;
double gamma;
{
int i,n,nps,nss,nvs,nr,nss1,pflg,pflg1,nad;
double da1,db1,da2,db2,dp1,dp2,dps,sp1,sp2,dq1,dq2,dr,ds,dqs,dw;


nad = covad(nd1,nd2,ndist);

/*  printf("nad =%d n1 n2 n3 n4 %d %d %d %d  nd1=%d nd2=%d\n",nad,n1,n2,n3,n4,nd1,nd2);*/
   switch(dop){
      case 3:
             nps=0;
             for(i=0; i<nppsite ; i++){
               n = ppsite[i];
	       /*         printf("n=%d\n",n);*/
               if( a[n][n3] != a[n][n4] )  nps++;
             }
             dps = nps;
             dps /= nasite;
             dp1 = np1;
             dp1 /= nasite;
             dp2 = np2;
             dp2 /= nasite;
             dw = (dps-dp1*dp2)*sqrt(dp1*(1.0-dp1)*dp2*(1.0-dp2));
             dw /= nasite;
             if( covflg == 0 ){
                cov[nad] = dw;
	     }
             else{
                if( write(fpcov,&dw,sizeof(double)) == -1 ){
                     printf("write error\n");
                     exit(1);
                   }
	     }
/*             printf("nps=%d np1=%d np2=%d cov=%e\n",nps,np1,np2,cov[nad]); */
             break;
     

     case 4:
             nps=0;
             for(i=0; i<nppsite ; i++){
               n = ppsite[i];
               if( a[n][n3] != a[n][n4] ) nps++;
	     }
             dps = nps;
             dps /= nasite;
             dp1 = np1;
             dp1 /= nasite;
             dp2 = np2;
             dp2 /= nasite;
             dw = (dps-dp1*dp2)/(1.0-dp1/0.95)/(1.0-dp2/0.95);
             dw /= nasite;
             if( covflg == 0 ){
                 cov[nad] = dw;
	     }
             else{
                   if( write(fpcov,&dw,sizeof(double)) == -1 ){
                     printf("write error\n");
                     exit(1);
                   }
	     }
             break;

     case 7:
             nps=0;
             for(i=0; i<nppsite ; i++){
               n = ppsite[i];
               if( a[n][n3] != a[n][n4] ) nps++;
	     }
             dps = nps;
             dps /= nasite;
             dp1 = np1;
             dp1 /= nasite;
             dp2 = np2;
             dp2 /= nasite;
             dw = (dps-dp1*dp2)*pow((1.0-dp1/0.95)*(1.0-dp2/0.95),-(1.0/gamma+1.0));
             dw /= nasite;
             if( covflg == 0 ){
                 cov[nad] = dw;
	     }
             else {
              if( write(fpcov,&dw,sizeof(double)) == -1 ){
                     printf("write error\n");
                     exit(1);
                   }
	     }
             break;
     
	   }


return(0);

    
}


int caldcv()
{
int i,j;
int *nla1/*[MAXOTU]*/,*nlb1/*[MAXOTU]*/,*nlc1/*[MAXOTU]*/,*nla2/*[MAXOTU]*/,*nlb2/*[MAXOTU]*/,*nlc2/*[MAXOTU]*/,ma1,mb1,mc1,ma2,mb2,mc2;
extern double getcvd();
extern int *ivector();


nla1 = ivector(nseq);
nlb1 = ivector(nseq);
nlc1 = ivector(nseq);
nla2 = ivector(nseq);
nlb2 = ivector(nseq);
nlc2 = ivector(nseq);


  if( dflg == 1 )  {
      printf("npc=%d\n",npc); fflush(stdout);
    }
  for(i=0; i<npc-1; i++){
    /*    printf("node %d\n",addelta[i]->nkey); 
    fflush(stdout); 
    */
    getabc(addelta[i],nla1,nlb1,nlc1,&ma1,&mb1,&mc1);
    if( dflg == 1 ){
          printf("ma1=%d mb1=%d mc1=%d\n",ma1,mb1,mc1);
          fflush(stdout);
	}
    for(j=i+1; j<npc ; j++){
        getabc(addelta[j],nla2,nlb2,nlc2,&ma2,&mb2,&mc2);
        deltav[i][j]=getcvd(nla1,nlb1,nlc1,ma1,mb1,mc1,nla2,nlb2,nlc2,ma2,mb2,mc2,dcoef[i],dcoef[j]);
        if( dflg == 4 ) printf("node %d %d %e\n",addelta[i]->nkey,addelta[j]->nkey,deltav[i][j]);

        deltav[j][i] = deltav[i][j];
      }
     if( dflg == 1 ) printf("\n");
  }
free_ivector(nla1,nseq);
free_ivector(nlb1,nseq);
free_ivector(nlc1,nseq);
free_ivector(nla2,nseq);
free_ivector(nlb2,nseq);
free_ivector(nlc2,nseq);

return(0);

}




getabc(cur,nla,nlb,nlc,ma,mb,mc)
struct nds *cur;
int *nla,*nlb,*nlc,*ma,*mb,*mc;
{
int i,nm,na;
unsigned char nx,ny,ny2;

   if( dflg == 1 ) printf("cur %d lc=%d rc=%d\n",cur->nkey,cur->lc->nkey,cur->rc->nkey);
   if( cur->lc->nkey <= nseq ){
       *ma = 1;
       nla[0]= cur->lc->nkey-1;
     }else{
       *ma=0;
       for(i=0; i<nseq ; i++){
          nm=i/8;
          na=i%8;
          nx = 0x80;
          nx >>= na;
          ny = cur->plcx[nm] & nx;
          if( ny > 0 ) {
            nla[(*ma)]=i;
            (*ma)++;
          }
	}
     }
  if( cur->rc->nkey <= nseq){
    *mb = 1;
    nlb[0]= cur->rc->nkey-1;
  }else{
    *mb=0;
    for(i=0; i<nseq ; i++){
         nm=i/8;
          na=i%8;
          nx = 0x80;
          nx >>= na;
          ny = cur->prcx[nm] & nx;
          if( ny > 0 ) {
            nlb[(*mb)]=i;
            (*mb)++;
          }
	}
  }

       *mc=0;
       for(i=0; i<nseq ; i++){
          nm=i/8;
          na=i%8;
          nx = 0x80;
          nx >>= na;
          ny = cur->pbx[nm] & nx;
          if( ny == 0 ) {
            nlc[(*mc)]=i;
            (*mc)++;
          }
	}

   if( dflg == 1 ) printf("ma=%d mb=%d mc=%d\n",*ma,*mb,*mc);
   return(0);
}

double getcvd(nla1,nlb1,nlc1,ma1,mb1,mc1,nla2,nlb2,nlc2,ma2,mb2,mc2,dc1,dc2)
int *nla1,*nlb1,*nlc1,*nla2,*nlb2,*nlc2,ma1,mb1,mc1,ma2,mb2,mc2;
{
int i,j,k,l,ad1,ad2,c1,c2,c3,c4,ndist,nad,s1,s2,nad0;
double dx1,dx2,dw1,dw2,dw3,dw;

    ndist = nseq*(nseq-1)/2;
    dx1=0.0;
    dx2=0.0;
    c1 = 1;
    c2 = -1;
    c3 = 1;
    c4 = -1;
    c1 *= dc1;
    c2 *= dc1;
    c3 *= dc2;
    c4 *= dc2;
    if( dflg == 1 ) printf("ma1=%d mb1=%d mc1=%d ma2=%d mb2=%d mc2=%d  %d %d %d %d\n",ma1,mb1,mc1,ma2,mb2,mc2,nla1[0],nlb1[0],nla2[0],nlb2[0]);
    for(i=0; i<ma1 ; i++){
     for(j=0; j<mc1 ; j++){
         ad1 = distad(nla1[i],nlc1[j],nseq);
         dw1 = 0.0;
       for(k=0; k<ma2; k++){
         for(l=0; l<mc2; l++){
            ad2 = distad(nla2[k],nlc2[l],nseq);
            if( ad1 != ad2 ) {
                nad0 = covad(ad1,ad2,ndist);
                if( covflg == 0 ) {
                  dw1 +=  cov[nad0];
		}
                else{
                 lseek(fpcov,nad0*sizeof(double),SEEK_SET);
                 read(fpcov,&dw,sizeof(double));
                 dw1 += dw;
		}
            }
            if( ad1 == ad2 ){
               s1 = nla2[k]; s2= nlc2[l];
               if( s1 < s2 ) dw1 += dist0[s2][s1];
               if( s1 > s2 ) dw1 += dist0[s1][s2];
	     }

	  }
       }
       dw1 /= ma2*mc2;
       dw1 *= c3;
       dw2 = 0.0;
       for(k=0; k<mb2; k++){
         for(l=0; l<mc2; l++){
            ad2 = distad(nlb2[k],nlc2[l],nseq);
            if( ad1 != ad2 ) {
                nad0 = covad(ad1,ad2,ndist);
                if( covflg == 0 ) {
                   dw2 +=  cov[nad0];
		}
                else{
                 lseek(fpcov,nad0*sizeof(double),SEEK_SET);
                 read(fpcov,&dw,sizeof(double));
                 dw2 += dw;
		}
	    }
            if( ad1 == ad2 ){
              s1 = nlb2[k]; s2=nlc2[l];
              if( s1 < s2 ) dw2 += dist0[s2][s1];
              if( s1 > s2 ) dw2 += dist0[s1][s2];
	    }
	  }
       }
       dw2 /= mb2*mc2;
       dw2 *= c4;
       dx1 += dw1+dw2;    
     }
    }

    dx1 /= ma1*mc1;
    dx1 *= c1;
    for(i=0; i<mb1 ; i++){
     for(j=0; j<mc1 ; j++){
/*       ad1 = dad[nlb1[i]][nlc1[j]]; */
       ad1 = distad(nlb1[i],nlc1[j],nseq);
       dw1 = 0.0;
       for(k=0; k<ma2; k++){
         for(l=0; l<mc2; l++){
/*            ad2 = dad[nla2[k]][nlc2[l]];*/
            ad2 = distad(nla2[k],nlc2[l],nseq);
             if( ad1 != ad2 ) {
                nad0 = covad(ad1,ad2,ndist);
                if( covflg == 0 ) {
                   dw1 +=  cov[nad0];
		}
                else{
                 lseek(fpcov,nad0*sizeof(double),SEEK_SET);
                 read(fpcov,&dw,sizeof(double));
                 dw1 += dw;
		}

	     }
             if( ad1 == ad2 ){
                s1 = nla2[k]; s2 = nlc2[l];
                if( s1 < s2 ) dw1 += dist0[s2][s1];
                if( s1 > s2 ) dw1 += dist0[s1][s2];
	      }
/*           dw1 += cov[ad1][ad2]; */
	  }
       }
       dw1 /= ma2*mc2;
       dw1 *= c3;
       dw2 = 0.0;
       for(k=0; k<mb2; k++){
         for(l=0; l<mc2; l++){
/*            ad2 = dad[nlb2[k]][nlc2[l]]; */
             ad2 = distad(nlb2[k],nlc2[l],nseq);

/*            dw2 += cov[ad1][ad2]; */
             if( ad1 != ad2 ){
                nad0 = covad(ad1,ad2,ndist);
                if( covflg == 0 ) {
                   dw2 +=  cov[nad0];
		}
                else{
                 lseek(fpcov,nad0*sizeof(double),SEEK_SET);
                 read(fpcov,&dw,sizeof(double));
                 dw2 += dw;
		}
	     }
             if( ad1 == ad2 ){
               s1 = nlb2[k]; s2 =nlc2[l];
               if( s1 < s2 ) dw2 += dist0[s2][s1];
               if( s1 > s2 ) dw2 += dist0[s1][s2];
	     }
	 }
       }
       dw2 /= mb2*mc2;
       dw2 *= c4;
       dx2 += dw1+dw2;    
/*       printf("2) i=%d j=%d dx2=%e dw1=%e dw2=%e\n",i,j,dx2,dw1,dw2);*/
     }
    }
   dx2 /= mb1*mc1;
   dx2 *= c2;
   if( dflg == 1 ) printf("dw=%e dw1=%e dw2=%e dw3=%e\n",dx1+dx2,dw1,dw2,dw3);
/* printf("i=%d j=%d dw=%e dw1=%e dw2=%e dw3=%e\n",i,j,dx1+dx2,dw1,dw2,dw3);*/
   return(dx1+dx2);
}



double calq()
{
int i,j,k,degrees;
double *dc/*[MAXOTU-2]*/,**vin/*[MAXOTU-1][MAXOTU-1]*/,dw;
double **xa1/*[MAXOTU-2][MAXOTU-2]*/;
double delq;
double **B/*[MAXOTU-2][MAXOTU-2]*/,**Temp/*[MAXOTU-2][MAXOTU-2]*/;
extern double *dvector(),**dmatrix();

dc = dvector(nseq-2);
vin = dmatrix(nseq-1,nseq-1);
xa1 = dmatrix(nseq-2,nseq-2);
B = dmatrix(nseq-2,nseq-2);
Temp = dmatrix(nseq-2,nseq-2);

for(i=0; i<npc ; i++){
   for(j=0; j<npc ; j++){
     xa1[i][j]=deltav[i][j];
/*     printf("deltav[%d][%d]=%e\n",i,j,deltav[i][j]);  */

   }
 }
/* printf("calq deltav\n"); */
/*
    for(i=0; i<nseq-2; i++){
     for(j=0; j<nseq-2; j++){
        printf(" %e",xa1[i][j]);
      }
      printf("\n");
    }
*/
decompose(&degrees, npc, xa1, B,Temp);
/*
  for(i=0; i<npc; i++){
   for(j=0; j<npc ; j++){
     dw=0.0;
     for(k=0; k<nseq-2 ; k++){
       dw += deltav[i][k]*xa1[k][j];
     }
     printf(" %f",dw); 
   }
   printf("\n"); 
 }
*/
  
/*  printf("dc"); */
  for(i=0; i<nseq-2 ; i++){
    dc[i]=0.0;
    for(j=0; j<nseq-2; j++){
      dc[i] += delta[j]*xa1[j][i];
    }
/*    printf(" %f",dc[i]); */
  }
/*  printf("\n"); */

/* printf("delta=");
 for(i=0; i<nseq-2 ; i++) printf(" %f",delta[i]);
 printf("\n");
*/
 delq = 0.0;
 for(i=0; i<nseq-2 ; i++){
/*   printf("i=%d dc=%f delta=%f\n",i,dc[i],delta[i]); */
   (delq) += dc[i]*delta[i];
 }

free_dvector(dc,nseq-2);
free_dmatrix(vin,nseq-1,nseq-1);
free_dmatrix(xa1,nseq-2,nseq-2);
free_dmatrix(B,nseq-2,nseq-2);
free_dmatrix(Temp,nseq-2,nseq-2);

  return(delq);
}




double caldev(ravw,rbvw,rcvw)
double *ravw,*rbvw,*rcvw;
{
int i,j,k,l,na1,na2,n,s1,s2,ndist,nad;
double dw,dv1,dv2,dc1,dc2,dcv;

/*   printf("dflg1 = %d\n",dflg1); */
   dv1=0.0;
   dv2=0.0;
   dc1=0.0;
   dc2=0.0;
   dcv=0.0;
   n=0;
   ndist = nseq*(nseq-1)/2;
   for(i=0; i<ml ; i++){
     for(j=0; j<mb ; j++){
        if( nll[i] == nlb[j] ) {
          printf("caldev nll[%d]=%d nlb[%d]=%d\n",i,j,nll[i],nlb[j]);
          exit(1);
        }
/*        na1 = dad[nll[i]][nlb[j]]; */
        s1 = nll[i];
        s2 = nlb[j];
        if( s1 < s2 ) dv1 += dist0[s2][s1];
        if( s1 > s2 ) dv1 += dist0[s1][s2];
/*        dv1 += dist[na1][na1];*/
        n++;
        if( dflg == 1 ) {
           printf("na1=%d cov=%f %f\n",n,dist0[s2][s1],dist0[s1][s2]);fflush(stdout);     
	 }
      }
   }
   if( n!= ml*mb ){
      printf("caldev n=%d ml*mb=%d\n",n,ml*mb);
      exit(1);
    }
   n=0;
   for(i=0; i<ml ; i++){
     for(j=0; j<mb; j++){
/*        na1 = dad[nll[i]][nlb[j]]; */
        na1 = distad(nll[i],nlb[j],nseq);
        k=i;
        l=j+1;
        for(; l<mb ; l++){
/*          na2 = dad[nll[k]][nlb[l]]; */
          na2 = distad(nll[k],nlb[l],nseq); 
          nad=covad(na1,na2,ndist);
          if( covflg == 0 ){
              dc1 += cov[nad];
	  }
          else{
             lseek(fpcov,nad*sizeof(double),SEEK_SET);
             read(fpcov,&dw,sizeof(double));
             dc1 += dw;
	  }
          n++;
          if( na1 == na2 ) {
                   printf("caldev na1=%d na2=%d nll[%d]=%d nlb[%d]=%d nll[%d]=%d nlb[%d]=%d\n",na1,na2,i,nll[i],j,nlb[j],k,nll[k],l,nlb[l]);
		     exit(1);
           }
/*          printf(" %d %d %d %d   %d %d %d %d\n",i,j,k,l,nll[i],nlb[j],nlr[k],nlb[l]);*/
       }
      for(k=i+1; k<ml ; k++){
         for(l=0; l<mb ; l++){
/*           na2 = dad[nll[k]][nlb[l]]; */
           na2 = distad(nll[k],nlb[l],nseq);
          if( na1 == na2 ) {
                   printf("caldev na1=%d na2=%d\n",na1,na2);
                   exit(1);
           }
           nad = covad(na1,na2,ndist);
           if( covflg == 0 ){
             dc1 += cov[nad];
	   }
           else{
             lseek(fpcov,nad*sizeof(double),SEEK_SET);
             read(fpcov,&dw,sizeof(double));
             dc1 += dw;
	   }
           n++;
	 }
       }
      }
   }
/*   printf("dv1=%f dc1=%f",dv1,dc1); */
   dv1 += 2.0*dc1;
   dv1 /= ml*mb*ml*mb;
   *ravw= dv1;
/*   printf("  %f",dv1); */
 n=0;
 for(i=0; i<mr ; i++){
     for(j=0; j<mb ; j++){
        if( nlr[i] == nlb[j] ) {
          printf("caldev nlr[%d]=%d nlb[%d]=%d\n",i,j,nlr[i],nlb[j]);
          exit(1);
        }
/*        na1 = dad[nlr[i]][nlb[j]]; */
        s1 = nlr[i];
        s2 = nlb[j];
        if( s1 < s2 ) dv2 += dist0[s2][s1];
        if( s1 > s2 ) dv2 += dist0[s1][s2];
/*        dv2 += cov[na1][na1]; */
        n++;
      }
   }
   if( n != mr*mb){
      printf("caldev n=%d mr*mb=%d\n",n,mr*mb);
      exit(1);
    }
   n=0;
   for(i=0; i<mr ; i++){
     for(j=0; j<mb; j++){
/*        na1 = dad[nlr[i]][nlb[j]]; */
        na1 = distad(nlr[i],nlb[j],nseq);
        k=i;
        l=j+1;
        for(; l<mb ; l++){
          if( na1 == na2 ) {
                   printf("caldev na1=%d na2=%d\n",na1,na2);
                   exit(1);
           }
/*         na2 = dad[nlr[k]][nlb[l]]; */
         na2 = distad(nlr[k],nlb[l],nseq);
         nad = covad(na1,na2,ndist);
         if( covflg == 0 ){
           dc2 += cov[nad];
	 }
         else{
           lseek(fpcov,nad*sizeof(double),SEEK_SET);
           read(fpcov,&dw,sizeof(double));
           dc2 += dw;
	 }
         n++;
/*           printf("%d %d %d %d  %d %d %d %d  %f\n",i,j,k,l,nlr[i],nlb[j],nlr[k],nlb[l],cov[na1][na2]); */


	}
      for(k=i+1; k<mr ; k++){
         for(l=0; l<mb ; l++){
          if( na1 == na2 ) {
                   printf("caldev na1=%d na2=%d\n",na1,na2);
                   exit(1);
           }
  /*         na2 = dad[nlr[k]][nlb[l]]; */
           na2 = distad(nlr[k],nlb[l],nseq);
           nad = covad(na1,na2,ndist);
           if( covflg == 0 ) {
              dc2 += cov[nad];
	   }
           else{
             lseek(fpcov,nad*sizeof(double),SEEK_SET);
             read(fpcov,&dw,sizeof(double));
             dc2 += dw;
	   }

           n++;
         if( dflg1 == 1 ){
           printf("%d %d %d %d  %f\n",nlr[i],nlb[j],nlr[k],nlb[l],cov[covad(na1,na2,ndist)]);
         }
	}
       }
      }
   }
   if( n != mr*mb*(mr*mb-1)/2 ){
      printf("caldev n=%d mr*mb*(mr*mb-1)/2 =%d\n",n,mr*mb*(mr*mb-1)/2);
      exit(1);
    }


/*   printf(" dv2=%f dc2=%f",dv2,dc2); */
      dv2 += 2.0*dc2;
      dv2 /= mr*mb*mr*mb;
      *rbvw= dv2;
/*  printf("  %f",dv2); */

      dcv=0.0;
      for(i=0; i<ml ; i++){
        for(j=0; j<mb ; j++){
/*          na1 = dad[nll[i]][nlb[j]]; */
          na1 = distad(nll[i],nlb[j],nseq);
          for(k=0; k<mr ; k++){
            for(l=0; l<mb ; l++){
               if( na1 == na2 ) {
                   printf("delv na1=%d na2=%d\n",na1,na2);
                   exit(1);
		 }
/*               na2 = dad[nlr[k]][nlb[l]];*/
               na2 = distad(nlr[k],nlb[l],nseq);
               nad = covad(na1,na2,ndist);
               if( covflg == 0 ){
                    dcv += cov[nad];
	       }
               else{
                lseek(fpcov,nad*sizeof(double),SEEK_SET);
                read(fpcov,&dw,sizeof(double));
                dcv += dw;
	       }

	     }
	  }
	}
      }
/*      printf("dcv=%f ",dcv); */
      dcv /= ml*mr*mb*mb;
/*      printf("dcv=%f ",dcv); */
      dcv *= 2.0;
      dw = dv1+dv2-dcv;
/*      printf("dv1=%f dv2=%f dcv=%f\n",dv1,dv2,dcv); */
/*      printf("dv=%f\n",dw); */
     if( dflg == 1 )  printf("caldev dw=%f\n",dw);
      return(dw);
}




double delc(raw,rbw,rcw)
double *raw,*rbw,*rcw;
{
int i,j,n,s1,s2;
double dac,dbc,dw,dab;

   n=0;
   dac=0.0;
   dbc=0.0;
   dab=0.0;
   for(i=0; i<ml ; i++){
        for(j=0; j<mb ; j++){
           s1 = nll[i];
           s2 = nlb[j];
           if( s1 < s2 ) dac += dist0[s1][s2];
           if( s1 > s2 ) dac += dist0[s2][s1];
           n++;
      }
    }
    if( n != ml*mb){
       printf("delc n=%d ml*mb=%d\n",n,ml*mb);
       exit(1);
     }
   dac /= ml*mb;

   n=0;
   for(i=0; i<mr ; i++){
     for(j=0; j<mb ; j++){
        s1 = nlr[i];
        s2 = nlb[j];
        if( s1 < s2 )  dbc += dist0[s1][s2];
        if( s1 > s2 )  dbc += dist0[s2][s1];
/*        dbc += dist0[nlr[i]][nlb[j]]; */
        n++;
      }
   }
    if( n != mr*mb){
       printf("delc n=%d mr*mb=%d\n",n,mr*mb);
       exit(1);
     }
   dbc /= mr*mb;
   n=0;
   for(i=0; i<mr ; i++){
     for(j=0; j<ml ; j++){
        s1 = nlr[i];
        s2 = nll[j];
        if( s1 < s2 ) dab += dist0[s1][s2];
        if( s1 > s2 ) dab += dist0[s2][s1];
/*        dab += dist0[nlr[i]][nll[j]]; */
        n++;
      }
   }
    if( n != mr*ml){
       printf("delc n=%d mr*mb=%d\n",n,mr*mb);
       exit(1);
     }
   dab /= mr*ml;
   
   dw = dac-dbc;
   dcoef[npc]=1;
   *raw = (dac+dab - dbc)/2.0;
   *rbw = (dbc+dab - dac)/2.0;
   *rcw = (dac+dbc - dab)/2.0;

   if( dw < 0.0 ) {
     dw *= -1.0;
     dcoef[npc]=-1;
   }
   return(dw);
}
   


double calhv()
{
int i,j,k,l,na1,na2,s1,s2,ndist,nad;
double dw,dv,dc;

  ndist = nseq*(nseq-1)/2;
  if( dflg == 1 ){
     printf("calhv\n");fflush(stdout);
   }
  dv = 0.0;
  for(i=0; i<ml ; i++){
    for(j=0; j<mr ; j++){
/*      na1 = dad[nll[i]][nlr[j]]; */
      s1 = nll[i];
      s2 = nlr[j];
      if( s1 < s2 ) dv += dist0[s2][s1];
      if( s1 > s2 ) dv += dist0[s1][s2];
/*     dv += dist[na1][na1]; */
/*      printf("cov %d %d na1=%d cov=%e\n",nll[i],nlr[j],na1,cov[na1][na1]); */
    }
  }
  if( dflg == 1 ) {
      printf("calhv dv=%f\n",dv);fflush(stdout);
    }
  dc = 0.0;
  for(i=0; i<ml ; i++){
    for(j=0; j<mr ; j++){
/*       na1 = dad[nll[i]][nlr[j]]; */
       na1 = distad(nll[i],nlr[j],nseq);
       k=i;
       for(l=j+1; l<mr; l++){
/*         na2 = dad[nll[k]][nlr[l]]; */
         na2 = distad(nll[k],nlr[l],nseq);
          if( na1 == na2 ) {
                   printf("calh na1=%d na2=%d\n",na1,na2);
                   exit(1);
           }
         nad = covad(na1,na2,ndist);
         if( covflg == 0 ){
             dc += cov[nad];
	 }
         else{
           lseek(fpcov,nad*sizeof(double),SEEK_SET);
           read(fpcov,&dw,sizeof(double));
           dc += dw;
	 }
/*          printf("n1 %d n2 %d n3 %d n4 %d cov %e na1=%d na2=%d\n",nll[i],nlr[j],nll[k],nlr[l],cov[na1][na2],na1,na2); */
       }
       for(k=i+1; k<ml ; k++){
         for(l=0; l<mr ; l++){
/*          na2 = dad[nll[k]][nlr[l]]; */
          na2 = distad(nll[k],nlr[l],nseq);
          if( na1 == na2 ) {
                   printf("calh na1=%d na2=%d\n",na1,na2);
                   exit(1);
           }
          nad = covad(na1,na2,ndist);
          if( covflg == 0 ){
             dc += cov[nad];
	  }
          else{
           lseek(fpcov,nad*sizeof(double),SEEK_SET);
           read(fpcov,&dw,sizeof(double));
           dc += dw;
	  }
/*          printf("n1 %d n2 %d n3 %d n4 %d cov %e na1=%d na2=%d\n",nll[i],nlr[j],nll[k],nlr[l],cov[na1][na2],na1,na2); */
	}
       }
     }
  }

    dw = dv + 2.0*dc;
/*    printf("calhv ml=%d mr=%d dv=%e dc=%e dw=%e\n",ml,mr,dv,dc,dw); */
    dw /= 4*mr*mr*ml*ml;
    return(dw);
}


delchk(a,nseq0,nsite,npsite,nasite,asite,asite0,cdnpos,dop,ntsite,tsite)
int nseq0,nsite,*npsite,*nasite,*asite,*asite0,cdnpos,dop,*ntsite,*tsite;

char **a/*[MAXSITE][MAXOTU]*/;
{
int i,j,k,flg,iw,pol,del,nbs,delc[3];
printf("delchk nsite=%d nseq0=%d dop=%d\n",nsite,nseq0,dop); fflush(stdout);

  (*npsite) =0;
  (*nasite) =0;
  (*ntsite) =0;
  for(i=0; i < nsite ; i++){
    /*       printf("i=%d\n",i); fflush(stdout);*/
       del=0;
       pol=0;
       if( cdnpos > 0 ){
         if( i%3 != cdnpos-1 ) continue;
       }
       for(j=0; j<nseq0; j++){
          if( del != 0 ) break;
          flg=0;
/*          if( dflg == 1 ) printf("a[%d][%d]=%c %x\n",i,j,a[i][j],a[i][j]); */
          if( a[i][j] == '.' ) a[i][j] = a[i][0];
          for(k=0; k<8 ; k++){
            if( a[i][j] == base[k] ) {
               a[i][j]=k; 
               flg=1;
               break;
             }
          }
          if( flg == 0 ){
             printf("seq %d site %d  invalid base %c %x\n",j+1,i+1,a[i][j],a[i][j]);
             exit(1);
	   }
           if( a[i][j] > 3){
                  del=1;   
                  break;
		}
              if( a[i][j] != a[i][0] ) pol=1;


	}
        delc[i%3]=del;
        if( dop >= 15 && dop <= 22 ){
          if( i%3 != 2 ) continue;
	  if( delc[0]+delc[1]+delc[2] != 0 ) {
           tsite[*ntsite]= (i-2)/3;
           (*ntsite)++;
	  }else{
           asite0[(*nasite)] = (i-2)/3;
           (*nasite)++;
	   /*           printf("nasite=%d\n",*nasite); fflush(stdout);*/
  	  }
          continue;
	}
        if( del != 0  ) continue;
        asite0[(*nasite)]=i;
        (*nasite)++;
        if( pol == 1 ){
             asite[(*npsite)]=i;
             (*npsite)++;
	   }
     }


    return(0);
}



delchka(a,nseq0,nsite,npsite,nasite,asite)
int nseq0,nsite,*npsite,*nasite,*asite;
char **a/*[MAXSITE][MAXOTU]*/;
{
int i,j,k,flg,iw,pol,del,nbs;
  (*npsite) =0;
  (*nasite) =0;
  for(i=0; i<nsite ; i++){
       del=0;
       pol=0;
       for(j=0; j<nseq0; j++){
          if( del != 0 ) break;
          flg=0;
/*          if( dflg == 1 ) printf("a[%d][%d]=%c %x\n",i,j,a[i][j],a[i][j]); */
          if( a[i][j] == '.' ) a[i][j] = a[i][0];
          for(k=0; k<24 ; k++){
            if( a[i][j] == amn[k] ) {
               a[i][j]=k; 
               flg=1;
               break;
             }
          }
          if( flg == 0 ){
             printf("seq %d site %d  invalid amn %c %x\n",j+1,i+1,a[i][j],a[i][j]);
             exit(1);
	   }
           if( a[i][j] >= 20 ){
                  del=1;   
                  break;
		}
              if( a[i][j] != a[i][0] ) pol=1;


	}
    
        if( del != 0  ) continue;
        (*nasite)++;
        if( pol == 1 ){
             asite[(*npsite)]=i;
             (*npsite)++;
	   }
     }
    return(0);
}


basefr(a,nseq,nasite,asite,nbal)
char **a/*[MAXSITE][MAXOTU]*/;
int nseq,nasite,*asite/*[MAXSITE]*/,**nbal/*[MAXOTU][4]*/;
{
int i,j,n1;

for(i=0; i<nseq ; i++){
  for(j=0; j<4 ; j++) nbal[i][j]=0;
}
for(i=0; i<nseq ; i++){
  for(j=0; j<nasite ; j++){
      n1=a[asite[j]][i];
      if( n1 > 5 ) {
         printf("seq %d invalid base %d %c %d\n",i,n1,n1,asite[j]);
      } 
      nbal[i][n1]++;
    }
}
return(0);
}



/************************************/
   decompose(degrees, dim, V, B,Temp)
   int *degrees, dim;
   double **V/*[MAXOTU-2][MAXOTU-2]*/,**B/*[MAXOTU-2][MAXOTU-2]*/,**Temp/*[MAXOTU-2][MAXOTU-2]*/;
/************************************/
{
double f;
double lambda;
int i, j, k;

           for(i=0; i<dim; i++)
              {
              for(j=i; j<dim; j++)
                 {
                 if( i == j ) B[i][j] = 1.;
                 else         B[i][j] = B[j][i] = 0.;
                 }
	    }

for(i=0; i<dim; i++)
   {
   if( fabs(V[i][i]) <=  TINY) V[i][i] = 0.0;

   if( V[i][i] == 0. && i < dim-1)
     {
     for( j=i+1; j<dim; j++)
        {
        if( fabs(V[i][j]) >  TINY )
          {
/* i := i + j rows and columns */

          for(k=0; k<dim; k++)
             {
             V[i][k] += V[j][k];
             B[i][k] += B[j][k];
             }

          for(k=0; k<dim; k++)
             V[k][i] += V[k][j];

          break;
          }
    }
     }

   if(V[i][i] > 0.)
     {

     if(i < dim-1)
       {
        for( j=i+1; j<dim; j++)
           {

        /* j + i * lambda  rows and columns */
      lambda = -V[i][j]/V[i][i];

          for(k=0; k<dim; k++)
             {
             V[j][k] += V[i][k]*lambda;
             B[j][k] += B[i][k]*lambda;
             }

          for(k=0; k<dim; k++)
             V[k][j] += V[k][i]*lambda;

           }
       }

/* i := i*lambda, for rows and columns  */

          lambda = 1./sqrt(V[i][i]);
          for(k=0; k<dim; k++)
             {
             V[i][k] *= lambda;
             V[k][i] *= lambda;
             B[i][k] *= lambda;
             }
     }
   }

f = 0.;
for(i=0; i<dim; i++) f += V[i][i];
*degrees = (int)(f+0.5);

multiply_Bt_B(dim,V,B,Temp);

return;
}

/**************************/
   multiply_Bt_B( dim,V,B,Temp)
   int dim;
   double **V/*[MAXOTU-2][MAXOTU-2]*/,**B/*[MAXOTU-2][MAXOTU-2]*/,**Temp/*[MAXOTU-2][MAXOTU-2]*/;
/**************************/
{
int i, j, k;

for(i=0; i<dim; i++)
   for(j=0; j<dim; j++)
      {
      Temp[i][j] = 0.;
      for(k=0; k<dim; k++)
         Temp[i][j] += (double) B[k][i] * B[k][j];
      }

for(i=0; i<dim; i++)
   for(j=0; j<dim; j++)
      V[i][j] = Temp[i][j];

return;
}



float  Tdist[350]={
0.00,  0.01,  0.02,  0.03,  0.04,  0.05,  0.06,  0.07,  0.08,
0.09,  0.10,  0.11,  0.12,  0.13,  0.14,  0.15,  0.16,  0.17,  0.18,  0.19,
0.20,  0.21,  0.22,  0.23,  0.24,  0.25,  0.26,  0.27,  0.28,  0.29,  0.30,
0.31,  0.32,  0.33,  0.34,  0.35,  0.36,  0.37,  0.38,  0.39,  0.40,  0.41,
0.42,  0.43,  0.44,  0.45,  0.46,  0.47,  0.48,  0.49,  0.50,  0.51,  0.52,
0.53,  0.54,  0.55,  0.56,  0.57,  0.58,  0.59,  0.60,  0.61,  0.62,  0.63,
0.64,  0.65,  0.66,  0.67,  0.68,  0.69,  0.70,  0.71,  0.72,  0.73,  0.74,
0.75,  0.76,  0.77,  0.78,  0.79,  0.80,  0.81,  0.82,  0.83,  0.84,  0.85,
0.86,  0.87,  0.88,  0.89,  0.90,  0.91,  0.92,  0.93,  0.94,  0.95,  0.96,
0.97,  0.98,  0.99,  1.00,  1.01,  1.02,  1.03,  1.04,  1.05,  1.06,  1.07,
1.08,  1.09,  1.10,  1.11,  1.12,  1.13,  1.14,  1.15,  1.16,  1.17,  1.18,
1.19,  1.20,  1.21,  1.22,  1.23,  1.24,  1.25,  1.26,  1.27,  1.28,  1.29,
1.30,  1.31,  1.32,  1.33,  1.34,  1.35,  1.36,  1.37,  1.38,  1.39,  1.40,
1.41,  1.42,  1.43,  1.44,  1.45,  1.46,  1.47,  1.48,  1.49,  1.50,  1.51,
1.52,  1.53,  1.54,  1.55,  1.56,  1.57,  1.58,  1.59,  1.60,  1.61,  1.62,
1.63,  1.64,  1.65,  1.66,  1.67,  1.68,  1.69,  1.70,  1.71,  1.72,  1.73,
1.74,  1.75,  1.76,  1.77,  1.78,  1.79,  1.80,  1.81,  1.82,  1.83,  1.84,
1.85,  1.86,  1.87,  1.88,  1.89,  1.90,  1.91,  1.92,  1.93,  1.94,  1.95,
1.96,  1.97,  1.98,  1.99,  2.00,  2.01,  2.02,  2.03,  2.04,  2.05,  2.06,
2.07,  2.08,  2.09,  2.10,  2.11,  2.12,  2.13,  2.14,  2.15,  2.16,  2.17,
2.18,  2.19,  2.20,  2.21,  2.22,  2.23,  2.24,  2.25,  2.26,  2.27,  2.28,
2.29,  2.30,  2.31,  2.32,  2.33,  2.34,  2.35,  2.36,  2.37,  2.38,  2.39,
2.40,  2.41,  2.42,  2.43,  2.44,  2.45,  2.46,  2.47,  2.48,  2.49,  2.50,
2.51,  2.52,  2.53,  2.54,  2.55,  2.56,  2.57,  2.58,  2.59,  2.60,  2.61,
2.62,  2.63,  2.64,  2.65,  2.66,  2.67,  2.68,  2.69,  2.70,  2.71,  2.72,
2.73,  2.74,  2.75,  2.76,  2.77,  2.78,  2.79,  2.80,  2.81,  2.82,  2.83,
2.84,  2.85,  2.86,  2.87,  2.88,  2.89,  2.90,  2.91,  2.92,  2.93,  2.94,
2.95,  2.96,  2.97,  2.98,  2.99,  3.00,  3.01,  3.02,  3.03,  3.04,  3.05,
3.06,  3.07,  3.08,  3.09,  3.10,  3.11,  3.12,  3.13,  3.14,  3.15,  3.16,
3.17,  3.18,  3.19,  3.20,  3.21,  3.22,  3.23,  3.24,  3.25,  3.26,  3.27,
3.28,  3.29,  3.30,  3.31,  3.32,  3.33,  3.34,  3.35,  3.36,  3.37,  3.38,
3.39,  3.40,  3.41,  3.42,  3.43,  3.44,  3.45,  3.46,  3.47,  3.48,  3.49};

float PP[350]={
0.5000,0.5040,0.5080,0.5120,0.5160,0.5199,0.5239,0.5279,0.5319,0.5359,0.5398,
0.5438,0.5478,0.5517,0.5557,0.5596,0.5636,0.5675,0.5714,0.5753,0.5793,0.5832,
0.5871,0.5910,0.5948,0.5987,0.6026,0.6064,0.6103,0.6141,0.6179,0.6217,0.6255,
0.6293,0.6331,0.6368,0.6406,0.6443,0.6480,0.6517,0.6554,0.6591,0.6628,0.6664,
0.6700,0.6736,0.6772,0.6808,0.6844,0.6879,0.6915,0.6950,0.6985,0.7019,0.7054,
0.7088,0.7123,0.7157,0.7190,0.7224,0.7257,0.7291,0.7324,0.7357,0.7389,0.7422,
0.7454,0.7486,0.7517,0.7549,0.7580,0.7611,0.7642,0.7673,0.7704,0.7738,0.7764,
0.7794,0.7823,0.7852,0.7881,0.7991,0.7939,0.7967,0.7995,0.8023,0.8051,0.8078,
0.8106,0.8133,0.8159,0.8186,0.8212,0.8238,0.8264,0.8289,0.8315,0.8340,0.8365,
0.8389,0.8413,0.8438,0.8461,0.8485,0.8508,0.8531,0.8554,0.8577,0.8599,0.8621,
0.8643,0.8665,0.8686,0.8708,0.8729,0.8749,0.8770,0.8790,0.8810,0.8830,0.8849,
0.8869,0.8888,0.8907,0.8925,0.8944,0.8962,0.8980,0.8997,0.9015,0.9032,0.9049,
0.9066,0.9082,0.9099,0.9115,0.9131,0.9147,0.9162,0.9177,0.9192,0.9207,0.9222,
0.9236,0.9251,0.9265,0.9279,0.9292,0.9306,0.9319,0.9332,0.9332,0.9345,0.9357,
0.9370,0.9382,0.9406,0.9418,0.9429,0.9441,0.9452,0.9463,0.9474,0.9484,0.9495,
0.9505,0.9515,0.9525,0.9535,0.9545,0.9554,0.9564,0.9573,0.9582,0.9591,0.9599,
0.9608,0.9616,0.9625,0.9633,0.9641,0.9649,0.9656,0.9664,0.9671,0.9678,0.9686,
0.9693,0.9699,0.9706,0.9713,0.9719,0.9726,0.9732,0.9738,0.9744,0.9750,0.9756,
0.9761,0.9767,0.9772,0.9778,0.9783,0.9788,0.9793,0.9798,0.9803,0.9808,0.9812,
0.9817,0.9821,0.9826,0.9830,0.9834,0.9838,0.9842,0.9846,0.9850,0.9854,0.9857,
0.9861,0.9864,0.9868,0.9871,0.9875,0.9878,0.9881,0.9884,0.9887,0.9890,0.9893,
0.9896,0.9898,0.9901,0.9904,0.9906,0.9909,0.9911,0.9913,0.9916,0.9918,0.9920,
0.9922,0.9925,0.9927,0.9929,0.9931,0.9932,0.9934,0.9936,0.9938,0.9940,0.9941,
0.9943,0.9945,0.9946,0.9948,0.9949,0.9950,0.9952,0.9953,0.9955,0.9956,0.9957,
0.9959,0.9960,0.9961,0.9962,0.9963,0.9964,0.9965,0.9967,0.9967,0.9968,0.9969,
0.9970,0.9971,0.9972,0.9972,0.9974,0.9974,0.9975,0.9976,0.9977,0.9977,0.9977,
0.9978,0.9979,0.9980,0.9980,0.9981,0.9981,0.9982,0.9983,0.9983,0.9984,0.9985,
0.9985,0.9986,0.9986,0.9987,0.9987,0.9987,0.9988,0.9988,0.9989,0.9989,0.9989,
0.9990,0.9990,0.9990,0.9990,0.9991,0.9991,0.9992,0.9992,0.9992,0.9992,0.9993,
0.9993,0.9993,0.9993,0.9994,0.9994,0.9994,0.9994,0.9994,0.9995,0.9995,0.9995,
0.9995,0.9995,0.9996,0.9996,0.9996,0.9996,0.9996,0.9996,0.9996,0.9997,0.9997,
0.9997,0.9997,0.9997,0.9997,0.9997,0.9997,0.9997,0.9998,0.9998};

float ttest(Value)
/***********************/
/*   float T_test(Value) */
/***********************/
float Value;
{
int i;
float Prob;
Prob = 0.;
if(Value < 0.) Value *= -1.;
i=349; while((float)Tdist[i] > (float)Value) i--; Prob = 2.*(PP[i]-0.5);
return Prob;
}



rdseq(fpi,nseq1,nsite,seq,seqnm,maxnm1)
FILE *fpi;
int nseq1,nsite,maxnm1;
char **seq,**seqnm;
{
int i,cw,flg,fc,sc,flg1,cw1,seqc,sitec,cn;
/* flg  0   initial
        1   file name
        2   file name end
        3   sequence
   flg1 1   comment
 */
   cn=0;
   seqc=0;
   sitec=0;
   fc=0;
   sc=0;
   flg1=0;
   flg = 0;
   cw =0;
   cw1=0;
   for( ; ; ){
      cw1=cw;
      if( cw1 != EOF ) cw = getc(fpi);
      if( cw1 == EOF ) break;
      cn++;
      if( cn == 1 ) continue;
      if( cw1 == '/' && cw == '*' ){
          flg1 = 1;
          continue;
	}
      if( flg1 == 1 ) {
           if( cw1 == '*' && cw == '/' ){
               flg1=0;
	     }
            continue;
	 }
      

      switch(flg){
        case 0: if( cw1 == ' ' || cw1 == '\t' ) break;
                if( cw1 == '\n' ) break;
                flg=1;
                seqnm[seqc][fc]=cw1;
                fc++;
                if( fc > maxnm1 ) printf("fc=%d maxnm1=%d seq %d\n",fc,maxnm1,seqc);
                break;
        case 1: if( cw1 == ' ' || cw1 == '\t' ) {
                  fc=0;
                  flg = 2;
                  break;
		}
                if( cw1 == '\n' ){
                   fprintf(ERR,"format error (1) in data file\n");
                   exit(1);
		 }
                seqnm[seqc][fc]=cw1;
                fc++;
                if( fc > maxnm1 ) printf("fc=%d maxnm1=%d seq %d\n",fc,maxnm1,seqc);
                break;
        case 2: if( cw1 == ' ' || cw1 == '\t' ) break;
                if( cw1 == '\n' ){
                   fprintf(ERR,"format error (2) in data file\n");
                   exit(1);
		 }
                 flg=3;
                 seq[sc][seqc]=cw1;
                 sc++;
                 break;
         case 3: if( cw1 == '\n'){
                     if( sc != nsite ){
                        fprintf(stderr,"nsite is not the same %d (in seq %d)\n",sc,(seqc)+1);
                        exit(1);                                                                    }
                   seqc++;
                   if( seqc > nseq1 ) printf("seqc=%d nseq=%d\n",seqc,nseq1);
                   flg=0;
                   sc=0;
                   fc=0;
                   break;
		   }
                 if( cw1 == ' ' || cw1 == '\t' ) break;
                 seq[sc][seqc]=cw1;
                 sc++;
                 break;
	default: break;
	}
     
    }
    if( sc != 0 ){
      if( sc != nsite ){
            fprintf(stderr,"nsite is not the same %d (in seq %d)\n",sc,seqc+1);
            exit(1);                                                                    }
      seqc++;
    }
   if( seqc != nseq1 ){
      printf("sequence number inconsistency seqc=%d nseq=%d\n",seqc,nseq1);
      exit(1);
    }
   

/*   printf("rdseq seqc=%d\n",seqc); */
/*   for(i=0; i<nseq1 ; i++) printf("%d %s\n",i+1,seqnm[i]); */

    return(0);
}


checkfl(fpi,nseq1,nsite,maxnm)
FILE *fpi;
int *nseq1,*nsite,*maxnm;
{
int cw,flg,fc,sc,flg1,cw1;
/* flg  0   initial
        1   file name
        2   file name end
        3   sequence
   flg1 1   comment
 */

   *nseq1=0;
   *nsite =0;
   *maxnm=0;
   fc=0;
   sc=0;
   flg1=0;
   flg = 0;
   cw =0;
   cw1=0;
   for( ; ; ){
      cw1=cw;
      if( cw1 != EOF ) cw = getc(fpi);
      if( cw1 == EOF ) break;
      if( cw1 == '/' && cw == '*' ){
          flg1 = 1;
          continue;
	}
      if( flg1 == 1 ) {
           if( cw1 == '*' && cw == '/' ){
               flg1=0;
	     }
            continue;
	 }
      switch(flg){
        case 0: if( cw1 == ' ' || cw1 == '\t' ) break;
                if( cw1 == '\n' ) break;
                flg=1;
                fc++;
                break;
        case 1: if( cw1 == ' ' || cw1 == '\t' ) {
                  if( fc > *maxnm ) *maxnm=fc;
                  fc=0;
                  flg = 2;
                  break;
		}
                if( cw1 == '\n' ){
                   fprintf(ERR,"format error (1) in data file\n");
                   exit(1);
		 }
                fc++;
                break;
        case 2: if( cw1 == ' ' || cw1 == '\t' ) break;
                if( cw1 == '\n' ){
                   fprintf(ERR,"format error (2) in data file\n");
                   exit(1);
		 }
                 flg=3;
                 sc++;
                 break;
         case 3: if( cw1 == '\n'){
                   if( *nseq1 == 0 ) {
                     *nsite = sc;
                   }else{
                     if( sc != *nsite ){
                        fprintf(ERR,"nsite is not the same %d (in seq %d)\n",sc,(*nseq1)+1);
                        exit(1);                                                                    }
                   }
                   (*nseq1)++;
                   flg=0;
                   sc=0;
                   fc=0;
                   break;
		 }
                 if( cw1 == ' ' || cw1 == '\t' ) break;
                 sc++;
	}
     
    }
    if( sc != 0 ){
      if( sc != *nsite ){
            fprintf(ERR,"nsite is not the same %d (in seq %d)\n",sc,(*nseq1)+1);
            exit(1);                                                                    }
      (*nseq1)++;
    }
    return(0);
}


prncn(fpo,nseq0,nda,fl,dop,nsite,nasite,inp,outgroup,noutg,outg)
FILE *fpo;
int nseq0,nsite,nasite,dop,outgroup,noutg,outg[];
char **fl/*[MAXOTU][MAXNM]*/,*inp;
Nds *nda/*[2*MAXOTU-2]*/;
{
int i,j;

      printf("prncn fpo %p nseq0=%d nsite=%d nasite=%d noutg=%d\n",fpo,nseq0,nsite,nasite,noutg);fflush(stdout); 
      fprintf(fpo," %d sequences\n",nseq0); fflush(fpo);
      printf("seq nseq0=%d\n",nseq0);fflush(stdout); 
      for(i=0; i<nseq0 ; i++)  fprintf(fpo,"%d %s\n",i+1,fl[i]);
      fflush(fpo);
      for(i=0; i<2*nseq0-2 ; i++){
	if( nda[i].nkey <= nseq0 ) continue;
        fprintf(fpo,"%3d and %3d        %f\n",nda[i].nkey,nda[i].lc->nkey,*nda[i].blcx1);
        fprintf(fpo,"%3d and %3d        %f\n",nda[i].nkey,nda[i].rc->nkey,*nda[i].brcx1);
      fflush(fpo);
        if( nda[i].b->nkey == outgroup ){
            fprintf(fpo,"%3d and %3d",nda[i].nkey,outgroup);
            fflush(fpo);
            fprintf(fpo,"        %f\n",*nda[i].bbx1);
	  }
      fflush(fpo);
      }


fprintf(fpo,"\n");
fprintf(fpo,"file:%s  constant rate for NJ (negative branches allowed)\n %s was used.\n",inp,dname[dop]);
      fflush(fpo);
fprintf(fpo,"Number of nucleotide sites compared %d (nsite=%d)\n",nasite,nsite);
  fflush(fpo);
fprintf(fpo,"outgroup:");
for(i=0; i<noutg ; i++){
   fprintf(fpo,"  %d %s",outg[i],fl[outg[i]-1]);
 }
fprintf(fpo,"\n");
  fflush(fpo);
  
return(0);
}




prncng(fpo,nseq0,nda,fl,dop,nsite,nasite,inp,outgroup,noutg,outg)
FILE *fpo;
int nseq0,nsite,nasite,dop,outgroup,noutg,outg[];
char **fl/*[MAXOTU][MAXNM]*/,*inp;
Nds *nda/*[2*MAXOTU-2]*/;
{
int i,j;

      fprintf(fpo," %d sequences\n",nseq0);
      for(i=0; i<nseq0 ; i++)  fprintf(fpo,"%d %s\n",i+1,fl[i]);
      for(i=0; i<2*nseq0-2 ; i++){
	if( nda[i].nkey <= nseq0 ) continue;
        fprintf(fpo,"%3d and %3d        %f\n",nda[i].nkey,nda[i].lc->nkey,*nda[i].blcx2);
        fprintf(fpo,"%3d and %3d        %f\n",nda[i].nkey,nda[i].rc->nkey,*nda[i].brcx2);
        if( nda[i].b->nkey == outgroup )
               fprintf(fpo,"%3d and %3d        %f\n",nda[i].nkey,nda[i].b->nkey,*nda[i].b->bbx2);

      }

fprintf(fpo,"\n");
fprintf(fpo,"file:%s  constant rate for NJ (negative branches not allowed)\n %s was used.\n",inp,dname[dop]);
fprintf(fpo,"Number of nucleotide sites compared %d (nsite=%d)\n",nasite,nsite);
fprintf(fpo,"outgroup=%d\n",outgroup);


return(0);
}

 /* The Genetic Codes */
/* The Standard Code (transl_table=1) */

   static char *AAst1 = {"FFLLSSSSYY**CC*WLLLLPPPPHHQQRRRRIIIMTTTTNNKKSSRRVVVVAAAADDEEGGGG"};
static char *Startst1 = {"---M---------------M---------------M----------------------------"};
static char *Base1t1 =  {"TTTTTTTTTTTTTTTTCCCCCCCCCCCCCCCCAAAAAAAAAAAAAAAAGGGGGGGGGGGGGGGG"};
static char *Base2t1 =  {"TTTTCCCCAAAAGGGGTTTTCCCCAAAAGGGGTTTTCCCCAAAAGGGGTTTTCCCCAAAAGGGG"};
static char *Base3t1 =  {"TCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAG"};
static char *inic[3] = {"AUG","CUG","UUG"};

/* The Vertebrate Mitochondrial Code (transl_table=2) */
static char *AAst2 =    {"FFLLSSSSYY**CCWWLLLLPPPPHHQQRRRRIIMMTTTTNNKKSS**VVVVAAAADDEEGGGG"};
static char *Startst2 = {"--------------------------------MMMM---------------M------------"};
static char *Base1t2  = {"TTTTTTTTTTTTTTTTCCCCCCCCCCCCCCCCAAAAAAAAAAAAAAAAGGGGGGGGGGGGGGGG"};
static char *Base2t2  = {"TTTTCCCCAAAAGGGGTTTTCCCCAAAAGGGGTTTTCCCCAAAAGGGGTTTTCCCCAAAAGGGG"};
static char *Base3t2  = {"TCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAG"};

/* Bos: AUA <BR>
   Homo: AUA, AUU<BR>
   Mus: AUA, AUU, AUC<BR>
   Coturnix, Gallus: also GUG (Desjardins and Morais, 1991)<BR>
*/
/* The Yeast Mitochondrial Code (transl_table=3) */
static char    *AAst3  = {"FFLLSSSSYY**CCWWTTTTPPPPHHQQRRRRIIMMTTTTNNKKSSRRVVVVAAAADDEEGGGG"};
static char  *Startst3 = {"-----------------------------------M----------------------------"};
static char  *Base1t3  = {"TTTTTTTTTTTTTTTTCCCCCCCCCCCCCCCCAAAAAAAAAAAAAAAAGGGGGGGGGGGGGGGG"};
static char  *Base2t3  = {"TTTTCCCCAAAAGGGGTTTTCCCCAAAAGGGGTTTTCCCCAAAAGGGGTTTTCCCCAAAAGGGG"};
static char  *Base3t3  = {"TCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAG"};
/*  Saccharomyces cerevisiae, Candida glabrata, Hansenula saturnus,
    Schizosaccharomyces pombe, and Kluyveromyces thermotolerans
   (Clark-Walker and Weiller, 1994)
   The remaining CGN codons are rare in Saccharomyces cerevisiae and
   absent in Candida glabrata (= Torulopsis glabrata)
*/

/* The Mold, Protozoan, and Coelenterate Mitochondrial Code 
and the Mycoplasma/Spiroplasma Code (transl_table=4) */
static char *AAst4  =    {"FFLLSSSSYY**CCWWLLLLPPPPHHQQRRRRIIIMTTTTNNKKSSRRVVVVAAAADDEEGGGG"};
static char *Startst4 =  {"--MM---------------M------------MMMM---------------M------------"};
static char *Base1t4  = {"TTTTTTTTTTTTTTTTCCCCCCCCCCCCCCCCAAAAAAAAAAAAAAAAGGGGGGGGGGGGGGGG"};
static char *Base2t4  = {"TTTTCCCCAAAAGGGGTTTTCCCCAAAAGGGGTTTTCCCCAAAAGGGGTTTTCCCCAAAAGGGG"};
static char *Base3t4  = {"TCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAG"};
/* Alternative initiation codons 
  Trypanosoma: UUA, UUG, CUG
  Leishmania: AUU, AUA
  Tertrahymena: AUU, AUA, AUG 
  Paramecium: AUU, AUA, AUG, AUC, GUG, GUA(?) 
  (Pritchard et al., 1990)
*/
/* Mycoplasmatales: Mycoplasma, Spiroplasma (Bove et al., 1989);
   Fungi: Emericella nidulans, Neurospora crassa,
   Podospora anserina, Acremonium (Fox, 1987), Candida
   parapsilosis (Guelin et al., 1991), Trichophyton rubrum (de
   Bievre and Dujon, 1992), Dekkera/Brettanomyces, Eeniella (Hoeben
   et al., 1993), and probably Ascobolus immersus, Aspergillus
   amstelodami, Claviceps purpurea, and Protozoa: Trypanosoma brucei, 
   Leishmania tarentolae, Paramecium tetraurelia, Tetrahymena
   pyriformis and probably Plasmodium gallinaceum (Aldritt et al., 1989).

   Metazoa: Coelenterata (Ctenophora and Cnidaria)
   This code is also used for the kinetoplast DNA (maxicircles,
   minicircles).  Kinetoplasts are modified mitochondria (or their
   parts).
   This code is not used in the Acholeplasmataceae and plant-pathogenic
   mycoplasma-like organisms (MLO) (Lim and Sears, 1992)
*/

/* The Invertebrate Mitochondrial Code (transl_table=5) */
static char *AAst5  = {"FFLLSSSSYY**CCWWLLLLPPPPHHQQRRRRIIMMTTTTNNKKSSSSVVVVAAAADDEEGGGG"};
static char *Startst5 = {"---M----------------------------MMMM---------------M------------"};
static char *Base1t5  = {"TTTTTTTTTTTTTTTTCCCCCCCCCCCCCCCCAAAAAAAAAAAAAAAAGGGGGGGGGGGGGGGG"};
static char *Base2t5  = {"TTTTCCCCAAAAGGGGTTTTCCCCAAAAGGGGTTTTCCCCAAAAGGGGTTTTCCCCAAAAGGGG"};
static char *Base3t5  = {"TCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAG"};
/* The codon AGG is absent in Drosophila. */
/* AUA, AUU
   AUC: Apis (Crozier and Crozier, 1993)
   GUG: Polyplacophora (Boore and Brown, 1994)
   UUG: Ascaris, Caenorhabditis<BR>
*/

/* Nematoda: Ascaris, Caenorhabditis;
   Mollusca: Bivalvia (Hoffmann et al., 1992); Polyplacophora 
   (Boore and Brown, 1994)
   Arthropoda/Crustacea: Artemia (Batuecas et al., 1988);
   Arthropoda/Insecta: Drosophila [Locusta migratoria (migratory locust), 
   Apis mellifera (honeybee)
*/

/* The Ciliate, Dasycladacean and Hexamita Nuclear Code (transl_table=6)*/
static char *AAst6  = {"FFLLSSSSYYQQCC*WLLLLPPPPHHQQRRRRIIIMTTTTNNKKSSRRVVVVAAAADDEEGGGG"};
static char *Startst6 = {"-----------------------------------M----------------------------"};
static char *Base1t6 = {"TTTTTTTTTTTTTTTTCCCCCCCCCCCCCCCCAAAAAAAAAAAAAAAAGGGGGGGGGGGGGGGG"};
static char *Base2t6  = {"TTTTCCCCAAAAGGGGTTTTCCCCAAAAGGGGTTTTCCCCAAAAGGGGTTTTCCCCAAAAGGGG"};
static char *Base3t6  = {"TCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAG"};
/* Ciliata: Oxytricha and Stylonychia (Hoffman et al. 1995), Paramecium,
   Tetrahymena, Oxytrichidae and probably Glaucoma chattoni.
   Dasycladaceae: Acetabularia (Schneider et al., 1989) and
   Batophora (Schneider and de Groot, 1991).
   Diplomonadida
   Scope: Hexamita inflata, Diplomonadida ATCC50330, and ATCC50380. 
/* The Echinoderm Mitochondrial Code (transl_table=9) */
static char  *AAst9  = {"FFLLSSSSYY**CCWWLLLLPPPPHHQQRRRRIIIMTTTTNNNKSSSSVVVVAAAADDEEGGGG"};
static char  *Startst9 ={" -----------------------------------M----------------------------"};
static char  *Base1t9  = {"TTTTTTTTTTTTTTTTCCCCCCCCCCCCCCCCAAAAAAAAAAAAAAAAGGGGGGGGGGGGGGGG"};
static char  *Base2t9  = {"TTTTCCCCAAAAGGGGTTTTCCCCAAAAGGGGTTTTCCCCAAAAGGGGTTTTCCCCAAAAGGGG"};
static char  *Base3t9  = {"TCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAG"};
/*  Asterozoa (starfishes) (Himeno et al., 1987)
    Echinozoa (sea urchins) (Jacobs et al., 1988; Cantatore et al., 1989)
  */
/* 10. The Euplotid Nuclear Code (transl_table=10) */
static char  *AAst10  = {"FFLLSSSSYY**CCCWLLLLPPPPHHQQRRRRIIIMTTTTNNKKSSRRVVVVAAAADDEEGGGG"};
static char  *Startst10 = {"-----------------------------------M----------------------------"};
static char  *Base1t10  = {"TTTTTTTTTTTTTTTTCCCCCCCCCCCCCCCCAAAAAAAAAAAAAAAAGGGGGGGGGGGGGGGG"};
static char  *Base2t10  = {"TTTTCCCCAAAAGGGGTTTTCCCCAAAAGGGGTTTTCCCCAAAAGGGGTTTTCCCCAAAAGGGG"};
static char  *Base3t10  = {"TCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAG"};

/* 11. The Bacterial "Code" (transl_table=11)  */
static char *AAst11  =   {"FFLLSSSSYY**CC*WLLLLPPPPHHQQRRRRIIIMTTTTNNKKSSRRVVVVAAAADDEEGGGG"};
static char *Startst11 = {"---M---------------M------------MMMM---------------M------------"};
static char *Base1t11  = {"TTTTTTTTTTTTTTTTCCCCCCCCCCCCCCCCAAAAAAAAAAAAAAAAGGGGGGGGGGGGGGGG"};
static char *Base2t11  = {"TTTTCCCCAAAAGGGGTTTTCCCCAAAAGGGGTTTTCCCCAAAAGGGGTTTTCCCCAAAAGGGG"};
static char *Base3t11  = {"TCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAG"};

/* GUG, UUG, AUU, CUG */
/* Prokaryotes including the eubacteria (Kozak, 1983) and archaebacteria
   (Brown et al. 1989; Noelling et al., unpublished).
*/
/* 12. The Alternative Yeast Nuclear Code (transl_table=12) */
static char *AAst12  = {"FFLLSSSSYY**CC*WLLLSPPPPHHQQRRRRIIIMTTTTNNKKSSRRVVVVAAAADDEEGGGG"};
static char *Startst12 = {"-------------------M---------------M----------------------------"};
static char *Base1t12  = {"TTTTTTTTTTTTTTTTCCCCCCCCCCCCCCCCAAAAAAAAAAAAAAAAGGGGGGGGGGGGGGGG"};
static char *Base2t12  = {"TTTTCCCCAAAAGGGGTTTTCCCCAAAAGGGGTTTTCCCCAAAAGGGGTTTTCCCCAAAAGGGG"};
static char *Base3t12  = {"TCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAG"};

/* 13. The Ascidian Mitochondrial Code (transl_table=13) */
static char *AAst13  = {"FFLLSSSSYY**CCWWLLLLPPPPHHQQRRRRIIMMTTTTNNKKSSGGVVVVAAAADDEEGGGG"};
static char *Startst13 = {"-----------------------------------M----------------------------"};
static char *Base1t13  = {"TTTTTTTTTTTTTTTTCCCCCCCCCCCCCCCCAAAAAAAAAAAAAAAAGGGGGGGGGGGGGGGG"};
static char *Base2t13  = {"TTTTCCCCAAAAGGGGTTTTCCCCAAAAGGGGTTTTCCCCAAAAGGGGTTTTCCCCAAAAGGGG"};
static char *Base3t13  = {"TCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAG"};
/*Ascidiacea (sea squirts): Pyuridae (Durrheim et al. 1993; Yokobori et al., 1993)
*/
/* 14. The Flatworm Mitochondrial Code (transl_table=14) */
/* 15. The Flatworm Mitochondrial Code (transl_table=14) */







calsyn(nseq,a,fl,nasite,rsite,dist,dop,cdn,cdnn,synsite,synchg,nsynchg,pflg,maxnm)
int nseq,nasite,*rsite,dop,cdn[4][4][4],cdnn[4][4][4],pflg,maxnm;
char **a,**fl;
double **dist,***synsite,**synchg,**nsynchg;
{
FILE *fpo=stdout;
int i,j,k,inap;
double dsyn1,dnosyn1,dsyn2,dnosyn2,syn,nsyn,ps,pn,ds,dn,vps,vpn,vds,vdn;
double tssyn,tsnsyn,tvsyn,tvnsyn;
double getnsite(),getvar();
   inap=0;
   /*     printf("nseq=%d nasite=%d dop=%d\n",nseq,nasite,dop);   fflush(stdout);*/
  if( pflg == 1 ){
    for(k=0; k<maxnm*2+4 ; k++) fprintf(fpo," ");
    fprintf(fpo,"synsite nsynste synchg nsynch ps    pn    ds    dn\n");
    fflush(stdout);
  }
for(i=0; i<nseq-1 ; i++){
  dsyn1=getnsite(nasite,rsite,a,i,cdn,cdnn,synsite);
  dnosyn1 = (double)(nasite*3)-dsyn1;
  /*  printf("calsyn %d dsyn1=%f dnosyn1=%f\n",i,dsyn1,dnosyn1); fflush(stdout);*/
  for(j=i+1; j<nseq ; j++){
    dsyn2=getnsite(nasite,rsite,a,j,cdn,cdnn,synsite);
    dnosyn2 = (double)(nasite*3)-dsyn2;
    if( dop >= 15 && dop <= 18 ) getsync(nasite,rsite,a,i,j,cdn,cdnn,&syn,&nsyn,&tssyn,&tsnsyn,&tvsyn,&tvnsyn,synchg);
    if( dop >= 19 && dop <= 22 ) getsynctsv(nasite,rsite,a,i,j,cdn,cdnn,&syn,&nsyn,&tssyn,&tsnsyn,&tvsyn,&tvnsyn,synchg,nsynchg);
    ps = 2.*syn/(dsyn1 + dsyn2);
    pn = 2.*nsyn/(dnosyn1 + dnosyn2);
    tssyn /= (dsyn1 + dsyn2)/2.;
    tsnsyn /= (dsyn1 + dsyn2)/2.;
    tvsyn /= (dsyn1 + dsyn2)/2.;
    tvnsyn /= (dsyn1 + dsyn2)/2.;
    ds =  -0.75*log(1.0 - ps*4./3.);
    dn =  -0.75*log(1.0 - pn*4./3.);
    /*       printf("calsyn %d dsyn2=%f dnosyn2=%f syn=%f nsyn=%f ps=%f pn=%f\n",j,dsyn2,dnosyn2,syn,nsyn,ps,pn); fflush(stdout);*/
    dist[j][i]=getvar(nasite,rsite,a,i,j,cdn,cdnn,(dsyn1 + dsyn2)/2.,(dnosyn1 + dnosyn2)/2.,ps,pn,dop,synsite,synchg,nsynchg,tssyn,tsnsyn,tvsyn,tvnsyn);
    /*    printf("var %d %d %f\n",i,j,dist[j][i]);*/
    if( syn <= ACU ) ds = 0.;
    if( nsyn <= ACU ) dn = 0.;
    if( pflg == 1 ) {
     vps=getvar(nasite,rsite,a,i,j,cdn,cdnn,(dsyn1 + dsyn2)/2.,(dnosyn1 + dnosyn2)/2.,ps,pn,15,synsite,synchg,nsynchg,tssyn,tsnsyn,tvsyn,tvnsyn);
     vpn=getvar(nasite,rsite,a,i,j,cdn,cdnn,(dsyn1 + dsyn2)/2.,(dnosyn1 + dnosyn2)/2.,ps,pn,16,synsite,synchg,nsynchg,tssyn,tsnsyn,tvsyn,tvnsyn);
     vds=getvar(nasite,rsite,a,i,j,cdn,cdnn,(dsyn1 + dsyn2)/2.,(dnosyn1 + dnosyn2)/2.,ps,pn,17,synsite,synchg,nsynchg,tssyn,tsnsyn,tvsyn,tvnsyn);
     vdn=getvar(nasite,rsite,a,i,j,cdn,cdnn,(dsyn1 + dsyn2)/2.,(dnosyn1 + dnosyn2)/2.,ps,pn,18,synsite,synchg,nsynchg,tssyn,tsnsyn,tvsyn,tvnsyn);
     fprintf(fpo,"%s",fl[i]);
     for(k=0; k< maxnm-strlen(fl[i]) ; k++) fprintf(fpo," ");
     fprintf(fpo," vs");
     fprintf(fpo," %s",fl[j]);
     for(k=0; k< maxnm-strlen(fl[j]) ; k++) fprintf(fpo," ");
     fprintf(fpo,"%7.2f %7.2f %6.2f %6.2f %5.3f(%5.3f) %5.3f(%5.3f) %5.3f(%5.3f) %5.3f(%5.3f) %5.3f %5.3f %5.3f %5.3f\n",(dsyn1+dsyn2)/2.,(dnosyn1+dnosyn2)/2.,syn,nsyn,ps,sqrt(vps),pn,sqrt(vpn),ds,sqrt(vds),dn,sqrt(vdn),tssyn,tvsyn,tsnsyn,tvnsyn); fflush(stdout);
    }
    switch(dop){
      case 15: dist[i][j]=ps; break;
      case 16: dist[i][j]=pn; break;
      case 17: if( 1.0 - ps*4./3. <= ACU ) {
                 dist[i][j] = INAP;
                 inap++;
               }
               dist[i][j]= ds; break;
      case 18: if( 1.0 - pn*4./3. <= ACU ){
                 dist[i][j] = INAP;
                 inap++;
               }
               dist[i][j]= dn; break;
      case 19: dist[i][j]=tvsyn; break;
      case 20: dist[i][j]=tvnsyn; break;
      case 21: if( 1.0 - tvsyn*2. <= ACU ) {
                 dist[i][j] = INAP;
                 inap++;
               }
               dist[i][j]= -0.25*log(1.- tvsyn*2.);
               break;
      case 22: if( 1.0 - tvnsyn*2. <= ACU ){
                 dist[i][j] = INAP;
                 inap++;
               }
               dist[i][j]= -0.25*log(1.- tvnsyn*2.); 
               break;

    }
    /*    printf("i=%d j=%d d=%f v=%f\n",i,j,dist[i][j],dist[j][i]);*/
  }
}
return(inap);
}

double getnsite(nasite,rsite,a,nseqn,cdn,cdnn,synsite)
int nasite, *rsite,nseqn,cdn[4][4][4],cdnn[4][4][4];
char **a;
double ***synsite;
{
int i,j,k,n[3],nc1,nc2,nc3,np1,np2,np3;
double dsyn,dsyn1;
dsyn=0.;
for(i=0; i<nasite; i++){
  for(j=0; j<3 ; j++) n[j] = a[rsite[i]*3+j][nseqn];
    dsyn += synsite[n[0]][n[1]][n[2]];
}   

return(dsyn);
}
getsync(nasite,rsite,a,nseq1,nseq2,cdn,cdnn,syn,nsyn,tssyn,tsnsyn,tvsyn,tvnsyn,synchg)
int nasite,*rsite,nseq1,nseq2,cdn[4][4][4],cdnn[4][4][4];
char **a;
double *syn,*nsyn,*tssyn,*tsnsyn,*tvsyn,*tvnsyn,**synchg;
{
int i,j,c1[3],c2[3],nc,cp[3],np,n1,n2;
double syn1,nsyn1;
*syn=*nsyn=0.;
*tssyn=*tsnsyn=*tvsyn=*tvnsyn=0.;
np=0;
for(i=0; i< nasite; i++){
  for(j=0; j<3 ; j++){
     c1[j] = a[rsite[i]*3+j][nseq1]; 
     c2[j] = a[rsite[i]*3+j][nseq2]; 
  }
  n1 = cdnn[c1[0]][c1[1]][c1[2]];
  n2 = cdnn[c2[0]][c2[1]][c2[2]];
  if(  n1 < n2 ){
   *syn += synchg[n1][n2];
   *nsyn += synchg[n2][n1];
  }
  if(  n1 > n2 ){
   *syn += synchg[n2][n1];
   *nsyn += synchg[n1][n2];
  }
}

return(0);
}

getsynctsv(nasite,rsite,a,nseq1,nseq2,cdn,cdnn,syn,nsyn,tssyn,tsnsyn,tvsyn,tvnsyn,synchg,nsynchg)
int nasite,*rsite,nseq1,nseq2,cdn[4][4][4],cdnn[4][4][4];
char **a;
double *syn,*nsyn,*tssyn,*tsnsyn,*tvsyn,*tvnsyn,**synchg,**nsynchg;
{
int i,j,c1[3],c2[3],nc,cp[3],np,tsv[3],n1,n2;
double syn1,nsyn1,tssyn1,tsnsyn1,tvsyn1,tvnsyn1;
/*printf("getsynctsv \n"); fflush(stdout);
printf("getsynctsv %f %f\n",*tssyn,*tsnsyn);fflush(stdout);
*/
*syn=*nsyn=0.;
*tssyn=*tsnsyn=*tvsyn=*tvnsyn=0.;
np=0;
for(i=0; i< nasite; i++){
  for(j=0; j<3 ; j++){
     c1[j] = a[rsite[i]*3+j][nseq1]; 
     c2[j] = a[rsite[i]*3+j][nseq2]; 
  }
  n1 = cdnn[c1[0]][c1[1]][c1[2]];
  n2 = cdnn[c2[0]][c2[1]][c2[2]];
  if( n1 < n2 ){
     *tssyn += synchg[n1][n2];
     *tvsyn += synchg[n2][n1];
     *tsnsyn += nsynchg[n1][n2];
     *tvnsyn += nsynchg[n2][n1];
  }
  if( n2 < n1 ){
     *tssyn += synchg[n2][n1];
     *tvsyn += synchg[n1][n2];
     *tsnsyn += nsynchg[n2][n1];
     *tvnsyn += nsynchg[n1][n2];
  }
  *syn += synchg[n1][n2]+synchg[n2][n1];;
  *nsyn += nsynchg[n1][n2]+nsynchg[n2][n1];;

}

return(0);
}
  




getsynctsv1(c1,c2,cdn,syn,nsyn,tssyn,tsnsyn,tvsyn,tvnsyn)
int c1[3],c2[3],cdn[4][4][4];
double *syn,*nsyn,*tssyn,*tsnsyn,*tvsyn,*tvnsyn;
{
int i,j,nc,cp[3],np,tsv[3];
double syn1,nsyn1,tssyn1,tsnsyn1,tvsyn1,tvnsyn1;
*syn=*nsyn=0.;
*tssyn=*tsnsyn=*tvsyn=*tvnsyn=0.;
np=0;
  nc=0;
  for(j=0; j<3 ; j++){
    if( c1[j] != c2[j] ) {
      cp[nc]=j;
      tsv[j]=tr[c1[j]][c2[j]];
      nc++;
    }
  }
  
   nsyn1 = syn1 = 0.;
   tssyn1 = tsnsyn1 = tvsyn1 = tvnsyn1 = 0.;
  switch(nc){
     case 1:  if( cdn[c1[0]][c1[1]][c1[2]] == cdn[c2[0]][c2[1]][c2[2]] ) {
                    syn1 += 1.;
                    if( tsv[cp[0]] == 0 ) tssyn1 += 1.;
                    if( tsv[cp[0]] == 1 ) tvsyn1 += 1.;
              }
              else {
                    nsyn1 += 1.;
                    if( tsv[cp[0]] == 0 ) tsnsyn1 += 1.;
                    if( tsv[cp[0]] == 1 ) tvnsyn1 += 1.;
	      }
              break;       
     case 2:  syn1=nsyn1=0.;
              np=0;
              switch(cp[0]+cp[1]){
               case 1:
       		 /*  1 - 2 */
		 if( cdn[c2[0]][c1[1]][c1[2]] != TER ) {
                       if( cdn[c1[0]][c1[1]][c1[2]] == cdn[c2[0]][c1[1]][c2[2]] ) {
                       syn1 += 1.;
                       if( tr[c1[0]][c2[0]] == 0 ) tssyn1 += 1.;
                       if( tr[c1[0]][c2[0]] == 1 ) tvsyn1 += 1.;
		       }
                       else {
                       nsyn1 += 1.;
                       if( tr[c1[0]][c2[0]] == 0 ) tsnsyn1 += 1.;
                       if( tr[c1[0]][c2[0]] == 1 ) tvnsyn1 += 1.;
		       }
                       if( cdn[c2[0]][c1[1]][c1[2]] == cdn[c2[0]][c2[1]][c1[2]] ) {
                       syn1 += 1.;  
                       if( tr[c1[1]][c2[1]] == 0 ) tssyn1 += 1.;
                       if( tr[c1[1]][c2[1]] == 1 ) tvsyn1 += 1.;
		       }
                       else {
                          nsyn1 += 1.;
                          if( tr[c1[1]][c2[1]] == 0 ) tsnsyn1 += 1.;
                          if( tr[c1[1]][c2[1]] == 1 ) tvnsyn1 += 1.;
		       }
                       np++;
		       }
       		 /*  2 - 1 */
		 if( cdn[c1[0]][c2[1]][c1[2]] != TER ){
                       if( cdn[c1[0]][c1[1]][c1[2]] == cdn[c1[0]][c2[1]][c1[2]] ) {
                          syn1 += 1.;
                          if( tr[c1[1]][c2[1]] == 0 ) tssyn1 += 1.;
                          if( tr[c1[1]][c2[1]] == 1 ) tvsyn1 += 1.;
		       }
                       else {
                          nsyn1 += 1.;
                          if( tr[c1[1]][c2[1]] == 0 ) tsnsyn1 += 1.;
                          if( tr[c1[1]][c2[1]] == 1 ) tvnsyn1 += 1.;
		       }
                       if( cdn[c1[0]][c2[1]][c1[2]] == cdn[c2[0]][c2[1]][c1[2]] ){
                           syn1 += 1.;  
                           if( tr[c1[0]][c2[0]] == 0 ) tssyn1 += 1.;
                           if( tr[c1[0]][c2[0]] == 1 ) tvsyn1 += 1.;
		       }
                       else {
                           nsyn1 += 1.;
                           if( tr[c1[0]][c2[0]] == 0 ) tsnsyn1 += 1.;
                           if( tr[c1[0]][c2[0]] == 1 ) tvnsyn1 += 1.;
		       }
                       np++;
		 }
                       syn1 /= np; nsyn1 /= np;
                       tssyn1 /= np; tvsyn1 /= np; tsnsyn1 /= np; tsnsyn1 /= np;
 
                       break;       
               case 2:
		 /* 1 - 3 */
		 if( cdn[c2[0]][c1[1]][c1[2]] != TER ){
                       if( cdn[c1[0]][c1[1]][c1[2]] == cdn[c2[0]][c1[1]][c1[2]] ) {
                         if( tr[c1[0]][c2[0]] == 0 ) tssyn1 += 1.;
                         if( tr[c1[0]][c2[0]] == 1 ) tvsyn1 += 1.;
                         syn1 += 1.;
		       }
                       else {
                          if( tr[c1[0]][c2[0]] == 0 ) tsnsyn1 += 1.;
                          if( tr[c1[0]][c2[0]] == 1 ) tvnsyn1 += 1.;
                          nsyn1 += 1.;
		       }
                       if( cdn[c2[0]][c1[1]][c1[2]] == cdn[c2[0]][c1[1]][c2[2]] ) {
                         syn1 += 1.;  
                         if( tr[c1[2]][c2[2]] == 0 ) tssyn1 += 1.;
                         if( tr[c1[2]][c2[2]] == 1 ) tvsyn1 += 1.;
		       }
                       else {
                         nsyn1 += 1.;
                         if( tr[c1[2]][c2[2]] == 0 ) tsnsyn1 += 1.;
                         if( tr[c1[2]][c2[2]] == 1 ) tvnsyn1 += 1.;
		       }
                       np++;
		 }
		 /* 3 - 1 */
		 if( cdn[c1[0]][c1[1]][c2[2]] != TER ){
                       if( cdn[c1[0]][c1[1]][c1[2]] == cdn[c1[0]][c1[1]][c2[2]] ) {
                           syn1 += 1.;
                           if( tr[c1[2]][c2[2]] == 0 ) tssyn1 += 1.;
                           if( tr[c1[2]][c2[2]] == 1 ) tvsyn1 += 1.;
		       }
                       else {
                           nsyn1 += 1.;
                           if( tr[c1[2]][c2[2]] == 0 ) tsnsyn1 += 1.;
                           if( tr[c1[2]][c2[2]] == 1 ) tvnsyn1 += 1.;
		       }
                       if( cdn[c1[0]][c1[1]][c2[2]] == cdn[c2[0]][c1[1]][c2[2]] ) {
                           syn1 += 1.;  
                           if( tr[c1[0]][c2[0]] == 0 ) tssyn1 += 1.;
                           if( tr[c1[0]][c2[0]] == 1 ) tvsyn1 += 1.;
		       }
                       else {
                           nsyn1 += 1.;
                           if( tr[c1[0]][c2[0]] == 0 ) tsnsyn1 += 1.;
                           if( tr[c1[0]][c2[0]] == 1 ) tvnsyn1 += 1.;
		       }
                       np++;
		 }
                       syn1 /= np; nsyn1 /= np;
                       tssyn1 /= np; tvsyn1 /= np;
                       tsnsyn1 /= np; tvnsyn1 /= np;
                       break;       

                 
               case 3:
                 /* 2 - 3 */
		 if( cdn[c1[0]][c2[1]][c1[2]] != TER ){
                       if( cdn[c1[0]][c1[1]][c1[2]] == cdn[c1[0]][c2[1]][c1[2]] ) {
                       syn1 += 1.;
                       if( tr[c1[1]][c2[1]] == 0 ) tssyn1 += 1.;
                       if( tr[c1[1]][c2[1]] == 1 ) tvsyn1 += 1.;
		       }
                       else {
                         nsyn1 += 1.;
                         if( tr[c1[1]][c2[1]] == 0 ) tsnsyn1 += 1.;
                         if( tr[c1[1]][c2[1]] == 1 ) tvnsyn1 += 1.;
		       }
                       if( cdn[c1[0]][c2[1]][c1[2]] == cdn[c1[0]][c2[1]][c2[2]] ) {
                         syn1 += 1.;  
                         if( tr[c1[2]][c2[2]] == 0 ) tssyn1 += 1.;
                         if( tr[c1[2]][c2[2]] == 1 ) tvsyn1 += 1.;
		       }
                       else {
                         nsyn1 += 1.;
                         if( tr[c1[2]][c2[2]] == 0 ) tsnsyn1 += 1.;
                         if( tr[c1[2]][c2[2]] == 1 ) tvnsyn1 += 1.;
		       }
                       np++;
		 }
                 /* 3 - 2 */
		 if( cdn[c1[0]][c1[1]][c2[2]] != TER ){
                       if( cdn[c1[0]][c1[1]][c1[2]] == cdn[c1[0]][c1[1]][c2[2]] ) {
                        syn1 += 1.;
                        if( tr[c1[2]][c2[2]] == 0 ) tssyn1 += 1.;
                        if( tr[c1[2]][c2[2]] == 1 ) tvsyn1 += 1.;
		       }
                       else {
                        nsyn1 += 1.;
                        if( tr[c1[2]][c2[2]] == 0 ) tsnsyn1 += 1.;
                        if( tr[c1[2]][c2[2]] == 1 ) tvnsyn1 += 1.;
		       }
                       if( cdn[c1[0]][c1[1]][c2[2]] == cdn[c1[0]][c2[1]][c2[2]] ) {
                         syn1 += 1.;  
                         if( tr[c1[1]][c2[1]] == 0 ) tssyn1 += 1.;
                         if( tr[c1[1]][c2[1]] == 1 ) tvsyn1 += 1.;
			 }
                       else {
                         nsyn1 += 1.;
                         if( tr[c1[1]][c2[1]] == 0 ) tsnsyn1 += 1.;
                         if( tr[c1[1]][c2[1]] == 1 ) tvnsyn1 += 1.;
		       }
                       np++;
		 }
                       syn1 /= np; nsyn1 /= np;
                       tssyn1 /= np; tvsyn1 /= np;
                       tsnsyn1 /= np; tvnsyn1 /= np;
                       break;       
	      default: printf("invalid number cp %d %d\n",cp[0],cp[1]);

		 }
       
              break;
	      
  case 3:
               np=0;              
               syn1=nsyn1=0.;
	       /* 1 - 2 - 3 */

               if( cdn[c2[0]][c1[1]][c1[2]] != TER && cdn[c2[0]][c2[1]][c1[2]] != TER){
               if( cdn[c1[0]][c1[1]][c1[2]] == cdn[c2[0]][c1[1]][c1[2]] ){
                      syn1 += 1.;
                      if( tr[c1[0]][c2[0]] == 0 ) tssyn1 += 1.;
                      if( tr[c1[0]][c2[0]] == 1 ) tvsyn1 += 1.;
	       }
               else {
                      nsyn1 += 1.;
                      if( tr[c1[0]][c2[0]] == 0 ) tsnsyn1 += 1.;
                      if( tr[c1[0]][c2[0]] == 1 ) tvnsyn1 += 1.;
	       }
               if( cdn[c2[0]][c1[1]][c1[2]] == cdn[c2[0]][c2[1]][c1[2]] ) {
                      syn1 += 1.;
                      if( tr[c1[1]][c2[1]] == 0 ) tssyn1 += 1.;
                      if( tr[c1[1]][c2[1]] == 1 ) tvsyn1 += 1.;
	       }
               else {
                     nsyn1 += 1.;
                     if( tr[c1[1]][c2[1]] == 0 ) tsnsyn1 += 1.;
                     if( tr[c1[1]][c2[1]] == 1 ) tvnsyn1 += 1.;
	       }
               if( cdn[c2[0]][c2[1]][c1[2]] == cdn[c2[0]][c2[1]][c2[2]] ){
                     syn1 += 1.;
                     if( tr[c1[2]][c2[2]] == 0 ) tssyn1 += 1.;
                     if( tr[c1[2]][c2[2]] == 1 ) tvsyn1 += 1.;
	       }
               else {
                     nsyn1 += 1.;
                     if( tr[c1[2]][c2[2]] == 0 ) tsnsyn1 += 1.;
                     if( tr[c1[2]][c2[2]] == 1 ) tvnsyn1 += 1.;
	       }
                   np++;
	       }
	       /* 1 - 3 - 2 */
               if( cdn[c2[0]][c1[1]][c1[2]] != TER && cdn[c2[0]][c1[1]][c2[2]] != TER){
               if( cdn[c1[0]][c1[1]][c1[2]] == cdn[c2[0]][c1[1]][c1[2]] ){
                    syn1 += 1.;
                    if( tr[c1[0]][c2[0]] == 0 ) tssyn1 += 1.;
                    if( tr[c1[0]][c2[0]] == 1 ) tvsyn1 += 1.;
	       }
                else {
                    nsyn1 += 1.;
                    if( tr[c1[0]][c2[0]] == 0 ) tsnsyn1 += 1.;
                    if( tr[c1[0]][c2[0]] == 1 ) tvnsyn1 += 1.;
		}
               if( cdn[c2[0]][c1[1]][c1[2]] == cdn[c2[0]][c1[1]][c2[2]] ) {
                    syn1 += 1.;
                    if( tr[c1[2]][c2[2]] == 0 ) tssyn1 += 1.;
                    if( tr[c1[2]][c2[2]] == 1 ) tvsyn1 += 1.;
               }
               else {
                    nsyn1 += 1.;
                    if( tr[c1[2]][c2[2]] == 0 ) tsnsyn1 += 1.;
                    if( tr[c1[2]][c2[2]] == 1 ) tvnsyn1 += 1.;
	       }
               if( cdn[c2[0]][c1[1]][c2[2]] == cdn[c2[0]][c2[1]][c2[2]] ) {
                    syn1 += 1.; 
                    if( tr[c1[1]][c2[1]] == 0 ) tssyn1 += 1.;
                    if( tr[c1[1]][c2[1]] == 1 ) tvsyn1 += 1.;
	       }
               else {
                    nsyn1 += 1.;
                    if( tr[c1[1]][c2[1]] == 0 ) tsnsyn1 += 1.;
                    if( tr[c1[1]][c2[1]] == 1 ) tvnsyn1 += 1.;
	       }
                  np++;
	       }
	       /* 2 - 1 - 3 */
               if( cdn[c1[0]][c2[1]][c1[2]] != TER && cdn[c2[0]][c2[1]][c1[2]] != TER){
               if( cdn[c1[0]][c1[1]][c1[2]] == cdn[c1[0]][c2[1]][c1[2]] ) {
                    syn1 += 1.;
                    if( tr[c1[1]][c2[1]] == 0 ) tssyn1 += 1.;
                    if( tr[c1[1]][c2[1]] == 1 ) tvsyn1 += 1.;
	       }
               else {
                    nsyn1 += 1.;
                    if( tr[c1[1]][c2[1]] == 0 ) tsnsyn1 += 1.;
                    if( tr[c1[1]][c2[1]] == 1 ) tvnsyn1 += 1.;
	       }
               if( cdn[c1[0]][c2[1]][c1[2]] == cdn[c2[0]][c2[1]][c1[2]] ) {
                    syn1 += 1.; 
                    if( tr[c1[0]][c2[0]] == 0 ) tssyn1 += 1.;
                    if( tr[c1[0]][c2[0]] == 1 ) tvsyn1 += 1.;
	       }
               else {
                    nsyn1 += 1.;
                    if( tr[c1[0]][c2[0]] == 0 ) tsnsyn1 += 1.;
                    if( tr[c1[0]][c2[0]] == 1 ) tvnsyn1 += 1.;
	       }
               if( cdn[c2[0]][c2[1]][c1[2]] == cdn[c2[0]][c2[1]][c2[2]] ) {
                    syn1 += 1.;
                    if( tr[c1[2]][c2[2]] == 0 ) tssyn1 += 1.;
                    if( tr[c1[2]][c2[2]] == 1 ) tvsyn1 += 1.;
	       }
               else {
                    nsyn1 += 1.;
                    if( tr[c1[2]][c2[2]] == 0 ) tsnsyn1 += 1.;
                    if( tr[c1[2]][c2[2]] == 1 ) tvnsyn1 += 1.;
	       }
                  np++;
	       }
	       /* 2 - 3 - 1 */
               if( cdn[c1[0]][c2[1]][c1[2]] != TER && cdn[c1[0]][c2[1]][c2[2]] != TER){
               if( cdn[c1[0]][c1[1]][c1[2]] == cdn[c2[0]][c1[1]][c1[2]] ) {
                   syn1 += 1.;
                   if( tr[c1[1]][c2[1]] == 0 ) tssyn1 += 1.;
                   if( tr[c1[1]][c2[1]] == 1 ) tvsyn1 += 1.;
                } else {
                   nsyn1 += 1.;
                   if( tr[c1[1]][c2[1]] == 0 ) tsnsyn1 += 1.;
                   if( tr[c1[1]][c2[1]] == 1 ) tvnsyn1 += 1.;
		}
               if( cdn[c1[0]][c2[1]][c1[2]] == cdn[c1[0]][c2[1]][c2[2]] ) {
                   syn1 += 1.;
                   if( tr[c1[2]][c2[2]] == 0 ) tssyn1 += 1.;
                   if( tr[c1[2]][c2[2]] == 1 ) tvsyn1 += 1.;
               } else {
                   nsyn1 += 1.;
                   if( tr[c1[2]][c2[2]] == 0 ) tsnsyn1 += 1.;
                   if( tr[c1[2]][c2[2]] == 1 ) tvnsyn1 += 1.;
	       }
               if( cdn[c1[0]][c2[1]][c2[2]] == cdn[c2[0]][c2[1]][c2[2]] ) {
                   syn1 += 1.;
                   if( tr[c1[0]][c2[0]] == 0 ) tssyn1 += 1.;
                   if( tr[c1[0]][c2[0]] == 1 ) tvsyn1 += 1.;
               } else {
                   nsyn1 += 1.;
                   if( tr[c1[0]][c2[0]] == 0 ) tsnsyn1 += 1.;
                   if( tr[c1[0]][c2[0]] == 1 ) tvnsyn1 += 1.;
	       }
                  np++;
	       }
	       /* 3 - 1 - 2 */
               if( cdn[c1[0]][c1[1]][c2[2]] != TER && cdn[c2[0]][c1[1]][c2[2]] != TER){
               if( cdn[c1[0]][c1[1]][c1[2]] == cdn[c1[0]][c1[1]][c2[2]] ) {
                  syn1 += 1.;
                  if( tr[c1[2]][c2[2]] == 0 ) tssyn1 += 1.;
                  if( tr[c1[2]][c2[2]] == 1 ) tvsyn1 += 1.;
               } else {
                  nsyn1 += 1.;
                  if( tr[c1[2]][c2[2]] == 0 ) tsnsyn1 += 1.;
                  if( tr[c1[2]][c2[2]] == 1 ) tvnsyn1 += 1.;
	       }
               if( cdn[c1[0]][c1[1]][c2[2]] == cdn[c2[0]][c1[1]][c2[2]] ) {
                  syn1 += 1.;
                  if( tr[c1[0]][c2[0]] == 0 ) tssyn1 += 1.;
                  if( tr[c1[0]][c2[0]] == 1 ) tvsyn1 += 1.;
               } else {
                  nsyn1 += 1.;
                  if( tr[c1[0]][c2[0]] == 0 ) tsnsyn1 += 1.;
                  if( tr[c1[0]][c2[0]] == 1 ) tvnsyn1 += 1.;
	       }
               if( cdn[c2[0]][c1[1]][c2[2]] == cdn[c2[0]][c2[1]][c2[2]] ) {
                  syn1 += 1.;
                  if( tr[c1[1]][c2[1]] == 0 ) tssyn1 += 1.;
                  if( tr[c1[1]][c2[1]] == 1 ) tvsyn1 += 1.;
                } else {
                  nsyn1 += 1.;
                  if( tr[c1[1]][c2[1]] == 0 ) tsnsyn1 += 1.;
                  if( tr[c1[1]][c2[1]] == 1 ) tvnsyn1 += 1.;
		}
                  np++;
	       }
	       /* 3 - 2 - 1 */
               if( cdn[c1[0]][c1[1]][c2[2]] != TER && cdn[c1[0]][c2[1]][c2[2]] != TER){
               if( cdn[c1[0]][c1[1]][c1[2]] == cdn[c1[0]][c1[1]][c2[2]] ) {
                   syn1 += 1.;
                   if( tr[c1[2]][c2[2]] == 0 ) tssyn1 += 1.;
                   if( tr[c1[2]][c2[2]] == 1 ) tvsyn1 += 1.;
               } else {
                   nsyn1 += 1.;
                   if( tr[c1[2]][c2[2]] == 0 ) tsnsyn1 += 1.;
                   if( tr[c1[2]][c2[2]] == 1 ) tvnsyn1 += 1.;
	       }
               if( cdn[c1[0]][c1[1]][c2[2]] == cdn[c2[0]][c2[1]][c1[2]] ) {
                   syn1 += 1.;
                   if( tr[c1[1]][c2[1]] == 0 ) tssyn1 += 1.;
                   if( tr[c1[1]][c2[1]] == 1 ) tvsyn1 += 1.;
                } else {
                   nsyn1 += 1.;
                   if( tr[c1[1]][c2[1]] == 0 ) tsnsyn1 += 1.;
                   if( tr[c1[1]][c2[1]] == 1 ) tvnsyn1 += 1.;
		}
               if( cdn[c2[0]][c2[1]][c1[2]] == cdn[c2[0]][c2[1]][c2[2]] ) {
                   syn1 += 1.;
                   if( tr[c1[0]][c2[0]] == 0 ) tssyn1 += 1.;
                   if( tr[c1[0]][c2[0]] == 1 ) tvsyn1 += 1.;
                } else {
                   nsyn1 += 1.;
                   if( tr[c1[0]][c2[0]] == 0 ) tsnsyn1 += 1.;
                   if( tr[c1[0]][c2[0]] == 1 ) tvnsyn1 += 1.;
		}
                np++;
	       }
                  syn1 /= np;
                  nsyn1 /= np;
                  tssyn1 /= np; tvsyn1 /= np;
                  tsnsyn1 /= np; tvnsyn1 /= np;
  }

  /*  printf("%d nc=%d %c%c%c %c%c%c np=%d\n",i,nc,base[c1[0]],base[c1[1]],base[c1[2]], 
base[c2[0]],base[c2[1]],base[c2[2]],np);*/

   *syn += syn1; *tssyn += tssyn1; *tvsyn += tvsyn1;
   *nsyn += nsyn1; *tsnsyn += tsnsyn1; *tvnsyn += tvnsyn1;

return(0);
}
  

double getvar(nasite,rsite,a,nseq1,nseq2,cdn,cdnn,syn,nsyn,ps,pn,dop,synsite,synchg,nsynchg,tssyn,tsnsyn,tvsyn,tvnsyn)
int nasite,*rsite,nseq1,nseq2,cdn[4][4][4],cdnn[4][4][4],dop;
char **a;
double syn,nsyn,ps,pn,***synsite,**synchg,**nsynchg,tssyn,tsnsyn,tvsyn,tvnsyn;
{
int i,j,k,n1[3],n2[3],nc1,nc2,nc3,np1,np2,np3,m1,m2;
double dsyn,dsyn1,ssite1,nsite1,ssite2,nsite2,syn1,nsyn1,var,sw,tvsyn1,tvnsyn1;

/*printf("syn=%f nsyn=%f ps=%f pn=%f\n",syn,nsyn,ps,pn);*/

var = 0.;
  switch(dop){
    case 15: 
    case 17:   if( syn <= 0.+ACU ) return(0.); 
               break;
    case 16:
    case 18:   if( nsyn <= 0.+ACU ) return(0.);
               break;
    case 19: 
    case 21:   if( tvsyn <= 0.+ACU ) return(0.);
               break;
    case 20:
    case 22:   if( tvnsyn <= 0.+ACU ) return(0.);
               break;
  }


for(i=0; i<nasite; i++){
  for(j=0; j<3 ; j++) {
       n1[j] = a[rsite[i]*3+j][nseq1];
       n2[j] = a[rsite[i]*3+j][nseq2];
}
  ssite1 = synsite[n1[0]][n1[1]][n1[2]];
  ssite2 = synsite[n2[0]][n2[1]][n2[2]];
  nsite1 = 3. - ssite1;
  nsite2 = 3. - ssite2;
  m1 = cdnn[n1[0]][n1[1]][n1[2]];
  m2 = cdnn[n2[0]][n2[1]][n2[2]];
  if( dop >= 15 && dop <= 18 ){
    if( m1 < m2 ){
      syn1 = synchg[m1][m2];
      nsyn1 = synchg[m2][m1];
    }
    if( m1 > m2 ){
      syn1 = synchg[m2][m1];
      nsyn1 = synchg[m1][m2];
    }
  }
  if( dop >= 19 && dop <= 22 ){
    if( m1 < m2 ){
      tvsyn1 = synchg[m2][m1];
      tvnsyn1 = nsynchg[m2][m1];
    }
    if( m1 > m2 ){
      tvsyn1 = synchg[m1][m2];
      tvnsyn1 = nsynchg[m1][m2];
    }
  }
  switch(dop){
    case 15: 
    case 17: 
               sw = (ssite1+ssite2)/2.;
               var += (syn1 - ps*sw)*(syn1 - ps*sw);
	       /*          printf("syn1=%f ps=%f sw=%f\n",syn1,ps,sw);*/
               break;
    case 16:
    case 18:   sw = (nsite1+nsite2)/2.;
      /*   printf("nsyn1=%f pn=%f sw=%f %f\n",syn1,pn,sw,(nsyn1 - pn*sw)*(nsyn1 - pn*sw));*/
               var += (nsyn1 - pn*sw)*(nsyn1 - pn*sw);
               break;
    case 19: 
    case 21: 
               sw = (ssite1+ssite2)/2.;
               var += (tvsyn1 - tvsyn*sw)*(tvsyn1 - tvsyn*sw);
	       /*          printf("syn1=%f ps=%f sw=%f\n",syn1,ps,sw);*/
               break;
    case 20:
    case 22:   sw = (nsite1+nsite2)/2.;
      /*   printf("nsyn1=%f pn=%f sw=%f %f\n",syn1,pn,sw,(tvnsyn1 - pn*sw)*(tvnsyn1 - pn*sw));*/
               var += (tvnsyn1 - tvnsyn*sw)*(tvnsyn1 - tvnsyn*sw);
               break;

  }

}
switch(dop){
   case 15:  var /= syn*syn;
             break;
   case 16:  /*printf("var=%f nsyn=%f\n",var,nsyn);*/
             var /= nsyn*nsyn;
             break;
   case 17:  var /= syn*syn*(1. - 4.*ps/3.)*(1. - 4.*ps/3.);
             break;
   case 18:  var /= nsyn*nsyn*(1. - 4.*pn/3.)*(1. - 4.*pn/3.);
             break;
   case 19:  var /= syn*syn;
             break;
   case 20:  /*printf("var=%f nsyn=%f\n",var,nsyn);*/
             var /= nsyn*nsyn;
             break;
   case 21:  var /= syn*syn*(1. - tvsyn*2.)*(1. - tvsyn*2.);
             break;
   case 22:  var /= nsyn*nsyn*(1. - tvnsyn*2.)*(1. - tvnsyn*2.);
             break;
}
 return(var);
}



double getcov(nasite,rsite,a,nseq1,nseq2,nseq3,nseq4,cdn,cdnn,ps1,pn1,ps2,pn2,ssite1,ssite2,nssite1,nssite2,dop,synsite,synchg,nsynchg,pstv1,pntv1,pstv2,pntv2)
int nasite,*rsite,nseq1,nseq2,nseq3,nseq4,cdn[4][4][4],cdnn[4][4][4],dop;
char **a;
double ssite1,ssite2,nssite1,nssite2,ps1,pn1,ps2,pn2,***synsite,**synchg,**nsynchg;
double pstv1,pntv1,pstv2,pntv2;
{
int i,j,k,n1[3],n2[3],n3[3],n4[3],nc1,nc2,nc3,np1,np2,np3,m1,m2,m3,m4;
double dsyn,dsyn1,syn1,nsyn1,syn2,nsyn2,sw1,sw2,dcov,tvsyn1,tvnsyn1,tvsyn2,tvnsyn2;
double  ss1,ns1,ss2,ns2,ss3,ns3,ss4,ns4;
dcov = 0.;
/* printf("nseq %d %d %d %d\n",nseq1,nseq2,nseq3,nseq4);*/
for(i=0; i<nasite; i++){
  for(j=0; j<3 ; j++) {
       n1[j] = a[rsite[i]*3+j][nseq1];
       n2[j] = a[rsite[i]*3+j][nseq2];
       n3[j] = a[rsite[i]*3+j][nseq3];
       n4[j] = a[rsite[i]*3+j][nseq4];
  }
  ss1 = synsite[n1[0]][n1[1]][n1[2]];
  ss2 = synsite[n2[0]][n2[1]][n2[2]];
  ss3 = synsite[n3[0]][n3[1]][n3[2]];
  ss4 = synsite[n4[0]][n4[1]][n4[2]];
  ns1 = 3. - ss1;
  ns2 = 3. - ss2;
  ns3 = 3. - ss3;
  ns4 = 3. - ss4;
  m1 = cdnn[n1[0]][n1[1]][n1[2]];
  m2 = cdnn[n2[0]][n2[1]][n2[2]];
  m3 = cdnn[n3[0]][n3[1]][n3[2]];
  m4 = cdnn[n4[0]][n4[1]][n4[2]];
  if( dop >= 15 && dop <= 18 ){
    if( m1 < m2 ){
      syn1 = synchg[m1][m2];
      nsyn1 = synchg[m2][m1];
    }
    if( m2 < m1 ){
      syn1 = synchg[m2][m1];
      nsyn1 = synchg[m1][m2];
    }
    if( m3 < m4 ){
      syn2 = synchg[m3][m4];
      nsyn2 = synchg[m4][m3];
    }
    if( m4 < m3 ){
      syn2 = synchg[m4][m3];
      nsyn2 = synchg[m3][m4];
    }
   }
  if( dop >= 19 && dop <= 22 ){
    if( m1 < m2 ){
      tvsyn1 = synchg[m2][m1];
      tvnsyn1 = nsynchg[m2][m1];
    }
    if( m2 < m1 ){
      tvsyn1 = synchg[m1][m2];
      tvnsyn1 = nsynchg[m1][m2];
    }
    if( m3 < m4 ){
      tvsyn2 = synchg[m4][m3];
      tvnsyn2 = nsynchg[m4][m3];
    }
    if( m4 < m3 ){
      tvsyn2 = synchg[m3][m4];
      tvnsyn2 = nsynchg[m3][m4];
    }
   }

  switch(dop){
    case 15: 
    case 17: 
               sw1 = (ss1+ss2)/2.;
               sw2 = (ss3+ss4)/2.;
               dcov += (syn1 - ps1*sw1)*(syn2 - ps2*sw2);
               break;
    case 16:
    case 18:   sw1 = (ns1+ns2)/2.;
               sw2 = (ns3+ns4)/2.;
               dcov += (nsyn1 - pn1*sw1)*(nsyn2 - pn2*sw2);
               break;
    case 19: 
    case 21: 
               sw1 = (ss1+ss2)/2.;
               sw2 = (ss3+ss4)/2.;
               dcov += (tvsyn1 - pstv1*sw1)*(tvsyn2 - pstv2*sw2);
               break;
    case 20:
    case 22:   sw1 = (ns1+ns2)/2.;
               sw2 = (ns3+ns4)/2.;
               dcov += (tvnsyn1 - pntv1*sw1)*(tvnsyn2 - pntv2*sw2);
               break;

  }

}

switch(dop){
   case 15:  dcov /= ssite1*ssite2;
             break;
   case 16:  dcov /= nssite1*nssite2;
             break;
   case 17:  dcov /= ssite1*ssite2*(1. - 4.*ps1/3.)*(1. - 4.*ps2/3.);
             break;
   case 18:  dcov /= nssite1*nssite2*(1. - 4.*pn1/3.)*(1. - 4.*pn1/3.);
             break;
   case 19:  dcov /= ssite1*ssite2;
             break;
   case 20:  dcov /= nssite1*nssite2;
             break;
   case 21:  dcov /= ssite1*ssite2*(1. - pstv1*2.)*(1. - pstv2*2.);
             break;
   case 22:  dcov /= nssite1*nssite2*(1. - pntv1*2.)*(1. - pntv2*2.);
             break;
}
/* printf("getcov %d %d %d %d ss ns %f %f  %f %f %f %f  %f %f syn nsyn %f %f  %f %f dcov=%f ssite1=%f ssite2=%f\n",nseq1,nseq2,nseq3,nseq4,ss1,ns1,ss2,ns2,ss3,ns3,ss4,ns4,syn1,nsyn1,syn2,nsyn2,dcov,ssite1,ssite2);*/

 return(dcov);
}


getssite1(n,ssite,nsite,cdn)
int n[3],cdn[4][4][4];
double *ssite,*nsite;
{
int i,j,nc1,nc2,nc3,np1,np2,np3;
    
  *ssite = *nsite = 0.;
    nc1=nc2=nc3=0;
    np1=np2=np3=0;
    for(j=0; j<4 ; j++){
      if( j == n[0] ) continue;
      if( cdn[j][n[1]][n[2]] == TER ) continue;
      np1++;
      if( cdn[j][n[1]][n[2]] == cdn[n[0]][n[1]][n[2]] ) nc1++;
    }
    for(j=0; j<4 ; j++){
      if( j == n[1] ) continue;
      if( cdn[n[0]][j][n[2]] == TER ) continue;
      np2++;
      if( cdn[n[0]][j][n[2]] == cdn[n[0]][n[1]][n[2]] ) nc2++;
    }
    for(j=0; j<4 ; j++){
      if( j == n[2] ) continue;
      if( cdn[n[0]][n[1]][j] == TER ) continue;
      np3++;
      if( cdn[n[0]][n[1]][j] == cdn[n[0]][n[1]][n[2]] ) nc3++;
    }
    *ssite = (double)nc1/(double)np1 + (double)nc2/(double)np2 + (double)nc3/(double)np3;
    /*    printf("%c%c%c  dsyn1=%f nc %d %d %d np %d %d %d\n",base[n[0]],base[n[1]],base[n[2]],dsyn1,nc1,nc2,nc3,np1,np2,np3);*/
    *nsite = 3. - *ssite;
    return(0);
}




getsync1(c1,c2,cdn,syn,nsyn)
int c1[3],c2[3],cdn[4][4][4];
double *syn,*nsyn;
{
int i,j,nc,cp[3],np;
double syn1,nsyn1;
*syn=*nsyn=0.;
np=0;

  nc=0;
  for(j=0; j<3 ; j++){
    if( c1[j] != c2[j] ) {
      cp[nc]=j;
      nc++;
    }
  }
  
   nsyn1 = syn1 = 0.;
  switch(nc){
     case 1:  if( cdn[c1[0]][c1[1]][c1[2]] == cdn[c2[0]][c2[1]][c2[2]] ) syn1 += 1.;
              else nsyn1 += 1.;
              break;       
     case 2:  syn1=nsyn1=0.;
              np=0;
              switch(cp[0]+cp[1]){
               case 1:
       		 /*  1 - 2 */
		 if( cdn[c2[0]][c1[1]][c1[2]] != TER ) {
                       if( cdn[c1[0]][c1[1]][c1[2]] == cdn[c2[0]][c1[1]][c2[2]] ) syn1 += 1.;
                       else nsyn1 += 1.;
                       if( cdn[c2[0]][c1[1]][c1[2]] == cdn[c2[0]][c2[1]][c1[2]] ) syn1 += 1.;  
                       else nsyn1 += 1.;
                       np++;
		 }
       		 /*  2 - 1 */
		 if( cdn[c1[0]][c2[1]][c1[2]] != TER ){
                       if( cdn[c1[0]][c1[1]][c1[2]] == cdn[c1[0]][c2[1]][c1[2]] ) syn1 += 1.;
                       else nsyn1 += 1.;
                       if( cdn[c1[0]][c2[1]][c1[2]] == cdn[c2[0]][c2[1]][c1[2]] ) syn1 += 1.;  
                       else nsyn1 += 1.;
                       np++;
		 }
                       syn1 /= np; nsyn1 /= np;

                       break;       
               case 2:
		 /* 1 - 3 */
		 if( cdn[c2[0]][c1[1]][c1[2]] != TER ){
                       if( cdn[c1[0]][c1[1]][c1[2]] == cdn[c2[0]][c1[1]][c1[2]] ) syn1 += 1.;
                       else nsyn1 += 1.;
                       if( cdn[c2[0]][c1[1]][c1[2]] == cdn[c2[0]][c1[1]][c2[2]] ) syn1 += 1.;  
                       else nsyn1 += 1.;
                       np++;
		 }
		 /* 3 - 1 */
		 if( cdn[c1[0]][c1[1]][c2[2]] != TER ){
                       if( cdn[c1[0]][c1[1]][c1[2]] == cdn[c1[0]][c1[1]][c2[2]] ) syn1 += 1.;
                       else nsyn1 += 1.;
                       if( cdn[c1[0]][c1[1]][c2[2]] == cdn[c2[0]][c1[1]][c2[2]] ) syn1 += 1.;  
                       else nsyn1 += 1.;
                       np++;
		 }
                       syn1 /= np; nsyn1 /= np;
                       break;       

                 
               case 3:
                 /* 2 - 3 */
		 if( cdn[c1[0]][c2[1]][c1[2]] != TER ){
                       if( cdn[c1[0]][c1[1]][c1[2]] == cdn[c1[0]][c2[1]][c1[2]] ) syn1 += 1.;
                       else nsyn1 += 1.;
                       if( cdn[c1[0]][c2[1]][c1[2]] == cdn[c1[0]][c2[1]][c2[2]] ) syn1 += 1.;  
                       else nsyn1 += 1.;
                       np++;
		 }
                 /* 3 - 2 */
		 if( cdn[c1[0]][c1[1]][c2[2]] != TER ){
                       if( cdn[c1[0]][c1[1]][c1[2]] == cdn[c1[0]][c1[1]][c2[2]] ) syn1 += 1.;
                       else nsyn1 += 1.;
                       if( cdn[c1[0]][c1[1]][c2[2]] == cdn[c1[0]][c2[1]][c2[2]] ) syn1 += 1.;  
                       else nsyn1 += 1.;
                       np++;
		 }
                       syn1 /= np; nsyn1 /= np;

                       break;       
	      default: printf("invalid number cp %d %d\n",cp[0],cp[1]);

	      }
       
              break;
  case 3:
               np=0;              
               syn1=nsyn1=0.;
	       /* 1 - 2 - 3 */

               if( cdn[c2[0]][c1[1]][c1[2]] != TER && cdn[c2[0]][c2[1]][c1[2]] != TER){
               if( cdn[c1[0]][c1[1]][c1[2]] == cdn[c2[0]][c1[1]][c1[2]] ) syn1 += 1.; else nsyn1 += 1.;
               if( cdn[c2[0]][c1[1]][c1[2]] == cdn[c2[0]][c2[1]][c1[2]] ) syn1 += 1.; else nsyn1 += 1.;
               if( cdn[c2[0]][c2[1]][c1[2]] == cdn[c2[0]][c2[1]][c2[2]] ) syn1 += 1.; else nsyn1 += 1.;
                   np++;
	       }
	       /* 1 - 3 - 2 */
               if( cdn[c2[0]][c1[1]][c1[2]] != TER && cdn[c2[0]][c1[1]][c2[2]] != TER){
               if( cdn[c1[0]][c1[1]][c1[2]] == cdn[c2[0]][c1[1]][c1[2]] ) syn1 += 1.; else nsyn1 += 1.;
               if( cdn[c2[0]][c1[1]][c1[2]] == cdn[c2[0]][c1[1]][c2[2]] ) syn1 += 1.; else nsyn1 += 1.;
               if( cdn[c2[0]][c1[1]][c2[2]] == cdn[c2[0]][c2[1]][c2[2]] ) syn1 += 1.; else nsyn1 += 1.;
                  np++;
	       }
	       /* 2 - 1 - 3 */
               if( cdn[c1[0]][c2[1]][c1[2]] != TER && cdn[c2[0]][c2[1]][c1[2]] != TER){
               if( cdn[c1[0]][c1[1]][c1[2]] == cdn[c1[0]][c2[1]][c1[2]] ) syn1 += 1.; else nsyn1 += 1.;
               if( cdn[c1[0]][c2[1]][c1[2]] == cdn[c2[0]][c2[1]][c1[2]] ) syn1 += 1.; else nsyn1 += 1.;
               if( cdn[c2[0]][c2[1]][c1[2]] == cdn[c2[0]][c2[1]][c2[2]] ) syn1 += 1.; else nsyn1 += 1.;
                  np++;
	       }
	       /* 2 - 3 - 1 */
               if( cdn[c1[0]][c2[1]][c1[2]] != TER && cdn[c1[0]][c2[1]][c2[2]] != TER){
               if( cdn[c1[0]][c1[1]][c1[2]] == cdn[c2[0]][c1[1]][c1[2]] ) syn1 += 1.; else nsyn1 += 1.;
               if( cdn[c1[0]][c2[1]][c1[2]] == cdn[c1[0]][c2[1]][c2[2]] ) syn1 += 1.; else nsyn1 += 1.;
               if( cdn[c1[0]][c2[1]][c2[2]] == cdn[c2[0]][c2[1]][c2[2]] ) syn1 += 1.; else nsyn1 += 1.;
                  np++;
	       }
	       /* 3 - 1 - 2 */
               if( cdn[c1[0]][c1[1]][c2[2]] != TER && cdn[c2[0]][c1[1]][c2[2]] != TER){
               if( cdn[c1[0]][c1[1]][c1[2]] == cdn[c1[0]][c1[1]][c2[2]] ) syn1 += 1.; else nsyn1 += 1.;
               if( cdn[c1[0]][c1[1]][c2[2]] == cdn[c2[0]][c1[1]][c2[2]] ) syn1 += 1.; else nsyn1 += 1.;
               if( cdn[c2[0]][c1[1]][c2[2]] == cdn[c2[0]][c2[1]][c2[2]] ) syn1 += 1.; else nsyn1 += 1.;
                  np++;
	       }
	       /* 3 - 2 - 1 */
               if( cdn[c1[0]][c1[1]][c2[2]] != TER && cdn[c1[0]][c2[1]][c2[2]] != TER){
               if( cdn[c1[0]][c1[1]][c1[2]] == cdn[c1[0]][c1[1]][c2[2]] ) syn1 += 1.; else nsyn1 += 1.;
               if( cdn[c1[0]][c1[1]][c2[2]] == cdn[c2[0]][c2[1]][c1[2]] ) syn1 += 1.; else nsyn1 += 1.;
               if( cdn[c2[0]][c2[1]][c1[2]] == cdn[c2[0]][c2[1]][c2[2]] ) syn1 += 1.; else nsyn1 += 1.;
                np++;
	       }
                  syn1 /= np;
                  nsyn1 /= np;
  }
   *syn = syn1;
   *nsyn = nsyn1;

return(0);
  }

distv(nasite,npsite,asite,nd1,a,s1,s2,dop,dist,np,nts,ntv,nts1,nts2,gamma,db0,asite0,nbal,cdn,fl,maxnm,pflg)
int s1,s2,dop,nasite,npsite,*asite,*np,*nts,*ntv,*nts1,*nts2,nd1,*asite0,pflg;
int **nbal/*[MAXOTU][4]*/,maxnm;
char **a/*[MAXSITE][MAXOTU]*/,**fl;
double **dist/*[MAXOTU][MAXOTU]*/,gamma,*db0;
{
int k,l,np1,ns1,nv1,i1,j1,cnch[4][4],b1,b2,nt,ns2,nid,na;
double sp,dp,dq,da,db,dsq,dc,g[4],dw;
double c1,c2,c3,c4,c5,ga,gt,gg,gc,gr,gy,dp1,dp2,dw1,dw2,dw3;

/*         printf("distv s1=%d s2=%d nd1=%d dop=%d",s1,s2,nd1,dop);         */
/*         if( dflg == 1 ) printf("dop=%d\n",dop);*/
         switch(dop){
            case 0:   np1=0;
                      for(k=0; k<npsite ; k++){
                        switch(tr[a[asite[k]][s1]][a[asite[k]][s2]]){
	         		case -1: /* no difference */
                                           break;
			        default:   np1++;
                                           break;
				       }
		      }
                      sp = np1;
                      sp /= nasite;
                      dist[s1][s2]=sp;
                      dist[s2][s1] = sp*(1.0-sp);
                      dist[s2][s1] /= nasite;
                      (*np) = np1;
                      return(0);

            case 1: /* JC */
                    np1=0;
                      for(k=0; k<npsite ; k++){
                        switch(tr[a[asite[k]][s1]][a[asite[k]][s2]]){
	         		case -1: /* no difference */
                                           break;
			        default:   np1++;
                                           break;
				       }
		      }
                      sp = np1;
                      sp /= nasite;
                      if( 1.0-sp*4.0/3.0  <= 0.0 ) return(-1);
                      dist[s1][s2] = -0.75*log(1.0-sp*4.0/3.0);
                      dist[s2][s1] = sp*(1.0-sp)/(1.0-sp/0.75)/(1.0-sp/0.75);
                      dist[s2][s1] /= nasite;
                      (*np) = np1;
                      return(0);
            case 8: /* Tajima Nei */
                    np1=0;
                    for(k=0; k<4 ; k++){
                        for(l=0; l<4 ; l++){
                          cnch[k][l]=0;
			}
		      }
                      for(k=0; k<nasite ; k++){
                        b1 = a[asite0[k]][s1];
                        b2 = a[asite0[k]][s2];
                        cnch[b1][b2]++; 
                        switch(tr[b1][b2]){
        			case -1: break;
        			default: np1++;
                                         break;
				}
		      }
                      dp = np1;
                      dp /= nasite;
                      if( np1 == 0){
                          printf("distance 0  seq %d %d\n",s1+1,s2+1);
                          exit(1);
                      }
                      nt=0;
                      for(i1=0; i1<4 ; i1++) g[i1]=0.0;
                      for(i1=0; i1<4 ; i1++){
                        for(j1=0; j1<4 ; j1++){
                            g[i1] += cnch[i1][j1];
                            g[j1] += cnch[i1][j1];
                            nt += 2*cnch[i1][j1];
			  }
		      }
                      for(i1=0; i1<4 ; i1++)   g[i1] /= nt;
                      dc = 0.0;
                      for(i1=0; i1<3 ; i1++){
                       for(j1=i1+1 ; j1<4 ; j1++){
                          dw = cnch[i1][j1] + cnch[j1][i1];
                          dw /= nasite;
                          dc += dw*dw/(2.0*g[i1]*g[j1]);
			}
		     } 
                      db = (1.0 + dp*dp/dc - g[0]*g[0] - g[1]*g[1] - g[2]*g[2]- g[3]*g[3])/2.0;
                     if( 1.0 - dp/db <= 0.0 ) return(-1);
                     dist[s1][s2] = -db*log(1.0 - dp/db);
                     dist[s2][s1] = db*db*dp*(1.0-dp)/((db-dp)*(db-dp));
                     dist[s2][s1] /= nasite;
                      (*np) = np1;
                      (*db0) = db;
                      return(0);
            case 5: /* JC  gamma*/
                    np1=0;
                      for(k=0; k<npsite ; k++){
                        switch(tr[a[asite[k]][s1]][a[asite[k]][s2]]){
	         		case -1: /* no difference */
                                           break;
			        default:   np1++;
                                           break;
				       }
		      }
                      sp = np1;
                      sp /= nasite;
                      if( 1.0-sp*4.0/3.0  <= 0.0 ) return(-1);
                      dist[s1][s2] = 0.75*gamma*pow(1.0-sp/0.75,-1.0/gamma);
                      dist[s2][s1] = sp*(1.0-sp)*pow(1.0-sp/0.75, -2.0*(1.0/gamma+1.0));
                      dist[s2][s1] /= nasite;
                      (*np) = np1;
                      return(0);
	    case 2 :  /*k2p */
                       ns1=0;
                       nv1=0;
                       for(k=0; k<npsite ; k++){
                          switch(tr[a[asite[k]][s1]][a[asite[k]][s2]]){
	         		case -1: /* no difference */
                                           break;
				case 0 : ns1++;
                                         break;
			        case 1 : nv1++;
                                         break;
			        default:   printf("invalid code s1 =%d s2=%d %c %02x %c %02x\n",s1,s2,a[asite[k]][s1],a[asite[k]][s2]);
                                           exit(1);
				       }
	                }
                      if( dflg == 1 ) printf("ns1=%d nv1=%d\n",ns1,nv1);
                      dp = ns1;
         	      dq = nv1;
                      dp /= nasite;
                      dq /= nasite;
                      if( nasite - 2*nv1 <= 0 ) return(-1);
                      if( nasite -2*ns1 -nv1 <= 0 ) return(-1);

                      dsq = sqrt(1.0- 2.0*dq);
                      dist[s1][s2] = -0.5*log((1.0-2.0*dp-dq)*dsq);
                      da = 1.0/(1.0-2.0*dp-dq);
                      db = 0.5*(da + 1.0/(1.0-2.0*dq));
                      dist[s2][s1] = (da*da*dp+db*db*dq-(da*dp+db*dq)*(da*dp+db*dq));
                      dist[s2][s1] /= nasite;
/*                      printf("cov =%e\n",cov[nd1][nd1]); */
                      (*np) = ns1+nv1;
                      (*nts) = ns1;
                      (*ntv) = nv1;
                      return(0);

	    case 6 :  /*k2p */
                       ns1=0;
                       nv1=0;
                       for(k=0; k<npsite ; k++){
                          switch(tr[a[asite[k]][s1]][a[asite[k]][s2]]){
	         		case -1: /* no difference */
                                           break;
				case 0 : ns1++;
                                         break;
			        case 1 : nv1++;
                                         break;
			        default:   printf("invalid code s1 =%d s2=%d %c %02x %c %02x\n",s1,s2,a[asite[k]][s1],a[asite[k]][s2]);
                                           exit(1);
				       }
	                }
                      if( dflg == 1 ) printf("ns1=%d nv1=%d\n",ns1,nv1);
                      dp = ns1;
         	      dq = nv1;
                      dp /= nasite;
                      dq /= nasite;
                      if( nasite - 2*nv1 <= 0 ) return(-1);
                      if( nasite -2*ns1 -nv1 <= 0 ) return(-1);

                      dsq = sqrt(1.0- 2.0*dq);
                      dist[s1][s2] = 0.5*gamma*(pow(1.0-2.0*dp-dq,-1.0/gamma)+0.5*pow(1.0-2.0*dq,-1.0/gamma) -1.5);
                      da = pow(1.0-2.0*dp-dq,-(1.0/gamma+1.0));
                      db = 0.5*(pow(1.0-2.0*dp-dq,-(1.0/gamma+1.0)) + pow(1.0-2.0*dq,-(1.0/gamma+1.0)));
                      dist[s2][s1] = (da*da*dp+db*db*dq-(da*dp+db*dq)*(da*dp+db*dq));
                      dist[s2][s1] /= nasite;
/*                      printf("cov =%e\n",cov[nd1][nd1]); */
                      (*np) = ns1+nv1;
                      (*nts) = ns1;
                      (*ntv) = nv1;
                      return(0);
	    case 9 :  /*k2p transversion */
                       ns1=0;
                       nv1=0;
                       for(k=0; k<npsite ; k++){
                          switch(tr[a[asite[k]][s1]][a[asite[k]][s2]]){
	         		case -1: /* no difference */
                                           break;
				case 0 : ns1++;
                                         break;
			        case 1 : nv1++;
                                         break;
			        default:   printf("invalid code s1 =%d s2=%d %c %02x %c %02x\n",s1,s2,a[asite[k]][s1],a[asite[k]][s2]);
                                           exit(1);
				       }
	                }
                      if( dflg == 1 ) printf("ns1=%d nv1=%d\n",ns1,nv1);
                      dp = ns1;
         	      dq = nv1;
                      dp /= nasite;
                      dq /= nasite;
                      if( nasite - 2*nv1 <= 0 ) return(-1);
                      dist[s1][s2] = -0.5*log(1.0-2.0*dq);
                      dist[s2][s1] = dq*(1.0-dq)/((1.0-2.0*dq)*(1.0-2.0*dq));
                      dist[s2][s1] /= nasite;
/*                      printf("cov =%e\n",cov[nd1][nd1]); */
                      (*np) = ns1+nv1;
                      (*nts) = ns1;
                      (*ntv) = nv1;
                      return(0);

	    case 10 :  /*k2p transversion gamma*/
                       ns1=0;
                       nv1=0;
                       for(k=0; k<npsite ; k++){
                          switch(tr[a[asite[k]][s1]][a[asite[k]][s2]]){
	         		case -1: /* no difference */
                                           break;
				case 0 : ns1++;
                                         break;
			        case 1 : nv1++;
                                         break;
			        default:   printf("invalid code s1 =%d s2=%d %c %02x %c %02x\n",s1,s2,a[asite[k]][s1],a[asite[k]][s2]);
                                           exit(1);
				       }
	                }
                      if( dflg == 1 ) printf("ns1=%d nv1=%d\n",ns1,nv1);
                      dp = ns1;
         	      dq = nv1;
                      dp /= nasite;
                      dq /= nasite;
                      if( nasite - 2*nv1 <= 0 ) return(-1);
                      dist[s1][s2] = pow(1.0-2.0*dq,-1.0/gamma)-1.0;
                      dist[s1][s2] *= 0.5*gamma;
                      c5 = pow(1.0-2.0*dq,-(1.0+1.0/gamma));
                      dist[s2][s1] = c5*c5*dq*(1.0-dq);
                      dist[s2][s1] /= nasite;
/*                      printf("cov =%e\n",cov[nd1][nd1]); */
                      (*np) = ns1+nv1;
                      (*nts) = ns1;
                      (*ntv) = nv1;
                      return(0);
	    case 11 :  /*Hasegawa transversion*/
            case 12 :  /*Hasegawa transversion gamma*/
            case 13 :  /* Tamura Nei*/
            case 14 :  /* Tamura Nei gamma*/
                         ns1=ns2=nv1=0;
                         nid=0;
                         for(k=0; k<npsite ; k++){
                           b1= a[asite[k]][s1];
                           b2= a[asite[k]][s2];
                           if( b1 >= 4 ) continue;
                           if( b2 >= 4 ) continue;
                           switch(tr1[b1][b2]){
         	            case 0:   nid++;
                                      break;
                 	    case 1:   ns1++;
                                      break;
                  	    case 2:   ns2++;
                                      break;
                 	    case 3:   nv1++;
                                      break;
			    }

         	       }
/*                       printf("dop=%d ns1=%d ns2=%d nv1=%d nid=%d\n",dop,ns1,ns2,nv1,nid); */
                       if( nid+ns1+ns2+nv1 == 0 ) return(-10);
                       (*np) = ns1+ns2+nv1;
                       (*nts) = ns1+ns2;
                       (*ntv) = nv1;
                       (*nts1) = ns1;
                       (*nts2) = ns2;
                        nt = nasite;
                        if ( nt != nbal[s1][0]+nbal[s1][1]+nbal[s1][2]+nbal[s1][3] ){
                        printf("inconsistent number of nucleotides\n");
                        printf("i=%d  nasite=%d   %d %d %d %d\n",s1,nasite,nbal[s1][0],nbal[s1][1],nbal[s1][2],nbal[s1][3]);
                        exit(1);
		      }
                      if ( nt != nbal[s2][0]+nbal[s2][1]+nbal[s2][2]+nbal[s2][3] ){
                        printf("inconsistent number of nucleotides\n");
                        printf("j=%d  nasite=%d   %d %d %d %d\n",s2,nasite,nbal[s2][0],nbal[s2][1],nbal[s2][2],nbal[s2][3]);
                        exit(1);
	              }
	    
                     na = nt*2;
                     ga = nbal[s1][2]+nbal[s2][2];
                     gt = nbal[s1][0]+nbal[s2][0];
                     gg = nbal[s1][3]+nbal[s2][3];
                     gc = nbal[s1][1]+nbal[s2][1];
                     ga /= na;
                     gt /= na;
                     gg /= na;
                     gc /= na;
                     gr = ga + gg;
                     gy = gt + gc;
                     dp1 = ns1;
                     dp2 = ns2;
                     dq  = nv1;
                     dp1 /= nt;
                     dp2 /= nt;
                     dq  /= nt;
                     /*        printf("g %f %f %f %f  %f %f\n",ga,gt,gg,gc,gr,gy); */
                     /*        printf("%d %d  %d %d %d  %f %f %f %f %f\n",i,j,nts1,nts2,ntv,ga,gg,gt,gc,ga+gg+gt+gc); */
                    if( ns1+ns2+nv1 == 0 ) {
                     dist[s1][s2]=0.0;
                     dist[s2][s1]=0.0;
                     return(0);
                    }



                    dw1 = 1.0 - gr*dp1/(2.0*ga*gg) - dq/(2.0*gr);
                    dw2 = 1.0 - gy*dp2/(2.0*gt*gc) - dq/(2.0*gy);
                    dw3 = 1.0 - dq/(2.0*gr*gy);
/*                    printf("dw %f %f %f\n",dw1,dw2,dw3); */
/*                         printf("a t g c %f %f %f %f dw %f %f %f\n",ga,gt,gg,gc,dw1,dw2,dw3);  */
                  if( dop == 13 || dop == 14 ) if( 1.0 - gr*dp1/(2.0*ga*gg) - dq/(2.0*gr) <= 0.0 ) return(-1);
                  if( dop == 13 || dop == 14 ) if( 1.0 - gy*dp2/(2.0*gt*gc) - dq/(2.0*gy) <=0.0 ) return(-1);
                  if( 1.0- dq/(2.0*gr*gy) <= 0.0 ) return(-1);
                  switch(dop){
                     case 13: dist[s1][s2]= ga*gg/(gr)*log(dw1) + gt*gc/(gy)*log(dw2) + (gr*gy-ga*gg*gy/gr - gt*gc*gr/gy)*log(dw3);
                              dist[s1][s2] *= -2.0;
                              c1 = 2.0*ga*gg*gr/(2.0*ga*gg*gr-gr*gr*dp1-ga*gg*dq);
                              c2 = 2.0*gt*gc*gy/(2.0*gt*gc*gy-gy*gy*dp2-gt*gc*dq);
                              c3 = c1*ga*gg/(gr*gr) + c2*gt*gc/(gy*gy)
                                  +(1.0- ga*ga/(gr*gr) - gt*gc/(gy*gy))/dw3;
                             dist[s2][s1] = (c1*c1*dp1+c2*c2*dp2+c3*c3*dq)-(c1*dp1+c2*dp2+c3*dq)*(c1*dp1+c2*dp2+c3*dq);
                             dist[s2][s1] /= nt;
/*                   printf("i=%d j=%d  %f %f ns1=%d ns2=%d nv1=%d\n",s1,s2,dist[s1][s2],sqrt(cov[nd1][nd1]),ns1,ns2,nv1);  */

                              break;
                    case 14:  dist[s1][s2] = ga*gg/(gr)*pow(dw1,-1.0/gamma)+gt*gc/gy*pow(dw2,-1.0/gamma)+(gr*gy-ga*gg*gy/gr-gt*gc*gr/gy)*pow(dw3,-1.0/gamma) -ga*gg-gt*gc-gr*gy;
                              dist[s1][s2] *= 2.0*gamma;
                              c1 = pow(1.0-gr*dp1/(2.0*ga*gg) - dq/(2.0*gr),-(1.0+1.0/gamma));
                              c2 = pow(1.0-gy*dp2/(2.0*gt*gc) - dq/(2.0*gy),-(1.0+1.0/gamma));
                              c3 = c1*ga*gg/gr/gr+c2*gt*gc/gy/gy + ((ga*ga+gg*gg)/(2.0*gr*gr)+(gt*gt+gc*gc)/(2.0*gy*gy))*pow(dw3,-(1.0+1.0/gamma));
                              dist[s2][s1] = (c1*c1*dp1+c2*c2*dp2+c3*c3*dq)-(c1*dp1+c2*dp2+c3*dq)*(c1*dp1+c2*dp2+c3*dq);
                              dist[s2][s1] /= nt;
 /*                   printf("i=%d j=%d  %f %f %f\n",i,j,dist[i][j],dist[j][i],sqrt(dist[j][i])); */
                              break;

           case 11:  dist[s1][s2] = -2.0*gr*gy*log(dw3);
                     c5 = 1.0/(dw3);
                     dist[s2][s1] = c5*c5*dq*(1.0-dq);
                     dist[s2][s1] /= nt;
                     break;
           case 12:  dist[s1][s2] = pow(dw3,-1.0/gamma)-1.0;
                     dist[s1][s2] *= 2.0*gamma*gr*gy;
                     c5 = pow(dw3,-(1.0+1.0/gamma));
                     dist[s2][s1] = c5*c5*dq*(1.0-dq);
                     dist[s2][s1] /= nt;
                    break;
                   

		     }



                      return(0);

	    }





	    
    }



calcovsyn(a,nseq0,nsite,nasite,asite,dop,dist,asite0,cdn,cdnn,synsite,synchg,nsynchg,fl,maxnm,pflg)
char **a/*[MAXSITE][MAXOTU]*/,**fl;
int nseq0,nsite,nasite,*asite,dop,*asite0,cdn[4][4][4],cdnn[4][4][4],maxnm,pflg;
double **dist/*[MAXOTU][MAXOTU]*/,***synsite,**synchg,**nsynchg;
{
int i,j,k,l,npb,np1,np2,np3,ns1,ns2,ns21,ns22,nv1,nv2,nd1,nd2,n,nts1,nts2;
int n1,n2,n3,n4,rn,nbx[4],nby[4],na,ndist,nad;
double sp,dp,dq,dsp,da,db1,db2,dw,db,ssite1,ssite2,nssite1,nssite2,syn1,nsyn1,syn2,nsyn2;
double ps1,ps2,pn1,pn2,ssite3,ssite4,nssite3,nssite4,tssyn1,tsnsyn1,tvsyn1,tvnsyn1,tssyn2,tsnsyn2,tvsyn2,tvnsyn2;
double pstv1,pntv1,pstv2,pntv2;
int *ppsite/*[MAXSITE]*/,*pqsite/*[MAXSITE]*/,nppsite,npqsite,*p2site/*[MAXSITE]*/,np2site;
float fw,*fwp;
extern int *ivector();
extern double getcov(),getnsite();
   nd1=0;
   n=0;
   ndist = nseq0*(nseq0-1)/2;
   /*     printf("calcovsyn\n"); fflush(stdout);*/
     rn=calsyn(nseq,a,fl,nasite,asite0,dist,dop,cdn,cdnn,synsite,synchg,nsynchg,pflg,maxnm);
     /*     printf("calsyn ended rn=%d\n",rn); fflush(stdout);*/
     if( rn != 0 ){     
        for(i=0; i<nseq ; i++){
           for(j=i+1; j<nseq ; j++){
             if(  dist[i][j] <= INAP + ACU && dist[i][j] >= INAP - ACU ){
                printf("%d %s %d %s inapplicable\n",i+1,fl[i],j+1,fl[j]);
	     }
	   }
	}
       exit(1);
     }

     /*
        for(i=0; i<nseq ; i++){
           for(j=0; j<nseq ; j++){
                if( i == j) dist[j][i]=0.;
                printf(" %f",dist[i][j]);
	     }
           printf("\n");
	}
	*/
    
     nd1=0;
     n=0;
     for(i=0; i<nseq0; i++){
       for(j=i+1; j<nseq0 ; j++){
        ssite1=getnsite(nasite,asite0,a,i,cdn,cdnn,synsite);
        ssite2=getnsite(nasite,asite0,a,j,cdn,cdnn,synsite);
        nssite1 = (double)(3*nasite)-ssite1;
        nssite2 = (double)(3*nasite)-ssite2;
        if( dop >= 15 && dop <= 18 ) getsync(nasite,asite0,a,i,j,cdn,cdnn,&syn1,&nsyn1,&tssyn1,&tsnsyn1,&tvsyn1,&tvnsyn1,synchg);
        if( dop >= 19 && dop <= 22 ) getsync(nasite,asite0,a,i,j,cdn,cdnn,&syn1,&nsyn1,&tssyn1,&tsnsyn1,&tvsyn1,&tvnsyn1,synchg);
	/*        printf("i=%d j=%d ssite %f %f syn1 %f %f\n",i,j,ssite1,ssite2,syn1,nsyn1);fflush(stdout);        */
        ps1 = 2.*syn1/(ssite1 + ssite2);
        pn1 = 2.*nsyn1/(nssite1 + nssite2);
        pstv1 = 2.*tvsyn1/(ssite1 + ssite2);
        pntv1 = 2.*tvnsyn1/(nssite1 + nssite2);
        k=i;
        nd2=nd1;
        for(l=j+1; l<nseq0 ; l++){
         n++;
         nd2++;
         nad = covad(nd1,nd2,ndist);
         ssite3=getnsite(nasite,asite0,a,k,cdn,cdnn,synsite);
         ssite4=getnsite(nasite,asite0,a,l,cdn,cdnn,synsite);
         nssite3 = (double)(3*nasite)-ssite3;
         nssite4 = (double)(3*nasite)-ssite4;
         getsync(nasite,asite0,a,k,l,cdn,cdnn,&syn2,&nsyn2,&tssyn2,&tsnsyn2,&tvsyn2,&tvnsyn2,synchg);
	 /*        printf("k=%d l=%d ssite %f %f syn1 %f %f\n",k,l,ssite3,ssite4,syn2,nsyn2);fflush(stdout);        */
         ps2 = 2.*syn2/(ssite3 + ssite4);
         pn2 = 2.*nsyn2/(nssite3 + nssite4);
         pstv2 = 2.*tvsyn2/(ssite3 + ssite4);
         pntv2 = 2.*tvnsyn2/(nssite3 + nssite4);
	 /*         printf("%d %d %d %d ssite %f %f %f %f nssite %f %f %f %f\n",i,j,k,l,ssite1,ssite2,ssite3,ssite4,nssite1,nssite2,nssite3,nssite4);*/
         dw = getcov(nasite,asite0,a,i,j,k,l,cdn,cdnn,ps1,pn1,ps2,pn2,(ssite1+ssite2)/2.,(ssite3+ssite4)/2.,(nssite1+nssite2)/2.,(nssite3+nssite4)/2.,dop,synsite,synchg,nsynchg,pstv1,pntv1,pstv2,pntv2);
          if( covflg == 0 ) cov[nad] = dw;
             else if( write(fpcov,&dw,sizeof(double)) == -1 ){
                     printf("write error\n");
                     exit(1);
                   }

          
	 /*                printf("%d %d %d %d cov[%d]=%f\n",i,j,k,l,nad,cov[nad]);*/
	}
      
     for(k=i+1; k<nseq0 ; k++){
       for(l=k+1; l<nseq0 ; l++){
        nd2++;
        n++;
             nad = covad(nd1,nd2,ndist);
             ssite3=getnsite(nasite,asite0,a,k,cdn,cdnn,synsite);
             ssite4=getnsite(nasite,asite0,a,l,cdn,cdnn,synsite);
             nssite3 = (double)(3*nasite)-ssite3;
             nssite4 = (double)(3*nasite)-ssite4;
             getsync(nasite,asite0,a,k,l,cdn,cdnn,&syn2,&nsyn2,&tssyn2,&tsnsyn2,&tvsyn2,&tvnsyn2,synchg);
             ps2 = 2.*syn2/(ssite3 + ssite4);
             pn2 = 2.*nsyn2/(nssite3 + nssite4);
             pstv2 = 2.*tvsyn2/(ssite3 + ssite4);
             pntv2 = 2.*tvnsyn2/(nssite3 + nssite4);
             dw = getcov(nasite,asite0,a,i,j,k,l,cdn,cdnn,ps1,pn1,ps2,pn2,(ssite1+ssite2)/2.,(ssite3+ssite4)/2.,(nssite1+nssite2)/2.,(nssite3+nssite4)/2.,dop,synsite,synchg,nsynchg,pstv1,pntv1,pstv2,pntv2);
             if( covflg == 0 ) cov[nad] = dw;
             else if( write(fpcov,&dw,sizeof(double)) == -1 ){
                     printf("write error\n");
                     exit(1);
                   }
	     /*    	     printf(" %d %d %d %d   cov[%d]=%e\n",i,j,k,l,nad,cov[nad]);*/
       }
     }
     nd1++;
       }
     }
   if( n != nseq0*(nseq-1)/2*(nseq0*(nseq-1)/2-1)/2 ){
     /*     printf("calcovo n=%d nseq0*(nseq-1)/2*(nseq0*(nseq-1)/2-1)/2=%d\n",n,nseq0*(nseq-1)/2*(nseq0*(nseq-1)/2-1)/2);*/
     exit(1);
   }
    return(0);

}























codonset(dop,ntable,cdn,cdnn,synsite,synchg,nsynchg)
int dop,ntable;
int cdn[4][4][4],cdnn[4][4][4];
double ***synsite,**synchg,**nsynchg;
{
char amino[64],start[64],base1[64],base2[64],base3[64];
int i,j,k,n1[3],n2[3];
double ssite1,nsite1,syn1,nsyn1;
double tssyn1,tsnsyn1,tvsyn1,tvnsyn1;

static char amn1[21]={'A','C','D','E','F','G','H','I','K','L','M','N','P','Q',
                     'R','S','T','V','W','Y','*'};

     switch(ntable){
      case 1: for(i=0; i<64 ; i++){
                 amino[i] = AAst1[i];
                 start[i] = Startst1[i];
                 base1[i] = Base1t1[i];
                 base2[i] = Base2t1[i];
                 base3[i] = Base3t1[i];
              }
              break;
      case 2: for(i=0; i<64 ; i++){
                 amino[i] = AAst2[i];
                 start[i] = Startst2[i];
                 base1[i] = Base1t2[i];
                 base2[i] = Base2t2[i];
                 base3[i] = Base3t2[i];
              }
              break;
      case 3: for(i=0; i<64 ; i++){
                 amino[i] = AAst3[i];
                 start[i] = Startst3[i];
                 base1[i] = Base1t3[i];
                 base2[i] = Base2t3[i];
                 base3[i] = Base3t3[i];
              }
              break;
      case 4: for(i=0; i<64 ; i++){
                 amino[i] = AAst4[i];
                 start[i] = Startst4[i];
                 base1[i] = Base1t4[i];
                 base2[i] = Base2t4[i];
                 base3[i] = Base3t4[i];
              }
              break;
      case 5: for(i=0; i<64 ; i++){
                 amino[i] = AAst5[i];
                 start[i] = Startst5[i];
                 base1[i] = Base1t5[i];
                 base2[i] = Base2t5[i];
                 base3[i] = Base3t5[i];
              }
              break;
      case 6: for(i=0; i<64 ; i++){
                 amino[i] = AAst6[i];
                 start[i] = Startst6[i];
                 base1[i] = Base1t6[i];
                 base2[i] = Base2t6[i];
                 base3[i] = Base3t6[i];
              }
              break;

      case 9: for(i=0; i<64 ; i++){
                 amino[i] = AAst9[i];

                 start[i] = Startst9[i];
                 base1[i] = Base1t9[i];
                 base2[i] = Base2t9[i];
                 base3[i] = Base3t9[i];
              }
              break;
      case 10: for(i=0; i<64 ; i++){
                 amino[i] = AAst10[i];
                 start[i] = Startst10[i];
                 base1[i] = Base1t10[i];
                 base2[i] = Base2t10[i];
                 base3[i] = Base3t10[i];
              }
              break;

      case 11: for(i=0; i<64 ; i++){
                 amino[i] = AAst11[i];
                 start[i] = Startst11[i];
                 base1[i] = Base1t11[i];
                 base2[i] = Base2t11[i];
                 base3[i] = Base3t11[i];
              }
              break;

      case 12: for(i=0; i<64 ; i++){
                 amino[i] = AAst12[i];
                 start[i] = Startst12[i];
                 base1[i] = Base1t12[i];
                 base2[i] = Base2t12[i];
                 base3[i] = Base3t12[i];
              }
              break;
      case 13: for(i=0; i<64 ; i++){
                 amino[i] = AAst13[i];
                 start[i] = Startst13[i];
                 base1[i] = Base1t13[i];
                 base2[i] = Base2t13[i];
                 base3[i] = Base3t13[i];
   }
              break;
     default: printf("invalid table number %d\n");
              exit(1);

     }

     for(i=0; i<64 ; i++){
       for(j=0; j<4 ; j++){
         if( base1[i] == base[j] ){
             base1[i] = j;
             break;
	 }
       }
       for(j=0; j<4 ; j++){
         if( base2[i] == base[j] ){
             base2[i] = j;
             break;
	 }
       }
       for(j=0; j<4 ; j++){
         if( base3[i] == base[j] ){
             base3[i] = j;
             break;
	 }
       }
       for(j=0; j<21 ; j++){
         if( amino[i] == amn1[j] ) {
            amino[i] = j;
            break;
	 }
       }
       /*      printf("i=%d %d %d %d %d\n",i,base1[i],base2[i],base3[i],amino[i]);*/
     }
    
     for(i=0; i<64 ; i++){
       /*      printf("i=%d\n",i); fflush(stdout);*/
      cdn[base1[i]][base2[i]][base3[i]] = amino[i];
      cdnn[base1[i]][base2[i]][base3[i]] = i;
     }
     for(i=0; i<64 ; i++){
      n1[0] = base1[i];
      n1[1] = base2[i];
      n1[2] = base3[i];
      getssite1(n1,&ssite1,&nsite1,cdn);
      synsite[n1[0]][n1[1]][n1[2]]=ssite1;
      /*      printf("ssite %d=%f\n",i,ssite1);*/
      synchg[i][i] = 0.;
      for(j=i+1 ; j<64 ; j++){
        n2[0] = base1[j];
        n2[1] = base2[j];
        n2[2] = base3[j];
        if( dop >= 15 && dop <= 18 ){
         getsync1(n1,n2,cdn,&syn1,&nsyn1);
         synchg[i][j] = syn1;
         synchg[j][i] = nsyn1;
	}
        if( dop >= 19 && dop <= 22 ){
         getsynctsv1(n1,n2,cdn,&syn1,&nsyn1,&tssyn1,&tsnsyn1,&tvsyn1,&tvnsyn1);
         synchg[i][j] = tssyn1;
         synchg[j][i] = tvsyn1;
         nsynchg[i][j] = tsnsyn1;
         nsynchg[j][i] = tvnsyn1;
	}
        
      }
      
     }
     
     /*
     for(i=0; i<4 ; i++){
       for(j=0; j<4 ; j++){
	 for(k=0; k<4 ; k++){
           printf("cdn[%d][%d][%d]=%d ter=%d\n",i,j,k,cdn[i][j][k],TER);
	 }
       }
     }
     */

     /*    printf("codonset\n"); fflush(stdout);             */
   return(0);
}









   




























































main(argc,argv)
int argc;
char **argv;
{
FILE *fpi,*fpo=stdout,*fpt;
float fw;
Nds *nda/*[2*MAXOTU-2]*/,*cur,*anc;
int i,j,k,l,nsite,npsite,nasite,seed,rn,tief,ifc,itc;
int dop=0,outgroup=0,iw,cdnpos,nw;
int *outg/*[MAXOTU]*/,noutg=1,nseqw,ioutc;
double *blen/*[2*MAXOTU-2]*/;
double **dist/*[MAXOTU][MAXOTU]*/,delq,gamma,dw;
char **a/*[MAXSITE][MAXOTU]*/;
char **fl/*[MAXOTU][MAXNM]*/,fcn[50],fcng[50];
char cw,cw1;
int sc,nln,*asite/*[MAXSITE]*/,*asite0/*[MAXSITE]*/,**ndif/*[MAXOTU][MAXOTU]*/,**ndif1/*[MAXOTU][MAXOTU]*/;
int cdn[4][4][4],cdnn[4][4][4],ntsite,*tsite,ntable,pflg;
double ***synsite/*[4][4][4]*/,**synchg/*[64][64]*/,**nsynchg/*[64][64]*/;
extern double calq();
extern float ttest();
extern int *ivector(), **imatrix();
extern char **cmatrix();
extern unsigned char **ucmatrix();
extern double *dvector(),*dvectorc(),**dmatrix(), ***d3matrix(), ******d6matrix();
extern Nds **Ndsptrvector(),*Ndsvector();
extern float ttest();

covflg=0;
ntable=1; 
pflg=0;
dflg=0;dflg1=0;
ifc = 0;
itc = 0;
ioutc=0;
cdnpos=-1;
gamma = 1.0;
for(i=0; i<50 ; i++){
  fcn[i]=fcng[i]=0;
}
/* seed = getseed(); */
        if( argc == 1 ){
            fprintf(fpo,"tpcv  inputfile -t[treefile] -o [outgroup1 outgroup2 ... ] -d[distance] -c[codon position] -g[gamma a  value] -p[pflg]\n");
            fprintf(fpo,"distance option\n");
            for(i=0; i<NDIST ; i++) fprintf(fpo,"%d %s\n",i,dname[i]);
            exit(0);
	  }
        for(i=1; i<argc; i++){
           if(argv[i][0] == '-' ){
              switch(argv[i][1]){
        	   case 'o': 
                             noutg=0; ioutc=i;
                             if( argv[i][2] <= '9' && argv[i][2] >= '0' ){
                                 noutg++;
                             }                                 
                             for(j=i+1 ; j<argc ; j++){
                              if( argv[j][0] > '9' || argv[j][0] < '0' ) break;
 /*                             sscanf(argv[j],"%d",&outg[noutg]); */
                                noutg++;
                                i++;
			    }
                            if( noutg == 0 ){
                                 printf("no outgroup");
                                 exit(1);
			       }
                         
                             break;
                   case 's' : sscanf(argv[i]+2,"%d",&seed);
                              break;
                   case 'c' : sscanf(argv[i]+2,"%d",&cdnpos);
                              break;
                   case 'd' : sscanf(argv[i]+2,"%d",&dop);
                              break;
                   case 'g' : sscanf(argv[i]+2,"%f",&fw);
                              gamma=fw;
                              break;
                   case 'b' : sscanf(argv[i]+2,"%d",&dflg);
                              break;
                   case 'p' : pflg=1;
                              break;
                   case 't' : if( (fpt = fopen(argv[i]+2,"r")) == NULL ){
                                 printf("Can't open treefile %s\n",argv[i]+2);
                                 exit(1);
			       }
                              itc=i;
                              break;
        
		   }
               }else{
                         if((fpi = fopen(argv[i],"r")) == NULL ){
                                 printf("Can't open file %s\n",argv[i]);
                                 exit(1);
                               }
                         strcpy(fcn,argv[i]);
                         strcpy(fcng,argv[i]);
                         strcat(fcn,".cn");
                         strcat(fcng,".cng");
                         ifc=i;
		       }


         }
    if( ifc == 0 ){
       printf("input file is not specified\n");
       exit(1);
    }
    if( itc == 0 ){
       printf("topology file is not specified\n");
       exit(1);
    }
    if( ioutc == 0 ){
       printf("outgroup is not specified\n");
       exit(1);
    }
   if( dop >=  NDIST ) {
       printf("invalid distance option %d\n",dop);
       exit(1);
     }
   nseq=0;
   nsite=0;
/*   printf("before checkfl\n"); fflush(stdout); */
  checkfl(fpi,&nseq,&nsite,&maxnm);
  /*   printf("after checkfl nseq = %d nsite =%d maxnm=%d\n",nseq,nsite,maxnm); fflush(stdout);*/
  fclose(fpi);

 outg =  ivector(noutg);
 blen = dvector(2*nseq-2);
 dist = dmatrix(nseq,nseq);
 a  = cmatrix(nsite,nseq);
 fl = cmatrix(nseq,maxnm+1);
 for(i=0; i<nseq ; i++){
  for(j=0; j<maxnm+1 ; j++) fl[i][j]=0;
 }
 asite = ivector(nsite);
 asite0 = ivector(nsite);
 if( dop >= 15 && dop <= 22 ){
     tsite = ivector(nsite/3);
     synsite = d3matrix(4,4,4);
     synchg = dmatrix(64,64);
     if( dop >= 19 && dop <= 22 ) nsynchg = dmatrix(64,64);
      /*      dop >= 15 && dop <= 18
                   synchg[i][j] : i<j synonymous change, i>j nonsynonymous change 
            dop >= 19 && dop <= 22
                    synchg[i][j] : i<j ts change, i>j tv change 
          nsynchg[i][j] : i<j ts change, i>j tv change 
		    */        
}
 ndif = imatrix(nseq,nseq);
 ndif1 = imatrix(nseq,nseq);
 
  addelta = Ndsptrvector(nseq-2);  
  adpart = Ndsptrvector(nseq-2); 
  part = ucmatrix(nseq-2,(nseq-1)/8+1); 
  nda = Ndsvector(2*nseq-2);  
  nlr = ivector(nseq);
  nll = ivector(nseq);
  nlb = ivector(nseq);
  dist0 = dmatrix(nseq,nseq);
  blen1 = dvector(2*nseq-2);
  blen2 = dvector(2*nseq-2);
  delta = dvector(nseq-2);
  ra = dvector(nseq-2);
  rb = dvector(nseq-2);
  rc = dvector(nseq-2);
  rav = dvector(nseq-2);
  rbv = dvector(nseq-2);
  rcv = dvector(nseq-2);
  deltav = dmatrix(nseq-2,nseq-2);
  dcoef = ivector(nseq-2);
  nbal = imatrix(nseq,4);
  iw = nseq*(nseq-1)/2;
  cov = dvectorc(iw*(iw-1)/2,&covflg);
  /*  printf("cov=%p %d covflg=%d\n",cov,iw*(iw-1)/2,covflg);*/
  if( covflg == 1 ){
      if( (fpcov = open ("COV",O_RDWR | O_TRUNC | O_CREAT ) ) == -1 ){
            printf("Can't open file %s\n","COV");
            exit(1);
      }
      system("chmod 755 COV");
    }



  addelta = Ndsptrvector(nseq-2);
  adpart = Ndsptrvector(nseq-2);


  /*   printf("after memory allocation\n"); fflush(stdout);*/
   noutg=0;
  if( argv[ioutc][2] >= '0' && argv[ioutc][2] <= '9' ){
       sscanf(argv[ioutc]+2,"%d",&outg[noutg]); noutg++;
  }
  for(j=ioutc+1 ; j<argc ; j++){
    if( argv[j][0] > '9' || argv[j][0] < '0' ) break;
        sscanf(argv[j],"%d",&outg[noutg]);
        noutg++;
        if( noutg > nseq){
            printf("too many outgroup %d\n",noutg);
            exit(1);
	 }
  }
  
/*  printf("before rdseq\n"); fflush(stdout); */
  if( (fpi= fopen(argv[ifc],"r")) == NULL ){
    fprintf(fpo,"Can't open file %s\n",argv[ifc]);
    exit(1);
  }
  rdseq(fpi,nseq,nsite,a,fl,maxnm);   
  fclose(fpi);
  

rdtv(fpt,&nseqw,fl,nda,blen,nsite);
if( nseqw != nseq ){
   printf("nseq inconsistent %d %d\n",nseqw,nseq);
   exit(1);
 }   
fclose(fpt);
   
for(i=0; i<noutg ; i++){
   if( outg[i] > nseq ) {
      printf("invalid outgroup %d\n",outg[i]);
      exit(1);
    }
 }

for(i=0; i<noutg-1 ; i++){
   for(j=i+1; j<noutg ; j++){
     if( outg[i] > outg[j] ){
        iw = outg[i];
        outg[i]=outg[j];
        outg[j]=iw;
      }
   }
 }

for(i=0; i<(nseq-1)/8+1 ; i++){
  for(j=0; j<nseq-2; j++) part[j][i]=0;
}

if( dop == 3 || dop == 4  || dop == 7 ){
   delchka(a,nseq,nsite,&npsite,&nasite,asite);
 }else{
   delchk(a,nseq,nsite,&npsite,&nasite,asite,asite0,cdnpos,dop,&ntsite,tsite);
   if( dop < 15) basefr(a,nseq,nasite,asite0,nbal);
}

/*if( outgroup == 0 ) outgroup=nseq; */

if( dop >= 15 && dop < 18 ){
fprintf(fpo,"file %s: nseq=%d nsite=%d nasite=%d %s",argv[ifc],nseq,nsite,nasite,dname[dop]); fflush(fpo);
}else
fprintf(fpo,"file %s: nseq=%d nsite=%d npsite=%d nasite=%d %s",argv[ifc],nseq,nsite,npsite,nasite,dname[dop]); fflush(fpo);
if( (dop >= 5 && dop < 8) || (dop == 12) || (dop == 14) ) fprintf(fpo," a=%f",gamma);
if( (dop >= 15) && (dop <= 22)){
       codonset(dop,ntable,cdn,cdnn,synsite,synchg,nsynchg);
       fprintf(fpo,"codon table %d\n",ntable); fflush(fpo);
}
if( cdnpos > 0 ) fprintf(fpo," codon position %d",cdnpos);
fprintf(fpo,"\n");
fprintf(fpo,"outgroup");
for(i=0; i<noutg ; i++) fprintf(fpo," %d %s",outg[i],fl[outg[i]-1]);
fprintf(fpo,"\n");
fflush(stdout);

   if( (dop == 3 || dop == 4 ) || dop == 7 ) {
      rn=calcova(a,nseq,nsite,nasite,npsite,asite,dop,dist,ndif,gamma);
      /*      printf("calcova\n"); fflush(stdout);*/
    }else{
      if( dop >= 15 && dop <= 22 ) {
      rn=calcovsyn(a,nseq,nsite,nasite,asite,dop,dist,asite0,cdn,cdnn,synsite,synchg,nsynchg,fl,maxnm,pflg);
	 }else{
      rn=calcov(a,nseq,nsite,nasite,npsite,asite,dop,dist,ndif,ndif1,gamma,asite0,nbal,fl,maxnm,pflg);
	 }
    }

   /*   printf("calcov\n"); fflush(stdout);*/
   if( covflg == 1 ) {
     close(fpcov);
     if( (fpcov = open ("COV",O_RDONLY) ) == -1 ){
            printf("Can't open file %s\n","COV");
            exit(1);
      }
   }


   if( rn != 0 ){
      printf("calcov\n");
      exit(-1);
    }
   for(i=0; i<nseq-1; i++){
      for(j=i+1; j<nseq; j++){
         dist0[i][j]=dist[i][j];
         dist0[j][i]=dist[j][i];
/*         printf("%d %d %f %f\n",i,j,dist0[i][j],dist0[j][i]); */
       }
      }
      npc=0;
      bc=0;
      ngflg=0;
      outgroup = outg[0];
      preargv(&nda[outgroup-1],nda[outgroup-1].b); 

      /*      printf("preargv\n");      fflush(stdout);*/
      anc = &nda[outgroup-1];
      cur = nda[outgroup-1].b;
      if( noutg > 1 ) {
/*         printf("outchk noutg=%d\n",noutg);  */
         rn=outchk(nseq,noutg,outg,&cur,&anc);
         if( rn != 0 ){
            printf("outgroup error\n");
            exit(1);
          }
/*         printf("aft cur %d anc %d\n",cur->nkey,anc->nkey); */
       }
      /*      printf("cur %d anc %d\n",cur->nkey,anc->nkey);*/
      npc=0;
      for(i=0; i<(nseq-1)/8+1 ; i++){
          for(j=0; j<nseq-2; j++) part[j][i]=0;
      }

      bc=0;
      npc=0;
      arargv(anc,cur);
      /*      printf("arargv\n");
      fflush(stdout);
      */
      if( ngflg > 0 ){
           reestb(anc,cur); 
	 }
      posargv(&nda[outgroup-1],nda[outgroup-1].b); 
      /*      printf("posargv\n");fflush(stdout); */
      if( (fpt = fopen(fcn,"w")) == NULL){
          printf("Can't open file %s\n",fcn);
          exit(1);
	}
      prncn(fpt,nseq,nda,fl,dop,nsite,nasite,argv[ifc],outgroup,noutg,outg);
      fclose(fpt);
      if( ngflg > 0 ){
           if( (fpt = fopen(fcng,"w")) == NULL){
              printf("Can't open file %s\n",fcng);
              exit(1);
	   }
           prncng(fpt,nseq,nda,fl,dop,nsite,nasite,argv[ifc],outgroup,noutg,outg);
           fclose(fpt);
	 }


     rn=caldcv();

    if( covflg == 1 ){
          close(fpcov);
          system("rm COV");
    }
/*     for(i=0; i<npc ; i++){
      for(j=0; j<npc ; j++){
        printf(" %f",deltav[i][j]);
      }
      printf("\n");
    }
*/
    cw1 = '%';
     printf("node  L    R    delta     s.e.        Z     CP   height     s.e.        bA       bB       bC\n");
     for(i=0; i<npc; i++){
      cw = '>';
      if( dcoef[i] == -1 )  cw = '<';
      if(  deltav[i][i] <= 0. +ACU )
        printf("  %2d %2d %c %2d %f %f NAN       NAN   %f %f  %f %f %f\n",addelta[i]->nkey,addelta[i]->lc->nkey,cw,addelta[i]->rc->nkey,delta[i],0.,addelta[i]->height,sqrt(addelta[i]->heightv),ra[i],rb[i],rc[i]);
      else 
        printf("  %2d %2d %c %2d %f %f %f %5.2f%c %f %f  %f %f %f\n",addelta[i]->nkey,addelta[i]->lc->nkey,cw,addelta[i]->rc->nkey,delta[i],sqrt(deltav[i][i]),delta[i]/sqrt(deltav[i][i]),ttest(delta[i]/sqrt(deltav[i][i]))*100.0,cw1,addelta[i]->height,sqrt(addelta[i]->heightv),ra[i],rb[i],rc[i]);
      
/*      printf("%2d l(%2d) %c r (%2d) delta=%f %f %f %2.2f%c  height=%f %f  %f %f %f\n",addelta[i]->nkey,addelta[i]->lc->nkey,cw,addelta[i]->rc->nkey,delta[i],sqrt(deltav[i][i]),delta[i]/sqrt(deltav[i][i]),ttest(delta[i]/sqrt(deltav[i][i]))*100.0,cw1,addelta[i]->height,sqrt(addelta[i]->heightv),ra[i],rb[i],rc[i]);*/


    }
/*
    for(i=0; i<nseq-2; i++){
      for(j=0; j<nseq-2; j++){
        printf(" %f",deltav[i][j]);
      }
      printf("\n");
    }
*/
/*     printf("npc=%d\n",npc); */
    delq=calq();
    printf("Q=%f\n",delq);
exit(0);
}



